diff -pruN 2.10.2-1/debian/changelog 2.11.1-1/debian/changelog
--- 2.10.2-1/debian/changelog	2020-02-16 13:27:13.000000000 +0000
+++ 2.11.1-1/debian/changelog	2020-07-09 11:53:55.000000000 +0000
@@ -1,3 +1,19 @@
+jackson-databind (2.11.1-1) unstable; urgency=medium
+
+  * New upstream version 2.11.1.
+    - Exclude the javadocs from the source tarball because they require more
+      than 500 MB disk space.
+    - Fixes CVE-2020-9548, CVE-2020-9547, CVE-2020-9546, CVE-2020-8840,
+      CVE-2020-14195, CVE-2020-14062, CVE-2020-14061, CVE-2020-14060,
+      CVE-2020-11620, CVE-2020-11619, CVE-2020-11113, CVE-2020-11112,
+      CVE-2020-11111, CVE-2020-10969, CVE-2020-10968, CVE-2020-10673,
+      CVE-2020-10672.
+  * Switch to debhelper-compat = 13.
+  * Refresh base-pom.patch.
+  * Remove README.source.
+
+ -- Markus Koschany <apo@debian.org>  Thu, 09 Jul 2020 13:53:55 +0200
+
 jackson-databind (2.10.2-1) unstable; urgency=medium
 
   * New upstream version 2.10.2.
diff -pruN 2.10.2-1/debian/control 2.11.1-1/debian/control
--- 2.10.2-1/debian/control	2020-02-16 13:27:13.000000000 +0000
+++ 2.11.1-1/debian/control	2020-07-09 11:53:55.000000000 +0000
@@ -5,7 +5,7 @@ Maintainer: Debian Java Maintainers <pkg
 Uploaders:
  Markus Koschany <apo@debian.org>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  default-jdk,
  default-jdk-doc,
  groovy,
diff -pruN 2.10.2-1/debian/copyright 2.11.1-1/debian/copyright
--- 2.10.2-1/debian/copyright	2020-02-16 13:27:13.000000000 +0000
+++ 2.11.1-1/debian/copyright	2020-07-09 11:53:55.000000000 +0000
@@ -16,13 +16,17 @@ Comment: FasterXML used a dual licensing
  [2] http://markmail.org/message/repexr3kb6gn4uam
  [3] http://markmail.org/message/bwxz2hle5fhrhm3q
      http://markmail.org/message/ckwelxnmoqlm5qr4
+Files-Excluded:
+ docs/*
+
 
 Files: *
-Copyright: 2012-2016, FasterXML, LLC, Seattle, USA <info@fasterxml.com>
+Copyright: 2012-2020, FasterXML, LLC, Seattle, USA <info@fasterxml.com>
 License: Apache-2.0
 
 Files: debian/*
-Copyright: 2013, Wolodja Wentland <debian@babilen5.org>
+Copyright: 2013,      Wolodja Wentland <debian@babilen5.org>
+           2017-2020, Markus Koschany <apo@debian.org>
 License: Apache-2.0
 
 License: Apache-2.0
diff -pruN 2.10.2-1/debian/patches/base-pom.patch 2.11.1-1/debian/patches/base-pom.patch
--- 2.10.2-1/debian/patches/base-pom.patch	2020-02-16 13:27:13.000000000 +0000
+++ 2.11.1-1/debian/patches/base-pom.patch	2020-07-09 11:53:55.000000000 +0000
@@ -18,7 +18,7 @@ index 95fdb10..4ee8e91 100644
    <parent>
      <groupId>com.fasterxml.jackson</groupId>
      <artifactId>jackson-base</artifactId>
--    <version>2.10.2</version>
+-    <version>2.11.1</version>
 +    <version>2.9.8</version>
    </parent>
  
diff -pruN 2.10.2-1/debian/README.source 2.11.1-1/debian/README.source
--- 2.10.2-1/debian/README.source	2020-02-16 13:27:13.000000000 +0000
+++ 2.11.1-1/debian/README.source	1970-01-01 00:00:00.000000000 +0000
@@ -1,9 +0,0 @@
-Information about jackson-databind
-------------------------------
-
-This package was debianized using the mh_make command
-from the maven-debian-helper package.
-
-The build system uses Maven but prevents it from downloading
-anything from the Internet, making the build compliant with
-the Debian policy.
diff -pruN 2.10.2-1/pom.xml 2.11.1-1/pom.xml
--- 2.10.2-1/pom.xml	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/pom.xml	2020-06-25 02:44:21.000000000 +0000
@@ -5,23 +5,30 @@
   <parent>
     <groupId>com.fasterxml.jackson</groupId>
     <artifactId>jackson-base</artifactId>
-    <version>2.10.2</version>
+    <version>2.11.1</version>
   </parent>
 
   <groupId>com.fasterxml.jackson.core</groupId>
   <artifactId>jackson-databind</artifactId>
-  <version>2.10.2</version>
+  <version>2.11.1</version>
   <name>jackson-databind</name>
   <packaging>bundle</packaging>
   <description>General data-binding functionality for Jackson: works on core streaming API</description>
   <url>http://github.com/FasterXML/jackson</url>
   <inceptionYear>2008</inceptionYear>
-
+  <licenses>
+    <license>
+      <name>The Apache Software License, Version 2.0</name>
+      <url>http://www.apache.org/licenses/LICENSE-2.0.txt</url>
+      <distribution>repo</distribution>
+    </license>
+  </licenses>
+  
   <scm>
     <connection>scm:git:git@github.com:FasterXML/jackson-databind.git</connection>
     <developerConnection>scm:git:git@github.com:FasterXML/jackson-databind.git</developerConnection>
     <url>http://github.com/FasterXML/jackson-databind</url>
-    <tag>jackson-databind-2.10.2</tag>
+    <tag>jackson-databind-2.11.1</tag>
   </scm>
 
   <properties>
@@ -170,8 +177,8 @@
         <artifactId>maven-javadoc-plugin</artifactId>
         <configuration>
           <links combine.children="append">
-            <link>http://fasterxml.github.com/jackson-annotations/javadoc/2.10</link>
-            <link>http://fasterxml.github.com/jackson-core/javadoc/2.10</link>
+            <link>http://fasterxml.github.com/jackson-annotations/javadoc/2.11</link>
+            <link>http://fasterxml.github.com/jackson-core/javadoc/2.11</link>
           </links>
         </configuration>
       </plugin>
diff -pruN 2.10.2-1/release-notes/CREDITS-2.x 2.11.1-1/release-notes/CREDITS-2.x
--- 2.10.2-1/release-notes/CREDITS-2.x	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/release-notes/CREDITS-2.x	2020-06-25 02:44:21.000000000 +0000
@@ -378,10 +378,12 @@ Jayson Minard (apatrida@github)
    (2.8.5)
 
 David Bakin (david-bakin@github)
-  * Reported #1013: `@JsonUnwrapped` is not treated as assuming `@JsonProperty("")`
+* Reported #1013: `@JsonUnwrapped` is not treated as assuming `@JsonProperty("")`
    (2.6.4)
   * Suggested #1011: Change ObjectWriter::withAttributes() to take a Map with some kind of wildcard types
    (2.7.0)
+  * Reported #962: `@JsonInject` fails on trying to find deserializer even if inject-only
+   (2.11.0)
 
 Dmitry Romantsov (DmRomantsov@github)
   * Reported #1036: Problem with case-insensitive deserialization
@@ -611,6 +613,9 @@ Ivo Studens (istudens@redhat.com)
   * Contributed #1585: Invoke ServiceLoader.load() inside of a privileged block
     when loading modules using `ObjectMapper.findModules()`
    (2.8.9)
+  * Contributed fix for #2482: `JSONMappingException` `Location` column number
+    is one line Behind the actual location
+   (2.10.3)
 
 Javy Luo (AnywnYu@github)
   * Reported #1595: `JsonIgnoreProperties.allowSetters` is not working in Jackson 2.8
@@ -986,6 +991,11 @@ João Guerra (joca-bt@github)
   (2.10.1)
   * Reported #2567: Incorrect target type for arrays when providing nulls and nulls are disabled
   (2.10.2)
+  * Reported #2635: JsonParser cannot getText() for input stream on MismatchedInputException
+  (2.11.0)
+  * Reported #2770: JsonParser from MismatchedInputException cannot getText() for
+    floating-point value
+  (2.11.1)
 
 Ryan Bohn (bohnman@github)
   * Reported #2475: `StringCollectionSerializer` calls `JsonGenerator.setCurrentValue(value)`,
@@ -1022,3 +1032,102 @@ Greg Arakelian (arakelian@github)
   * Reported #2566: `MissingNode.toString()` returns `null` (4 character token) instead
     of empty string
   (2.10.2)
+
+Kamal Aslam (aslamkam@github)
+  * Reported #2482: `JSONMappingException` `Location` column number is one line
+    Behind the actual location
+  (2.10.3)
+
+Tobias Preuss (johnjohndoe@github)
+  * Reported #2599: NoClassDefFoundError at DeserializationContext.<init> on Android 4.1.2
+    and Jackson 2.10.0
+  (2.10.3)
+
+Eduard Tudenhöfner (nastra@github)
+  * Reported #2602, contributed fix for: ByteBufferSerializer produces unexpected results with
+    a duplicated ByteBuffer and a position > 0
+  (2.10.3)
+
+Alexander Shilov (ashlanderr@github)
+  * Reported, suggested fix for #2610: `EXTERNAL_PROPERTY` doesn't work with `@JsonIgnoreProperties`
+  (2.10.3)
+
+Endre Stølsvik (stolsvik@github)
+  * Reported #2679: `ObjectMapper.readValue("123", Void.TYPE)` throws "should never occur"
+  (2.10.4)
+
+Máté Rédecsi (rmatesz@github)
+  * Reported #953: i-I case convertion problem in Turkish locale with case-insensitive deserialization
+  (2.11.0)
+
+Ville Koskela (vjkoskela@github)
+  * Contributed #2487: BeanDeserializerBuilder Protected Factory Method for Extension
+  (2.11.0)
+  * Reported #2486: Builder Deserialization with JsonCreator Value vs Array
+  (2.11.1)
+
+Fitz (Joongsoo.Park) (joongsoo@github)
+  * Contributed #2511: Add `SerializationFeature.WRITE_SELF_REFERENCES_AS_NULL`
+  (2.11.0)
+
+Antonio Petrelli (apetrelli@github)
+  * Reported #2049: TreeTraversingParser and UTF8StreamJsonParser create contexts differently
+  (2.11.0)
+
+Robert Diebels (RobertDiebels@github)
+  * Contributed #2352: Support use of `@JsonAlias` for enum values
+  (2.11.0)
+
+Joseph Koshakow (jkosh44@github)
+  * Contributed fix for #2515: `ObjectMapper.registerSubtypes(NamedType...)` doesn't allow registering
+    the same POJO for two different type ids
+  (2.11.0)
+
+Haowei Wen (yushijinhun@github)
+  * Reported #2565: Java 8 `Optional` not working with `@JsonUnwrapped` on unwrappable type
+  (2.11.0)
+
+Bartosz Baranowski (baranowb@github)
+  * Reported #2589: `DOMDeserializer`: setExpandEntityReferences(false) may not prevent
+   external entity expansion in all cases
+  (2.11.0)
+
+Oleksii Khomchenko (gagoman@github)
+  * Reported, contributed fix for #2592: `ObjectMapper.setSerializationInclusion()` is
+   ignored for `JsonAnyGetter`
+  (2.11.0)
+
+Oleksandr Poslavskyi (alevskyi@github)
+  * Contributed fix for #1983: Polymorphic deserialization should handle case-insensitive Type Id
+    property name if `MapperFeature.ACCEPT_CASE_INSENSITIVE_PROPERTIES` is enabled
+  (2.11.0)
+
+Simone D'Avico (simonedavico@github)
+  * Reported #2632: Failure to resolve generic type parameters on serialization
+  (2.11.0)
+ 
+Robin Roos (robinroos@github)
+  * Contributed #2636: ObjectReader readValue lacks Class<T> argument
+  (2.11.0)
+
+Michael Cramer (BigMichi1@github)
+  * Reported #2725: JsonCreator on static method in Enum and Enum used as key in map
+   fails randomly
+  (2.11.1)
+ 
+Frank Schmager (fschmager@github)
+  * Reported #2757: "Conflicting setter definitions for property" exception for `Map`
+   subtype during deserialization
+  (2.11.1)
+
+Johannes Kuhn (DasBrain@github)
+  * Reported #2758: Fail to deserialize local Records
+  (2.11.1)
+  * Reported #2760: Jackson doesn't respect `CAN_OVERRIDE_ACCESS_MODIFIERS=false` for
+    deserializer properties
+  (2.11.1)
+
+Oleg Chtchoukine (oshatrk@github)
+  * Reported #2759: Rearranging of props when property-based generator is in use leads
+    to incorrect output
+  (2.11.1)
diff -pruN 2.10.2-1/release-notes/VERSION-2.x 2.11.1-1/release-notes/VERSION-2.x
--- 2.10.2-1/release-notes/VERSION-2.x	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/release-notes/VERSION-2.x	2020-06-25 02:44:21.000000000 +0000
@@ -4,30 +4,122 @@ Project: jackson-databind
 === Releases === 
 ------------------------------------------------------------------------
 
+2.11.1 (25-Jun-2020)
+
+#2486: Builder Deserialization with JsonCreator Value vs Array
+ (reported by Ville K)
+#2725: JsonCreator on static method in Enum and Enum used as key in map
+  fails randomly
+ (reported by Michael C)
+#2755: `StdSubtypeResolver` is not thread safe (possibly due to copy
+  not being made with `ObjectMapper.copy()`)
+ (reported by tjwilson90@github)
+#2757: "Conflicting setter definitions for property" exception for `Map`
+  subtype during deserialization
+ (reported by Frank S)
+#2758: Fail to deserialize local Records
+ (reported by Johannes K)
+#2759: Rearranging of props when property-based generator is in use leads
+  to incorrect output
+ (reported by Oleg C)
+#2760: Jackson doesn't respect `CAN_OVERRIDE_ACCESS_MODIFIERS=false` for
+  deserializer properties
+ (reported by Johannes K)
+#2767: `DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS` don't support `Map`
+  type field
+ (reported by abomb4@github)
+#2770: JsonParser from MismatchedInputException cannot getText() for
+  floating-point value
+ (reported by João G)
+
+2.11.0 (26-Apr-2020)
+
+#953: i-I case conversion problem in Turkish locale with case-insensitive deserialization
+ (reported by Máté R)
+#962: `@JsonInject` fails on trying to find deserializer even if inject-only
+ (reported by David B)
+#1983: Polymorphic deserialization should handle case-insensitive Type Id property name
+  if `MapperFeature.ACCEPT_CASE_INSENSITIVE_PROPERTIES` is enabled
+ (reported by soundvibe@github, fix contributed by Oleksandr P)
+#2049: TreeTraversingParser and UTF8StreamJsonParser create contexts differently
+ (reported by Antonio P)
+#2352: Support use of `@JsonAlias` for enum values
+ (contributed by Robert D)
+#2365: `declaringClass` of "enum-as-POJO" not removed for `ObjectMapper` with
+  a naming strategy
+ (reported by Tynakuh@github)
+#2480: Fix `JavaType.isEnumType()` to support sub-classes
+#2487: BeanDeserializerBuilder Protected Factory Method for Extension
+ (contributed by Ville K)
+#2503: Support `@JsonSerialize(keyUsing)` and `@JsonDeserialize(keyUsing)` on Key class
+#2511: Add `SerializationFeature.WRITE_SELF_REFERENCES_AS_NULL`
+ (contributed by Joongsoo P)
+#2515: `ObjectMapper.registerSubtypes(NamedType...)` doesn't allow registering
+  same POJO for two different type ids
+ (contributed by Joseph K)
+#2522: `DeserializationContext.handleMissingInstantiator()` throws
+  `MismatchedInputException` for non-static inner classes
+#2525: Incorrect `JsonStreamContext` for `TokenBuffer` and `TreeTraversingParser`
+#2527: Add `AnnotationIntrospector.findRenameByField()` to support Kotlin's
+  "is-getter" naming convention
+#2555: Use `@JsonProperty(index)` for sorting properties on serialization
+#2565: Java 8 `Optional` not working with `@JsonUnwrapped` on unwrappable type
+ (reported by Haowei W)
+#2587: Add `MapperFeature.BLOCK_UNSAFE_POLYMORPHIC_BASE_TYPES` to allow blocking
+  use of unsafe base type for polymorphic deserialization
+#2589: `DOMDeserializer`: setExpandEntityReferences(false) may not prevent
+  external entity expansion in all cases
+ (reported by Bartosz B)
+#2592: `ObjectMapper.setSerializationInclusion()` is ignored for `JsonAnyGetter`
+ (reported by Oleksii K)
+#2608: `ValueInstantiationException` when deserializing using a builder and
+  `UNWRAP_SINGLE_VALUE_ARRAYS`
+ (reported by cadrake@github)
+#2627: JsonIgnoreProperties(ignoreUnknown = true) does not work on field and method level
+ (reported by robotmrv@github)
+#2632: Failure to resolve generic type parameters on serialization
+ (reported by Simone D)
+#2635: JsonParser cannot getText() for input stream on MismatchedInputException
+ (reported by João G)
+#2636: ObjectReader readValue lacks Class<T> argument
+ (contributed by Robin R)
+#2643: Change default textual serialization of `java.util.Date`/`Calendar`
+  to include colon in timezone offset
+#2647: Add `ObjectMapper.createParser()` and `createGenerator()` methods
+#2657: Allow serialization of `Properties` with non-String values
+#2663: Add new factory method for creating custom `EnumValues` to pass to `EnumDeserializer
+ (requested by Rafal K)
+#2668: `IllegalArgumentException` thrown for mismatched subclass deserialization
+ (reported by nbruno@github)
+#2693: Add convenience methods for creating `List`, `Map` valued `ObjectReader`s
+  (ObjectMapper.readerForListOf())
+- Add `SerializerProvider.findContentValueSerializer()` methods
+
+2.10.4 (03-May-2020)
+
+#2679: `ObjectMapper.readValue("123", Void.TYPE)` throws "should never occur"
+ (reported by Endre S)
+
+2.10.3 (03-Mar-2020)
+
+#2482: `JSONMappingException` `Location` column number is one line Behind the actual
+  location
+ (reported by Kamal A, fixed by Ivo S)
+#2599: NoClassDefFoundError at DeserializationContext.<init> on Android 4.1.2
+  and Jackson 2.10.0
+ (reported by Tobias P)
+#2602: ByteBufferSerializer produces unexpected results with a duplicated ByteBuffer
+  and a position > 0
+ (reported by Eduard T)
+#2605: Failure to deserializer polymorphic subtypes of base type `Enum`
+ (reported by uewle@github)
+#2610: `EXTERNAL_PROPERTY` doesn't work with `@JsonIgnoreProperties`
+ (reported, fix suggested by Alexander S)
+
 2.10.2 (05-Jan-2020)
 
 #2101: `FAIL_ON_NULL_FOR_PRIMITIVES` failure does not indicate field name in exception message
  (reported by raderio@github)
-#2544: java.lang.NoClassDefFoundError Thrown for compact profile1
-  (reported by Jon A)
-#2553: JsonDeserialize(contentAs=...) broken with raw collections
- (reported by cpopp@github)
-#2556: Contention in `TypeNameIdResolver.idFromClass()`
- (reported by Fabian L)
-#2560: Check `WRAP_EXCEPTIONS` in `CollectionDeserializer.handleNonArray()`
- (reported by Stefan W)
-#2564: Fix `IllegalArgumentException` on empty input collection for `ArrayBlockingQueue`
- (reported, fix suggested by yamert89@github)
-#2566: `MissingNode.toString()` returns `null` (4 character token) instead of empty string
- (reported by Greg A)
-#2567: Incorrect target type for arrays when providing nulls and nulls are disabled
- (reported by João G)
-#2573: Problem with `JsonInclude` config overrides for `java.util.Map`
- (reported by SukruthKS@github)
-#2576: Fail to serialize `Enum` instance which includes a method override
-  as POJO (shape = Shape.OBJECT)
- (reported by ylhuang-veeva@github)
-- Fix an issue with `ObjectReader.with(JsonParser.Feature)` (and related) not working
 
 2.10.1 (09-Nov-2019)
 
@@ -107,7 +199,7 @@ Project: jackson-databind
 #2241: Add `PropertyNamingStrategy.LOWER_DOT_CASE` for dot-delimited names
  (contributed by zenglian@github.com)
 #2251: Getter that returns an abstract collection breaks a delegating `@JsonCreator`
-#2265: Inconsistent handling of Collections$UnmodifiableList vs Collections$UnmodifiableRandomAccessListq
+#2265: Inconsistent handling of Collections$UnmodifiableList vs Collections$UnmodifiableRandomAccessList
 #2273: Add basic Java 9+ module info
 #2280: JsonMerge not work with constructor args
  (reported by Deblock T)
@@ -166,17 +258,7 @@ Project: jackson-databind
   deserialize as "null value"
  (contributed by Martin C)
 
-2.9.10.2 (03-Jan-2020)
-
-#2526: Block two more gadget types (ehcache/JNDI - CVEs to be allocated)
-  (repoerted by UltramanGaia)
-
-2.9.10.1 (20-Oct-2019)
-
-#2478: Block two more gadget types (commons-dbcp, p6spy,
-  CVE-2019-16942 / CVE-2019-16943)
- (reported by b5mali4 / root@codersec.net)
-#2498: Block one more gadget type (log4j-extras/1.2, CVE-2019-17531)
+[2.9.10.x micro-patches omitted]
 
 2.9.10 (21-Sep-2019)
 
@@ -350,7 +432,7 @@ Project: jackson-databind
  (reported by Alexander S)
 #1854: NPE deserializing collection with `@JsonCreator` and `ACCEPT_CASE_INSENSITIVE_PROPERTIES`
  (reported by rue-jw@github)
-#1855: Blacklist for more serialization gadgets (dbcp/tomcat, spring)
+#1855: Blacklist for more serialization gadgets (dbcp/tomcat, spring, CVE-2017-17485)
 #1859: Issue handling unknown/unmapped Enum keys
  (reported by remya11@github)
 #1868: Class name handling for JDK unmodifiable Collection types changed
@@ -561,9 +643,9 @@ Project: jackson-databind
 #1872: `NullPointerException` in `SubTypeValidator.validateSubType` when
   validating Spring interface
  (reported by Rob W)
-#1899: Another two gadgets to exploit default typing issue in jackson-databind
+#1899: Another two gadgets to exploit default typing issue (CVE-2018-5968)
  (reported by OneSourceCat@github)
-#1931: Two more `c3p0` gadgets to exploit default typing issue
+#1931: Two more `c3p0` gadgets to exploit default typing issue (c3p0, CVE-2018-7489)
 
 2.8.11 (24-Dec-2017)
 
@@ -577,7 +659,7 @@ Project: jackson-databind
  (reported by henryptung@github)
 #1807: Jackson-databind caches plain map deserializer and use it even map has `@JsonDeserializer`
  (reported by lexas2509@github)
-#1855: Blacklist for more serialization gadgets (dbcp/tomcat, spring)
+#1855: Blacklist for more serialization gadgets (dbcp/tomcat, spring / CVE-2017-17485)
 
 2.8.10 (24-Aug-2017)
 
@@ -593,7 +675,7 @@ Project: jackson-databind
  binary formats (CBOR, Smile)
 #1735: Missing type checks when using polymorphic type ids
  (reported by Lukas Euler)
-#1737: Block more JDK types from polymorphic deserialization
+#1737: Block more JDK types from polymorphic deserialization (CVE 2017-15095)
 
 2.8.9 (12-Jun-2017)
 
@@ -618,7 +700,7 @@ Project: jackson-databind
 #1585: Invoke ServiceLoader.load() inside of a privileged block when loading
   modules using `ObjectMapper.findModules()`
  (contributed by Ivo S)
-#1599: Jackson Deserializer security vulnerability
+#1599: Jackson Deserializer security vulnerability (CVE-2017-7525)
  (reported by ayound@github)
 #1607: @JsonIdentityReference not used when setup on class only
  (reported by vboulaye@github)
diff -pruN 2.10.2-1/SECURITY.md 2.11.1-1/SECURITY.md
--- 2.10.2-1/SECURITY.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/SECURITY.md	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,22 @@
+# Security Policy
+
+Last Updated: 2019-11-26
+
+## Supported Versions
+
+Current status of open branches, with new releases, can be found from [Jackson Releases](https://github.com/FasterXML/jackson/wiki/Jackson-Releases)
+wiki page
+
+## Reporting a Vulnerability
+
+The recommended mechanism for reporting possible security vulnerabilities follows
+so-called "Coordinated Disclosure Plan" (see [definition of DCP](https://vuls.cert.org/confluence/display/Wiki/Coordinated+Vulnerability+Disclosure+Guidance)
+for general idea). The first step is to file a [Tidelift security contact](https://tidelift.com/security):
+Tidelift will route all reports via their system to maintainers of relevant package(s), and start the
+process that will evaluate concern and issue possible fixes, send update notices and so on.
+Note that you do not need to be a Tidelift subscriber to file a security contact.
+
+Alternatively you may also report possible vulnerabilities to `info` at fasterxml dot com
+mailing address. Note that filing an issue to go with report is fine, but if you do that please
+DO NOT include details of security problem in the issue but only in email contact.
+This is important to give us time to provide a patch, if necessary, for the problem.
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/AbstractTypeResolver.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/AbstractTypeResolver.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/AbstractTypeResolver.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/AbstractTypeResolver.java	2020-06-25 02:44:21.000000000 +0000
@@ -1,6 +1,5 @@
 package com.fasterxml.jackson.databind;
 
-
 /**
  * Defines interface for resolvers that can resolve abstract types into concrete
  * ones; either by using static mappings, or possibly by materializing
@@ -22,9 +21,11 @@ public abstract class AbstractTypeResolv
      * of bindings; that is, it is legal to return type that could be further
      * resolved: caller is expected to keep calling this method on registered
      * resolvers, until a concrete type is located.
-     * 
-     * @param config Configuration in use; should always be of type
-     *    {@code DeserializationConfig}
+     *
+     * @param config Configuration in use
+     * @param type Type to find mapping for
+     *
+     * @return Type to map given input type (if mapping found) or {@code null} (if not).
      */
     public JavaType findTypeMapping(DeserializationConfig config, JavaType type) {
         return null;
@@ -35,6 +36,11 @@ public abstract class AbstractTypeResolv
      * obsoleted in 2.7
      *
      * @deprecated since 2.8 (may be removed from 2.9 or later)
+     *
+     * @param config Configuration in use
+     * @param type Type to resolve
+     *
+     * @return Resolved concrete type
      */
     @Deprecated
     public JavaType resolveAbstractType(DeserializationConfig config,
@@ -49,8 +55,7 @@ public abstract class AbstractTypeResolv
      * It will be called after checking all other possibilities,
      * including defaulting.
      *
-     * @param config Configuration in use; should always be of type
-     *    <code>DeserializationConfig</code>
+     * @param config Configuration in use
      * @param typeDesc Description of the POJO type to resolve
      * 
      * @return Resolved concrete type (which should retain generic
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/AnnotationIntrospector.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/AnnotationIntrospector.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/AnnotationIntrospector.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/AnnotationIntrospector.java	2020-06-25 02:44:21.000000000 +0000
@@ -615,6 +615,42 @@ public abstract class AnnotationIntrospe
     }
 
     /**
+     * Method called on fields that are eligible candidates for properties
+     * (that is, non-static member fields), but not necessarily selected (may
+     * or may not be visible), to let fields affect name linking.
+     * Call will be made after finding implicit name (which by default is just
+     * name of the field, but may be overridden by introspector), but before
+     * discovering other accessors.
+     * If non-null name returned, it is to be used to find other accessors (getters,
+     * setters, creator parameters) and replace their implicit names with that
+     * of field's implicit name (assuming they differ).
+     *<p>
+     * Specific example (and initial use case is for support Kotlin's "is getter"
+     * matching (see
+     * <a href="https://kotlinlang.org/docs/reference/java-to-kotlin-interop.html">Kotling Interop</a>
+     * for details), in which field like '{@code isOpen}' would have implicit name of
+     * "isOpen", match getter {@code getOpen()} and setter {@code setOpen(boolean)},
+     * but use logical external name of "isOpen" (and not implicit name of getter/setter, "open"!).
+     * To achieve this, field implicit name needs to remain "isOpen" but this method needs
+     * to return name {@code PropertyName.construct("open")}: doing so will "pull in" getter
+     * and/or setter, and rename them as "isOpen".
+     *
+     * @param config Effective mapper configuration in use
+     * @param f Field to check
+     * @param implName Implicit name of the field; usually name of field itself but not always,
+     *    used as the target name for accessors to rename.
+     *
+     * @return Name used to find other accessors to rename, if any; {@code null} to indicate
+     *    no renaming
+     *
+     * @since 2.11
+     */
+    public PropertyName findRenameByField(MapperConfig<?> config,
+            AnnotatedField f, PropertyName implName) {
+        return null;
+    }
+
+    /**
      * @deprecated Since 2.9 Use {@link #findInjectableValue} instead
      */
     @Deprecated // since 2.9
@@ -631,7 +667,7 @@ public abstract class AnnotationIntrospe
     /**
      * Method for getting a serializer definition on specified method
      * or field. Type of definition is either instance (of type {@link JsonSerializer})
-     * or Class (of {@code Class&lt;JsonSerializer} implementation subtype);
+     * or Class (of {@code Class<JsonSerializer>} implementation subtype);
      * if value of different type is returned, a runtime exception may be thrown by caller.
      */
     public Object findSerializer(Annotated am) {
@@ -641,7 +677,7 @@ public abstract class AnnotationIntrospe
     /**
      * Method for getting a serializer definition for keys of associated {@code java.util.Map} property.
      * Type of definition is either instance (of type {@link JsonSerializer})
-     * or Class (of type  {@code Class&lt;JsonSerializer>});
+     * or Class (of type  {@code Class<JsonSerializer>});
      * if value of different type is returned, a runtime exception may be thrown by caller.
      */
     public Object findKeySerializer(Annotated am) {
@@ -652,7 +688,7 @@ public abstract class AnnotationIntrospe
      * Method for getting a serializer definition for content (values) of
      * associated <code>Collection</code>, <code>array</code> or {@code Map} property.
      * Type of definition is either instance (of type {@link JsonSerializer})
-     * or Class (of type  {@code Class&lt;JsonSerializer>});
+     * or Class (of type  {@code Class<JsonSerializer>});
      * if value of different
      * type is returned, a runtime exception may be thrown by caller.
      */
@@ -925,10 +961,6 @@ public abstract class AnnotationIntrospe
      * Method for efficiently figuring out which if given set of <code>Enum</code> values
      * have explicitly defined name. Method will overwrite entries in incoming <code>names</code>
      * array with explicit names found, if any, leaving other entries unmodified.
-     *<p>
-     * Default implementation will simply delegate to {@link #findEnumValue}, which is close
-     * enough, although unfortunately NOT 100% equivalent (as it will also consider <code>name()</code>
-     * to give explicit value).
      *
      * @since 2.7
      */
@@ -938,6 +970,19 @@ public abstract class AnnotationIntrospe
     }
 
     /**
+     * Method that is related to {@link #findEnumValues} but is called to check if
+     * there are alternative names (aliased) that can be accepted for entries, in 
+     * addition to primary names introspected earlier.
+     * If so, these aliases should be returned in {@code aliases} {@link List} passed
+     * as argument (and initialized for proper size by caller).
+     *
+     * @since 2.11
+     */
+    public void findEnumAliases(Class<?> enumType, Enum<?>[] enumValues, String[][] aliases) {
+        ;
+    }
+
+    /**
      * Finds the Enum value that should be considered the default value, if possible.
      *
      * @param enumCls The Enum class to scan for the default value.
@@ -992,7 +1037,7 @@ public abstract class AnnotationIntrospe
      * Method for getting a deserializer definition on specified method
      * or field.
      * Type of definition is either instance (of type {@link JsonDeserializer})
-     * or Class (of type  {@code Class&lt;JsonDeserializer>});
+     * or Class (of type  {@code Class&<JsonDeserializer>});
      * type is returned, a runtime exception may be thrown by caller.
      */
     public Object findDeserializer(Annotated am) {
@@ -1003,7 +1048,7 @@ public abstract class AnnotationIntrospe
      * Method for getting a deserializer definition for keys of
      * associated <code>Map</code> property.
      * Type of definition is either instance (of type {@link JsonDeserializer})
-     * or Class (of type  {@code Class&lt;JsonDeserializer>});
+     * or Class (of type  {@code Class<JsonDeserializer>});
      * if value of different
      * type is returned, a runtime exception may be thrown by caller.
      */
@@ -1016,7 +1061,7 @@ public abstract class AnnotationIntrospe
      * associated <code>Collection</code>, <code>array</code> or
      * <code>Map</code> property.
      * Type of definition is either instance (of type {@link JsonDeserializer})
-     * or Class (of type  {@code Class&lt;JsonDeserializer>});
+     * or Class (of type  {@code Class<JsonDeserializer>});
      * if value of different
      * type is returned, a runtime exception may be thrown by caller.
      */
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/cfg/MapperBuilder.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/cfg/MapperBuilder.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/cfg/MapperBuilder.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/cfg/MapperBuilder.java	2020-06-25 02:44:21.000000000 +0000
@@ -18,6 +18,7 @@ import com.fasterxml.jackson.databind.in
 import com.fasterxml.jackson.databind.jsontype.NamedType;
 import com.fasterxml.jackson.databind.jsontype.PolymorphicTypeValidator;
 import com.fasterxml.jackson.databind.jsontype.SubtypeResolver;
+import com.fasterxml.jackson.databind.jsontype.TypeResolverBuilder;
 import com.fasterxml.jackson.databind.node.JsonNodeFactory;
 import com.fasterxml.jackson.databind.ser.*;
 import com.fasterxml.jackson.databind.type.TypeFactory;
@@ -703,7 +704,29 @@ public abstract class MapperBuilder<M ex
         _mapper.deactivateDefaultTyping();
         return _this();
     }
-    
+
+    /**
+     * Method for enabling automatic inclusion of type information, using
+     * specified handler object for determining which types this affects,
+     * as well as details of how information is embedded.
+     *<p>
+     * NOTE: use of Default Typing can be a potential security risk if incoming
+     * content comes from untrusted sources, so care should be taken to use
+     * a {@link TypeResolverBuilder} that can limit allowed classes to
+     * deserialize. Note in particular that
+     * {@link com.fasterxml.jackson.databind.jsontype.impl.StdTypeResolverBuilder}
+     * DOES NOT limit applicability but creates type (de)serializers for all
+     * types.
+     *
+     * @param typer Type information inclusion handler
+     *
+     * @since 2.12
+     */
+    public B setDefaultTyping(TypeResolverBuilder<?> typer) {
+        _mapper.setDefaultTyping(typer);
+        return _this();
+    }
+
     /*
     /**********************************************************************
     /* Other helper methods
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/cfg/MapperConfig.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/cfg/MapperConfig.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/cfg/MapperConfig.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/cfg/MapperConfig.java	2020-06-25 02:44:21.000000000 +0000
@@ -15,10 +15,12 @@ import com.fasterxml.jackson.databind.in
 import com.fasterxml.jackson.databind.introspect.ClassIntrospector;
 import com.fasterxml.jackson.databind.introspect.NopAnnotationIntrospector;
 import com.fasterxml.jackson.databind.introspect.VisibilityChecker;
+import com.fasterxml.jackson.databind.jsontype.DefaultBaseTypeLimitingValidator;
 import com.fasterxml.jackson.databind.jsontype.PolymorphicTypeValidator;
 import com.fasterxml.jackson.databind.jsontype.SubtypeResolver;
 import com.fasterxml.jackson.databind.jsontype.TypeIdResolver;
 import com.fasterxml.jackson.databind.jsontype.TypeResolverBuilder;
+import com.fasterxml.jackson.databind.jsontype.impl.LaissezFaireSubTypeValidator;
 import com.fasterxml.jackson.databind.type.TypeFactory;
 import com.fasterxml.jackson.databind.util.ClassUtil;
 
@@ -139,7 +141,7 @@ public abstract class MapperConfig<T ext
      * serialization, deserialization)
      */
     public final boolean isEnabled(MapperFeature f) {
-        return (_mapperFeatures & f.getMask()) != 0;
+        return f.enabledIn(_mapperFeatures);
     }
 
     /**
@@ -211,7 +213,7 @@ public abstract class MapperConfig<T ext
      */
     public SerializableString compileString(String src) {
         /* 20-Jan-2014, tatu: For now we will just construct it directly, but
-         *    for 2.4 need to allow overriding to support non-standard extensions
+         *    in future should allow overriding to support non-standard extensions
          *    to be used by extensions like Afterburner.
          */
         return new SerializedString(src);
@@ -267,10 +269,25 @@ public abstract class MapperConfig<T ext
     public abstract SubtypeResolver getSubtypeResolver();
 
     /**
+     * Simple accessor for default {@link PolymorphicTypeValidator} to use for
+     * legacy Default Typing methods ({@code ObjectMapper.enableDefaultTyping()})
+     * and annotation based enabling.
+     *<p>
+     * Since 2.11 will also check {@link MapperFeature#BLOCK_UNSAFE_POLYMORPHIC_BASE_TYPES}
+     * to possibly override default to more restrictive implementation, see
+     * {@link com.fasterxml.jackson.databind.jsontype.DefaultBaseTypeLimitingValidator}).
+     *
      * @since 2.10
      */
     public PolymorphicTypeValidator getPolymorphicTypeValidator() {
-        return _base.getPolymorphicTypeValidator();
+        PolymorphicTypeValidator ptv = _base.getPolymorphicTypeValidator();
+        // [databind#2587]: allow stricter default settings:
+        if (ptv == LaissezFaireSubTypeValidator.instance) {
+            if (isEnabled(MapperFeature.BLOCK_UNSAFE_POLYMORPHIC_BASE_TYPES)) {
+                ptv = new DefaultBaseTypeLimitingValidator();
+            }
+        }
+        return ptv;
     }
 
     public final TypeFactory getTypeFactory() {
@@ -302,7 +319,8 @@ public abstract class MapperConfig<T ext
     }
 
     public JavaType constructSpecializedType(JavaType baseType, Class<?> subclass) {
-        return getTypeFactory().constructSpecializedType(baseType, subclass);
+        // note: since 2.11 specify "strict" resolution
+        return getTypeFactory().constructSpecializedType(baseType, subclass, true);
     }
 
     /*
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/DatabindContext.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/DatabindContext.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/DatabindContext.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/DatabindContext.java	2020-06-25 02:44:21.000000000 +0000
@@ -153,15 +153,11 @@ public abstract class DatabindContext
 
     /**
      * Convenience method for constructing subtypes, retaining generic
-     * type parameter (if any)
+     * type parameter (if any).
+     *<p>
+     * Note: since 2.11 handling has varied a bit across serialization, deserialization.
      */
-    public JavaType constructSpecializedType(JavaType baseType, Class<?> subclass) {
-        // simple optimization to avoid costly introspection if type-erased type does NOT differ
-        if (baseType.getRawClass() == subclass) {
-            return baseType;
-        }
-        return getConfig().constructSpecializedType(baseType, subclass);
-    }
+    public abstract JavaType constructSpecializedType(JavaType baseType, Class<?> subclass);
 
     /**
      * Lookup method called when code needs to resolve class name from input;
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/BasicDeserializerFactory.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/BasicDeserializerFactory.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/BasicDeserializerFactory.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/BasicDeserializerFactory.java	2020-06-25 02:44:21.000000000 +0000
@@ -193,7 +193,7 @@ public abstract class BasicDeserializerF
 
     /*
     /**********************************************************
-    /* JsonDeserializerFactory impl (partial): ValueInstantiators
+    /* DeserializerFactory impl (partial): ValueInstantiators
     /**********************************************************
      */
 
@@ -461,17 +461,17 @@ index, owner, defs[index], propDef);
             for (int i = 0; i < argCount; ++i) {
                 final AnnotatedParameter param = ctor.getParameter(i);
                 BeanPropertyDefinition propDef = candidate.propertyDef(i);
-                JacksonInject.Value injectId = intr.findInjectableValue(param);
+                JacksonInject.Value injectable = intr.findInjectableValue(param);
                 final PropertyName name = (propDef == null) ? null : propDef.getFullName();
 
                 if (propDef != null && propDef.isExplicitlyNamed()) {
                     ++explicitNameCount;
-                    properties[i] = constructCreatorProperty(ctxt, beanDesc, name, i, param, injectId);
+                    properties[i] = constructCreatorProperty(ctxt, beanDesc, name, i, param, injectable);
                     continue;
                 }
-                if (injectId != null) {
+                if (injectable != null) {
                     ++injectCount;
-                    properties[i] = constructCreatorProperty(ctxt, beanDesc, name, i, param, injectId);
+                    properties[i] = constructCreatorProperty(ctxt, beanDesc, name, i, param, injectable);
                     continue;
                 }
                 NameTransformer unwrapper = intr.findUnwrappingNameTransformer(param);
@@ -637,7 +637,7 @@ nonAnnotatedParamIndex, ctor);
     }
 
     /**
-     * Helper method called when there is the explicit "is-creator", but no mode declaration.
+     * Helper method called when there is explicit "is-creator" marker, but no mode declaration.
      *
      * @since 2.9.2
      */
@@ -1013,9 +1013,8 @@ nonAnnotatedParamIndex, ctor);
 
         // Note: contextualization of typeDeser _should_ occur in constructor of CreatorProperty
         // so it is not called directly here
-        Object injectableValueId = (injectable == null) ? null : injectable.getId();
-        SettableBeanProperty prop = new CreatorProperty(name, type, property.getWrapperName(),
-                typeDeser, beanDesc.getClassAnnotations(), param, index, injectableValueId,
+        SettableBeanProperty prop = CreatorProperty.construct(name, type, property.getWrapperName(),
+                typeDeser, beanDesc.getClassAnnotations(), param, index, injectable,
                 metadata);
         JsonDeserializer<?> deser = findDeserializerFromAnnotation(ctxt, param);
         if (deser == null) {
@@ -1108,7 +1107,7 @@ nonAnnotatedParamIndex, ctor);
 
     /*
     /**********************************************************
-    /* JsonDeserializerFactory impl: array deserializers
+    /* DeserializerFactory impl: array deserializers
     /**********************************************************
      */
         
@@ -1154,7 +1153,7 @@ nonAnnotatedParamIndex, ctor);
 
     /*
     /**********************************************************************
-    /* JsonDeserializerFactory impl: Collection(-like) deserializers
+    /* DeserializerFactory impl: Collection(-like) deserializers
     /**********************************************************************
      */
 
@@ -1246,7 +1245,8 @@ nonAnnotatedParamIndex, ctor);
     {
         final Class<?> collectionClass = ContainerDefaultMappings.findCollectionFallback(type);
         if (collectionClass != null) {
-            return (CollectionType) config.constructSpecializedType(type, collectionClass);
+            return (CollectionType) config.getTypeFactory()
+                    .constructSpecializedType(type, collectionClass, true);
         }
         return null;
     }
@@ -1283,7 +1283,7 @@ nonAnnotatedParamIndex, ctor);
 
     /*
     /**********************************************************
-    /* JsonDeserializerFactory impl: Map(-like) deserializers
+    /* DeserializerFactory impl: Map(-like) deserializers
     /**********************************************************
      */
 
@@ -1326,8 +1326,7 @@ nonAnnotatedParamIndex, ctor);
                 } else {
                     inst = findValueInstantiator(ctxt, beanDesc);
                 }
-                Class<?> kt = keyType.getRawClass();
-                if (kt == null || !ClassUtil.isEnumType(kt)) {
+                if (!keyType.isEnumImplType()) {
                     throw new IllegalArgumentException("Cannot construct EnumMap; generic (key) type not available");
                 }
                 deser = new EnumMapDeserializer(type, inst, null,
@@ -1395,12 +1394,12 @@ nonAnnotatedParamIndex, ctor);
     {
         final Class<?> mapClass = ContainerDefaultMappings.findMapFallback(type);
         if (mapClass != null) {
-            return (MapType) config.constructSpecializedType(type, mapClass);
+            return (MapType) config.getTypeFactory()
+                    .constructSpecializedType(type, mapClass, true);
         }
         return null;
     }
 
-    
     // Copied almost verbatim from "createMapDeserializer" -- should try to share more code
     @Override
     public JsonDeserializer<?> createMapLikeDeserializer(DeserializationContext ctxt,
@@ -1443,7 +1442,7 @@ nonAnnotatedParamIndex, ctor);
 
     /*
     /**********************************************************
-    /* JsonDeserializerFactory impl: other types
+    /* DeserializerFactory impl: other types
     /**********************************************************
      */
     
@@ -1461,6 +1460,15 @@ nonAnnotatedParamIndex, ctor);
         JsonDeserializer<?> deser = _findCustomEnumDeserializer(enumClass, config, beanDesc);
 
         if (deser == null) {
+            // 12-Feb-2020, tatu: while we can't really create real deserializer for `Enum.class`,
+            //    it is necessary to allow it in one specific case: see [databind#2605] for details
+            //    but basically it can be used as polymorphic base.
+            //    We could check `type.getTypeHandler()` to look for that case but seems like we
+            //    may as well simply create placeholder (AbstractDeserializer) regardless
+            if (enumClass == Enum.class) {
+                return AbstractDeserializer.constructForNonPOJO(beanDesc);
+            }
+
             ValueInstantiator valueInstantiator = _constructDefaultValueInstantiator(ctxt, beanDesc);
             SettableBeanProperty[] creatorProps = (valueInstantiator == null) ? null
                     : valueInstantiator.getFromObjectArguments(ctxt.getConfig());
@@ -1473,10 +1481,13 @@ nonAnnotatedParamIndex, ctor);
                     }
                     Class<?> returnType = factory.getRawReturnType();
                     // usually should be class, but may be just plain Enum<?> (for Enum.valueOf()?)
-                    if (returnType.isAssignableFrom(enumClass)) {
-                        deser = EnumDeserializer.deserializerForCreator(config, enumClass, factory, valueInstantiator, creatorProps);
-                        break;
+                    if (!returnType.isAssignableFrom(enumClass)) {
+                        ctxt.reportBadDefinition(type, String.format(
+"Invalid `@JsonCreator` annotated Enum factory method [%s]: needs to return compatible type",
+factory.toString()));
                     }
+                    deser = EnumDeserializer.deserializerForCreator(config, enumClass, factory, valueInstantiator, creatorProps);
+                    break;
                 }
             }
            
@@ -1560,7 +1571,7 @@ nonAnnotatedParamIndex, ctor);
 
     /*
     /**********************************************************
-    /* JsonDeserializerFactory impl (partial): type deserializers
+    /* DeserializerFactory impl (partial): type deserializers
     /**********************************************************
      */
 
@@ -1616,22 +1627,23 @@ nonAnnotatedParamIndex, ctor);
     {
         return OptionalHandlerFactory.instance.findDeserializer(type, ctxt.getConfig(), beanDesc);
     }
-    
+
     /*
     /**********************************************************
-    /* JsonDeserializerFactory impl (partial): key deserializers
+    /* DeserializerFactory impl (partial): key deserializers
     /**********************************************************
      */
-    
+
     @Override
     public KeyDeserializer createKeyDeserializer(DeserializationContext ctxt,
             JavaType type)
         throws JsonMappingException
     {
         final DeserializationConfig config = ctxt.getConfig();
+        BeanDescription beanDesc = null;
         KeyDeserializer deser = null;
         if (_factoryConfig.hasKeyDeserializers()) {
-            BeanDescription beanDesc = config.introspectClassAnnotations(type.getRawClass());
+            beanDesc = config.introspectClassAnnotations(type);
             for (KeyDeserializers d  : _factoryConfig.keyDeserializers()) {
                 deser = d.findKeyDeserializer(type, config, beanDesc);
                 if (deser != null) {
@@ -1639,12 +1651,20 @@ nonAnnotatedParamIndex, ctor);
                 }
             }
         }
+
         // the only non-standard thing is this:
         if (deser == null) {
-            if (type.isEnumType()) {
-                deser = _createEnumKeyDeserializer(ctxt, type);
-            } else {
-                deser = StdKeyDeserializers.findStringBasedKeyDeserializer(config, type);
+            // [databind#2452]: Support `@JsonDeserialize(keyUsing = ...)`
+            if (beanDesc == null) {
+                beanDesc = config.introspectClassAnnotations(type.getRawClass());
+            }
+            deser = findKeyDeserializerFromAnnotation(ctxt, beanDesc.getClassInfo());
+            if (deser == null) {
+                if (type.isEnumType()) {
+                    deser = _createEnumKeyDeserializer(ctxt, type);
+                } else {
+                    deser = StdKeyDeserializers.findStringBasedKeyDeserializer(config, type);
+                }
             }
         }
         // and then post-processing
@@ -1682,7 +1702,8 @@ nonAnnotatedParamIndex, ctor);
             }
         }
         EnumResolver enumRes = constructEnumResolver(enumClass, config, beanDesc.findJsonValueAccessor());
-        // May have @JsonCreator for static factory method:
+
+        // May have @JsonCreator for static factory method
         for (AnnotatedMethod factory : beanDesc.getFactoryMethods()) {
             if (_hasCreatorAnnotation(ctxt, factory)) {
                 int argCount = factory.getParameterCount();
@@ -1692,7 +1713,11 @@ nonAnnotatedParamIndex, ctor);
                     if (returnType.isAssignableFrom(enumClass)) {
                         // note: mostly copied from 'EnumDeserializer.deserializerForCreator(...)'
                         if (factory.getRawParameterType(0) != String.class) {
-                            throw new IllegalArgumentException("Parameter #0 type for factory method ("+factory+") not suitable, must be java.lang.String");
+                            // [databind#2725]: Should not error out because (1) there may be good creator
+                            //   method and (2) this method may be valid for "regular" enum value deserialization
+                            // (leaving aside potential for multiple conflicting creators)
+//                            throw new IllegalArgumentException("Parameter #0 type for factory method ("+factory+") not suitable, must be java.lang.String");
+                            continue;
                         }
                         if (config.canOverrideAccessModifiers()) {
                             ClassUtil.checkAndFixAccess(factory.getMember(),
@@ -1711,6 +1736,60 @@ nonAnnotatedParamIndex, ctor);
 
     /*
     /**********************************************************
+    /* DeserializerFactory impl: checking explicitly registered desers
+    /**********************************************************
+     */
+
+    @Override
+    public boolean hasExplicitDeserializerFor(DeserializationConfig config,
+            Class<?> valueType)
+    {
+        // First things first: unpeel Array types as the element type is
+        // what we are interested in -- this because we will always support array
+        // types via composition, and since array types are JDK provided (and hence
+        // can not be custom or customized).
+        while (valueType.isArray()) {
+            valueType = valueType.getComponentType();
+        }
+
+        // Yes, we handle all Enum types
+        if (Enum.class.isAssignableFrom(valueType)) {
+            return true;
+        }
+        // Numbers?
+        final String clsName = valueType.getName();
+        if (clsName.startsWith("java.")) {
+            if (Collection.class.isAssignableFrom(valueType)) {
+                return true;
+            }
+            if (Map.class.isAssignableFrom(valueType)) {
+                return true;
+            }
+            if (Number.class.isAssignableFrom(valueType)) {
+                return NumberDeserializers.find(valueType, clsName) != null;
+            }
+            if (JdkDeserializers.hasDeserializerFor(valueType)
+                    || (valueType == CLASS_STRING)
+                    || (valueType == Boolean.class)
+                    || (valueType == EnumMap.class)
+                    || (valueType == AtomicReference.class)
+                    ) {
+                return true;
+            }
+            if (DateDeserializers.hasDeserializerFor(valueType)) {
+                return true;
+            }
+        } else if (clsName.startsWith("com.fasterxml.")) {
+            return JsonNode.class.isAssignableFrom(valueType)
+                   || (valueType == TokenBuffer.class);
+        } else {
+            return OptionalHandlerFactory.instance.hasDeserializerFor(valueType);
+        }
+        return false;
+    }
+
+    /*
+    /**********************************************************
     /* Extended API
     /**********************************************************
      */
@@ -2025,7 +2104,7 @@ nonAnnotatedParamIndex, ctor);
 
     /**
      * Helper method called to check if a class or method
-     * has annotation that tells which class to use for deserialization.
+     * has annotation that tells which class to use for deserialization of {@link java.util.Map} keys.
      * Returns null if no such annotation found.
      */
     protected KeyDeserializer findKeyDeserializerFromAnnotation(DeserializationContext ctxt,
@@ -2147,7 +2226,7 @@ nonAnnotatedParamIndex, ctor);
         }
         return false;
     }
-    
+
     /*
     /**********************************************************
     /* Deprecated helper methods
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/BeanDeserializerBase.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/BeanDeserializerBase.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/BeanDeserializerBase.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/BeanDeserializerBase.java	2020-06-25 02:44:21.000000000 +0000
@@ -84,9 +84,13 @@ public abstract class BeanDeserializerBa
     protected PropertyBasedCreator _propertyBasedCreator;
 
     /**
-     * Flag that is set to mark "non-standard" cases; where either
-     * we use one of non-default creators, or there are unwrapped
-     * values to consider.
+     * Flag that is set to mark cases where deserialization from Object value
+     * using otherwise "standard" property binding will need to use non-default
+     * creation method: namely, either "full" delegation (array-delegation does
+     * not apply), or properties-based Creator method is used.
+     *<p>
+     * Note that flag is somewhat mis-named as it is not affected by scalar-delegating
+     * creators; it only has effect on Object Value binding.
      */
     protected boolean _nonStandardCreation;
 
@@ -212,9 +216,17 @@ public abstract class BeanDeserializerBa
         _injectables = (injectables == null || injectables.isEmpty()) ? null
                 : injectables.toArray(new ValueInjector[injectables.size()]);
         _objectIdReader = builder.getObjectIdReader();
+
+        // 02-May-2020, tatu: This boolean setting is only used when binding from
+        //    Object value, and hence does not consider "array-delegating" or various
+        //    scalar-delegation cases. It is set when default (0-argument) constructor
+        //    is NOT to be used when binding an Object value (or in case of
+        //    POJO-as-array, Array value).
         _nonStandardCreation = (_unwrappedPropertyHandler != null)
             || _valueInstantiator.canCreateUsingDelegate()
-            || _valueInstantiator.canCreateUsingArrayDelegate() // new in 2.7
+        // [databind#2486]: as per above, array-delegating creator should not be considered
+        //   as doing so will prevent use of Array-or-standard-Object deserialization
+        //            || _valueInstantiator.canCreateUsingArrayDelegate()
             || _valueInstantiator.canCreateFromObjectWith()
             || !_valueInstantiator.canCreateUsingDefault()
             ;
@@ -400,6 +412,18 @@ public abstract class BeanDeserializerBa
 
     public abstract BeanDeserializerBase withIgnorableProperties(Set<String> ignorableProps);
 
+    // NOTE! To be made `abstract` in 2.12 or later
+    /**
+     * @since 2.11
+     */
+    public BeanDeserializerBase withIgnoreAllUnknown(boolean ignoreUnknown) {
+        // Only to prevent some backwards-compatibility issues
+        if (ignoreUnknown == _ignoreAllUnknown) {
+            return this;
+        }
+        return withIgnorableProperties(_ignorableProps);
+    }
+
     /**
      * Mutant factory method that custom sub-classes must override; not left as
      * abstract to prevent more drastic backwards compatibility problems.
@@ -740,6 +764,13 @@ public abstract class BeanDeserializerBa
                     }
                     contextual = contextual.withIgnorableProperties(ignored);
                 }
+                // 30-Mar-2020, tatu: As per [databind#2627], need to also allow
+                //    per-property override to "ignore all unknown".
+                //  NOTE: there is no way to override with `false` because annotation
+                //  defaults to `false` (i.e. can not know if `false` is explicit value)
+                if (ignorals.getIgnoreUnknown() && !_ignoreAllUnknown) {
+                    contextual = contextual.withIgnoreAllUnknown(true);
+                }
             }
         }
 
@@ -1280,8 +1311,12 @@ public abstract class BeanDeserializerBa
     {
         final JsonDeserializer<Object> delegateDeser = _delegateDeserializer();
         if (delegateDeser != null) {
-            return _valueInstantiator.createUsingDelegate(ctxt,
+            final Object bean = _valueInstantiator.createUsingDelegate(ctxt,
                     delegateDeser.deserialize(p, ctxt));
+            if (_injectables != null) {
+                injectValues(ctxt, bean);
+            }
+            return bean;
         }
         if (_propertyBasedCreator != null) {
             return _deserializeUsingPropertyBased(p, ctxt);
@@ -1426,38 +1461,15 @@ public abstract class BeanDeserializerBa
         return _valueInstantiator.createFromBoolean(ctxt, value);
     }
 
-    public Object deserializeFromArray(JsonParser p, DeserializationContext ctxt) throws IOException
-    {
-        // note: cannot call `_delegateDeserializer()` since order reversed here:
-        JsonDeserializer<Object> delegateDeser = _arrayDelegateDeserializer;
-        // fallback to non-array delegate
-        if ((delegateDeser != null) || ((delegateDeser = _delegateDeserializer) != null)) {
-            Object bean = _valueInstantiator.createUsingArrayDelegate(ctxt,
-                    delegateDeser.deserialize(p, ctxt));
-            if (_injectables != null) {
-                injectValues(ctxt, bean);
-            }
-            return bean;
-        }
-        if (ctxt.isEnabled(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS)) {
-            JsonToken t = p.nextToken();
-            if (t == JsonToken.END_ARRAY && ctxt.isEnabled(DeserializationFeature.ACCEPT_EMPTY_ARRAY_AS_NULL_OBJECT)) {
-                return null;
-            }
-            final Object value = deserialize(p, ctxt);
-            if (p.nextToken() != JsonToken.END_ARRAY) {
-                handleMissingEndArrayForSingle(p, ctxt);
-            }
-            return value;
-        }
-        if (ctxt.isEnabled(DeserializationFeature.ACCEPT_EMPTY_ARRAY_AS_NULL_OBJECT)) {
-            JsonToken t = p.nextToken();
-            if (t == JsonToken.END_ARRAY) {
-                return null;
-            }
-            return ctxt.handleUnexpectedToken(getValueType(ctxt), JsonToken.START_ARRAY, p, null);
-        }
-        return ctxt.handleUnexpectedToken(getValueType(ctxt), p);
+    /**
+     * @deprecated Since 2.11 Should not be used: was never meant to be called by
+     *    code other than sub-classes (implementations), and implementations details
+     *    differ
+     */
+    @Deprecated
+    public Object deserializeFromArray(JsonParser p, DeserializationContext ctxt) throws IOException {
+        // should work as subtypes ought to override this method:
+        return _deserializeFromArray(p, ctxt);
     }
 
     public Object deserializeFromEmbedded(JsonParser p, DeserializationContext ctxt)
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/BeanDeserializerBuilder.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/BeanDeserializerBuilder.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/BeanDeserializerBuilder.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/BeanDeserializerBuilder.java	2020-06-25 02:44:21.000000000 +0000
@@ -193,7 +193,9 @@ public class BeanDeserializerBuilder
         // 15-Sep-2016, tatu: For some reason fixing access at point of `build()` does
         //    NOT work (2 failing unit tests). Not 100% clear why, but for now force
         //    access set early; unfortunate, but since it works....
-        prop.fixAccess(_config);
+        if (_config.canOverrideAccessModifiers()) {
+            prop.fixAccess(_config);
+        }
         _backRefProperties.put(referenceName, prop);
         // 16-Jan-2018, tatu: As per [databind#1878] we may want to leave it as is, to allow
         //    population for cases of "wrong direction", traversing parent first
@@ -213,10 +215,8 @@ public class BeanDeserializerBuilder
         if (_injectables == null) {
             _injectables = new ArrayList<ValueInjector>();
         }
-        boolean fixAccess = _config.canOverrideAccessModifiers();
-        boolean forceAccess = fixAccess && _config.isEnabled(MapperFeature.OVERRIDE_PUBLIC_ACCESS_MODIFIERS);
-        if (fixAccess) {
-            member.fixAccess(forceAccess);
+        if ( _config.canOverrideAccessModifiers()) {
+            member.fixAccess(_config.isEnabled(MapperFeature.OVERRIDE_PUBLIC_ACCESS_MODIFIERS));
         }
         _injectables.add(new ValueInjector(propName, propType, member, valueId));
     }
@@ -348,8 +348,7 @@ public class BeanDeserializerBuilder
     {
         Collection<SettableBeanProperty> props = _properties.values();
         _fixAccess(props);
-        BeanPropertyMap propertyMap = BeanPropertyMap.construct(props,
-                _config.isEnabled(MapperFeature.ACCEPT_CASE_INSENSITIVE_PROPERTIES),
+        BeanPropertyMap propertyMap = BeanPropertyMap.construct(_config, props,
                 _collectAliases(props));
         propertyMap.assignIndexes();
 
@@ -425,8 +424,7 @@ public class BeanDeserializerBuilder
         // And if so, we can try building the deserializer
         Collection<SettableBeanProperty> props = _properties.values();
         _fixAccess(props);
-        BeanPropertyMap propertyMap = BeanPropertyMap.construct(props,
-                _config.isEnabled(MapperFeature.ACCEPT_CASE_INSENSITIVE_PROPERTIES),
+        BeanPropertyMap propertyMap = BeanPropertyMap.construct(_config, props,
                 _collectAliases(props));
         propertyMap.assignIndexes();
 
@@ -455,7 +453,7 @@ public class BeanDeserializerBuilder
     /**
      * Extension point for overriding the actual creation of the builder deserializer.
      *
-     * @since 2.10.1 (officially in 2.10.0)
+     * @since 2.11
      */
     protected JsonDeserializer<?> createBuilderBasedDeserializer(JavaType valueType,
             BeanPropertyMap propertyMap, boolean anyViews) {
@@ -484,15 +482,22 @@ public class BeanDeserializerBuilder
             ignorable = Collections.emptySet();
         }
         */
-        for (SettableBeanProperty prop : mainProps) {
-            /*
-            // first: no point forcing access on to-be-ignored properties
-            if (ignorable.contains(prop.getName())) {
-                continue;
+
+        // 17-Jun-2020, tatu: [databind#2760] means we should not force access
+        //   if we are not configured to... at least not "regular" properties
+
+        if (_config.canOverrideAccessModifiers()) {
+            for (SettableBeanProperty prop : mainProps) {
+                /*
+                // first: no point forcing access on to-be-ignored properties
+                if (ignorable.contains(prop.getName())) {
+                    continue;
+                }
+                */
+                prop.fixAccess(_config);
             }
-            */
-            prop.fixAccess(_config);
         }
+
         // 15-Sep-2016, tatu: Access via back-ref properties has been done earlier
         //   as it has to, for some reason, so not repeated here.
 /*        
@@ -502,6 +507,11 @@ public class BeanDeserializerBuilder
             }
         }
         */
+
+        // 17-Jun-2020, tatu: Despite [databind#2760], it seems that methods that
+        //    are explicitly defined (any setter via annotation, builder too) can not
+        //    be left as-is? May reconsider based on feedback
+        
         if (_anySetter != null) {
             _anySetter.fixAccess(_config);
         }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/BeanDeserializerFactory.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/BeanDeserializerFactory.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/BeanDeserializerFactory.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/BeanDeserializerFactory.java	2020-06-25 02:44:21.000000000 +0000
@@ -875,9 +875,8 @@ name, ((AnnotatedParameter) m).getIndex(
         if (ClassUtil.isProxyType(type)) {
             throw new IllegalArgumentException("Cannot deserialize Proxy class "+type.getName()+" as a Bean");
         }
-        /* also: can't deserialize some local classes: static are ok; in-method not;
-         * other non-static inner classes are ok
-         */
+        // also: can't deserialize some local classes: static are ok; in-method not;
+        // other non-static inner classes are ok
         typeStr = ClassUtil.isLocalType(type, true);
         if (typeStr != null) {
             throw new IllegalArgumentException("Cannot deserialize Class "+type.getName()+" (of type "+typeStr+") as a Bean");
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/BeanDeserializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/BeanDeserializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/BeanDeserializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/BeanDeserializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -123,6 +123,11 @@ public class BeanDeserializer
     }
 
     @Override
+    public BeanDeserializerBase withIgnoreAllUnknown(boolean ignoreUnknown) {
+        return new BeanDeserializer(this, ignoreUnknown);
+    }
+
+    @Override
     public BeanDeserializerBase withBeanProperties(BeanPropertyMap props) {
         return new BeanDeserializer(this, props);
     }
@@ -181,8 +186,8 @@ public class BeanDeserializer
             case VALUE_NULL:
                 return deserializeFromNull(p, ctxt);
             case START_ARRAY:
-                // these only work if there's a (delegating) creator...
-                return deserializeFromArray(p, ctxt);
+                // these only work if there's a (delegating) creator, or UNWRAP_SINGLE_ARRAY
+                return _deserializeFromArray(p, ctxt);
             case FIELD_NAME:
             case END_OBJECT: // added to resolve [JACKSON-319], possible related issues
                 if (_vanillaProcessing) {
@@ -324,9 +329,6 @@ public class BeanDeserializer
                 return deserializeWithExternalTypeId(p, ctxt);
             }
             Object bean = deserializeFromObjectUsingNonDefault(p, ctxt);
-            if (_injectables != null) {
-                injectValues(ctxt, bean);
-            }
             /* 27-May-2014, tatu: I don't think view processing would work
              *   at this point, so commenting it out; but leaving in place
              *   just in case I forgot something fundamental...
@@ -485,11 +487,16 @@ public class BeanDeserializer
         // We hit END_OBJECT, so:
         Object bean;
         try {
-            bean =  creator.build(ctxt, buffer);
+            bean = creator.build(ctxt, buffer);
         } catch (Exception e) {
             wrapInstantiationProblem(e, ctxt);
             bean = null; // never gets here
         }
+        // 13-Apr-2020, tatu: [databind#2678] need to handle injection here
+        if (_injectables != null) {
+            injectValues(ctxt, bean);
+        }
+
         if (referrings != null) {
             for (BeanReferring referring : referrings) {
                referring.setBean(bean);
@@ -562,6 +569,41 @@ public class BeanDeserializer
         return ctxt.handleUnexpectedToken(getValueType(ctxt), p);
     }
 
+    @Override
+    protected Object _deserializeFromArray(JsonParser p, DeserializationContext ctxt) throws IOException
+    {
+        // note: cannot call `_delegateDeserializer()` since order reversed here:
+        JsonDeserializer<Object> delegateDeser = _arrayDelegateDeserializer;
+        // fallback to non-array delegate
+        if ((delegateDeser != null) || ((delegateDeser = _delegateDeserializer) != null)) {
+            Object bean = _valueInstantiator.createUsingArrayDelegate(ctxt,
+                    delegateDeser.deserialize(p, ctxt));
+            if (_injectables != null) {
+                injectValues(ctxt, bean);
+            }
+            return bean;
+        }
+        if (ctxt.isEnabled(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS)) {
+            JsonToken t = p.nextToken();
+            if (t == JsonToken.END_ARRAY && ctxt.isEnabled(DeserializationFeature.ACCEPT_EMPTY_ARRAY_AS_NULL_OBJECT)) {
+                return null;
+            }
+            final Object value = deserialize(p, ctxt);
+            if (p.nextToken() != JsonToken.END_ARRAY) {
+                handleMissingEndArrayForSingle(p, ctxt);
+            }
+            return value;
+        }
+        if (ctxt.isEnabled(DeserializationFeature.ACCEPT_EMPTY_ARRAY_AS_NULL_OBJECT)) {
+            JsonToken t = p.nextToken();
+            if (t == JsonToken.END_ARRAY) {
+                return null;
+            }
+            return ctxt.handleUnexpectedToken(getValueType(ctxt), JsonToken.START_ARRAY, p, null);
+        }
+        return ctxt.handleUnexpectedToken(getValueType(ctxt), p);
+    }
+
     /*
     /**********************************************************
     /* Deserializing when we have to consider an active View
@@ -992,7 +1034,10 @@ public class BeanDeserializer
             if (_anySetter != null) {
                 buffer.bufferAnyProperty(_anySetter, propName,
                         _anySetter.deserialize(p, ctxt));
+                continue;
             }
+            // Unknown: let's call handler method
+            handleUnknownProperty(p, ctxt, _valueClass, propName);
         }
         tokens.writeEndObject();
 
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/BuilderBasedDeserializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/BuilderBasedDeserializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/BuilderBasedDeserializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/BuilderBasedDeserializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -137,6 +137,11 @@ public class BuilderBasedDeserializer
     }
 
     @Override
+    public BeanDeserializerBase withIgnoreAllUnknown(boolean ignoreUnknown) {
+        return new BuilderBasedDeserializer(this, ignoreUnknown);
+    }
+
+    @Override
     public BeanDeserializerBase withBeanProperties(BeanPropertyMap props) {
         return new BuilderBasedDeserializer(this, props);
     }
@@ -192,8 +197,7 @@ public class BuilderBasedDeserializer
             if (_vanillaProcessing) {
                 return finishBuild(ctxt, vanillaDeserialize(p, ctxt, t));
             }
-            Object builder = deserializeFromObject(p, ctxt);
-            return finishBuild(ctxt, builder);
+            return finishBuild(ctxt, deserializeFromObject(p, ctxt));
         }
         // and then others, generally requiring use of @JsonCreator
         switch (p.getCurrentTokenId()) {
@@ -209,8 +213,9 @@ public class BuilderBasedDeserializer
         case JsonTokenId.ID_FALSE:
             return finishBuild(ctxt, deserializeFromBoolean(p, ctxt));
         case JsonTokenId.ID_START_ARRAY:
-            // these only work if there's a (delegating) creator...
-            return finishBuild(ctxt, deserializeFromArray(p, ctxt));
+            // these only work if there's a (delegating) creator, or UNWRAP_SINGLE_ARRAY
+            // [databind#2608]: Do NOT call `finishBuild()` as method implements it
+            return _deserializeFromArray(p, ctxt);
         case JsonTokenId.ID_FIELD_NAME:
         case JsonTokenId.ID_END_OBJECT:
             return finishBuild(ctxt, deserializeFromObject(p, ctxt));
@@ -473,6 +478,41 @@ public class BuilderBasedDeserializer
         return builder;
     }
 
+    @Override // since 2.11, custom implementation
+    protected Object _deserializeFromArray(JsonParser p, DeserializationContext ctxt) throws IOException
+    {
+        // note: cannot call `_delegateDeserializer()` since order reversed here:
+        JsonDeserializer<Object> delegateDeser = _arrayDelegateDeserializer;
+        // fallback to non-array delegate
+        if ((delegateDeser != null) || ((delegateDeser = _delegateDeserializer) != null)) {
+            Object builder = _valueInstantiator.createUsingArrayDelegate(ctxt,
+                    delegateDeser.deserialize(p, ctxt));
+            if (_injectables != null) {
+                injectValues(ctxt, builder);
+            }
+            return finishBuild(ctxt, builder);
+        }
+        if (ctxt.isEnabled(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS)) {
+            JsonToken t = p.nextToken();
+            if (t == JsonToken.END_ARRAY && ctxt.isEnabled(DeserializationFeature.ACCEPT_EMPTY_ARRAY_AS_NULL_OBJECT)) {
+                return null;
+            }
+            final Object value = deserialize(p, ctxt);
+            if (p.nextToken() != JsonToken.END_ARRAY) {
+                handleMissingEndArrayForSingle(p, ctxt);
+            }
+            return value;
+        }
+        if (ctxt.isEnabled(DeserializationFeature.ACCEPT_EMPTY_ARRAY_AS_NULL_OBJECT)) {
+            JsonToken t = p.nextToken();
+            if (t == JsonToken.END_ARRAY) {
+                return null;
+            }
+            return ctxt.handleUnexpectedToken(getValueType(ctxt), JsonToken.START_ARRAY, p, null);
+        }
+        return ctxt.handleUnexpectedToken(getValueType(ctxt), p);
+    }
+
     /*
     /**********************************************************
     /* Deserializing when we have to consider an active View
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/CreatorProperty.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/CreatorProperty.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/CreatorProperty.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/CreatorProperty.java	2020-06-25 02:44:21.000000000 +0000
@@ -3,6 +3,7 @@ package com.fasterxml.jackson.databind.d
 import java.io.IOException;
 import java.lang.annotation.Annotation;
 
+import com.fasterxml.jackson.annotation.JacksonInject;
 import com.fasterxml.jackson.core.JsonParser;
 
 import com.fasterxml.jackson.databind.*;
@@ -40,8 +41,10 @@ public class CreatorProperty
     /**
      * Id of value to inject, if value injection should be used for this parameter
      * (in addition to, or instead of, regular deserialization).
+     *
+     * @since 2.11
      */
-    protected final Object _injectableValueId;
+    protected final JacksonInject.Value _injectableValue;
 
     /**
      * In special cases, when implementing "updateValue", we cannot use
@@ -73,8 +76,43 @@ public class CreatorProperty
     protected boolean _ignorable;
 
     /**
+     * @since 2.11
+     */
+    protected CreatorProperty(PropertyName name, JavaType type, PropertyName wrapperName,
+            TypeDeserializer typeDeser,
+            Annotations contextAnnotations, AnnotatedParameter param,
+            int index, JacksonInject.Value injectable,
+            PropertyMetadata metadata)
+    {
+        super(name, type, wrapperName, typeDeser, contextAnnotations, metadata);
+        _annotated = param;
+        _creatorIndex = index;
+        _injectableValue = injectable;
+        _fallbackSetter = null;
+    }
+
+    /**
+     * @deprecated Since 2.11 use factory method instead
+     */
+    @Deprecated // since 2.11
+    public CreatorProperty(PropertyName name, JavaType type, PropertyName wrapperName,
+            TypeDeserializer typeDeser,
+            Annotations contextAnnotations, AnnotatedParameter param,
+            int index, Object injectableValueId,
+            PropertyMetadata metadata)
+    {
+        this(name, type, wrapperName, typeDeser, contextAnnotations, param, index,
+                (injectableValueId == null) ? null
+                        : JacksonInject.Value.construct(injectableValueId, null),
+                metadata);
+    }
+
+    /**
+     * Factory method for creating {@link CreatorProperty} instances
+     *
      * @param name Name of the logical property
      * @param type Type of the property, used to find deserializer
+     * @param wrapperName Possible wrapper to use for logical property, if any
      * @param typeDeser Type deserializer to use for handling polymorphic type
      *    information, if one is needed
      * @param contextAnnotations Contextual annotations (usually by class that
@@ -82,30 +120,28 @@ public class CreatorProperty
      *    this property)
      * @param param Representation of property, constructor or factory
      *    method parameter; used for accessing annotations of the property
+     * @param injectable Information about injectable value, if any
      * @param index Index of this property within creator invocation
      * 
-     * @since 2.3
+     * @since 2.11
      */
-    public CreatorProperty(PropertyName name, JavaType type, PropertyName wrapperName,
+    public static CreatorProperty construct(PropertyName name, JavaType type, PropertyName wrapperName,
             TypeDeserializer typeDeser,
             Annotations contextAnnotations, AnnotatedParameter param,
-            int index, Object injectableValueId,
+            int index, JacksonInject.Value injectable,
             PropertyMetadata metadata)
     {
-        super(name, type, wrapperName, typeDeser, contextAnnotations, metadata);
-        _annotated = param;
-        _creatorIndex = index;
-        _injectableValueId = injectableValueId;
-        _fallbackSetter = null;
+        return new CreatorProperty(name, type, wrapperName, typeDeser, contextAnnotations,
+                param, index, injectable, metadata);
     }
-
+    
     /**
      * @since 2.3
      */
     protected CreatorProperty(CreatorProperty src, PropertyName newName) {
         super(src, newName);
         _annotated = src._annotated;
-        _injectableValueId = src._injectableValueId;
+        _injectableValue = src._injectableValue;
         _fallbackSetter = src._fallbackSetter;
         _creatorIndex = src._creatorIndex;
         _ignorable = src._ignorable;
@@ -115,7 +151,7 @@ public class CreatorProperty
             NullValueProvider nva) {
         super(src, deser, nva);
         _annotated = src._annotated;
-        _injectableValueId = src._injectableValueId;
+        _injectableValue = src._injectableValue;
         _fallbackSetter = src._fallbackSetter;
         _creatorIndex = src._creatorIndex;
         _ignorable = src._ignorable;
@@ -174,26 +210,29 @@ public class CreatorProperty
     /**********************************************************
      */
 
-    /**
-     * Method that can be called to locate value to be injected for this
-     * property, if it is configured for this.
-     */
+    // 14-Apr-2020, tatu: Does not appear to be used so deprecated in 2.11.0,
+    //    to be removed from 2.12.0
+
+    // Method that can be called to locate value to be injected for this
+    // property, if it is configured for this.
+    @Deprecated // remove from 2.12
     public Object findInjectableValue(DeserializationContext context, Object beanInstance)
         throws JsonMappingException
     {
-        if (_injectableValueId == null) {
+        if (_injectableValue == null) {
             context.reportBadDefinition(ClassUtil.classOf(beanInstance),
                     String.format("Property '%s' (type %s) has no injectable value id configured",
                     getName(), getClass().getName()));
         }
-        return context.findInjectableValue(_injectableValueId, this, beanInstance);
+        return context.findInjectableValue(_injectableValue.getId(), this, beanInstance);
     }
 
-    /**
-     * Method to find value to inject, and inject it to this property.
-     */
-    public void inject(DeserializationContext context, Object beanInstance)
-        throws IOException
+    // 14-Apr-2020, tatu: Does not appear to be used so deprecated in 2.11.0,
+    //    to be removed from 2.12.0
+
+    // Method to find value to inject, and inject it to this property.
+    @Deprecated // remove from 2.12
+    public void inject(DeserializationContext context, Object beanInstance) throws IOException
     {
         set(beanInstance, findInjectableValue(context, beanInstance));
     }
@@ -217,10 +256,10 @@ public class CreatorProperty
     @Override public int getCreatorIndex() {
         return _creatorIndex;
     }
-    
+
     /*
     /**********************************************************
-    /* Overridden methods
+    /* Overridden methods, SettableBeanProperty
     /**********************************************************
      */
 
@@ -268,13 +307,33 @@ public class CreatorProperty
         return md;
     }
 
+    // Perhaps counter-intuitively, ONLY creator properties return non-null id
     @Override
     public Object getInjectableValueId() {
-        return _injectableValueId;
+        return (_injectableValue == null) ? null : _injectableValue.getId();
     }
 
     @Override
-    public String toString() { return "[creator property, name '"+getName()+"'; inject id '"+_injectableValueId+"']"; }
+    public boolean isInjectionOnly() {
+        return (_injectableValue != null) && !_injectableValue.willUseInput(true);
+    }
+
+    //  public boolean isInjectionOnly() { return false; }
+
+    /*
+    /**********************************************************
+    /* Overridden methods, other
+    /**********************************************************
+     */
+    
+    @Override
+    public String toString() { return "[creator property, name '"+getName()+"'; inject id '"+getInjectableValueId()+"']"; }
+
+    /*
+    /**********************************************************
+    /* Internal helper methods
+    /**********************************************************
+     */
 
     // since 2.9
     private final void _verifySetter() throws IOException {
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/DeserializationProblemHandler.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/DeserializationProblemHandler.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/DeserializationProblemHandler.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/DeserializationProblemHandler.java	2020-06-25 02:44:21.000000000 +0000
@@ -203,13 +203,12 @@ public abstract class DeserializationPro
 
     /**
      * Deprecated variant of
-     * {@link #handleUnexpectedToken(DeserializationContext, JavaType, JsonToken, JsonParser, String)
+     * {@link #handleUnexpectedToken(DeserializationContext, JavaType, JsonToken, JsonParser, String)}
      *
      * @since 2.8
      *
      * @deprecated Since 2.10
      */
-    @SuppressWarnings("javadoc")
     @Deprecated
     public Object handleUnexpectedToken(DeserializationContext ctxt,
             Class<?> targetType, JsonToken t, JsonParser p,
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/DeserializerCache.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/DeserializerCache.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/DeserializerCache.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/DeserializerCache.java	2020-06-25 02:44:21.000000000 +0000
@@ -363,7 +363,10 @@ public final class DeserializerCache
         throws JsonMappingException
     {
         final DeserializationConfig config = ctxt.getConfig();
-        // If not, let's see which factory method to use:
+        // If not, let's see which factory method to use
+
+        // 12-Feb-20202, tatu: Need to ensure that not only all Enum implementations get
+        //    there, but also `Enum` -- latter wrt [databind#2605], polymorphic usage
         if (type.isEnumType()) {
             return factory.createEnumDeserializer(ctxt, type, beanDesc);
         }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/DeserializerFactory.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/DeserializerFactory.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/DeserializerFactory.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/DeserializerFactory.java	2020-06-25 02:44:21.000000000 +0000
@@ -201,4 +201,25 @@ public abstract class DeserializerFactor
     public abstract TypeDeserializer findTypeDeserializer(DeserializationConfig config,
             JavaType baseType)
         throws JsonMappingException;
+
+    /**
+     * Method that can be used to check if databind module has explicitly declared deserializer
+     * for given (likely JDK) type, explicit meaning that there is specific deserializer for
+     * given type as opposed to auto-generated "Bean" deserializer. Factory itself will check
+     * for known JDK-provided types, but registered {@link com.fasterxml.jackson.databind.Module}s
+     * are also called to see if they might provide explicit deserializer.
+     *<p> 
+     * Main use for this method is with Safe Default Typing (and generally Safe Polymorphic
+     * Deserialization), during which it is good to be able to check that given raw type
+     * is explicitly supported and as such "known type" (as opposed to potentially
+     * dangerous "gadget type" which could be exploited).
+     *<p>
+     * This matches {@code Deserializers.Base.hasDeserializerFor(Class)} method, which is
+     * the mechanism used to determine if a {@code Module} might provide an explicit
+     * deserializer instead of core databind.
+     *
+     * @since 2.11
+     */
+    public abstract boolean hasExplicitDeserializerFor(DeserializationConfig config,
+            Class<?> valueType);
 }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/Deserializers.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/Deserializers.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/Deserializers.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/Deserializers.java	2020-06-25 02:44:21.000000000 +0000
@@ -235,6 +235,9 @@ public interface Deserializers
             TypeDeserializer elementTypeDeserializer, JsonDeserializer<?> elementDeserializer)
         throws JsonMappingException;
 
+    // To be added in 3.0
+//    public boolean hasDeserializerFor(DeserializationConfig config, Class<?> valueType);
+
     /*
     /**********************************************************
     /* Helper classes
@@ -248,7 +251,8 @@ public interface Deserializers
      * of methods are not needed (especially enumeration and array deserializers are
      * very rarely overridden).
      */
-    public static class Base implements Deserializers
+    public abstract static class Base
+        implements Deserializers
     {
         @Override
         public JsonDeserializer<?> findEnumDeserializer(Class<?> type,
@@ -266,14 +270,13 @@ public interface Deserializers
             return null;
         }
 
-        @Override // since 2.7
+        @Override
         public JsonDeserializer<?> findReferenceDeserializer(ReferenceType refType,
                 DeserializationConfig config, BeanDescription beanDesc,
                 TypeDeserializer contentTypeDeserializer, JsonDeserializer<?> contentDeserializer)
-            throws JsonMappingException {
-            // 21-Oct-2015, tatu: For backwards compatibility, let's delegate to "bean" variant,
-            //    for 2.7 -- remove work-around from 2.8 or later
-            return findBeanDeserializer(refType, config, beanDesc);
+            throws JsonMappingException
+        {
+            return null;
         }
         
         @Override
@@ -330,5 +333,25 @@ public interface Deserializers
         {
             return null;
         }
+
+        /**
+         * Method that may be called to check whether this deserializer provider would provide
+         * deserializer for values of given type, without attempting to construct (and possibly
+         * fail in some cases) actual deserializer. Mostly needed to support validation
+         * of polymorphic type ids.
+         *<p>
+         * Note: implementations should take care NOT to claim supporting types that they do
+         * not recognize as this could to incorrect assumption of safe support by caller.
+         *<p>
+         * Method added in this implementation since adding new methods for interfaces
+         * before Java 8 is not a good idea: will be added in Jackson 3.0 for `Deserializers`.
+         *
+         * @since 2.11
+         */
+        public boolean hasDeserializerFor(DeserializationConfig config,
+                Class<?> valueType) {
+            return false;
+        }
+//      public abstract boolean hasDeserializerFor(Class<?> valueType);
     }
 }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/impl/BeanAsArrayBuilderDeserializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/impl/BeanAsArrayBuilderDeserializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/impl/BeanAsArrayBuilderDeserializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/impl/BeanAsArrayBuilderDeserializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -82,6 +82,12 @@ public class BeanAsArrayBuilderDeseriali
     }
 
     @Override
+    public BeanDeserializerBase withIgnoreAllUnknown(boolean ignoreUnknown) {
+        return new BeanAsArrayBuilderDeserializer(_delegate.withIgnoreAllUnknown(ignoreUnknown),
+                _targetType, _orderedProperties, _buildMethod);
+    }
+
+    @Override
     public BeanDeserializerBase withBeanProperties(BeanPropertyMap props) {
         return new BeanAsArrayBuilderDeserializer(_delegate.withBeanProperties(props),
                 _targetType, _orderedProperties, _buildMethod);
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/impl/BeanAsArrayDeserializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/impl/BeanAsArrayDeserializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/impl/BeanAsArrayDeserializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/impl/BeanAsArrayDeserializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -72,6 +72,12 @@ public class BeanAsArrayDeserializer
     }
 
     @Override
+    public BeanDeserializerBase withIgnoreAllUnknown(boolean ignoreUnknown) {
+        return new BeanAsArrayDeserializer(_delegate.withIgnoreAllUnknown(ignoreUnknown),
+                _orderedProperties);
+    }
+
+    @Override
     public BeanDeserializerBase withBeanProperties(BeanPropertyMap props) {
         return new BeanAsArrayDeserializer(_delegate.withBeanProperties(props),
                 _orderedProperties);
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/impl/BeanPropertyMap.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/impl/BeanPropertyMap.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/impl/BeanPropertyMap.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/impl/BeanPropertyMap.java	2020-06-25 02:44:21.000000000 +0000
@@ -10,7 +10,9 @@ import com.fasterxml.jackson.databind.De
 import com.fasterxml.jackson.databind.DeserializationFeature;
 import com.fasterxml.jackson.databind.JsonDeserializer;
 import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.MapperFeature;
 import com.fasterxml.jackson.databind.PropertyName;
+import com.fasterxml.jackson.databind.cfg.MapperConfig;
 import com.fasterxml.jackson.databind.deser.SettableBeanProperty;
 import com.fasterxml.jackson.databind.util.ClassUtil;
 import com.fasterxml.jackson.databind.util.NameTransformer;
@@ -77,18 +79,39 @@ public class BeanPropertyMap
     private final Map<String,String> _aliasMapping;
 
     /**
-     * @since 2.9
+     * We require {@link Locale} since case changes are locale-sensitive in certain
+     * cases (see <a href="https://en.wikipedia.org/wiki/Dotted_and_dotless_I">Turkish I</a>
+     * for example)
+     *
+     * @since 2.11
+     */
+    private final Locale _locale;
+
+    /**
+     * @since 2.11
      */
     public BeanPropertyMap(boolean caseInsensitive, Collection<SettableBeanProperty> props,
-            Map<String,List<PropertyName>> aliasDefs)
+            Map<String,List<PropertyName>> aliasDefs,
+            Locale locale)
     {
         _caseInsensitive = caseInsensitive;
         _propsInOrder = props.toArray(new SettableBeanProperty[props.size()]);
         _aliasDefs = aliasDefs;
-        _aliasMapping = _buildAliasMapping(aliasDefs);
+        _locale = locale;
+        _aliasMapping = _buildAliasMapping(aliasDefs, caseInsensitive, locale);
         init(props);
+
     }
 
+    /**
+     * @deprecated since 2.11
+     */
+    @Deprecated
+    public BeanPropertyMap(boolean caseInsensitive, Collection<SettableBeanProperty> props,
+            Map<String,List<PropertyName>> aliasDefs) {
+        this(caseInsensitive, props, aliasDefs, Locale.getDefault());
+    }
+    
     /* Copy constructors used when a property can replace existing one
      *
      * @since 2.9.6
@@ -98,6 +121,7 @@ public class BeanPropertyMap
     {
         // First, copy most fields as is:
         _caseInsensitive = src._caseInsensitive;
+        _locale = src._locale;
         _hashMask = src._hashMask;
         _size = src._size;
         _spillCount = src._spillCount;
@@ -120,6 +144,7 @@ public class BeanPropertyMap
     {
         // First, copy most fields as is:
         _caseInsensitive = src._caseInsensitive;
+        _locale = src._locale;
         _hashMask = src._hashMask;
         _size = src._size;
         _spillCount = src._spillCount;
@@ -156,7 +181,8 @@ public class BeanPropertyMap
     @Deprecated // since 2.8
     public BeanPropertyMap(boolean caseInsensitive, Collection<SettableBeanProperty> props)
     {
-        this(caseInsensitive, props, Collections.<String,List<PropertyName>>emptyMap());
+        this(caseInsensitive, props, Collections.<String,List<PropertyName>>emptyMap(),
+                Locale.getDefault());
     }
 
     /**
@@ -165,6 +191,7 @@ public class BeanPropertyMap
     protected BeanPropertyMap(BeanPropertyMap base, boolean caseInsensitive)
     {
         _caseInsensitive = caseInsensitive;
+        _locale = base._locale;
         _aliasDefs = base._aliasDefs;
         _aliasMapping = base._aliasMapping;
 
@@ -247,10 +274,22 @@ public class BeanPropertyMap
         }
         return result;
     }
-    
+
+    /**
+     * @since 2.11
+     */
+    public static BeanPropertyMap construct(MapperConfig<?> config,
+            Collection<SettableBeanProperty> props,
+            Map<String,List<PropertyName>> aliasMapping) {
+        return new BeanPropertyMap(config.isEnabled(MapperFeature.ACCEPT_CASE_INSENSITIVE_PROPERTIES),
+                props, aliasMapping,
+                config.getLocale());
+    }
+
     /**
-     * @since 2.6
+     * @deprecated since 2.11
      */
+    @Deprecated
     public static BeanPropertyMap construct(Collection<SettableBeanProperty> props,
             boolean caseInsensitive, Map<String,List<PropertyName>> aliasMapping) {
         return new BeanPropertyMap(caseInsensitive, props, aliasMapping);
@@ -490,7 +529,7 @@ public class BeanPropertyMap
     // Confining this case insensitivity to this function (and the find method) in case we want to
     // apply a particular locale to the lower case function.  For now, using the default.
     protected final String getPropertyName(SettableBeanProperty prop) {
-        return _caseInsensitive ? prop.getName().toLowerCase() : prop.getName();
+        return _caseInsensitive ? prop.getName().toLowerCase(_locale) : prop.getName();
     }
 
     /*
@@ -521,7 +560,7 @@ public class BeanPropertyMap
             throw new IllegalArgumentException("Cannot pass null property name");
         }
         if (_caseInsensitive) {
-            key = key.toLowerCase();
+            key = key.toLowerCase(_locale);
         }
 
         // inlined `_hashCode(key)`
@@ -770,7 +809,8 @@ public class BeanPropertyMap
     }
 
     // @since 2.9
-    private Map<String,String> _buildAliasMapping(Map<String,List<PropertyName>> defs)
+    private Map<String,String> _buildAliasMapping(Map<String,List<PropertyName>> defs,
+            boolean caseInsensitive, Locale loc)
     {
         if ((defs == null) || defs.isEmpty()) {
             return Collections.emptyMap();
@@ -778,13 +818,13 @@ public class BeanPropertyMap
         Map<String,String> aliases = new HashMap<>();
         for (Map.Entry<String,List<PropertyName>> entry : defs.entrySet()) {
             String key = entry.getKey();
-            if (_caseInsensitive) {
-                key = key.toLowerCase();
+            if (caseInsensitive) {
+                key = key.toLowerCase(loc);
             }
             for (PropertyName pn : entry.getValue()) {
                 String mapped = pn.getSimpleName();
-                if (_caseInsensitive) {
-                    mapped = mapped.toLowerCase();
+                if (caseInsensitive) {
+                    mapped = mapped.toLowerCase(loc);
                 }
                 aliases.put(mapped, key);
             }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/impl/PropertyBasedCreator.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/impl/PropertyBasedCreator.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/impl/PropertyBasedCreator.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/impl/PropertyBasedCreator.java	2020-06-25 02:44:21.000000000 +0000
@@ -58,7 +58,7 @@ public final class PropertyBasedCreator
     {
         _valueInstantiator = valueInstantiator;
         if (caseInsensitive) {
-            _propertyLookup = new CaseInsensitiveMap();
+            _propertyLookup = CaseInsensitiveMap.construct(ctxt.getConfig().getLocale());
         } else {
             _propertyLookup = new HashMap<String, SettableBeanProperty>();
         }
@@ -108,7 +108,11 @@ public final class PropertyBasedCreator
         for (int i = 0; i < len; ++i) {
             SettableBeanProperty prop = srcCreatorProps[i];
             if (!prop.hasValueDeserializer()) {
-                prop = prop.withValueDeserializer(ctxt.findContextualValueDeserializer(prop.getType(), prop));
+                // 15-Apr-2020, tatu: [databind#962] Avoid getting deserializer for Inject-only
+                //     cases
+                if (!prop.isInjectionOnly()) {
+                    prop = prop.withValueDeserializer(ctxt.findContextualValueDeserializer(prop.getType(), prop));
+                }
             }
             creatorProps[i] = prop;
         }
@@ -226,14 +230,36 @@ public final class PropertyBasedCreator
     {
         private static final long serialVersionUID = 1L;
 
+        /**
+         * Lower-casing can have Locale-specific minor variations.
+         *
+         * @since 2.11
+         */
+        protected final Locale _locale;
+
+        @Deprecated // since 2.11
+        public CaseInsensitiveMap() {
+            this(Locale.getDefault());
+        }
+
+        // @since 2.11
+        public CaseInsensitiveMap(Locale l) {
+            _locale = l;
+        }
+
+        // @since 2.11
+        public static CaseInsensitiveMap construct(Locale l) {
+            return new CaseInsensitiveMap(l);
+        }
+        
         @Override
         public SettableBeanProperty get(Object key0) {
-            return super.get(((String) key0).toLowerCase());
+            return super.get(((String) key0).toLowerCase(_locale));
         }
 
         @Override
         public SettableBeanProperty put(String key, SettableBeanProperty value) {
-            key = key.toLowerCase();
+            key = key.toLowerCase(_locale);
             return super.put(key, value);
         }
     }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/impl/ValueInjector.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/impl/ValueInjector.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/impl/ValueInjector.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/impl/ValueInjector.java	2020-06-25 02:44:21.000000000 +0000
@@ -44,7 +44,7 @@ public class ValueInjector
     {
         return context.findInjectableValue(_valueId, this, beanInstance);
     }
-    
+
     public void inject(DeserializationContext context, Object beanInstance)
         throws IOException
     {
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/SettableBeanProperty.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/SettableBeanProperty.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/SettableBeanProperty.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/SettableBeanProperty.java	2020-06-25 02:44:21.000000000 +0000
@@ -456,7 +456,19 @@ public abstract class SettableBeanProper
      * value injection.
      */
     public Object getInjectableValueId() { return null; }
-    
+
+    /**
+     * Accessor for checking whether this property is injectable, and if so,
+     * ONLY injectable (will not bind from input).
+     * Currently (2.11) can only return {@code true} for Creator-backed properties.
+     *
+     * @return True if (and only if) property has injector that is also defined NOT
+     *    to bind from input.
+     *
+     * @since 2.11
+     */
+    public boolean isInjectionOnly() { return false; } // overridden by CreatorProperty
+
     /*
     /**********************************************************
     /* Public API
@@ -731,6 +743,9 @@ public abstract class SettableBeanProper
         public Object getInjectableValueId() { return delegate.getInjectableValueId(); }
 
         @Override
+        public boolean isInjectionOnly() { return delegate.isInjectionOnly(); }
+
+        @Override
         public AnnotatedMember getMember() {
             return delegate.getMember();
         }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/AtomicBooleanDeserializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/AtomicBooleanDeserializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/AtomicBooleanDeserializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/AtomicBooleanDeserializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -13,7 +13,7 @@ public class AtomicBooleanDeserializer e
     public AtomicBooleanDeserializer() { super(AtomicBoolean.class); }
 
     @Override
-    public AtomicBoolean deserialize(JsonParser jp, DeserializationContext ctxt) throws IOException {
-        return new AtomicBoolean(_parseBooleanPrimitive(jp, ctxt));
+    public AtomicBoolean deserialize(JsonParser p, DeserializationContext ctxt) throws IOException {
+        return new AtomicBoolean(_parseBooleanPrimitive(ctxt, p, AtomicBoolean.class));
     }
 }
\ No newline at end of file
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/CollectionDeserializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/CollectionDeserializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/CollectionDeserializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/CollectionDeserializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -113,7 +113,6 @@ public class CollectionDeserializer
             JsonDeserializer<?> vd, TypeDeserializer vtd,
             NullValueProvider nuller, Boolean unwrapSingle)
     {
-//if (true) throw new Error();
         return new CollectionDeserializer(_containerType,
                 (JsonDeserializer<Object>) vd, vtd,
                 _valueInstantiator, (JsonDeserializer<Object>) dd,
@@ -190,7 +189,7 @@ _containerType,
             valueTypeDeser = valueTypeDeser.forProperty(property);
         }
         NullValueProvider nuller = findContentNullProvider(ctxt, property, valueDeser);
-        if ( (unwrapSingle != _unwrapSingle)
+        if ((unwrapSingle != _unwrapSingle)
                 || (nuller != _nullProvider)
                 || (delegateDeser != _delegateDeserializer)
                 || (valueDeser != _valueDeserializer)
@@ -237,9 +236,15 @@ _containerType,
         // there is also possibility of "auto-wrapping" of single-element arrays.
         // Hence we only accept empty String here.
         if (p.hasToken(JsonToken.VALUE_STRING)) {
-            String str = p.getText();
-            if (str.length() == 0) {
-                return (Collection<Object>) _valueInstantiator.createFromString(ctxt, str);
+            // 16-May-2020, tatu: As [dataformats-text#199] need to avoid blocking
+            //    check to `isExpectedStartArrayToken()` (needed for CSV in-field array/list logic)
+            // ... alas, trying to do this here leads to 2 unit test regressions so will
+            //   need to figure out safer mechanism.
+//            if (_valueInstantiator.canCreateFromString()) {
+                String str = p.getText();
+                if (str.length() == 0) {
+                    return (Collection<Object>) _valueInstantiator.createFromString(ctxt, str);
+//                }
             }
         }
         return deserialize(p, ctxt, createDefaultInstance(ctxt));
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/DateDeserializers.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/DateDeserializers.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/DateDeserializers.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/DateDeserializers.java	2020-06-25 02:44:21.000000000 +0000
@@ -60,6 +60,11 @@ public class DateDeserializers
         return null;
     }
 
+    // @since 2.11
+    public static boolean hasDeserializerFor(Class<?> rawType) {
+        return _classNames.contains(rawType.getName());
+    }
+
     /*
     /**********************************************************
     /* Intermediate class for Date-based ones
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/EnumDeserializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/EnumDeserializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/EnumDeserializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/EnumDeserializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -168,7 +168,7 @@ public class EnumDeserializer
     public Object deserialize(JsonParser p, DeserializationContext ctxt) throws IOException
     {
         JsonToken curr = p.currentToken();
-        
+
         // Usually should just get string value:
         if (curr == JsonToken.VALUE_STRING || curr == JsonToken.FIELD_NAME) {
             CompactStringObjectMap lookup = ctxt.isEnabled(DeserializationFeature.READ_ENUMS_USING_TO_STRING)
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/EnumMapDeserializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/EnumMapDeserializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/EnumMapDeserializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/EnumMapDeserializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -19,7 +19,7 @@ import com.fasterxml.jackson.databind.ut
  * Deserializer for {@link EnumMap} values.
  * <p>
  * Note: casting within this class is all messed up -- just could not figure out a way
- * to properly deal with recursive definition of "EnumMap&lt;K extends Enum&lt;K&gt;, V&gt;
+ * to properly deal with recursive definition of {@code EnumMap<K extends Enum<K>, V>}
  */
 @SuppressWarnings({ "unchecked", "rawtypes" }) 
 public class EnumMapDeserializer
@@ -124,7 +124,7 @@ public class EnumMapDeserializer
     /* Validation, post-processing (ResolvableDeserializer)
     /**********************************************************
      */
-    
+
     @Override
     public void resolve(DeserializationContext ctxt) throws JsonMappingException
     {
@@ -234,18 +234,34 @@ public class EnumMapDeserializer
             return (EnumMap<?,?>) _valueInstantiator.createUsingDelegate(ctxt,
                     _delegateDeserializer.deserialize(p, ctxt));
         }
-        // Ok: must point to START_OBJECT
-        JsonToken t = p.currentToken();
-        if ((t != JsonToken.START_OBJECT) && (t != JsonToken.FIELD_NAME) && (t != JsonToken.END_OBJECT)) {
-            // (empty) String may be ok however; or single-String-arg ctor
-            if (t == JsonToken.VALUE_STRING) {
-                return (EnumMap<?,?>) _valueInstantiator.createFromString(ctxt, p.getText());
+        // Ok: must point to START_OBJECT (or similar)
+        switch (p.currentTokenId()) {
+        case JsonTokenId.ID_START_OBJECT:
+        case JsonTokenId.ID_END_OBJECT:
+        case JsonTokenId.ID_FIELD_NAME:
+            return deserialize(p, ctxt, constructMap(ctxt));
+        case JsonTokenId.ID_STRING:
+            return (EnumMap<?,?>) _valueInstantiator.createFromString(ctxt, p.getText());
+        case JsonTokenId.ID_START_ARRAY:
+            {
+                JsonToken t = p.nextToken();
+                if (t == JsonToken.END_ARRAY) {
+                    if (ctxt.isEnabled(DeserializationFeature.ACCEPT_EMPTY_ARRAY_AS_NULL_OBJECT)) {
+                        return null;
+                    }
+                } else if (ctxt.isEnabled(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS)) {
+                    final Object value = deserialize(p, ctxt);
+                    if (p.nextToken() != JsonToken.END_ARRAY) {
+                        handleMissingEndArrayForSingle(p, ctxt);
+                    }
+                    return (EnumMap<?,?>) value;
+                }
             }
-            // slightly redundant (since String was passed above), but also handles empty array case:
-            return _deserializeFromEmpty(p, ctxt);
+            return (EnumMap<?,?>) ctxt.handleUnexpectedToken(getValueType(ctxt), JsonToken.START_ARRAY, p, null);
+        default:
         }
-        EnumMap result = constructMap(ctxt);
-        return deserialize(p, ctxt, result);
+        // slightly redundant (since String was passed above), but also handles empty array case:
+        return _deserializeFromEmpty(p, ctxt);
     }
 
     @Override
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/EnumSetDeserializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/EnumSetDeserializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/EnumSetDeserializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/EnumSetDeserializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -11,7 +11,6 @@ import com.fasterxml.jackson.databind.de
 import com.fasterxml.jackson.databind.deser.impl.NullsConstantProvider;
 import com.fasterxml.jackson.databind.jsontype.TypeDeserializer;
 import com.fasterxml.jackson.databind.util.AccessPattern;
-import com.fasterxml.jackson.databind.util.ClassUtil;
 
 /**
  * Standard deserializer for {@link EnumSet}s.
@@ -28,8 +27,6 @@ public class EnumSetDeserializer
 
     protected final JavaType _enumType;
 
-    protected final Class<Enum> _enumClass;
-
     protected JsonDeserializer<Enum<?>> _enumDeserializer;
 
     /**
@@ -67,9 +64,8 @@ public class EnumSetDeserializer
     {
         super(EnumSet.class);
         _enumType = enumType;
-        _enumClass = (Class<Enum>) enumType.getRawClass();
         // sanity check
-        if (!ClassUtil.isEnumType(_enumClass)) {
+        if (!enumType.isEnumType()) {
             throw new IllegalArgumentException("Type "+enumType+" not Java Enum type");
         }
         _enumDeserializer = (JsonDeserializer<Enum<?>>) deser;
@@ -96,7 +92,6 @@ public class EnumSetDeserializer
             JsonDeserializer<?> deser, NullValueProvider nuller, Boolean unwrapSingle) {
         super(base);
         _enumType = base._enumType;
-        _enumClass = base._enumClass;
         _enumDeserializer = (JsonDeserializer<Enum<?>>) deser;
         _nullProvider = nuller;
         _skipNullValues = NullsConstantProvider.isSkipper(nuller);
@@ -250,7 +245,7 @@ public class EnumSetDeserializer
     @SuppressWarnings("unchecked") 
     private EnumSet constructSet()
     {
-        return EnumSet.noneOf(_enumClass);
+        return EnumSet.noneOf((Class<Enum>) _enumType.getRawClass());
     }
 
     @SuppressWarnings("unchecked") 
@@ -267,7 +262,7 @@ public class EnumSetDeserializer
         }
         // First: since `null`s not allowed, slightly simpler...
         if (p.hasToken(JsonToken.VALUE_NULL)) {
-            return (EnumSet<?>) ctxt.handleUnexpectedToken(_enumClass, p);
+            return (EnumSet<?>) ctxt.handleUnexpectedToken(_enumType, p);
         }
         try {
             Enum<?> value = _enumDeserializer.deserialize(p, ctxt);
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/FactoryBasedEnumDeserializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/FactoryBasedEnumDeserializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/FactoryBasedEnumDeserializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/FactoryBasedEnumDeserializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -106,22 +106,35 @@ class FactoryBasedEnumDeserializer
     @Override
     public Object deserialize(JsonParser p, DeserializationContext ctxt) throws IOException
     {
-        Object value = null;
+        Object value;
         if (_deser != null) {
             value = _deser.deserialize(p, ctxt);
         } else if (_hasArgs) {
             JsonToken curr = p.currentToken();
-            //There can be a JSON object passed for deserializing an Enum,
-            //the below case handles it.
-            if (curr == JsonToken.VALUE_STRING || curr == JsonToken.FIELD_NAME) {
-                value = p.getText();
-            } else if ((_creatorProps != null) && p.isExpectedStartObjectToken()) {
+
+            // 30-Mar-2020, tatu: For properties-based one, MUST get JSON Object (before
+            //   2.11, was just assuming match)
+            if (_creatorProps != null) {
+                if (!p.isExpectedStartObjectToken()) {
+                    final JavaType targetType = getValueType(ctxt);
+                    ctxt.reportInputMismatch(targetType,
+"Input mismatch reading Enum %s: properties-based `@JsonCreator` (%s) expects JSON Object (JsonToken.START_OBJECT), got JsonToken.%s",
+ClassUtil.getTypeDescription(targetType), _factory, p.currentToken());
+                }
                 if (_propCreator == null) {
                     _propCreator = PropertyBasedCreator.construct(ctxt, _valueInstantiator, _creatorProps,
                             ctxt.isEnabled(MapperFeature.ACCEPT_CASE_INSENSITIVE_PROPERTIES));
                 }
                 p.nextToken();
                 return deserializeEnumUsingPropertyBased(p, ctxt, _propCreator);
+            }
+
+            // 30-Mar-2020, tatu: Single-arg delegating creators may go through
+            //    here; although not 100% sure why they do not take the first branch
+            if (curr == JsonToken.VALUE_STRING || curr == JsonToken.FIELD_NAME) {
+                value = p.getText();
+            } else if (curr == JsonToken.VALUE_NUMBER_INT) {
+                value = p.getNumberValue();
             } else {
                 value = p.getValueAsString();
             }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/JdkDeserializers.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/JdkDeserializers.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/JdkDeserializers.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/JdkDeserializers.java	2020-06-25 02:44:21.000000000 +0000
@@ -52,4 +52,9 @@ public class JdkDeserializers
         }
         return null;
     }
+
+    // @since 2.11
+    public static boolean hasDeserializerFor(Class<?> rawType) {
+        return _classNames.contains(rawType.getName());
+    }
 }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/JsonLocationInstantiator.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/JsonLocationInstantiator.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/JsonLocationInstantiator.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/JsonLocationInstantiator.java	2020-06-25 02:44:21.000000000 +0000
@@ -41,10 +41,10 @@ public class JsonLocationInstantiator
     }
 
     private static CreatorProperty creatorProp(String name, JavaType type, int index) {
-        return new CreatorProperty(PropertyName.construct(name), type, null,
+        return CreatorProperty.construct(PropertyName.construct(name), type, null,
                 null, null, null, index, null, PropertyMetadata.STD_REQUIRED);
     }
-    
+
     @Override
     public Object createFromObjectWith(DeserializationContext ctxt, Object[] args) {
         return new JsonLocation(args[0], _long(args[1]), _long(args[2]),
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/MapDeserializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/MapDeserializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/MapDeserializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/MapDeserializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -356,8 +356,21 @@ public class MapDeserializer
             if (t == JsonToken.VALUE_STRING) {
                 return (Map<Object,Object>) _valueInstantiator.createFromString(ctxt, p.getText());
             }
-            // slightly redundant (since String was passed above), but also handles empty array case:
-            return _deserializeFromEmpty(p, ctxt);
+            if (t == JsonToken.START_ARRAY) {
+                if (p.nextToken() == JsonToken.END_ARRAY) {
+                    if (ctxt.isEnabled(DeserializationFeature.ACCEPT_EMPTY_ARRAY_AS_NULL_OBJECT)) {
+                        return null;
+                    }
+                } else if (ctxt.isEnabled(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS)) {
+                    final Object value = deserialize(p, ctxt);
+                    if (p.nextToken() != JsonToken.END_ARRAY) {
+                        handleMissingEndArrayForSingle(p, ctxt);
+                    }
+                    return (Map<Object,Object>) value;
+                }
+                // fall through to failing case
+            }
+            return (Map<Object,Object>) ctxt.handleUnexpectedToken(getValueType(ctxt), t, p, null);
         }
         final Map<Object,Object> result = (Map<Object,Object>) _valueInstantiator.createUsingDefault(ctxt);
         if (_standardStringKey) {
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/NumberDeserializers.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/NumberDeserializers.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/NumberDeserializers.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/NumberDeserializers.java	2020-06-25 02:44:21.000000000 +0000
@@ -67,6 +67,11 @@ public class NumberDeserializers
             if (rawType == Float.TYPE) {
                 return FloatDeserializer.primitiveInstance;
             }
+            // [databind#2679]: bit odd place for this (Void.class handled in
+            // `JdkDeserializers`), due to `void` being primitive type
+            if (rawType == Void.TYPE) {
+                return NullifyingDeserializer.instance;
+            }
         } else if (_classNames.contains(clsName)) {
             // Start with most common types; int, boolean, long, double
             if (rawType == Integer.class) {
@@ -108,7 +113,7 @@ public class NumberDeserializers
         // should never occur
         throw new IllegalArgumentException("Internal error: can't find deserializer for "+rawType.getName());
     }
-    
+
     /*
     /**********************************************************
     /* Then one intermediate base class for things that have
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/PrimitiveArrayDeserializers.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/PrimitiveArrayDeserializers.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/PrimitiveArrayDeserializers.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/PrimitiveArrayDeserializers.java	2020-06-25 02:44:21.000000000 +0000
@@ -389,7 +389,7 @@ public abstract class PrimitiveArrayDese
                         _verifyNullForPrimitive(ctxt);
                         value = false;
                     } else {
-                        value = _parseBooleanPrimitive(p, ctxt);
+                        value = _parseBooleanPrimitive(ctxt, p, Boolean.TYPE);
                     }
                     if (ix >= chunk.length) {
                         chunk = builder.appendCompletedChunk(chunk, ix);
@@ -406,7 +406,7 @@ public abstract class PrimitiveArrayDese
         @Override
         protected boolean[] handleSingleElementUnwrapped(JsonParser p,
                 DeserializationContext ctxt) throws IOException {
-            return new boolean[] { _parseBooleanPrimitive(p, ctxt) };
+            return new boolean[] { _parseBooleanPrimitive(ctxt, p, Boolean.TYPE) };
         }
 
         @Override
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/StdDeserializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/StdDeserializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/StdDeserializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/StdDeserializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -50,7 +50,6 @@ public abstract class StdDeserializer<T>
             DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS.getMask() |
             DeserializationFeature.ACCEPT_EMPTY_ARRAY_AS_NULL_OBJECT.getMask();
 
-
     /**
      * Type of values this deserializer handles: sometimes
      * exact types, other time most specific supertype of
@@ -168,7 +167,14 @@ public abstract class StdDeserializer<T>
     /**********************************************************
      */
 
-    protected final boolean _parseBooleanPrimitive(JsonParser p, DeserializationContext ctxt) throws IOException
+    @Deprecated // since 2.11, use overloaded variant
+    protected final boolean _parseBooleanPrimitive(JsonParser p, DeserializationContext ctxt) throws IOException {
+        return _parseBooleanPrimitive(ctxt, p, Boolean.TYPE);
+    }
+
+    // @since 2.11
+    protected final boolean _parseBooleanPrimitive(DeserializationContext ctxt,
+            JsonParser p, Class<?> targetType) throws IOException
     {
         JsonToken t = p.getCurrentToken();
         if (t == JsonToken.VALUE_TRUE) return true;
@@ -196,19 +202,19 @@ public abstract class StdDeserializer<T>
                 _verifyNullForPrimitiveCoercion(ctxt, text);
                 return false;
             }
-            Boolean b = (Boolean) ctxt.handleWeirdStringValue(_valueClass, text,
+            Boolean b = (Boolean) ctxt.handleWeirdStringValue(targetType, text,
                     "only \"true\" or \"false\" recognized");
             return Boolean.TRUE.equals(b);
         }
         // [databind#381]
         if (t == JsonToken.START_ARRAY && ctxt.isEnabled(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS)) {
             p.nextToken();
-            final boolean parsed = _parseBooleanPrimitive(p, ctxt);
+            final boolean parsed = _parseBooleanPrimitive(ctxt, p, targetType);
             _verifyEndArrayForSingle(p, ctxt);
             return parsed;
         }
         // Otherwise, no can do:
-        return ((Boolean) ctxt.handleUnexpectedToken(_valueClass, p)).booleanValue();
+        return ((Boolean) ctxt.handleUnexpectedToken(targetType, p)).booleanValue();
     }
 
     protected boolean _parseBooleanFromInt(JsonParser p, DeserializationContext ctxt)
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/UntypedObjectDeserializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/UntypedObjectDeserializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/deser/std/UntypedObjectDeserializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/deser/std/UntypedObjectDeserializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -4,13 +4,8 @@ import java.io.IOException;
 import java.util.*;
 
 import com.fasterxml.jackson.core.*;
-import com.fasterxml.jackson.databind.BeanProperty;
-import com.fasterxml.jackson.databind.DeserializationConfig;
-import com.fasterxml.jackson.databind.DeserializationContext;
-import com.fasterxml.jackson.databind.DeserializationFeature;
-import com.fasterxml.jackson.databind.JavaType;
-import com.fasterxml.jackson.databind.JsonDeserializer;
-import com.fasterxml.jackson.databind.JsonMappingException;
+
+import com.fasterxml.jackson.databind.*;
 import com.fasterxml.jackson.databind.annotation.JacksonStdImpl;
 import com.fasterxml.jackson.databind.deser.ContextualDeserializer;
 import com.fasterxml.jackson.databind.deser.ResolvableDeserializer;
@@ -313,10 +308,9 @@ public class UntypedObjectDeserializer
 
         case JsonTokenId.ID_EMBEDDED_OBJECT:
             return p.getEmbeddedObject();
-            
-        /* Otherwise we probably got a "native" type (ones that map
-         * naturally and thus do not need or use type ids)
-         */
+
+        // Otherwise we probably got a "native" type (ones that map
+        // naturally and thus do not need or use type ids)
         case JsonTokenId.ID_STRING:
             if (_stringDeserializer != null) {
                 return _stringDeserializer.deserialize(p, ctxt);
@@ -366,8 +360,8 @@ public class UntypedObjectDeserializer
         switch (p.getCurrentTokenId()) {
         case JsonTokenId.ID_START_OBJECT:
         case JsonTokenId.ID_FIELD_NAME:
-            // 28-Oct-2015, tatu: [databind#989] We may also be given END_OBJECT (similar to FIELD_NAME),
-            //    if caller has advanced to the first token of Object, but for empty Object
+            // We may also be given END_OBJECT (similar to FIELD_NAME),
+            // if caller has advanced to the first token of Object, but for empty Object
         case JsonTokenId.ID_END_OBJECT:
             if (_mapDeserializer != null) {
                 return _mapDeserializer.deserialize(p, ctxt, intoValue);
@@ -605,6 +599,10 @@ public class UntypedObjectDeserializer
     /**********************************************************
      */
 
+    /**
+     * Streamlined version of {@link UntypedObjectDeserializer} that has fewer checks and
+     * is only used when no custom deserializer overrides are applied.
+     */
     @JacksonStdImpl
     public static class Vanilla
         extends StdDeserializer<Object>
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/DeserializationContext.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/DeserializationContext.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/DeserializationContext.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/DeserializationContext.java	2020-06-25 02:44:21.000000000 +0000
@@ -60,7 +60,7 @@ public abstract class DeserializationCon
     /* Configuration, immutable
     /**********************************************************
      */
-    
+
     /**
      * Object that handle details of {@link JsonDeserializer} caching.
      */
@@ -155,7 +155,10 @@ public abstract class DeserializationCon
     protected DeserializationContext(DeserializerFactory df,
             DeserializerCache cache)
     {
-        _factory = Objects.requireNonNull(df, "Cannot pass null DeserializerFactory");
+        if (df == null) {
+            throw new NullPointerException("Cannot pass null DeserializerFactory");
+        }
+        _factory = df;
         if (cache == null) {
             cache = new DeserializerCache();
         }
@@ -249,6 +252,18 @@ public abstract class DeserializationCon
         return _config.getTypeFactory();
     }
 
+    @Override // since 2.11
+    public JavaType constructSpecializedType(JavaType baseType, Class<?> subclass)
+        throws IllegalArgumentException
+    {
+        if (baseType.hasRawClass(subclass)) {
+            return baseType;
+        }
+        // On deserialization side, still uses "strict" type-compatibility checking;
+        // see [databind#2632] about serialization side
+        return getConfig().getTypeFactory().constructSpecializedType(baseType, subclass, false);
+    }
+
     /**
      * Method for accessing default Locale to use: convenience method for
      *<pre>
@@ -1049,10 +1064,17 @@ public abstract class DeserializationCon
         // 16-Oct-2016, tatu: This is either a definition problem (if no applicable creator
         //   exists), or input mismatch problem (otherwise) since none of existing creators
         //   match with token.
-        if ((valueInst != null) && !valueInst.canInstantiate()) {
-            msg = String.format("Cannot construct instance of %s (no Creators, like default construct, exist): %s",
+        // 24-Oct-2019, tatu: Further, as per [databind#2522], passing `null` ValueInstantiator
+        //   should simply trigger definition problem
+        if (valueInst == null ) {
+            msg = String.format("Cannot construct instance of %s: %s",
+                    ClassUtil.nameOf(instClass), msg);
+            return reportBadDefinition(instClass, msg);
+        }
+        if (!valueInst.canInstantiate()) {
+            msg = String.format("Cannot construct instance of %s (no Creators, like default constructor, exist): %s",
                     ClassUtil.nameOf(instClass), msg);
-            return reportBadDefinition(constructType(instClass), msg);
+            return reportBadDefinition(instClass, msg);
         }
         msg = String.format("Cannot construct instance of %s (although at least one Creator exists): %s",
                 ClassUtil.nameOf(instClass), msg);
@@ -1213,6 +1235,10 @@ public abstract class DeserializationCon
                         ClassUtil.getTypeDescription(targetType), t);
             }
         }
+        // 18-Jun-2020, tatu: to resolve [databind#2770], force access to `getText()` for scalars
+        if ((t != null) && t.isScalarValue()) {
+            p.getText();
+        }
         reportInputMismatch(targetType, msg);
         return null; // never gets here
     }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/DeserializationFeature.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/DeserializationFeature.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/DeserializationFeature.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/DeserializationFeature.java	2020-06-25 02:44:21.000000000 +0000
@@ -90,9 +90,9 @@ public enum DeserializationFeature imple
     
     /**
      * Feature that determines whether JSON Array is mapped to
-     * <code>Object[]</code> or <code>List&lt;Object&gt;</code> when binding
+     * <code>Object[]</code> or {@code List<Object>} when binding
      * "untyped" objects (ones with nominal type of <code>java.lang.Object</code>).
-     * If true, binds as <code>Object[]</code>; if false, as <code>List&lt;Object&gt;</code>.
+     * If true, binds as <code>Object[]</code>; if false, as {@code List<Object>}.
      *<p>
      * Feature is disabled by default, meaning that JSON arrays are bound as
      * {@link java.util.List}s.
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ext/CoreXMLDeserializers.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ext/CoreXMLDeserializers.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ext/CoreXMLDeserializers.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ext/CoreXMLDeserializers.java	2020-06-25 02:44:21.000000000 +0000
@@ -50,6 +50,14 @@ public class CoreXMLDeserializers extend
         return null;
     }
 
+    @Override // since 2.11
+    public boolean hasDeserializerFor(DeserializationConfig config, Class<?> valueType) {
+        return (valueType == QName.class)
+                || (valueType == XMLGregorianCalendar.class)
+                || (valueType == Duration.class)
+                ;
+    }
+
     /*
     /**********************************************************
     /* Concrete deserializers
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ext/DOMDeserializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ext/DOMDeserializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ext/DOMDeserializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ext/DOMDeserializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -39,6 +39,14 @@ public abstract class DOMDeserializer<T>
             // 14-Jul-2016, tatu: Not sure how or why, but during code coverage runs
             //   (via Cobertura) we get `java.lang.AbstractMethodError` so... ignore that too
         }
+
+        // [databind#2589] add two more settings just in case
+        try {
+            parserFactory.setFeature("http://apache.org/xml/features/disallow-doctype-decl", true);
+        } catch (Throwable t) { } // as per previous one, nothing much to do
+        try {
+            parserFactory.setFeature("http://apache.org/xml/features/nonvalidating/load-external-dtd", false);
+        } catch (Throwable t) { } // as per previous one, nothing much to do
         DEFAULT_PARSER_FACTORY = parserFactory;
     }
 
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ext/OptionalHandlerFactory.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ext/OptionalHandlerFactory.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ext/OptionalHandlerFactory.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ext/OptionalHandlerFactory.java	2020-06-25 02:44:21.000000000 +0000
@@ -146,7 +146,22 @@ public class OptionalHandlerFactory impl
         }
         return ((Deserializers) ob).findBeanDeserializer(type, config, beanDesc);
     }
-    
+
+    public boolean hasDeserializerFor(Class<?> valueType) {
+        if ((CLASS_DOM_NODE != null) && CLASS_DOM_NODE.isAssignableFrom(valueType)) {
+            return true;
+        }
+        if ((CLASS_DOM_DOCUMENT != null) && CLASS_DOM_DOCUMENT.isAssignableFrom(valueType)) {
+            return true;
+        }
+        String className = valueType.getName();
+        if (className.startsWith(PACKAGE_PREFIX_JAVAX_XML)
+                || hasSuperClassStartingWith(valueType, PACKAGE_PREFIX_JAVAX_XML)) {
+            return true;
+        }
+        return false;
+    }
+
     /*
     /**********************************************************
     /* Internal helper methods
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedClass.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedClass.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedClass.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedClass.java	2020-06-25 02:44:21.000000000 +0000
@@ -76,6 +76,11 @@ public final class AnnotatedClass
      */
     final protected Class<?> _primaryMixIn;
 
+    /**
+     * @since 2.11
+     */
+    final protected boolean _collectAnnotations;
+
     /*
     /**********************************************************
     /* Gathered information
@@ -129,7 +134,8 @@ public final class AnnotatedClass
      */
     AnnotatedClass(JavaType type, Class<?> rawType, List<JavaType> superTypes,
             Class<?> primaryMixIn, Annotations classAnnotations, TypeBindings bindings, 
-            AnnotationIntrospector aintr, MixInResolver mir, TypeFactory tf)
+            AnnotationIntrospector aintr, MixInResolver mir, TypeFactory tf,
+            boolean collectAnnotations)
     {
         _type = type;
         _class = rawType;
@@ -140,6 +146,16 @@ public final class AnnotatedClass
         _annotationIntrospector = aintr;
         _mixInResolver = mir;
         _typeFactory = tf;
+        _collectAnnotations = collectAnnotations;
+    }
+
+    @Deprecated // since 2.10
+    AnnotatedClass(JavaType type, Class<?> rawType, List<JavaType> superTypes,
+            Class<?> primaryMixIn, Annotations classAnnotations, TypeBindings bindings, 
+            AnnotationIntrospector aintr, MixInResolver mir, TypeFactory tf)
+    {
+        this(type, rawType, superTypes, primaryMixIn, classAnnotations, bindings,
+                aintr, mir, tf, true);
     }
 
     /**
@@ -158,6 +174,7 @@ public final class AnnotatedClass
         _annotationIntrospector = null;
         _mixInResolver = null;
         _typeFactory = null;
+        _collectAnnotations = false;
     }
 
     /**
@@ -347,7 +364,7 @@ public final class AnnotatedClass
                 f = Collections.emptyList();
             } else {
                 f = AnnotatedFieldCollector.collectFields(_annotationIntrospector,
-                        this, _mixInResolver, _typeFactory, _type);
+                        this, _mixInResolver, _typeFactory, _type, _collectAnnotations);
             }
             _fields = f;
         }
@@ -365,7 +382,7 @@ public final class AnnotatedClass
                 m = AnnotatedMethodCollector.collectMethods(_annotationIntrospector,
                         this,
                         _mixInResolver, _typeFactory,
-                        _type, _superTypes, _primaryMixIn);
+                        _type, _superTypes, _primaryMixIn, _collectAnnotations);
             }
             _memberMethods = m;
         }
@@ -379,7 +396,7 @@ public final class AnnotatedClass
                 c = NO_CREATORS;
             } else {
                 c = AnnotatedCreatorCollector.collectCreators(_annotationIntrospector,
-                        this, _type, _primaryMixIn);
+                        this, _type, _primaryMixIn, _collectAnnotations);
             }
             _creators = c;
         }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedClassResolver.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedClassResolver.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedClassResolver.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedClassResolver.java	2020-06-25 02:44:21.000000000 +0000
@@ -3,8 +3,10 @@ package com.fasterxml.jackson.databind.i
 import java.lang.annotation.Annotation;
 import java.lang.annotation.Retention;
 import java.lang.annotation.Target;
+import java.util.ArrayList;
 import java.util.Collections;
 import java.util.List;
+import java.util.Map;
 
 import com.fasterxml.jackson.databind.AnnotationIntrospector;
 import com.fasterxml.jackson.databind.JavaType;
@@ -24,6 +26,12 @@ public class AnnotatedClassResolver
 {
     private final static Annotations NO_ANNOTATIONS = AnnotationCollector.emptyAnnotations();
 
+    private final static Class<?> CLS_OBJECT = Object.class;
+    private final static Class<?> CLS_ENUM = Enum.class;
+
+    private final static Class<?> CLS_LIST = List.class;
+    private final static Class<?> CLS_MAP = Map.class;
+    
     private final MapperConfig<?> _config;
     private final AnnotationIntrospector _intr;
     private final MixInResolver _mixInResolver;
@@ -33,6 +41,11 @@ public class AnnotatedClassResolver
     private final Class<?> _class;
     private final Class<?> _primaryMixin;
 
+    /**
+     * @since 2.11
+     */
+    private final boolean _collectAnnotations;
+
     AnnotatedClassResolver(MapperConfig<?> config, JavaType type, MixInResolver r) {
         _config = config;
         _type = type;
@@ -41,7 +54,12 @@ public class AnnotatedClassResolver
         _bindings = type.getBindings();
         _intr = config.isAnnotationProcessingEnabled()
                 ? config.getAnnotationIntrospector() : null;
-        _primaryMixin = _config.findMixInClassFor(_class);
+        _primaryMixin = (r == null) ? null : r.findMixInClassFor(_class);
+
+        // Also... JDK types do not have annotations that are of interest to us
+        // At least JDK container types
+        _collectAnnotations = (_intr != null) &&
+                (!ClassUtil.isJDKClass(_class) || !_type.isContainerType());
     }
 
     AnnotatedClassResolver(MapperConfig<?> config, Class<?> cls, MixInResolver r) {
@@ -56,8 +74,10 @@ public class AnnotatedClassResolver
         } else {
             _intr = config.isAnnotationProcessingEnabled()
                     ? config.getAnnotationIntrospector() : null;
-            _primaryMixin = _config.findMixInClassFor(_class);
+            _primaryMixin = (r == null) ? null : r.findMixInClassFor(_class);
         }
+
+        _collectAnnotations = (_intr != null);
     }
 
     public static AnnotatedClass resolve(MapperConfig<?> config, JavaType forType,
@@ -93,7 +113,6 @@ public class AnnotatedClassResolver
 
     private static boolean skippableArray(MapperConfig<?> config, Class<?> type) {
         return (config == null) || (config.findMixInClassFor(type) == null);
-                
     }
 
     /**
@@ -113,10 +132,19 @@ public class AnnotatedClassResolver
     }
 
     AnnotatedClass resolveFully() {
-        List<JavaType> superTypes = ClassUtil.findSuperTypes(_type, null, false);
+        List<JavaType> superTypes = new ArrayList<JavaType>(8);
+        if (!_type.hasRawClass(Object.class)) {
+            if (_type.isInterface()) {
+                _addSuperInterfaces(_type, superTypes, false);
+            } else {
+                _addSuperTypes(_type, superTypes, false);
+            }
+        }
+//System.err.println("resolveFully("+_type.getRawClass().getSimpleName()+") ("+superTypes.size()+") -> "+superTypes);
         return new AnnotatedClass(_type, _class, superTypes, _primaryMixin,
                 resolveClassAnnotations(superTypes),
-                _bindings, _intr, _mixInResolver, _config.getTypeFactory());
+                _bindings, _intr, _mixInResolver, _config.getTypeFactory(),
+                _collectAnnotations);
 
     }
 
@@ -124,9 +152,62 @@ public class AnnotatedClassResolver
         List<JavaType> superTypes = Collections.<JavaType>emptyList();
         return new AnnotatedClass(null, _class, superTypes, _primaryMixin,
                 resolveClassAnnotations(superTypes),
-                _bindings, _intr, _config, _config.getTypeFactory());
+                _bindings, _intr, _mixInResolver, _config.getTypeFactory(),
+                _collectAnnotations);
+    }
+
+    private static void _addSuperTypes(JavaType type, List<JavaType> result,
+            boolean addClassItself)
+    {
+        final Class<?> cls = type.getRawClass();
+        // 15-Oct-2019, tatu: certain paths do not lead to useful information, so prune
+        //    as optimization
+        if ((cls == CLS_OBJECT) || (cls == CLS_ENUM)) {
+            return;
+        }
+        if (addClassItself) {
+            if (_contains(result, cls)) { // already added, no need to check supers
+                return;
+            }
+            result.add(type);
+        }
+        for (JavaType intCls : type.getInterfaces()) {
+            _addSuperInterfaces(intCls, result, true);
+        }
+        final JavaType superType = type.getSuperClass();
+        if (superType != null) {
+            _addSuperTypes(superType, result, true);
+        }
+    }
+
+    private static void _addSuperInterfaces(JavaType type, List<JavaType> result,
+            boolean addClassItself)
+    {
+        final Class<?> cls = type.getRawClass();
+        if (addClassItself) {
+            if (_contains(result, cls)) { // already added, no need to check supers
+                return;
+            }
+            result.add(type);
+            // 30-Oct-2019, tatu: Further, no point going beyond some containers
+            if ((cls == CLS_LIST) || (cls == CLS_MAP)) {
+                return;
+            }
+        }
+        for (JavaType intCls : type.getInterfaces()) {
+            _addSuperInterfaces(intCls, result, true);
+        }
     }
 
+    private static boolean _contains(List<JavaType> found, Class<?> raw) {
+        for (int i = 0, end = found.size(); i < end; ++i) {
+            if (found.get(i).getRawClass() == raw) {
+                return true;
+            }
+        }
+        return false;
+    }
+    
     /*
     /**********************************************************
     /* Class annotation resolution
@@ -144,33 +225,48 @@ public class AnnotatedClassResolver
         if (_intr == null) {
             return NO_ANNOTATIONS;
         }
+        // Plus we may or may not have mix-ins to consider
+        final boolean checkMixIns = (_mixInResolver != null)
+                && (!(_mixInResolver instanceof SimpleMixInResolver)
+                        || ((SimpleMixInResolver) _mixInResolver).hasMixIns());
+
+        // also skip if there's nothing to do
+        if (!checkMixIns && !_collectAnnotations) {
+            return NO_ANNOTATIONS;
+        }
+
         AnnotationCollector resolvedCA = AnnotationCollector.emptyCollector();
         // add mix-in annotations first (overrides)
         if (_primaryMixin != null) {
             resolvedCA = _addClassMixIns(resolvedCA, _class, _primaryMixin);
         }
         // then annotations from the class itself:
-        resolvedCA = _addAnnotationsIfNotPresent(resolvedCA,
-                ClassUtil.findClassAnnotations(_class));
+        // 06-Oct-2019, tatu: [databind#2464] Skip class annotations for JDK classes
+        if (_collectAnnotations) {
+            resolvedCA = _addAnnotationsIfNotPresent(resolvedCA,
+                    ClassUtil.findClassAnnotations(_class));
+        }
 
         // and then from super types
         for (JavaType type : superTypes) {
             // and mix mix-in annotations in-between
-            if (_mixInResolver != null) {
+            if (checkMixIns) {
                 Class<?> cls = type.getRawClass();
                 resolvedCA = _addClassMixIns(resolvedCA, cls,
                         _mixInResolver.findMixInClassFor(cls));
             }
-            resolvedCA = _addAnnotationsIfNotPresent(resolvedCA,
-                    ClassUtil.findClassAnnotations(type.getRawClass()));
+            if (_collectAnnotations) {
+                resolvedCA = _addAnnotationsIfNotPresent(resolvedCA,
+                        ClassUtil.findClassAnnotations(type.getRawClass()));
+            }
         }
-        /* and finally... any annotations there might be for plain
-         * old Object.class: separate because for all other purposes
-         * it is just ignored (not included in super types)
-         */
+
+        // and finally... any annotations there might be for plain old Object.class:
+        // separate because otherwise it is just ignored (not included in super types)
+
         // 12-Jul-2009, tatu: Should this be done for interfaces too?
         //  For now, yes, seems useful for some cases, and not harmful for any?
-        if (_mixInResolver != null) {
+        if (checkMixIns) {
             resolvedCA = _addClassMixIns(resolvedCA, Object.class,
                     _mixInResolver.findMixInClassFor(Object.class));
         }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedCreatorCollector.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedCreatorCollector.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedCreatorCollector.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedCreatorCollector.java	2020-06-25 02:44:21.000000000 +0000
@@ -27,23 +27,32 @@ final class AnnotatedCreatorCollector
 
     private final TypeResolutionContext _typeContext;
 
+    /**
+     * @since 2.11
+     */
+    private final boolean _collectAnnotations;
+
     // // // Collected state
 
     private AnnotatedConstructor _defaultConstructor;
 
     AnnotatedCreatorCollector(AnnotationIntrospector intr,
-            TypeResolutionContext tc)
+            TypeResolutionContext tc, boolean collectAnnotations)
     {
         super(intr);
         _typeContext = tc;
+        _collectAnnotations = collectAnnotations;
     }
 
     public static Creators collectCreators(AnnotationIntrospector intr,
             TypeResolutionContext tc, 
-            JavaType type, Class<?> primaryMixIn)
+            JavaType type, Class<?> primaryMixIn, boolean collectAnnotations)
     {
+        final boolean checkClassAnnotations = (intr != null)
+                && !ClassUtil.isJDKClass(type.getRawClass());
+
         // Constructor also always members of resolved class, parent == resolution context
-        return new AnnotatedCreatorCollector(intr, tc)
+        return new AnnotatedCreatorCollector(intr, tc, checkClassAnnotations)
                 .collect(type, primaryMixIn);
     }
 
@@ -60,7 +69,7 @@ final class AnnotatedCreatorCollector
          * ignorable after all annotations have been properly collapsed.
          */
         // AnnotationIntrospector is null if annotations not enabled; if so, can skip:
-        if (_intr != null) {
+        if (_collectAnnotations) {
             if (_defaultConstructor != null) {
                 if (_intr.hasIgnoreMarker(_defaultConstructor)) {
                     _defaultConstructor = null;
@@ -202,7 +211,7 @@ final class AnnotatedCreatorCollector
         // so far so good; but do we also need to find mix-ins overrides?
         if (primaryMixIn != null) {
             MemberKey[] methodKeys = null;
-            for (Method mixinFactory : ClassUtil.getDeclaredMethods(primaryMixIn)) {
+            for (Method mixinFactory : primaryMixIn.getDeclaredMethods()) {
                 if (!Modifier.isStatic(mixinFactory.getModifiers())) {
                     continue;
                 }
@@ -236,10 +245,6 @@ final class AnnotatedCreatorCollector
     protected AnnotatedConstructor constructDefaultConstructor(ClassUtil.Ctor ctor,
             ClassUtil.Ctor mixin)
     {
-        if (_intr == null) { // when annotation processing is disabled
-            return new AnnotatedConstructor(_typeContext, ctor.getConstructor(),
-                    _emptyAnnotationMap(), NO_ANNOTATION_MAPS);
-        }
         return new AnnotatedConstructor(_typeContext, ctor.getConstructor(),
                 collectAnnotations(ctor, mixin),
                 // 16-Jun-2019, tatu: default is zero-args, so can't have parameter annotations
@@ -320,27 +325,33 @@ ctor.getDeclaringClass().getName(), para
     }
 
     private AnnotationMap[] collectAnnotations(Annotation[][] mainAnns, Annotation[][] mixinAnns) {
-        final int count = mainAnns.length;
-        AnnotationMap[] result = new AnnotationMap[count];
-        for (int i = 0; i < count; ++i) {
-            AnnotationCollector c = collectAnnotations(AnnotationCollector.emptyCollector(),
-                    mainAnns[i]);
-            if (mixinAnns != null) {
-                c = collectAnnotations(c, mixinAnns[i]);
+        if (_collectAnnotations) {
+            final int count = mainAnns.length;
+            AnnotationMap[] result = new AnnotationMap[count];
+            for (int i = 0; i < count; ++i) {
+                AnnotationCollector c = collectAnnotations(AnnotationCollector.emptyCollector(),
+                        mainAnns[i]);
+                if (mixinAnns != null) {
+                    c = collectAnnotations(c, mixinAnns[i]);
+                }
+                result[i] = c.asAnnotationMap();
             }
-            result[i] = c.asAnnotationMap();
+            return result;
         }
-        return result;
+        return NO_ANNOTATION_MAPS;
     }
 
     // // NOTE: these are only called when we know we have AnnotationIntrospector
-    
+
     private AnnotationMap collectAnnotations(ClassUtil.Ctor main, ClassUtil.Ctor mixin) {
-        AnnotationCollector c = collectAnnotations(main.getConstructor().getDeclaredAnnotations());
-        if (mixin != null) {
-            c = collectAnnotations(c, mixin.getConstructor().getDeclaredAnnotations());
+        if (_collectAnnotations) {
+            AnnotationCollector c = collectAnnotations(main.getDeclaredAnnotations());
+            if (mixin != null) {
+                c = collectAnnotations(c, mixin.getDeclaredAnnotations());
+            }
+            return c.asAnnotationMap();
         }
-        return c.asAnnotationMap();
+        return _emptyAnnotationMap();
     }
 
     private final AnnotationMap collectAnnotations(AnnotatedElement main, AnnotatedElement mixin) {
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedFieldCollector.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedFieldCollector.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedFieldCollector.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedFieldCollector.java	2020-06-25 02:44:21.000000000 +0000
@@ -18,22 +18,29 @@ public class AnnotatedFieldCollector
     private final TypeFactory _typeFactory;
     private final MixInResolver _mixInResolver;
 
+    /**
+     * @since 2.11
+     */
+    private final boolean _collectAnnotations;
+
     // // // Collected state
 
     AnnotatedFieldCollector(AnnotationIntrospector intr,
-            TypeFactory types, MixInResolver mixins)
+            TypeFactory types, MixInResolver mixins, boolean collectAnnotations)
     {
         super(intr);
         _typeFactory = types;
         _mixInResolver = (intr == null) ? null : mixins;
+        _collectAnnotations = collectAnnotations;
     }
 
     public static List<AnnotatedField> collectFields(AnnotationIntrospector intr,
             TypeResolutionContext tc,
             MixInResolver mixins, TypeFactory types,
-            JavaType type)
+            JavaType type, boolean collectAnnotations)
     {
-        return new AnnotatedFieldCollector(intr, types, mixins).collect(tc, type);
+        return new AnnotatedFieldCollector(intr, types, mixins, collectAnnotations)
+                .collect(tc, type);
     }
 
     List<AnnotatedField> collect(TypeResolutionContext tc, JavaType type)
@@ -63,7 +70,7 @@ public class AnnotatedFieldCollector
         // Let's add super-class' fields first, then ours.
         fields = _findFields(new TypeResolutionContext.Basic(_typeFactory, parent.getBindings()),
                 parent, fields);
-        for (Field f : ClassUtil.getDeclaredFields(cls)) {
+        for (Field f : cls.getDeclaredFields()) {
             // static fields not included (transients are at this point, filtered out later)
             if (!_isIncludableField(f)) {
                 continue;
@@ -75,7 +82,7 @@ public class AnnotatedFieldCollector
                 fields = new LinkedHashMap<>();
             }
             FieldBuilder b = new FieldBuilder(tc, f);
-            if (_intr != null) {
+            if (_collectAnnotations) {
                 b.annotations = collectAnnotations(b.annotations, f.getDeclaredAnnotations());
             }
             fields.put(f.getName(), b);
@@ -100,7 +107,7 @@ public class AnnotatedFieldCollector
     {
         List<Class<?>> parents = ClassUtil.findSuperClasses(mixInCls, targetClass, true);
         for (Class<?> mixin : parents) {
-            for (Field mixinField : ClassUtil.getDeclaredFields(mixin)) {
+            for (Field mixinField : mixin.getDeclaredFields()) {
                 // there are some dummy things (static, synthetic); better ignore
                 if (!_isIncludableField(mixinField)) {
                     continue;
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedField.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedField.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedField.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedField.java	2020-06-25 02:44:21.000000000 +0000
@@ -75,12 +75,6 @@ public final class AnnotatedField
         return _field.getType();
     }
 
-    @Deprecated
-    @Override
-    public Type getGenericType() {
-        return _field.getGenericType();
-    }
-    
     @Override
     public JavaType getType() {
         return _typeContext.resolveType(_field.getGenericType());
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/Annotated.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/Annotated.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/Annotated.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/Annotated.java	2020-06-25 02:44:21.000000000 +0000
@@ -3,10 +3,8 @@ package com.fasterxml.jackson.databind.i
 import java.lang.annotation.Annotation;
 import java.lang.reflect.AnnotatedElement;
 import java.lang.reflect.Modifier;
-import java.lang.reflect.Type;
 
 import com.fasterxml.jackson.databind.JavaType;
-import com.fasterxml.jackson.databind.type.TypeBindings;
 
 /**
  * Shared base class used for anything on which annotations (included
@@ -49,28 +47,6 @@ public abstract class Annotated
     public abstract JavaType getType();
 
     /**
-     * @deprecated Since 2.7 Use {@link #getType()} instead. To be removed from 2.9
-     */
-    @Deprecated
-    public final JavaType getType(TypeBindings bogus) {
-        return getType();
-    }
-
-    /**
-     * JDK declared generic type of the annotated element; definition
-     * of what exactly this means depends on sub-class. Note that such type
-     * cannot be reliably resolved without {@link TypeResolutionContext}, and
-     * as a result use of this method was deprecated in Jackson 2.7: see
-     * {@link #getType} for replacement.
-     *
-     * @deprecated Since 2.7 should instead use {@link #getType()}. To be removed from 2.9
-     */
-    @Deprecated
-    public Type getGenericType() {
-        return getRawType();
-    }
-
-    /**
      * "Raw" type (type-erased class) of the annotated element; definition
      * of what exactly this means depends on sub-class.
      */
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedMethodCollector.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedMethodCollector.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedMethodCollector.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedMethodCollector.java	2020-06-25 02:44:21.000000000 +0000
@@ -16,20 +16,27 @@ public class AnnotatedMethodCollector
 {
     private final MixInResolver _mixInResolver;
 
+    /**
+     * @since 2.11
+     */
+    private final boolean _collectAnnotations;
+
     AnnotatedMethodCollector(AnnotationIntrospector intr,
-            MixInResolver mixins)
+            MixInResolver mixins, boolean collectAnnotations)
     {
         super(intr);
         _mixInResolver = (intr == null) ? null : mixins;
+        _collectAnnotations = collectAnnotations;
     }
 
     public static AnnotatedMethodMap collectMethods(AnnotationIntrospector intr,
             TypeResolutionContext tc,
             MixInResolver mixins, TypeFactory types,
-            JavaType type, List<JavaType> superTypes, Class<?> primaryMixIn)
+            JavaType type, List<JavaType> superTypes, Class<?> primaryMixIn,
+            boolean collectAnnotations)
     {
         // Constructor also always members of resolved class, parent == resolution context
-        return new AnnotatedMethodCollector(intr, mixins)
+        return new AnnotatedMethodCollector(intr, mixins, collectAnnotations)
                 .collect(types, tc, type, superTypes, primaryMixIn);
     }
 
@@ -118,7 +125,7 @@ public class AnnotatedMethodCollector
                         : collectAnnotations(m.getDeclaredAnnotations());
                 methods.put(key, new MethodBuilder(tc, m, c));
             } else {
-                if (_intr != null) {
+                if (_collectAnnotations) {
                     b.annotations = collectDefaultAnnotations(b.annotations, m.getDeclaredAnnotations());
                 }
                 Method old = b.method;
@@ -149,7 +156,7 @@ public class AnnotatedMethodCollector
             return;
         }
         for (Class<?> mixin : ClassUtil.findRawSuperTypes(mixInCls, targetClass, true)) {
-            for (Method m : ClassUtil.getDeclaredMethods(mixin)) {
+            for (Method m : mixin.getDeclaredMethods()) {
                 if (!_isIncludableMemberMethod(m)) {
                     continue;
                 }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedMethod.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedMethod.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedMethod.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedMethod.java	2020-06-25 02:44:21.000000000 +0000
@@ -87,12 +87,6 @@ public final class AnnotatedMethod
         return _method.getReturnType();
     }
 
-    @Deprecated
-    @Override
-    public Type getGenericType() {
-        return _method.getGenericReturnType();
-    }
-
     /*
     /*****************************************************
     /* AnnotatedWithParams
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedParameter.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedParameter.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedParameter.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotatedParameter.java	2020-06-25 02:44:21.000000000 +0000
@@ -93,12 +93,6 @@ public final class AnnotatedParameter
         return _type;
     }
 
-    @Deprecated
-    @Override
-    public Type getGenericType() {
-        return _owner.getGenericParameterType(_index);
-    }
-
     /*
     /**********************************************************
     /* AnnotatedMember extras
@@ -112,9 +106,8 @@ public final class AnnotatedParameter
 
     @Override
     public Member getMember() {
-        /* This is bit tricky: since there is no JDK equivalent; can either
-         * return null or owner... let's do latter, for now.
-         */
+        // This is bit tricky: since there is no JDK equivalent; can either
+        // return null or owner... let's do latter, for now.
         return _owner.getMember();
     }
 
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotationIntrospectorPair.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotationIntrospectorPair.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotationIntrospectorPair.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/AnnotationIntrospectorPair.java	2020-06-25 02:44:21.000000000 +0000
@@ -520,6 +520,16 @@ public class AnnotationIntrospectorPair
         return res;
     }
 
+    @Override // since 2.11
+    public PropertyName findRenameByField(MapperConfig<?> config,
+            AnnotatedField f, PropertyName implName) {
+        PropertyName n = _secondary.findRenameByField(config, f, implName);
+        if (n == null) {
+            n = _primary.findRenameByField(config, f, implName);
+        }
+        return n;
+    }
+
     // // // Serialization: type refinements
 
     @Override // since 2.7
@@ -617,6 +627,13 @@ public class AnnotationIntrospectorPair
     }
 
     @Override
+    public void findEnumAliases(Class<?> enumType, Enum<?>[] enumValues, String[][] aliases) {
+        // reverse order to give _primary higher precedence
+        _secondary.findEnumAliases(enumType, enumValues, aliases);
+        _primary.findEnumAliases(enumType, enumValues, aliases);
+    }
+
+    @Override
     public Enum<?> findDefaultEnumValue(Class<Enum<?>> enumCls) {
         Enum<?> en = _primary.findDefaultEnumValue(enumCls);
         return (en == null) ? _secondary.findDefaultEnumValue(enumCls) : en;
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/BasicClassIntrospector.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/BasicClassIntrospector.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/BasicClassIntrospector.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/BasicClassIntrospector.java	2020-06-25 02:44:21.000000000 +0000
@@ -6,18 +6,22 @@ import java.util.Map;
 import com.fasterxml.jackson.databind.AnnotationIntrospector;
 import com.fasterxml.jackson.databind.DeserializationConfig;
 import com.fasterxml.jackson.databind.JavaType;
+import com.fasterxml.jackson.databind.JsonNode;
 import com.fasterxml.jackson.databind.SerializationConfig;
 import com.fasterxml.jackson.databind.annotation.JsonPOJOBuilder;
 import com.fasterxml.jackson.databind.cfg.MapperConfig;
 import com.fasterxml.jackson.databind.type.SimpleType;
 import com.fasterxml.jackson.databind.util.ClassUtil;
-import com.fasterxml.jackson.databind.util.LRUMap;
 
 public class BasicClassIntrospector
     extends ClassIntrospector
     implements java.io.Serializable
 {
-    private static final long serialVersionUID = 1L;
+    private static final long serialVersionUID = 2L;
+
+    private final static Class<?> CLS_OBJECT = Object.class;
+    private final static Class<?> CLS_STRING = String.class;
+    private final static Class<?> CLS_JSON_NODE = JsonNode.class;
 
     /* We keep a small set of pre-constructed descriptions to use for
      * common non-structured values, such as Numbers and Strings.
@@ -30,7 +34,7 @@ public class BasicClassIntrospector
     protected final static BasicBeanDescription STRING_DESC;
     static {
         STRING_DESC = BasicBeanDescription.forOtherUse(null, SimpleType.constructUnsafe(String.class),
-                AnnotatedClassResolver.createPrimordial(String.class));
+                AnnotatedClassResolver.createPrimordial(CLS_STRING));
     }
     protected final static BasicBeanDescription BOOLEAN_DESC;
     static {
@@ -47,6 +51,11 @@ public class BasicClassIntrospector
         LONG_DESC = BasicBeanDescription.forOtherUse(null, SimpleType.constructUnsafe(Long.TYPE),
                 AnnotatedClassResolver.createPrimordial(Long.TYPE));
     }
+    protected final static BasicBeanDescription OBJECT_DESC;
+    static {
+        OBJECT_DESC = BasicBeanDescription.forOtherUse(null, SimpleType.constructUnsafe(Object.class),
+                AnnotatedClassResolver.createPrimordial(CLS_OBJECT));
+    }
 
     /*
     /**********************************************************
@@ -54,17 +63,7 @@ public class BasicClassIntrospector
     /**********************************************************
      */
 
-    /**
-     * Looks like 'forClassAnnotations()' gets called so frequently that we
-     * should consider caching to avoid some of the lookups.
-     * 
-     * @since 2.5
-     */
-    protected final LRUMap<JavaType,BasicBeanDescription> _cachedFCA;
-
     public BasicClassIntrospector() {
-        // a small cache should go a long way here
-        _cachedFCA = new LRUMap<JavaType,BasicBeanDescription>(16, 64);
     }
 
     @Override
@@ -79,73 +78,64 @@ public class BasicClassIntrospector
      */
 
     @Override
-    public BasicBeanDescription forSerialization(SerializationConfig cfg,
+    public BasicBeanDescription forSerialization(SerializationConfig config,
             JavaType type, MixInResolver r)
     {
         // minor optimization: for some JDK types do minimal introspection
-        BasicBeanDescription desc = _findStdTypeDesc(type);
+        BasicBeanDescription desc = _findStdTypeDesc(config, type);
         if (desc == null) {
             // As per [databind#550], skip full introspection for some of standard
             // structured types as well
-            desc = _findStdJdkCollectionDesc(cfg, type);
+            desc = _findStdJdkCollectionDesc(config, type);
             if (desc == null) {
-                desc = BasicBeanDescription.forSerialization(collectProperties(cfg,
+                desc = BasicBeanDescription.forSerialization(collectProperties(config,
                         type, r, true, "set"));
             }
-            // Also: this is a superset of "forClassAnnotations", so may optimize by optional add:
-            _cachedFCA.putIfAbsent(type, desc);
         }
         return desc;
     }
 
     @Override
-    public BasicBeanDescription forDeserialization(DeserializationConfig cfg,
+    public BasicBeanDescription forDeserialization(DeserializationConfig config,
             JavaType type, MixInResolver r)
     {
         // minor optimization: for some JDK types do minimal introspection
-        BasicBeanDescription desc = _findStdTypeDesc(type);
+        BasicBeanDescription desc = _findStdTypeDesc(config, type);
         if (desc == null) {
             // As per [Databind#550], skip full introspection for some of standard
             // structured types as well
-            desc = _findStdJdkCollectionDesc(cfg, type);
+            desc = _findStdJdkCollectionDesc(config, type);
             if (desc == null) {
-                desc = BasicBeanDescription.forDeserialization(collectProperties(cfg,
+                desc = BasicBeanDescription.forDeserialization(collectProperties(config,
                         		type, r, false, "set"));
             }
-            // Also: this is a superset of "forClassAnnotations", so may optimize by optional add:
-            _cachedFCA.putIfAbsent(type, desc);
         }
         return desc;
     }
 
     @Override
-    public BasicBeanDescription forDeserializationWithBuilder(DeserializationConfig cfg,
+    public BasicBeanDescription forDeserializationWithBuilder(DeserializationConfig config,
             JavaType type, MixInResolver r)
     {
         // no std JDK types with Builders, so:
-
-        BasicBeanDescription desc = BasicBeanDescription.forDeserialization(collectPropertiesWithBuilder(cfg,
+        return BasicBeanDescription.forDeserialization(collectPropertiesWithBuilder(config,
                 type, r, false));
-        // this is still a superset of "forClassAnnotations", so may optimize by optional add:
-        _cachedFCA.putIfAbsent(type, desc);
-        return desc;
     }
-    
+
     @Override
-    public BasicBeanDescription forCreation(DeserializationConfig cfg,
+    public BasicBeanDescription forCreation(DeserializationConfig config,
             JavaType type, MixInResolver r)
     {
-        BasicBeanDescription desc = _findStdTypeDesc(type);
+        BasicBeanDescription desc = _findStdTypeDesc(config, type);
         if (desc == null) {
             // As per [databind#550], skip full introspection for some of standard
             // structured types as well
-            desc = _findStdJdkCollectionDesc(cfg, type);
+            desc = _findStdJdkCollectionDesc(config, type);
             if (desc == null) {
                 desc = BasicBeanDescription.forDeserialization(
-            		collectProperties(cfg, type, r, false, "set"));
+                        collectProperties(config, type, r, false, "set"));
             }
         }
-        // should this be cached for FCA?
         return desc;
     }
 
@@ -153,14 +143,10 @@ public class BasicClassIntrospector
     public BasicBeanDescription forClassAnnotations(MapperConfig<?> config,
             JavaType type, MixInResolver r)
     {
-        BasicBeanDescription desc = _findStdTypeDesc(type);
+        BasicBeanDescription desc = _findStdTypeDesc(config, type);
         if (desc == null) {
-            desc = _cachedFCA.get(type);
-            if (desc == null) {
-                desc = BasicBeanDescription.forOtherUse(config, type,
-                        _resolveAnnotatedClass(config, type, r));
-                _cachedFCA.put(type, desc);
-            }
+            desc = BasicBeanDescription.forOtherUse(config, type,
+                    _resolveAnnotatedClass(config, type, r));
         }
         return desc;
     }
@@ -169,7 +155,7 @@ public class BasicClassIntrospector
     public BasicBeanDescription forDirectClassAnnotations(MapperConfig<?> config,
             JavaType type, MixInResolver r)
     {
-        BasicBeanDescription desc = _findStdTypeDesc(type);
+        BasicBeanDescription desc = _findStdTypeDesc(config, type);
         if (desc == null) {
             desc = BasicBeanDescription.forOtherUse(config, type,
                     _resolveAnnotatedWithoutSuperTypes(config, type, r));
@@ -216,23 +202,38 @@ public class BasicClassIntrospector
      * Method called to see if type is one of core JDK types
      * that we have cached for efficiency.
      */
-    protected BasicBeanDescription _findStdTypeDesc(JavaType type)
+    protected BasicBeanDescription _findStdTypeDesc(MapperConfig<?> config, JavaType type)
     {
         Class<?> cls = type.getRawClass();
         if (cls.isPrimitive()) {
-            if (cls == Boolean.TYPE) {
-                return BOOLEAN_DESC;
-            }
             if (cls == Integer.TYPE) {
                 return INT_DESC;
             }
             if (cls == Long.TYPE) {
                 return LONG_DESC;
             }
-        } else {
-            if (cls == String.class) {
+            if (cls == Boolean.TYPE) {
+                return BOOLEAN_DESC;
+            }
+        } else if (ClassUtil.isJDKClass(cls)) {
+            if (cls == CLS_OBJECT) {
+                return OBJECT_DESC;
+            }
+            if (cls == CLS_STRING) {
                 return STRING_DESC;
             }
+            if (cls == Integer.class) {
+                return INT_DESC;
+            }
+            if (cls == Long.class) {
+                return LONG_DESC;
+            }
+            if (cls == Boolean.class) {
+                return BOOLEAN_DESC;
+            }
+        } else if (CLS_JSON_NODE.isAssignableFrom(cls)) {
+            return BasicBeanDescription.forOtherUse(config, type,
+                    AnnotatedClassResolver.createPrimordial(cls));
         }
         return null;
     }
@@ -248,17 +249,12 @@ public class BasicClassIntrospector
             return false;
         }
         Class<?> raw = type.getRawClass();
-        String pkgName = ClassUtil.getPackageName(raw);
-        if (pkgName != null) {
-            if (pkgName.startsWith("java.lang")
-                    || pkgName.startsWith("java.util")) {
-                /* 23-Sep-2014, tatu: Should we be conservative here (minimal number
-                 *    of matches), or ambitious? Let's do latter for now.
-                 */
-                if (Collection.class.isAssignableFrom(raw)
-                        || Map.class.isAssignableFrom(raw)) {
-                    return true;
-                }
+        if (ClassUtil.isJDKClass(raw)) {
+            // 23-Sep-2014, tatu: Should we be conservative here (minimal number
+            //    of matches), or ambitious? Let's do latter for now.
+            if (Collection.class.isAssignableFrom(raw)
+                    || Map.class.isAssignableFrom(raw)) {
+                return true;
             }
         }
         return false;
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/BeanPropertyDefinition.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/BeanPropertyDefinition.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/BeanPropertyDefinition.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/BeanPropertyDefinition.java	2020-06-25 02:44:21.000000000 +0000
@@ -224,12 +224,15 @@ public abstract class BeanPropertyDefini
      * the highest precedence in current context (getter method when serializing,
      * if available, and so forth), if any.
      *<p>
+     * Note: may throw {@link IllegalArgumentException} in case problems are found
+     * trying to getter or setter info.
+     *<p>
      * Note: abstract since 2.5
      * 
      * @since 2.1
      */
     public abstract AnnotatedMember getPrimaryMember();
-    
+
     /*
     /**********************************************************
     /* More refined access to configuration features
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/JacksonAnnotationIntrospector.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/JacksonAnnotationIntrospector.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/JacksonAnnotationIntrospector.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/JacksonAnnotationIntrospector.java	2020-06-25 02:44:21.000000000 +0000
@@ -204,7 +204,7 @@ public class JacksonAnnotationIntrospect
     @Override // since 2.7
     public String[] findEnumValues(Class<?> enumType, Enum<?>[] enumValues, String[] names) {
         HashMap<String,String> expl = null;
-        for (Field f : ClassUtil.getDeclaredFields(enumType)) {
+        for (Field f : enumType.getDeclaredFields()) {
             if (!f.isEnumConstant()) {
                 continue;
             }
@@ -234,6 +234,30 @@ public class JacksonAnnotationIntrospect
         return names;
     }
 
+    @Override // since 2.11
+    public void findEnumAliases(Class<?> enumType, Enum<?>[] enumValues, String[][] aliasList)
+    {
+        // Main complication: discrepancy between Field that represent enum value,
+        // Enum abstraction; joint by name but not reference
+        for (Field f : enumType.getDeclaredFields()) {
+            if (f.isEnumConstant()) {
+                JsonAlias aliasAnnotation = f.getAnnotation(JsonAlias.class);
+                if (aliasAnnotation != null) {
+                    String[] aliases = aliasAnnotation.value();
+                    if (aliases.length != 0) {
+                        final String name = f.getName();
+                        // Find matching enum (could create Ma
+                        for (int i = 0, end = enumValues.length; i < end; ++i) {
+                            if (name.equals(enumValues[i].name())) {
+                                aliasList[i] = aliases;
+                            }
+                        }
+                    }
+                }
+            }
+        }
+    }
+
     /**
      * Finds the Enum value that should be considered the default value, if possible.
      * <p>
@@ -410,7 +434,9 @@ public class JacksonAnnotationIntrospect
     @Override
     public JsonFormat.Value findFormat(Annotated ann) {
         JsonFormat f = _findAnnotation(ann, JsonFormat.class);
-        return (f == null)  ? null : new JsonFormat.Value(f);
+        // NOTE: could also just call `JsonFormat.Value.from()` with `null`
+        // too, but that returns "empty" instance
+        return (f == null)  ? null : JsonFormat.Value.from(f);
     }
 
     @Override        
@@ -509,6 +535,13 @@ public class JacksonAnnotationIntrospect
         return null;
     }
 
+    @Override // since 2.11
+    public PropertyName findRenameByField(MapperConfig<?> config,
+            AnnotatedField f, PropertyName implName) {
+        // Nothing to report, only used by modules. But define just as documentation
+        return null;
+    }
+    
     /*
     /**********************************************************
     /* Annotations for Polymorphic Type handling
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/POJOPropertiesCollector.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/POJOPropertiesCollector.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/POJOPropertiesCollector.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/POJOPropertiesCollector.java	2020-06-25 02:44:21.000000000 +0000
@@ -89,6 +89,22 @@ public class POJOPropertiesCollector
     protected LinkedHashMap<String, POJOPropertyBuilder> _properties;
 
     protected LinkedList<POJOPropertyBuilder> _creatorProperties;
+
+    /**
+     * A set of "field renamings" that have been discovered, indicating
+     * intended renaming of other accesors: key is the implicit original
+     * name and value intended name to use instead.
+     *<p>
+     * Note that these renamings are applied earlier than "regular" (explicit)
+     * renamings and affect implicit name: their effect may be changed by
+     * further renaming based on explicit indicators.
+     * The main use case is to effectively relink accessors based on fields
+     * discovered, and used to sort of correct otherwise missing linkage between
+     * fields and other accessors.
+     *
+     * @since 2.11
+     */
+    protected Map<PropertyName, PropertyName> _fieldRenameMappings;
     
     protected LinkedList<AnnotatedMember> _anyGetters;
 
@@ -178,15 +194,6 @@ public class POJOPropertiesCollector
         return _injectables;
     }
 
-    @Deprecated // since 2.9
-    public AnnotatedMethod getJsonValueMethod() {
-        AnnotatedMember m = getJsonValueAccessor();
-        if (m instanceof AnnotatedMethod) {
-            return (AnnotatedMethod) m;
-        }
-        return null;
-    }
-
     /**
      * @since 2.9
      */
@@ -274,13 +281,6 @@ public class POJOPropertiesCollector
         return info;
     }
 
-    /**
-     * Method for finding Class to use as POJO builder, if any.
-     */
-    public Class<?> findPOJOBuilderClass() {
-        return _annotationIntrospector.findPOJOBuilder(_classDef);
-    }
-    
     // for unit tests:
     protected Map<String, POJOPropertyBuilder> getPropertyMap() {
         if (!_collected) {
@@ -289,6 +289,20 @@ public class POJOPropertiesCollector
         return _properties;
     }
 
+    @Deprecated // since 2.9
+    public AnnotatedMethod getJsonValueMethod() {
+        AnnotatedMember m = getJsonValueAccessor();
+        if (m instanceof AnnotatedMethod) {
+            return (AnnotatedMethod) m;
+        }
+        return null;
+    }
+
+    @Deprecated // since 2.11 (not used by anything at this point)
+    public Class<?> findPOJOBuilderClass() {
+        return _annotationIntrospector.findPOJOBuilder(_classDef);
+    }
+
     /*
     /**********************************************************
     /* Public API: main-level collection
@@ -305,14 +319,13 @@ public class POJOPropertiesCollector
         LinkedHashMap<String, POJOPropertyBuilder> props = new LinkedHashMap<String, POJOPropertyBuilder>();
 
         // First: gather basic data
-        _addFields(props);
+        _addFields(props); // note: populates _fieldRenameMappings
         _addMethods(props);
         // 25-Jan-2016, tatu: Avoid introspecting (constructor-)creators for non-static
         //    inner classes, see [databind#1502]
         if (!_classDef.isNonStaticInnerClass()) {
             _addCreators(props);
         }
-        _addInjectables(props);
 
         // Remove ignored properties, first; this MUST precede annotation merging
         // since logic relies on knowing exactly which accessor has which annotation
@@ -323,6 +336,10 @@ public class POJOPropertiesCollector
         // Rename remaining properties
         _renameProperties(props);
 
+        // and now add injectables, but taking care to avoid overlapping ones
+        // via creator and regular properties
+        _addInjectables(props);
+
         // then merge annotations, to simplify further processing
         // 26-Sep-2017, tatu: Before 2.9.2 was done earlier but that prevented some of
         //   annotations from getting properly merged
@@ -336,17 +353,14 @@ public class POJOPropertiesCollector
             _renameUsing(props, naming);
         }
 
-        /* Sort by visibility (explicit over implicit); drop all but first
-         * of member type (getter, setter etc) if there is visibility
-         * difference
-         */
+        // Sort by visibility (explicit over implicit); drop all but first of member
+        // type (getter, setter etc) if there is visibility difference
         for (POJOPropertyBuilder property : props.values()) {
             property.trimByVisibility();
         }
 
-        /* and, if required, apply wrapper name: note, MUST be done after
-         * annotations are merged.
-         */
+        // and, if required, apply wrapper name: note, MUST be done after
+        // annotations are merged.
         if (_config.isEnabled(MapperFeature.USE_WRAPPER_NAME_AS_PROPERTY_NAME)) {
             _renameWithWrappers(props);
         }
@@ -375,9 +389,8 @@ public class POJOPropertiesCollector
          */
         final boolean pruneFinalFields = !_forSerialization && !_config.isEnabled(MapperFeature.ALLOW_FINAL_FIELDS_AS_MUTATORS);
         final boolean transientAsIgnoral = _config.isEnabled(MapperFeature.PROPAGATE_TRANSIENT_MARKER);
-        
+
         for (AnnotatedField f : _classDef.fields()) {
-            String implName = ai.findImplicitPropertyName(f);
             // @JsonValue?
             if (Boolean.TRUE.equals(ai.hasAsValue(f))) {
                 if (_jsonValueAccessors == null) {
@@ -394,17 +407,31 @@ public class POJOPropertiesCollector
                 _anySetterField.add(f);
                 continue;
             }
+            String implName = ai.findImplicitPropertyName(f);
             if (implName == null) {
                 implName = f.getName();
             }
+            final PropertyName implNameP = _propNameFromSimple(implName);
+
+            // [databind#2527: Field-based renaming can be applied early (here),
+            // or at a later point, but probably must be done before pruning
+            // final fields. So let's do it early here
+            final PropertyName rename = ai.findRenameByField(_config, f, implNameP);
+            if ((rename != null) && !rename.equals(implNameP)) {
+                if (_fieldRenameMappings == null) {
+                    _fieldRenameMappings = new HashMap<>();
+                }
+                _fieldRenameMappings.put(rename, implNameP);
+                // todo
+            }
+
             PropertyName pn;
 
             if (_forSerialization) {
-                /* 18-Aug-2011, tatu: As per existing unit tests, we should only
-                 *   use serialization annotation (@JsonSerialize) when serializing
-                 *   fields, and similarly for deserialize-only annotations... so
-                 *   no fallbacks in this particular case.
-                 */
+                // 18-Aug-2011, tatu: As per existing unit tests, we should only
+                //   use serialization annotation (@JsonSerialize) when serializing
+                //   fields, and similarly for deserialize-only annotations... so
+                //   no fallbacks in this particular case.
                 pn = ai.findNameForSerialization(f);
             } else {
                 pn = ai.findNameForDeserialization(f);
@@ -437,7 +464,7 @@ public class POJOPropertiesCollector
             }
             /* [databind#190]: this is the place to prune final fields, if they are not
              *  to be used as mutators. Must verify they are not explicitly included.
-             *  Also: if 'ignored' is set, need to included until a later point, to
+             *  Also: if 'ignored' is set, need to include until a later point, to
              *  avoid losing ignoral information.
              */
             if (pruneFinalFields && (pn == null) && !ignored
@@ -503,9 +530,12 @@ public class POJOPropertiesCollector
             pn = PropertyName.construct(impl);
         }
 
+        // 27-Dec-2019, tatu: [databind#2527] may need to rename according to field
+        impl = _checkRenameByField(impl);
+
         // shouldn't need to worry about @JsonIgnore, since creators only added
         // if so annotated
-
+        
         /* 13-May-2015, tatu: We should try to start with implicit name, similar to how
          *   fields and methods work; but unlike those, we don't necessarily have
          *   implicit name to use (pre-Java8 at least). So:
@@ -523,11 +553,11 @@ public class POJOPropertiesCollector
     {
         final AnnotationIntrospector ai = _annotationIntrospector;
         for (AnnotatedMethod m : _classDef.memberMethods()) {
-            /* For methods, handling differs between getters and setters; and
-             * we will also only consider entries that either follow the bean
-             * naming convention or are explicitly marked: just being visible
-             * is not enough (unlike with fields)
-             */
+            // For methods, handling differs between getters and setters; and
+            // we will also only consider entries that either follow the bean
+            // naming convention or are explicitly marked: just being visible
+            // is not enough (unlike with fields)
+
             int argCount = m.getParameterCount();
             if (argCount == 0) { // getters (including 'any getter')
             	_addGetterMethod(props, m, ai);
@@ -608,6 +638,8 @@ public class POJOPropertiesCollector
             }
             visible = true;
         }
+        // 27-Dec-2019, tatu: [databind#2527] may need to rename according to field
+        implName = _checkRenameByField(implName);
         boolean ignore = ai.hasIgnoreMarker(m);
         _property(props, implName).addGetter(m, pn, nameExplicit, visible, ignore);
     }
@@ -645,6 +677,8 @@ public class POJOPropertiesCollector
             }
             visible = true;
         }
+        // 27-Dec-2019, tatu: [databind#2527] may need to rename according to field
+        implName = _checkRenameByField(implName);
         boolean ignore = (ai == null) ? false : ai.hasIgnoreMarker(m);
         _property(props, implName).addSetter(m, pn, nameExplicit, visible, ignore);
     }
@@ -689,7 +723,20 @@ public class POJOPropertiesCollector
     private PropertyName _propNameFromSimple(String simpleName) {
         return PropertyName.construct(simpleName, null);
     }
-    
+
+    // @since 2.11
+    private String _checkRenameByField(String implName) {
+        if (_fieldRenameMappings != null) {
+            PropertyName p = _fieldRenameMappings.get(_propNameFromSimple(implName));
+            if (p != null) {
+                implName = p.getSimpleName();
+                return implName;
+
+            }
+        }
+        return implName;
+    }
+
     /*
     /**********************************************************
     /* Internal methods; removing ignored properties
@@ -933,25 +980,24 @@ public class POJOPropertiesCollector
     /**********************************************************
      */
     
-    /* First, order by [JACKSON-90] (explicit ordering and/or alphabetic)
-     * and then for [JACKSON-170] (implicitly order creator properties before others)
-     */
+    // First, order by(explicit ordering and/or alphabetic),
+    // then by (optional) index (if any)
+    // and then implicitly order creator properties before others)
+
     protected void _sortProperties(Map<String, POJOPropertyBuilder> props)
     {
         // Then how about explicit ordering?
-        AnnotationIntrospector intr = _annotationIntrospector;
+        final AnnotationIntrospector intr = _annotationIntrospector;
         Boolean alpha = intr.findSerializationSortAlphabetically((Annotated) _classDef);
-        boolean sort;
-        
-        if (alpha == null) {
-            sort = _config.shouldSortPropertiesAlphabetically();
-        } else {
-            sort = alpha.booleanValue();
-        }
+        final boolean sort = (alpha == null)
+                ? _config.shouldSortPropertiesAlphabetically()
+                : alpha.booleanValue();
+        final boolean indexed = _anyIndexed(props.values());
+
         String[] propertyOrder = intr.findSerializationPropertyOrder(_classDef);
         
         // no sorting? no need to shuffle, then
-        if (!sort && (_creatorProperties == null) && (propertyOrder == null)) {
+        if (!sort && !indexed && (_creatorProperties == null) && (propertyOrder == null)) {
             return;
         }
         int size = props.size();
@@ -966,11 +1012,11 @@ public class POJOPropertiesCollector
         for (POJOPropertyBuilder prop : props.values()) {
             all.put(prop.getName(), prop);
         }
-        Map<String,POJOPropertyBuilder> ordered = new LinkedHashMap<String,POJOPropertyBuilder>(size+size);
+        Map<String,POJOPropertyBuilder> ordered = new LinkedHashMap<>(size+size);
         // Ok: primarily by explicit order
         if (propertyOrder != null) {
             for (String name : propertyOrder) {
-                POJOPropertyBuilder w = all.get(name);
+                POJOPropertyBuilder w = all.remove(name);
                 if (w == null) { // will also allow use of "implicit" names for sorting
                     for (POJOPropertyBuilder prop : props.values()) {
                         if (name.equals(prop.getInternalName())) {
@@ -986,7 +1032,26 @@ public class POJOPropertiesCollector
                 }
             }
         }
-        // And secondly by sorting Creator properties before other unordered properties
+
+        // Second (starting with 2.11): index, if any:
+        if (indexed) {
+            Map<Integer,POJOPropertyBuilder> byIndex = new TreeMap<>();
+            Iterator<Map.Entry<String,POJOPropertyBuilder>> it = all.entrySet().iterator();
+            while (it.hasNext()) {
+                Map.Entry<String,POJOPropertyBuilder> entry = it.next();
+                POJOPropertyBuilder prop = entry.getValue();
+                Integer index = prop.getMetadata().getIndex();
+                if (index != null) {
+                    byIndex.put(index, prop);
+                    it.remove();
+                }
+            }
+            for (POJOPropertyBuilder prop : byIndex.values()) {
+                ordered.put(prop.getName(), prop);
+            }
+        }
+
+        // Third by sorting Creator properties before other unordered properties
         if (_creatorProperties != null) {
             /* As per [databind#311], this is bit delicate; but if alphabetic ordering
              * is mandated, at least ensure creator properties are in alphabetic
@@ -1008,6 +1073,8 @@ public class POJOPropertiesCollector
                 // 16-Jan-2016, tatu: Related to [databind#1317], make sure not to accidentally
                 //    add back pruned creator properties!
                 String name = prop.getName();
+                // 27-Nov-2019, tatu: Not sure why, but we should NOT remove it from `all` tho:
+//                if (all.remove(name) != null) {
                 if (all.containsKey(name)) {
                     ordered.put(name, prop);
                 }
@@ -1017,7 +1084,16 @@ public class POJOPropertiesCollector
         ordered.putAll(all);
         props.clear();
         props.putAll(ordered);
-    }        
+    }
+
+    private boolean _anyIndexed(Collection<POJOPropertyBuilder> props) {
+        for (POJOPropertyBuilder prop : props) {
+            if (prop.getMetadata().hasIndex()) {
+                return true;
+            }
+        }
+        return false;
+    }
 
     /*
     /**********************************************************
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/POJOPropertyBuilder.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/POJOPropertyBuilder.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/introspect/POJOPropertyBuilder.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/introspect/POJOPropertyBuilder.java	2020-06-25 02:44:21.000000000 +0000
@@ -6,6 +6,7 @@ import com.fasterxml.jackson.annotation.
 import com.fasterxml.jackson.annotation.JsonProperty;
 import com.fasterxml.jackson.annotation.JsonSetter;
 import com.fasterxml.jackson.annotation.Nulls;
+
 import com.fasterxml.jackson.databind.*;
 import com.fasterxml.jackson.databind.cfg.ConfigOverride;
 import com.fasterxml.jackson.databind.cfg.MapperConfig;
@@ -238,16 +239,20 @@ public class POJOPropertyBuilder
      * Helper method that contains logic for accessing and merging all setter
      * information that we needed, regarding things like possible merging
      * of property value, and handling of incoming nulls.
+     * Only called for deserialization purposes.
      */
     protected PropertyMetadata _getSetterInfo(PropertyMetadata metadata)
     {
         boolean needMerge = true;
         Nulls valueNulls = null;
         Nulls contentNulls = null;
-        
+
         // Slightly confusing: first, annotations should be accessed via primary member
-        // (mutator); but accessor is needed for actual merge operation. So:
-        AnnotatedMember prim = getPrimaryMember();
+        // (mutator); but accessor is needed for actual merge operation. So
+
+        // 20-Jun-2020, tatu: Unfortunately strict checks lead to [databind#2757]
+        //   so we will need to try to avoid them at this point
+        AnnotatedMember prim = getPrimaryMemberUnchecked();
         AnnotatedMember acc = getAccessor();
 
         if (prim != null) {
@@ -271,7 +276,10 @@ public class POJOPropertyBuilder
             // If not, config override?
             // 25-Oct-2016, tatu: Either this, or type of accessor...
             if (needMerge || (valueNulls == null) || (contentNulls == null)) {
-                Class<?> rawType = getRawPrimaryType();
+                // 20-Jun-2020, tatu: Related to [databind#2757], need to find type
+                //   but keeping mind that type for setters is trickier; and that
+                //   generic typing gets tricky as well.
+                Class<?> rawType = _rawTypeOf(prim);
                 ConfigOverride co = _config.getConfigOverride(rawType);
                 JsonSetter.Value setterInfo = co.getSetterInfo();
                 if (setterInfo != null) {
@@ -329,7 +337,6 @@ public class POJOPropertyBuilder
                     // 09-Feb-2017, tatu: Not sure if this or `null` but...
                     return TypeFactory.unknownType();
                 }
-                return m.getType();
             }
             return m.getType();
         }
@@ -440,7 +447,7 @@ public class POJOPropertyBuilder
     @Override
     public AnnotatedMethod getSetter()
     {
-        // Easy with zero or one getters...
+        // Easy with zero or one setters...
         Linked<AnnotatedMethod> curr = _setters;
         if (curr == null) {
             return null;
@@ -576,6 +583,45 @@ public class POJOPropertyBuilder
         return m;
     }
 
+    // Sometimes we need to actually by-pass failures related to conflicting
+    // getters or setters (see [databind#2757] for specific example); if so,
+    // this method is to be used instead of `getPrimaryMember()`
+    // @since 2.11.1
+    protected AnnotatedMember getPrimaryMemberUnchecked() {
+        if (_forSerialization) { // Inlined `getAccessor()` logic:
+            // Inlined `getGetter()`:
+            if (_getters != null) {
+                return _getters.value;
+            }
+            // Inlined `getField()`:
+            if (_fields != null) {
+                return _fields.value;
+            }
+            return null;
+        }
+
+        // Otherwise, inlined `getMutator()` logic:
+
+        // Inlined `getConstructorParameter()`:
+        if (_ctorParameters != null) {
+            return _ctorParameters.value;
+        }
+        // Inlined `getSetter()`:
+        if (_setters != null) {
+            return _setters.value;
+        }
+        // Inlined `getField()`:
+        if (_fields != null) {
+            return _fields.value;
+        }
+        // but to support setterless-properties, also include part of
+        // `getAccessor()` not yet covered, `getGetter()`:
+        if (_getters != null) {
+            return _getters.value;
+        }
+        return null;
+    }
+
     protected int _getterPriority(AnnotatedMethod m)
     {
         final String name = m.getName();
@@ -1219,6 +1265,26 @@ public class POJOPropertyBuilder
         return null;
     }
 
+    // Helper method needed to work around oddity in type access for
+    // `AnnotatedMethod`.
+    //
+    // @since 2.11.1
+    protected Class<?> _rawTypeOf(AnnotatedMember m) {
+        // AnnotatedMethod always returns return type, but for setters we
+        // actually need argument type
+        if (m instanceof AnnotatedMethod) {
+            AnnotatedMethod meh = (AnnotatedMethod) m;
+            if (meh.getParameterCount() > 0) {
+                // note: get raw type FROM full type since only that resolves
+                // generic types
+                return meh.getParameterType(0).getRawClass();
+            }
+        }
+        // same as above, must get fully resolved type to handled generic typing
+        // of fields etc.
+        return m.getType().getRawClass();
+    }
+
     /*
     /**********************************************************
     /* Helper classes
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/JavaType.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/JavaType.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/JavaType.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/JavaType.java	2020-06-25 02:44:21.000000000 +0000
@@ -6,6 +6,7 @@ import java.util.List;
 import com.fasterxml.jackson.core.type.ResolvedType;
 import com.fasterxml.jackson.databind.type.TypeBindings;
 import com.fasterxml.jackson.databind.type.TypeFactory;
+import com.fasterxml.jackson.databind.util.ClassUtil;
 
 /**
  * Base class for type token classes used both to contain information
@@ -287,13 +288,28 @@ public abstract class JavaType
     @Override
     public boolean isArrayType() { return false; }
 
+    /**
+     * Method that basically does equivalent of:
+     *<pre>
+     *  Enum.class.isAssignableFrom(getRawClass())
+     *</pre>
+     * that is, return {@code true} if the underlying type erased class is {@code Enum}
+     * or one its subtypes (Enum implementations).
+     */
     @Override
     public final boolean isEnumType() {
-        // 29-Sep-2019, tatu: `Class.isEnum()` not enough to detect custom subtypes,
-        //   but for some reason this fix will break couple of unit tests:
-        // See [databind#2480]:
-//        return ClassUtil.isEnumType(_class);
-        return _class.isEnum();
+        // 29-Sep-2019, tatu: `Class.isEnum()` not enough to detect custom subtypes.
+        return ClassUtil.isEnumType(_class);
+    }
+
+    /**
+     * Similar to {@link #isEnumType} except does NOT return {@code true}
+     * for {@link java.lang.Enum} (since that is not Enum implementation type).
+     *
+     * @since 2.11
+     */
+    public final boolean isEnumImplType() {
+        return ClassUtil.isEnumType(_class) && (_class != Enum.class);
     }
 
     @Override
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/JsonMappingException.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/JsonMappingException.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/JsonMappingException.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/JsonMappingException.java	2020-06-25 02:44:21.000000000 +0000
@@ -251,7 +251,10 @@ public class JsonMappingException
     public JsonMappingException(Closeable processor, String msg, Throwable problem) {
         super(msg, problem);
         _processor = processor;
-        if (processor instanceof JsonParser) {
+        // 31-Jan-2020: [databind#2482] Retain original location
+        if (problem instanceof JsonProcessingException) {
+            _location = ((JsonProcessingException) problem).getLocation();
+        } else if (processor instanceof JsonParser) {
             _location = ((JsonParser) processor).getTokenLocation();
         }
     }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/jsontype/BasicPolymorphicTypeValidator.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/jsontype/BasicPolymorphicTypeValidator.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/jsontype/BasicPolymorphicTypeValidator.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/jsontype/BasicPolymorphicTypeValidator.java	2020-06-25 02:44:21.000000000 +0000
@@ -37,16 +37,16 @@ public class BasicPolymorphicTypeValidat
      * General matcher interface (predicate) for validating class values
      * (base type or resolved subtype)
      */
-    protected abstract static class TypeMatcher {
-        public abstract boolean match(Class<?> clazz);
+    public abstract static class TypeMatcher { // note: public since 2.11
+        public abstract boolean match(MapperConfig<?> config, Class<?> clazz);
     }
 
     /**
      * General matcher interface (predicate) for validating unresolved
      * subclass class name.
      */
-    protected abstract static class NameMatcher {
-        public abstract boolean match(String clazzName);
+    public abstract static class NameMatcher { // note: public since 2.11
+        public abstract boolean match(MapperConfig<?> config, String clazzName);
     }
     
     /*
@@ -64,6 +64,11 @@ public class BasicPolymorphicTypeValidat
      * rules are checked.
      */
     public static class Builder {
+        /**
+         * Optional set of base types (exact match) that are NOT accepted
+         * as base types for polymorphic properties. May be used to prevent "unsafe"
+         * base types like {@link java.lang.Object} or {@link java.io.Serializable}.
+         */
         protected Set<Class<?>> _invalidBaseTypes;
 
         /**
@@ -99,7 +104,7 @@ public class BasicPolymorphicTypeValidat
         public Builder allowIfBaseType(final Class<?> baseOfBase) {
             return _appendBaseMatcher(new TypeMatcher() {
                 @Override
-                public boolean match(Class<?> clazz) {
+                public boolean match(MapperConfig<?> config, Class<?> clazz) {
                     return baseOfBase.isAssignableFrom(clazz);
                 }
             });
@@ -125,7 +130,7 @@ public class BasicPolymorphicTypeValidat
         public Builder allowIfBaseType(final Pattern patternForBase) {
             return _appendBaseMatcher(new TypeMatcher() {
                 @Override
-                public boolean match(Class<?> clazz) {
+                public boolean match(MapperConfig<?> config, Class<?> clazz) {
                     return patternForBase.matcher(clazz.getName()).matches();
                 }
             });
@@ -145,13 +150,28 @@ public class BasicPolymorphicTypeValidat
         public Builder allowIfBaseType(final String prefixForBase) {
             return _appendBaseMatcher(new TypeMatcher() {
                 @Override
-                public boolean match(Class<?> clazz) {
+                public boolean match(MapperConfig<?> config, Class<?> clazz) {
                     return clazz.getName().startsWith(prefixForBase);
                 }
             });
         }
 
         /**
+         * Method for appending custom matcher called with base type: if matcher returns
+         * {@code true}, all possible subtypes will be accepted; if {@code false}, other
+         * matchers are applied.
+         * 
+         * @param matcher Custom matcher to apply to base type
+         *
+         * @return This Builder to allow call chaining
+         *
+         * @since 2.11
+         */
+        public Builder allowIfBaseType(final TypeMatcher matcher) {
+            return _appendBaseMatcher(matcher);
+        }
+        
+        /**
          * Method for appending matcher that will mark any polymorphic properties with exact
          * specific class to be invalid.
          * For example, call to
@@ -187,7 +207,7 @@ public class BasicPolymorphicTypeValidat
         public Builder allowIfSubType(final Class<?> subTypeBase) {
             return _appendSubClassMatcher(new TypeMatcher() {
                 @Override
-                public boolean match(Class<?> clazz) {
+                public boolean match(MapperConfig<?> config, Class<?> clazz) {
                     return subTypeBase.isAssignableFrom(clazz);
                 }
             });
@@ -212,7 +232,7 @@ public class BasicPolymorphicTypeValidat
         public Builder allowIfSubType(final Pattern patternForSubType) {
             return _appendSubNameMatcher(new NameMatcher() {
                 @Override
-                public boolean match(String clazzName) {
+                public boolean match(MapperConfig<?> config, String clazzName) {
                     return patternForSubType.matcher(clazzName).matches();
                 }
             });
@@ -232,13 +252,28 @@ public class BasicPolymorphicTypeValidat
         public Builder allowIfSubType(final String prefixForSubType) {
             return _appendSubNameMatcher(new NameMatcher() {
                 @Override
-                public boolean match(String clazzName) {
+                public boolean match(MapperConfig<?> config, String clazzName) {
                     return clazzName.startsWith(prefixForSubType);
                 }
             });
         }
 
         /**
+         * Method for appending custom matcher called with resolved subtype: if matcher returns
+         * {@code true}, type will be accepted; if {@code false}, other
+         * matchers are applied.
+         * 
+         * @param matcher Custom matcher to apply to resolved subtype
+         *
+         * @return This Builder to allow call chaining
+         *
+         * @since 2.11
+         */
+        public Builder allowIfSubType(final TypeMatcher matcher) {
+            return _appendSubClassMatcher(matcher);
+        }
+
+        /**
          * Method for appending matcher that will allow all subtypes that are Java arrays
          * (regardless of element type). Note that this does NOT validate element type
          * itself as long as Polymorphic Type handling is enabled for element type: this
@@ -250,17 +285,36 @@ public class BasicPolymorphicTypeValidat
          *    {@link java.util.Collection}s), mostly since use of generic types as polymorphic
          *    values is not (well) supported.
          *
-         * @since 2.10.1
+         * @since 2.11
          */
         public Builder allowIfSubTypeIsArray() {
             return _appendSubClassMatcher(new TypeMatcher() {
                 @Override
-                public boolean match(Class<?> clazz) {
+                public boolean match(MapperConfig<?> config, Class<?> clazz) {
                     return clazz.isArray();
                 }
             });
         }
-        
+
+        // 18-Nov-2019, tatu: alas, [databind#2539] can not be implemented with 2.x due
+        //    to (in hindsight) obvious design flaw: instead `MapperConfig`, `DatabindContext`
+        //    must be available to check what deserializers are registered.
+        /*
+        public Builder allowSubTypesWithExplicitDeserializer() {
+            return _appendSubClassMatcher(new TypeMatcher() {
+                @Override
+                public boolean match(MapperConfig<?> config, Class<?> clazz) {
+                    // First things first: "peel off" array type
+                    while (clazz.isArray()) {
+                        clazz = clazz.getComponentType();
+                    }
+                    DeserializerFactory df = ((DeserializationConfig) config).getDes
+                    return clazz.isArray();
+                }
+            });
+        }
+         */
+
         public BasicPolymorphicTypeValidator build() {
             return new BasicPolymorphicTypeValidator(_invalidBaseTypes,
                     (_baseTypeMatchers == null) ? null : _baseTypeMatchers.toArray(new TypeMatcher[0]),
@@ -349,7 +403,7 @@ public class BasicPolymorphicTypeValidat
         }
         if (_baseTypeMatchers != null) {
             for (TypeMatcher m : _baseTypeMatchers) {
-                if (m.match(rawBase)) {
+                if (m.match(ctxt, rawBase)) {
                     return Validity.ALLOWED;
                 }
             }
@@ -365,7 +419,7 @@ public class BasicPolymorphicTypeValidat
 //System.err.println("validateSubClassName('"+subClassName+"')");
         if (_subTypeNameMatchers != null)  {
             for (NameMatcher m : _subTypeNameMatchers) {
-                if (m.match(subClassName)) {
+                if (m.match(ctxt, subClassName)) {
                     return Validity.ALLOWED;
                 }
             }
@@ -382,7 +436,7 @@ public class BasicPolymorphicTypeValidat
         if (_subClassMatchers != null)  {
             final Class<?> subClass = subType.getRawClass();
             for (TypeMatcher m : _subClassMatchers) {
-                if (m.match(subClass)) {
+                if (m.match(ctxt, subClass)) {
                     return Validity.ALLOWED;
                 }
             }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/jsontype/DefaultBaseTypeLimitingValidator.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/jsontype/DefaultBaseTypeLimitingValidator.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/jsontype/DefaultBaseTypeLimitingValidator.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/jsontype/DefaultBaseTypeLimitingValidator.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,119 @@
+package com.fasterxml.jackson.databind.jsontype;
+
+import java.util.HashSet;
+import java.util.Set;
+
+import com.fasterxml.jackson.databind.JavaType;
+import com.fasterxml.jackson.databind.cfg.MapperConfig;
+
+/**
+ * {@link PolymorphicTypeValidator} that will only allow polymorphic handling if
+ * the base type is NOT one of potential dangerous base types (see {@link #isUnsafeBaseType}
+ * for specific list of such base types). No further validation is performed on subtype.
+ *<p>
+ * Note that when using potentially unsafe base type like {@link java.lang.Object} a custom
+ * implementation (or subtype with override) is needed. Most commonly subclasses would
+ * override both {@link #isUnsafeBaseType} and {@link #isSafeSubType}: former to allow
+ * all (or just more) base types, and latter to add actual validation of subtype.
+ *
+ * @since 2.11
+ */
+public class DefaultBaseTypeLimitingValidator
+    extends PolymorphicTypeValidator
+    implements java.io.Serializable
+{
+    private static final long serialVersionUID = 1L;
+
+    @Override
+    public Validity validateBaseType(MapperConfig<?> config, JavaType baseType)
+    {
+        // Immediately block potentially unsafe base types
+        if (isUnsafeBaseType(config, baseType)) {
+            return Validity.DENIED;
+        }
+        // otherwise indicate that type may be ok (so further calls are made --
+        // does not matter with base implementation but allows easier sub-classing)
+        return Validity.INDETERMINATE;
+    }
+
+    @Override
+    public Validity validateSubClassName(MapperConfig<?> config,
+            JavaType baseType, String subClassName) {
+        // return INDETERMINATE just for easier sub-classing
+        return Validity.INDETERMINATE;
+    }
+
+    @Override
+    public Validity validateSubType(MapperConfig<?> config, JavaType baseType,
+            JavaType subType)
+    {
+        return isSafeSubType(config, baseType, subType)
+                ? Validity.ALLOWED
+                : Validity.DENIED;
+    }
+
+    /**
+     * Helper method called to determine if the given base type is known to be
+     * problematic regarding possible "gadget types".
+     * Currently includes following types:
+     *<ul>
+     *  <li>{@link java.lang.Object}</li>
+     *  <li>{@link java.io.Closeable}</li>
+     *  <li>{@link java.io.Serializable}</li>
+     *  <li>{@link java.lang.AutoCloseable}</li>
+     *  <li>{@link java.lang.Cloneable}</li>
+     *  <li>{@link java.util.logging.Handler}</li>
+     *  <li>{@link javax.naming.Referenceable}</li>
+     *  <li>{@link javax.sql.DataSource}</li>
+     *</ul>
+     * which are JDK-included super types of at least one gadget type (not necessarily
+     * included in JDK)
+     *
+     * @param config Current mapper configuration
+     * @param baseType Base type to test
+     */
+    protected boolean isUnsafeBaseType(MapperConfig<?> config, JavaType baseType)
+    {
+        return UnsafeBaseTypes.instance.isUnsafeBaseType(baseType.getRawClass());
+    }
+
+    /**
+     * Helper called to determine whether given actual subtype is considered safe
+     * to process: this will only be called if subtype was considered acceptable
+     * earlier.
+     *
+     * @param config Current mapper configuration
+     * @param baseType Base type of sub type (validated earlier)
+     * @param subType Sub type to test
+     */
+    protected boolean isSafeSubType(MapperConfig<?> config,
+            JavaType baseType, JavaType subType)
+    {
+        return true;
+    }
+
+    private final static class UnsafeBaseTypes {
+        public final static UnsafeBaseTypes instance = new UnsafeBaseTypes();
+
+        private final Set<String> UNSAFE = new HashSet<>();
+        {
+            // first add names of types in `java.base`
+            UNSAFE.add(Object.class.getName());
+            UNSAFE.add(java.io.Closeable.class.getName());
+            UNSAFE.add(java.io.Serializable.class.getName());
+            UNSAFE.add(AutoCloseable.class.getName());
+            UNSAFE.add(Cloneable.class.getName());
+
+            // and then couple others typically included in JDK, but that we
+            // prefer not adding direct reference to
+            UNSAFE.add("java.util.logging.Handler");
+            UNSAFE.add("javax.naming.Referenceable");
+            UNSAFE.add("javax.sql.DataSource");
+        }
+        
+        public boolean isUnsafeBaseType(Class<?> rawBaseType)
+        {
+            return UNSAFE.contains(rawBaseType.getName());
+        }
+    }
+}
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/AsPropertyTypeDeserializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/AsPropertyTypeDeserializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/AsPropertyTypeDeserializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/AsPropertyTypeDeserializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -32,7 +32,7 @@ public class AsPropertyTypeDeserializer
     {
         this(bt, idRes, typePropertyName, typeIdVisible, defaultImpl, As.PROPERTY);
     }
-    
+
     /**
      * @since 2.8
      */
@@ -89,11 +89,13 @@ public class AsPropertyTypeDeserializer
         }
         // Ok, let's try to find the property. But first, need token buffer...
         TokenBuffer tb = null;
+        boolean ignoreCase = ctxt.isEnabled(MapperFeature.ACCEPT_CASE_INSENSITIVE_PROPERTIES);
 
         for (; t == JsonToken.FIELD_NAME; t = p.nextToken()) {
-            String name = p.getCurrentName();
+            final String name = p.getCurrentName();
             p.nextToken(); // to point to the value
-            if (name.equals(_typePropertyName)) { // gotcha!
+            if (name.equals(_typePropertyName)
+                    || (ignoreCase && name.equalsIgnoreCase(_typePropertyName))) { // gotcha!
                 return _deserializeTypedForId(p, ctxt, tb);
             }
             if (tb == null) {
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/LaissezFaireSubTypeValidator.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/LaissezFaireSubTypeValidator.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/LaissezFaireSubTypeValidator.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/LaissezFaireSubTypeValidator.java	2020-06-25 02:44:21.000000000 +0000
@@ -5,9 +5,11 @@ import com.fasterxml.jackson.databind.cf
 import com.fasterxml.jackson.databind.jsontype.PolymorphicTypeValidator;
 
 /**
- * Default {@link PolymorphicTypeValidator} used unless explicit one is constructed.
+ * Default {@link PolymorphicTypeValidator} used unless explicit one is constructed
+ * (and, in 2.11, {@link com.fasterxml.jackson.databind.MapperFeature#BLOCK_UNSAFE_POLYMORPHIC_BASE_TYPES}
+ * not enabled).
  * Does not do any validation, allows all subtypes. Only used for backwards-compatibility
- * reasons: users should not usually use such a permissive implementation but use
+ * reasons: users should usually NOT use such a permissive implementation but use
  * allow-list/criteria - based implementation.
  *
  * @since 2.10
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/StdSubtypeResolver.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/StdSubtypeResolver.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/StdSubtypeResolver.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/StdSubtypeResolver.java	2020-06-25 02:44:21.000000000 +0000
@@ -23,6 +23,19 @@ public class StdSubtypeResolver
 
     public StdSubtypeResolver() { }
 
+    // @since 2.12
+    protected StdSubtypeResolver(StdSubtypeResolver src) {
+        LinkedHashSet<NamedType> reg = src._registeredSubtypes;
+        _registeredSubtypes = (reg == null) ? null
+                : new LinkedHashSet<>(reg);
+    }
+
+    // @since 2.12
+    @Override
+    public SubtypeResolver copy() {
+        return new StdSubtypeResolver(this);
+    }
+
     /*
     /**********************************************************
     /* Subtype registration
@@ -112,7 +125,8 @@ public class StdSubtypeResolver
             AnnotatedClass type)
     {
         final AnnotationIntrospector ai = config.getAnnotationIntrospector();
-        HashMap<NamedType, NamedType> subtypes = new HashMap<NamedType, NamedType>();
+        HashMap<NamedType, NamedType> subtypes = new HashMap<>();
+
         // then consider registered subtypes (which have precedence over annotations)
         if (_registeredSubtypes != null) {
             Class<?> rawBase = type.getRawType();
@@ -223,19 +237,23 @@ public class StdSubtypeResolver
             }
         }
 
+        //For Serialization we only want to return a single NamedType per class so it's
+        //unambiguous what name we use.
+        NamedType typeOnlyNamedType = new NamedType(namedType.getType());
+
         // First things first: is base type itself included?
-        if (collectedSubtypes.containsKey(namedType)) {
+        if (collectedSubtypes.containsKey(typeOnlyNamedType)) {
             // if so, no recursion; however, may need to update name?
             if (namedType.hasName()) {
-                NamedType prev = collectedSubtypes.get(namedType);
+                NamedType prev = collectedSubtypes.get(typeOnlyNamedType);
                 if (!prev.hasName()) {
-                    collectedSubtypes.put(namedType, namedType);
+                    collectedSubtypes.put(typeOnlyNamedType, namedType);
                 }
             }
             return;
         }
         // if it wasn't, add and check subtypes recursively
-        collectedSubtypes.put(namedType, namedType);
+        collectedSubtypes.put(typeOnlyNamedType, namedType);
         Collection<NamedType> st = ai.findSubtypes(annotatedType);
         if (st != null && !st.isEmpty()) {
             for (NamedType subtype : st) {
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/StdTypeResolverBuilder.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/StdTypeResolverBuilder.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/StdTypeResolverBuilder.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/StdTypeResolverBuilder.java	2020-06-25 02:44:21.000000000 +0000
@@ -84,7 +84,10 @@ public class StdTypeResolverBuilder
         // 03-Oct-2016, tatu: As per [databind#1395] better prevent use for primitives,
         //    regardless of setting
         if (baseType.isPrimitive()) {
-            return null;
+            // 19-Jun-2020, tatu: But for [databind#2753], allow overriding
+            if (!allowPrimitiveTypes(config, baseType)) {
+                return null;
+            }
         }
         TypeIdResolver idRes = idResolver(config, baseType, subTypeValidator(config),
                 subtypes, true, false);
@@ -118,7 +121,10 @@ public class StdTypeResolverBuilder
         // 03-Oct-2016, tatu: As per [databind#1395] better prevent use for primitives,
         //    regardless of setting
         if (baseType.isPrimitive()) {
-            return null;
+            // 19-Jun-2020, tatu: But for [databind#2753], allow overriding
+            if (!allowPrimitiveTypes(config, baseType)) {
+                return null;
+            }
         }
 
         // 27-Apr-2019, tatu: Part of [databind#2195]; must first check whether any subtypes
@@ -151,7 +157,6 @@ public class StdTypeResolverBuilder
     protected JavaType defineDefaultImpl(DeserializationConfig config, JavaType baseType) {
         JavaType defaultImpl;
         if (_defaultImpl == null) {
-            //Fis of issue #955
             if (config.isEnabled(MapperFeature.USE_BASE_TYPE_AS_DEFAULT_IMPL) && !baseType.isAbstract()) {
                 defaultImpl = baseType;
             } else {
@@ -332,4 +337,31 @@ public class StdTypeResolverBuilder
                         ClassUtil.classNameOf(ptv), ClassUtil.classNameOf(baseType.getRawClass()))
         );
     }
+
+    /*
+    /**********************************************************
+    /* Overridable helper methods
+    /**********************************************************
+     */
+
+    /**
+     * Overridable helper method that is called to determine whether type serializers
+     * and type deserializers may be created even if base type is Java {@code primitive}
+     * type.
+     * Default implementation simply returns {@code false} (since primitive types can not
+     * be sub-classed, are never polymorphic) but custom implementations
+     * may change the logic for some special cases.
+     *
+     * @param config Currently active configuration
+     * @param baseType Primitive base type for property being handled
+     *
+     * @return True if type (de)serializer may be created even if base type is Java
+     *    {@code primitive} type; false if not
+     *
+     * @since 2.11.1
+     */
+    protected boolean allowPrimitiveTypes(MapperConfig<?> config,
+            JavaType baseType) {
+        return false;
+    }
 }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/SubTypeValidator.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/SubTypeValidator.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/SubTypeValidator.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/SubTypeValidator.java	2020-06-25 02:44:21.000000000 +0000
@@ -49,6 +49,9 @@ public class SubTypeValidator
         // [databind#1737]; 3rd party
 //s.add("org.springframework.aop.support.AbstractBeanFactoryPointcutAdvisor"); // deprecated by [databind#1855]
         s.add("org.springframework.beans.factory.config.PropertyPathFactoryBean");
+        // [databind#2680]
+        s.add("org.springframework.aop.config.MethodLocatingFactoryBean");
+        s.add("org.springframework.beans.factory.config.BeanReferenceFactoryBean");
 
 // s.add("com.mchange.v2.c3p0.JndiRefForwardingDataSource"); // deprecated by [databind#1931]
 // s.add("com.mchange.v2.c3p0.WrapperConnectionPoolDataSource"); // - "" -
@@ -74,10 +77,11 @@ public class SubTypeValidator
         s.add("com.sun.deploy.security.ruleset.DRSHelper");
         s.add("org.apache.axis2.jaxws.spi.handler.HandlerResolverImpl");
 
-        // [databind#2186]: yet more 3rd party gadgets
+        // [databind#2186], [databind#2670]: yet more 3rd party gadgets
         s.add("org.jboss.util.propertyeditor.DocumentEditor");
         s.add("org.apache.openjpa.ee.RegistryManagedRuntime");
         s.add("org.apache.openjpa.ee.JNDIManagedRuntime");
+        s.add("org.apache.openjpa.ee.WASRegistryManagedRuntime"); // [#2670] addition
         s.add("org.apache.axis2.transport.jms.JMSOutTransportInfo");
 
         // [databind#2326] (2.9.9)
@@ -109,8 +113,10 @@ public class SubTypeValidator
         s.add("org.apache.commons.configuration.JNDIConfiguration");
         s.add("org.apache.commons.configuration2.JNDIConfiguration");
 
-        // [databind#2469]: xalan2
+        // [databind#2469]: xalan
         s.add("org.apache.xalan.lib.sql.JNDIConnectionPool");
+        // [databind#2704]: xalan2
+        s.add("com.sun.org.apache.xalan.internal.lib.sql.JNDIConnectionPool");
 
         // [databind#2478]: comons-dbcp, p6spy
         s.add("org.apache.commons.dbcp.datasources.PerUserPoolDataSource");
@@ -125,6 +131,72 @@ public class SubTypeValidator
         s.add("net.sf.ehcache.transaction.manager.selector.GenericJndiSelector");
         s.add("net.sf.ehcache.transaction.manager.selector.GlassfishSelector");
 
+        // [databind#2620]: xbean-reflect
+        s.add("org.apache.xbean.propertyeditor.JndiConverter");
+
+        // [databind#2631]: shaded hikari-config
+        s.add("org.apache.hadoop.shaded.com.zaxxer.hikari.HikariConfig");
+
+        // [databind#2634]: ibatis-sqlmap, anteros-core
+        s.add("com.ibatis.sqlmap.engine.transaction.jta.JtaTransactionConfig");
+        s.add("br.com.anteros.dbcp.AnterosDBCPConfig");
+
+        // [databind#2642]: javax.swing (jdk)
+        s.add("javax.swing.JEditorPane");
+
+        // [databind#2648], [databind#2653]: shire-core
+        s.add("org.apache.shiro.realm.jndi.JndiRealmFactory");
+        s.add("org.apache.shiro.jndi.JndiObjectFactory");
+
+        // [databind#2658]: ignite-jta (, quartz-core)
+        s.add("org.apache.ignite.cache.jta.jndi.CacheJndiTmLookup");
+        s.add("org.apache.ignite.cache.jta.jndi.CacheJndiTmFactory");
+        s.add("org.quartz.utils.JNDIConnectionProvider");
+
+        // [databind#2659]: aries.transaction.jms
+        s.add("org.apache.aries.transaction.jms.internal.XaPooledConnectionFactory");
+        s.add("org.apache.aries.transaction.jms.RecoverablePooledConnectionFactory");
+
+        // [databind#2660]: caucho-quercus
+        s.add("com.caucho.config.types.ResourceRef");
+
+        // [databind#2662]: aoju/bus-proxy
+        s.add("org.aoju.bus.proxy.provider.RmiProvider");
+        s.add("org.aoju.bus.proxy.provider.remoting.RmiProvider");
+
+        // [databind#2664]: activemq-core, activemq-pool, activemq-pool-jms
+
+        s.add("org.apache.activemq.ActiveMQConnectionFactory"); // core
+        s.add("org.apache.activemq.ActiveMQXAConnectionFactory");
+        s.add("org.apache.activemq.spring.ActiveMQConnectionFactory");
+        s.add("org.apache.activemq.spring.ActiveMQXAConnectionFactory");
+        s.add("org.apache.activemq.pool.JcaPooledConnectionFactory"); // pool
+        s.add("org.apache.activemq.pool.PooledConnectionFactory");
+        s.add("org.apache.activemq.pool.XaPooledConnectionFactory");
+        s.add("org.apache.activemq.jms.pool.XaPooledConnectionFactory"); // pool-jms
+        s.add("org.apache.activemq.jms.pool.JcaPooledConnectionFactory");
+        
+        // [databind#2666]: apache/commons-jms
+        s.add("org.apache.commons.proxy.provider.remoting.RmiProvider");
+
+        // [databind#2682]: commons-jelly
+        s.add("org.apache.commons.jelly.impl.Embedded");
+
+        // [databind#2688]: apache/drill
+        s.add("oadd.org.apache.xalan.lib.sql.JNDIConnectionPool");
+
+        // [databind#2698]: weblogic w/ oracle/aq-jms
+        // (note: dependency not available via Maven Central, but as part of
+        // weblogic installation, possibly fairly old version(s))
+        s.add("oracle.jms.AQjmsQueueConnectionFactory");
+        s.add("oracle.jms.AQjmsXATopicConnectionFactory");
+        s.add("oracle.jms.AQjmsTopicConnectionFactory");
+        s.add("oracle.jms.AQjmsXAQueueConnectionFactory");
+        s.add("oracle.jms.AQjmsXAConnectionFactory");
+
+        // [databind#2764]: org.jsecurity:
+        s.add("org.jsecurity.realm.jndi.JndiRealmFactory");
+
         DEFAULT_NO_DESER_CLASS_NAMES = Collections.unmodifiableSet(s);
     }
 
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/TypeDeserializerBase.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/TypeDeserializerBase.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/TypeDeserializerBase.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/TypeDeserializerBase.java	2020-06-25 02:44:21.000000000 +0000
@@ -5,12 +5,10 @@ import java.util.Map;
 import java.util.concurrent.ConcurrentHashMap;
 
 import com.fasterxml.jackson.annotation.JsonTypeInfo;
+
 import com.fasterxml.jackson.core.*;
-import com.fasterxml.jackson.databind.BeanProperty;
-import com.fasterxml.jackson.databind.DeserializationContext;
-import com.fasterxml.jackson.databind.DeserializationFeature;
-import com.fasterxml.jackson.databind.JavaType;
-import com.fasterxml.jackson.databind.JsonDeserializer;
+
+import com.fasterxml.jackson.databind.*;
 import com.fasterxml.jackson.databind.deser.std.NullifyingDeserializer;
 import com.fasterxml.jackson.databind.jsontype.TypeDeserializer;
 import com.fasterxml.jackson.databind.jsontype.TypeIdResolver;
@@ -188,7 +186,13 @@ public abstract class TypeDeserializerBa
                     //  Whether this is sufficient to avoid problems remains to be seen, but for
                     //  now it should improve things.
                     if (!type.hasGenericTypes()) {
-                        type = ctxt.getTypeFactory().constructSpecializedType(_baseType, type.getRawClass());
+                        try { // [databind#2668]: Should not expose generic RTEs
+                            type = ctxt.constructSpecializedType(_baseType, type.getRawClass());
+                        } catch (IllegalArgumentException e) {
+                            // 29-Mar-2020, tatu: I hope this is not misleading for other cases, but
+                            //   for [databind#2668] seems reasonable
+                            throw ctxt.invalidTypeIdException(_baseType, typeId, e.getMessage());
+                        }
                     }
                 }
                 deser = ctxt.findContextualValueDeserializer(type, _property);
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/TypeNameIdResolver.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/TypeNameIdResolver.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/TypeNameIdResolver.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/jsontype/impl/TypeNameIdResolver.java	2020-06-25 02:44:21.000000000 +0000
@@ -7,6 +7,7 @@ import com.fasterxml.jackson.annotation.
 import com.fasterxml.jackson.databind.BeanDescription;
 import com.fasterxml.jackson.databind.DatabindContext;
 import com.fasterxml.jackson.databind.JavaType;
+import com.fasterxml.jackson.databind.MapperFeature;
 import com.fasterxml.jackson.databind.cfg.MapperConfig;
 import com.fasterxml.jackson.databind.jsontype.NamedType;
 
@@ -29,6 +30,11 @@ public class TypeNameIdResolver extends
      */
     protected final Map<String, JavaType> _idToType;
 
+    /**
+     * @since 2.11
+     */
+    protected final boolean _caseInsensitive;
+
     protected TypeNameIdResolver(MapperConfig<?> config, JavaType baseType,
             ConcurrentHashMap<String, String> typeToId,
             HashMap<String, JavaType> idToType)
@@ -37,6 +43,7 @@ public class TypeNameIdResolver extends
         _config = config;
         _typeToId = typeToId;
         _idToType = idToType;
+        _caseInsensitive = config.isEnabled(MapperFeature.ACCEPT_CASE_INSENSITIVE_VALUES);
     }
 
     public static TypeNameIdResolver construct(MapperConfig<?> config, JavaType baseType,
@@ -60,6 +67,8 @@ public class TypeNameIdResolver extends
             //    for a single value.
             typeToId = new ConcurrentHashMap<>(4);
         }
+        final boolean caseInsensitive = config.isEnabled(MapperFeature.ACCEPT_CASE_INSENSITIVE_VALUES);
+
         if (subtypes != null) {
             for (NamedType t : subtypes) {
                 // no name? Need to figure out default; for now, let's just
@@ -70,6 +79,10 @@ public class TypeNameIdResolver extends
                     typeToId.put(cls.getName(), id);
                 }
                 if (forDeser) {
+                    // [databind#1983]: for case-insensitive lookups must canonicalize:
+                    if (caseInsensitive) {
+                        id = id.toLowerCase();
+                    }
                     // One more problem; sometimes we have same name for multiple types;
                     // if so, use most specific
                     JavaType prev = idToType.get(id);
@@ -138,6 +151,10 @@ public class TypeNameIdResolver extends
     }
     
     protected JavaType _typeFromId(String id) {
+        // [databind#1983]: for case-insensitive lookups must canonicalize:
+        if (_caseInsensitive) {
+            id = id.toLowerCase();
+        }
         // Now: if no type is found, should we try to locate it by
         // some other means? (specifically, if in same package as base type,
         // could just try Class.forName)
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/jsontype/NamedType.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/jsontype/NamedType.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/jsontype/NamedType.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/jsontype/NamedType.java	2020-06-25 02:44:21.000000000 +0000
@@ -1,5 +1,7 @@
 package com.fasterxml.jackson.databind.jsontype;
 
+import java.util.Objects;
+
 /**
  * Simple container class for types with optional logical name, used
  * as external identifier
@@ -14,10 +16,10 @@ public final class NamedType implements
     protected String _name;
     
     public NamedType(Class<?> c) { this(c, null); }
-    
+
     public NamedType(Class<?> c, String name) {
         _class = c;
-        _hashCode = c.getName().hashCode();
+        _hashCode = c.getName().hashCode() + ((name == null) ? 0 : name.hashCode());
         setName(name);
     }
 
@@ -28,14 +30,16 @@ public final class NamedType implements
     public boolean hasName() { return _name != null; }
     
     /**
-     * Equality is defined based on class only, not on name
+     * Equality is defined based on class and name
      */
     @Override
     public boolean equals(Object o) {
         if (o == this) return true;
         if (o == null) return false;
         if (o.getClass() != getClass()) return false;
-        return _class == ((NamedType) o)._class;
+        NamedType other = (NamedType)o;
+        return (_class == other._class)
+                && Objects.equals(_name, other._name);
     }
 
     @Override
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/jsontype/SubtypeResolver.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/jsontype/SubtypeResolver.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/jsontype/SubtypeResolver.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/jsontype/SubtypeResolver.java	2020-06-25 02:44:21.000000000 +0000
@@ -14,9 +14,25 @@ import com.fasterxml.jackson.databind.in
  */
 public abstract class SubtypeResolver
 {
+    /**
+     * Method called by {@code ObjectMapper.copy()} to make sure that
+     * {@link SubtypeResolver} instances used by two independent mappers
+     * can not cause thread-safety issues: if resolver is immutable, it
+     * may return {@code this}, but if not, it should create a copy with
+     * same configuration and return that instead.
+     *
+     * @return Either new instance with same configuration as this one (if
+     *    instances are mutable), or this instance (if immutable)
+     *
+     * @since 2.12
+     */
+    public SubtypeResolver copy() {
+        return this;
+    }
+
     /*
     /**********************************************************
-    /* Methods for registering external subtype definitions
+    /* Methods for registering external subtype definitions (init/config)
     /**********************************************************
      */
 
@@ -36,7 +52,7 @@ public abstract class SubtypeResolver
     
     /*
     /**********************************************************
-    /* Subtype resolution
+    /* Subtype resolution (public API)
     /**********************************************************
      */
 
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/MapperFeature.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/MapperFeature.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/MapperFeature.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/MapperFeature.java	2020-06-25 02:44:21.000000000 +0000
@@ -501,8 +501,26 @@ public enum MapperFeature implements Con
      *
      * @since 2.9
      */
-    IGNORE_MERGE_FOR_UNMERGEABLE(true)
+    IGNORE_MERGE_FOR_UNMERGEABLE(true),
 
+    /**
+     * Setting that may be enabled to reconfigure <b>default</b>
+     * {@link com.fasterxml.jackson.databind.jsontype.PolymorphicTypeValidator}
+     * used by legacy {@code ObjectMapper.enableDefaultTyping()} methods as well as default used
+     * for annotation-based polymorphic handling so that it uses
+     * {@link com.fasterxml.jackson.databind.jsontype.DefaultBaseTypeLimitingValidator}.
+     * This will block use of a set of "unsafe" base types such as {@link java.lang.Object}
+     * through methods that do not require passing of explicit {@link com.fasterxml.jackson.databind.jsontype.PolymorphicTypeValidator}.
+     * It is still possible to override one used; this only affects default settings.
+     *<p>
+     * Enabling of this setting is <b>strongly recommended</b>.
+     *<p>
+     * Feature is disabled by default in 2.x for backwards compatibility reasons: it will become
+     * default setting (and feature likely removed) in 3.0.
+     * 
+     * @since 2.11
+     */
+    BLOCK_UNSAFE_POLYMORPHIC_BASE_TYPES(false)
     ;
 
     private final boolean _defaultState;
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/module/SimpleAbstractTypeResolver.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/module/SimpleAbstractTypeResolver.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/module/SimpleAbstractTypeResolver.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/module/SimpleAbstractTypeResolver.java	2020-06-25 02:44:21.000000000 +0000
@@ -30,7 +30,7 @@ public class SimpleAbstractTypeResolver
     extends AbstractTypeResolver
     implements java.io.Serializable
 {
-    private static final long serialVersionUID = 8635483102371490919L;
+    private static final long serialVersionUID = 1L;
 
     /**
      * Mappings from super types to subtypes
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/module/SimpleDeserializers.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/module/SimpleDeserializers.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/module/SimpleDeserializers.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/module/SimpleDeserializers.java	2020-06-25 02:44:21.000000000 +0000
@@ -18,7 +18,8 @@ import com.fasterxml.jackson.databind.ty
  * all mappings must be to exact declared deserialization type.
  */
 public class SimpleDeserializers
-   implements Deserializers, java.io.Serializable
+   extends Deserializers.Base
+   implements java.io.Serializable
 {
     private static final long serialVersionUID = 1L;
 
@@ -78,7 +79,7 @@ public class SimpleDeserializers
     /* Serializers implementation
     /**********************************************************
      */
-    
+
     @Override
     public JsonDeserializer<?> findArrayDeserializer(ArrayType type,
             DeserializationConfig config, BeanDescription beanDesc,
@@ -180,6 +181,13 @@ public class SimpleDeserializers
         return _find(type);
     }
 
+    @Override // since 2.11
+    public boolean hasDeserializerFor(DeserializationConfig config,
+            Class<?> valueType) {
+        return (_classMappings != null)
+                && _classMappings.containsKey(new ClassKey(valueType));
+    }
+
     private final JsonDeserializer<?> _find(JavaType type) {
         if (_classMappings == null) {
             return null;
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/module/SimpleSerializers.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/module/SimpleSerializers.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/module/SimpleSerializers.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/module/SimpleSerializers.java	2020-06-25 02:44:21.000000000 +0000
@@ -28,7 +28,7 @@ public class SimpleSerializers
     extends Serializers.Base
     implements java.io.Serializable
 {
-    private static final long serialVersionUID = 8531646511998456779L;
+    private static final long serialVersionUID = 3L;
 
     /**
      * Class-based mappings that are used both for exact and
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/node/DecimalNode.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/node/DecimalNode.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/node/DecimalNode.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/node/DecimalNode.java	2020-06-25 02:44:21.000000000 +0000
@@ -11,6 +11,7 @@ import com.fasterxml.jackson.databind.*;
  * Numeric node that contains values that do not fit in simple
  * integer (int, long) or floating point (double) values.
  */
+@SuppressWarnings("serial")
 public class DecimalNode
     extends NumericNode
 {
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/node/NodeCursor.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/node/NodeCursor.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/node/NodeCursor.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/node/NodeCursor.java	2020-06-25 02:44:21.000000000 +0000
@@ -75,11 +75,10 @@ abstract class NodeCursor
      */
 
     public abstract JsonToken nextToken();
-    public abstract JsonToken nextValue();
-    public abstract JsonToken endToken();
-
     public abstract JsonNode currentNode();
-    public abstract boolean currentHasChildren();
+
+    public abstract NodeCursor startObject();
+    public abstract NodeCursor startArray();
     
     /**
      * Method called to create a new context for iterating all
@@ -104,9 +103,8 @@ abstract class NodeCursor
      */
 
     /**
-     * Context matching root-level value nodes (i.e. anything other
-     * than JSON Object and Array).
-     * Note that context is NOT created for leaf values.
+     * Context for all root-level value nodes (including Arrays and Objects):
+     * only context for scalar values.
      */
     protected final static class RootCursor
         extends NodeCursor
@@ -135,26 +133,28 @@ abstract class NodeCursor
             _node = null;
             return null;
         }
-        
-        @Override
-        public JsonToken nextValue() { return nextToken(); }
+
         @Override
-        public JsonToken endToken() { return null; }
+        public JsonNode currentNode() {
+            // May look weird, but is necessary so as not to expose current node
+            // before it has been traversed
+            return _done ? _node : null;
+        }
+
         @Override
-        public JsonNode currentNode() { return _node; }
+        public NodeCursor startArray() { return new ArrayCursor(_node, this); }
+
         @Override
-        public boolean currentHasChildren() { return false; }
+        public NodeCursor startObject() { return new ObjectCursor(_node, this); }
     }
 
-    /**
-     * Cursor used for traversing non-empty JSON Array nodes
-     */
+    // Cursor used for traversing JSON Array nodes
     protected final static class ArrayCursor
         extends NodeCursor
     {
         protected Iterator<JsonNode> _contents;
 
-        protected JsonNode _currentNode;
+        protected JsonNode _currentElement;
 
         public ArrayCursor(JsonNode n, NodeCursor p) {
             super(JsonStreamContext.TYPE_ARRAY, p);
@@ -165,31 +165,25 @@ abstract class NodeCursor
         public JsonToken nextToken()
         {
             if (!_contents.hasNext()) {
-                _currentNode = null;
-                return null;
+                _currentElement = null;
+                return JsonToken.END_ARRAY;
             }
             ++_index;
-            _currentNode = _contents.next();
-            return _currentNode.asToken();
+            _currentElement = _contents.next();
+            return _currentElement.asToken();
         }
 
         @Override
-        public JsonToken nextValue() { return nextToken(); }
-        @Override
-        public JsonToken endToken() { return JsonToken.END_ARRAY; }
+        public JsonNode currentNode() { return _currentElement; }
 
         @Override
-        public JsonNode currentNode() { return _currentNode; }
+        public NodeCursor startArray() { return new ArrayCursor(_currentElement, this); }
+
         @Override
-        public boolean currentHasChildren() {
-            // note: ONLY to be called for container nodes
-            return ((ContainerNode<?>) currentNode()).size() > 0;
-        }
+        public NodeCursor startObject() { return new ObjectCursor(_currentElement, this); }
     }
 
-    /**
-     * Cursor used for traversing non-empty JSON Object nodes
-     */
+    // Cursor used for traversing JSON Object nodes
     protected final static class ObjectCursor
         extends NodeCursor
     {
@@ -213,7 +207,7 @@ abstract class NodeCursor
                 if (!_contents.hasNext()) {
                     _currentName = null;
                     _current = null;
-                    return null;
+                    return JsonToken.END_OBJECT;
                 }
                 ++_index;
                 _needEntry = false;
@@ -226,26 +220,14 @@ abstract class NodeCursor
         }
 
         @Override
-        public JsonToken nextValue()
-        {
-            JsonToken t = nextToken();
-            if (t == JsonToken.FIELD_NAME) {
-                t = nextToken();
-            }
-            return t;
+        public JsonNode currentNode() {
+            return (_current == null) ? null : _current.getValue();
         }
 
         @Override
-        public JsonToken endToken() { return JsonToken.END_OBJECT; }
+        public NodeCursor startArray() { return new ArrayCursor(currentNode(), this); }
 
         @Override
-        public JsonNode currentNode() {
-            return (_current == null) ? null : _current.getValue();
-        }
-        @Override
-        public boolean currentHasChildren() {
-            // note: ONLY to be called for container nodes
-            return ((ContainerNode<?>) currentNode()).size() > 0;
-        }
+        public NodeCursor startObject() { return new ObjectCursor(currentNode(), this); }
     }
 }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/node/TreeTraversingParser.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/node/TreeTraversingParser.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/node/TreeTraversingParser.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/node/TreeTraversingParser.java	2020-06-25 02:44:21.000000000 +0000
@@ -7,7 +7,6 @@ import java.math.BigInteger;
 
 import com.fasterxml.jackson.core.*;
 import com.fasterxml.jackson.core.base.ParserMinimalBase;
-
 import com.fasterxml.jackson.databind.JsonNode;
 
 /**
@@ -38,18 +37,6 @@ public class TreeTraversingParser extend
      */
 
     /**
-     * Sometimes parser needs to buffer a single look-ahead token; if so,
-     * it'll be stored here. This is currently used for handling 
-     */
-    protected JsonToken _nextToken;
-
-    /**
-     * Flag needed to handle recursion into contents of child
-     * Array/Object nodes.
-     */
-    protected boolean _startContainer;
-    
-    /**
      * Flag that indicates whether parser is closed or not. Gets
      * set when parser is either closed by explicit call
      * ({@link #close}) or when end-of-input is reached.
@@ -68,15 +55,7 @@ public class TreeTraversingParser extend
     {
         super(0);
         _objectCodec = codec;
-        if (n.isArray()) {
-            _nextToken = JsonToken.START_ARRAY;
-            _nodeCursor = new NodeCursor.ArrayCursor(n, null);
-        } else if (n.isObject()) {
-            _nextToken = JsonToken.START_OBJECT;
-            _nodeCursor = new NodeCursor.ObjectCursor(n, null);
-        } else { // value node
-            _nodeCursor = new NodeCursor.RootCursor(n, null);
-        }
+        _nodeCursor = new NodeCursor.RootCursor(n, null);
     }
 
     @Override
@@ -119,57 +98,37 @@ public class TreeTraversingParser extend
     @Override
     public JsonToken nextToken() throws IOException, JsonParseException
     {
-        if (_nextToken != null) {
-            _currToken = _nextToken;
-            _nextToken = null;
-            return _currToken;
-        }
-        // are we to descend to a container child?
-        if (_startContainer) {
-            _startContainer = false;
-            // minor optimization: empty containers can be skipped
-            if (!_nodeCursor.currentHasChildren()) {
-                _currToken = (_currToken == JsonToken.START_OBJECT) ?
-                    JsonToken.END_OBJECT : JsonToken.END_ARRAY;
-                return _currToken;
-            }
-            _nodeCursor = _nodeCursor.iterateChildren();
-            _currToken = _nodeCursor.nextToken();
-            if (_currToken == JsonToken.START_OBJECT || _currToken == JsonToken.START_ARRAY) {
-                _startContainer = true;
-            }
-            return _currToken;
-        }
-        // No more content?
-        if (_nodeCursor == null) {
+        _currToken = _nodeCursor.nextToken();
+        if (_currToken == null) {
             _closed = true; // if not already set
             return null;
         }
-        // Otherwise, next entry from current cursor
-        _currToken = _nodeCursor.nextToken();
-        if (_currToken != null) {
-            if (_currToken == JsonToken.START_OBJECT || _currToken == JsonToken.START_ARRAY) {
-                _startContainer = true;
-            }
-            return _currToken;
-        }
-        // null means no more children; need to return end marker
-        _currToken = _nodeCursor.endToken();
-        _nodeCursor = _nodeCursor.getParent();
+        switch (_currToken) {
+        case START_OBJECT:
+            _nodeCursor = _nodeCursor.startObject();
+            break;
+        case START_ARRAY:
+            _nodeCursor = _nodeCursor.startArray();
+            break;
+        case END_OBJECT:
+        case END_ARRAY:
+            _nodeCursor = _nodeCursor.getParent();
+        default:
+        }
         return _currToken;
     }
-    
+
     // default works well here:
-    //public JsonToken nextValue() throws IOException, JsonParseException
+    //public JsonToken nextValue() throws IOException
 
     @Override
-    public JsonParser skipChildren() throws IOException, JsonParseException
+    public JsonParser skipChildren() throws IOException
     {
         if (_currToken == JsonToken.START_OBJECT) {
-            _startContainer = false;
+            _nodeCursor = _nodeCursor.getParent();
             _currToken = JsonToken.END_OBJECT;
         } else if (_currToken == JsonToken.START_ARRAY) {
-            _startContainer = false;
+            _nodeCursor = _nodeCursor.getParent();
             _currToken = JsonToken.END_ARRAY;
         }
         return this;
@@ -186,19 +145,24 @@ public class TreeTraversingParser extend
     /**********************************************************
      */
 
-    @Override
-    public String getCurrentName() {
-        return (_nodeCursor == null) ? null : _nodeCursor.getCurrentName();
+    @Override public String getCurrentName() {
+        NodeCursor crsr = _nodeCursor;
+        if (_currToken == JsonToken.START_OBJECT || _currToken == JsonToken.START_ARRAY) {
+            crsr = crsr.getParent();
+        }
+        return (crsr == null) ? null : crsr.getCurrentName();
     }
 
-    @Override
-    public void overrideCurrentName(String name)
-    {
-        if (_nodeCursor != null) {
-            _nodeCursor.overrideCurrentName(name);
+    @Override public void overrideCurrentName(String name) {
+        NodeCursor crsr = _nodeCursor;
+        if (_currToken == JsonToken.START_OBJECT || _currToken == JsonToken.START_ARRAY) {
+            crsr = crsr.getParent();
+        }
+        if (crsr != null) {
+            crsr.overrideCurrentName(name);
         }
     }
-    
+
     @Override
     public JsonStreamContext getParsingContext() {
         return _nodeCursor;
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ObjectMapper.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ObjectMapper.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ObjectMapper.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ObjectMapper.java	2020-06-25 02:44:21.000000000 +0000
@@ -245,8 +245,17 @@ public class ObjectMapper
          * @since 2.10
          */
         public DefaultTypeResolverBuilder(DefaultTyping t, PolymorphicTypeValidator ptv) {
-            _appliesFor = Objects.requireNonNull(t, "Can not pass `null` DefaultTyping");
-            _subtypeValidator = Objects.requireNonNull(ptv, "Can not pass `null` PolymorphicTypeValidator");
+            _appliesFor = _requireNonNull(t, "Can not pass `null` DefaultTyping");
+            _subtypeValidator = _requireNonNull(ptv, "Can not pass `null` PolymorphicTypeValidator");
+        }
+
+        // 20-Jan-2020: as per [databind#2599] Objects.requireNonNull() from JDK7 not in all Android so
+        private static <T> T _requireNonNull(T value, String msg) {
+            // Replacement for: return Objects.requireNonNull(t, msg);
+            if (value == null) {
+                throw new NullPointerException(msg);
+            }
+            return value;
         }
 
         /**
@@ -329,8 +338,6 @@ public class ObjectMapper
         }
     }
 
-    
-    
     /*
     /**********************************************************
     /* Internal constants, singletons
@@ -351,7 +358,8 @@ public class ObjectMapper
             null, StdDateFormat.instance, null,
             Locale.getDefault(),
             null, // to indicate "use Jackson default TimeZone" (UTC since Jackson 2.7)
-            Base64Variants.getDefaultVariant(), // 2.1
+            Base64Variants.getDefaultVariant(),
+            // Only for 2.x; 3.x will use more restrictive default
             LaissezFaireSubTypeValidator.instance
     );
 
@@ -502,7 +510,7 @@ public class ObjectMapper
      * (should very quickly converge to zero after startup), let's
      * explicitly define a low concurrency setting.
      *<p>
-     * Since version 1.5, these may are either "raw" deserializers (when
+     * These may are either "raw" deserializers (when
      * no type information is needed for base type), or type-wrapped
      * deserializers (if it is needed)
      */
@@ -549,7 +557,7 @@ public class ObjectMapper
     {
         _jsonFactory = src._jsonFactory.copy();
         _jsonFactory.setCodec(this);
-        _subtypeResolver = src._subtypeResolver;
+        _subtypeResolver = src._subtypeResolver.copy();
         _typeFactory = src._typeFactory;
         _injectableValues = src._injectableValues;
         _configOverrides = src._configOverrides.copy();
@@ -1090,6 +1098,225 @@ public class ObjectMapper
 
     /*
     /**********************************************************
+    /* Factory methods for creating JsonGenerators (added in 2.11)
+    /**********************************************************
+     */
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonGenerator}
+     * to write content using specified {@link OutputStream}.
+     * Generator is not managed (or "owned") by mapper: caller is responsible
+     * for properly closing it once content generation is complete.
+     *
+     * @since 2.11
+     */
+    public JsonGenerator createGenerator(OutputStream out) throws IOException {
+        _assertNotNull("out", out);
+        return _jsonFactory.createGenerator(out, JsonEncoding.UTF8);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonGenerator}
+     * to write content using specified {@link OutputStream} and encoding.
+     * Generator is not managed (or "owned") by mapper: caller is responsible
+     * for properly closing it once content generation is complete.
+     *
+     * @since 2.11
+     */
+    public JsonGenerator createGenerator(OutputStream out, JsonEncoding enc) throws IOException {
+        _assertNotNull("out", out);
+        return _jsonFactory.createGenerator(out, enc);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonGenerator}
+     * to write content using specified {@link Writer}.
+     * Generator is not managed (or "owned") by mapper: caller is responsible
+     * for properly closing it once content generation is complete.
+     *
+     * @since 2.11
+     */
+    public JsonGenerator createGenerator(Writer w) throws IOException {
+        _assertNotNull("w", w);
+        return _jsonFactory.createGenerator(w);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonGenerator}
+     * to write content to specified {@link File}, using specified encoding.
+     * Generator is not managed (or "owned") by mapper: caller is responsible
+     * for properly closing it once content generation is complete.
+     *
+     * @since 2.11
+     */
+    public JsonGenerator createGenerator(File outputFile, JsonEncoding enc) throws IOException {
+        _assertNotNull("outputFile", outputFile);
+        return _jsonFactory.createGenerator(outputFile, enc);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonGenerator}
+     * to write content using specified {@link DataOutput}.
+     * Generator is not managed (or "owned") by mapper: caller is responsible
+     * for properly closing it once content generation is complete.
+     *
+     * @since 2.11
+     */
+    public JsonGenerator createGenerator(DataOutput out) throws IOException {
+        _assertNotNull("out", out);
+        return _jsonFactory.createGenerator(out);
+    }
+
+    /*
+    /**********************************************************
+    /* Factory methods for creating JsonParsers (added in 2.11)
+    /**********************************************************
+     */
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonParser}
+     * to read content from specified {@link File}.
+     * Parser is not managed (or "owned") by ObjectMapper: caller is responsible
+     * for properly closing it once content reading is complete.
+     *
+     * @since 2.11
+     */
+    public JsonParser createParser(File src) throws IOException {
+        _assertNotNull("src", src);
+        return _jsonFactory.createParser(src);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonParser}
+     * to read content from specified {@link File}.
+     * Parser is not managed (or "owned") by ObjectMapper: caller is responsible
+     * for properly closing it once content reading is complete.
+     *
+     * @since 2.11
+     */
+    public JsonParser createParser(URL src) throws IOException {
+        _assertNotNull("src", src);
+        return _jsonFactory.createParser(src);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonParser}
+     * to read content using specified {@link InputStream}.
+     * Parser is not managed (or "owned") by ObjectMapper: caller is responsible
+     * for properly closing it once content reading is complete.
+     *
+     * @since 2.11
+     */
+    public JsonParser createParser(InputStream in) throws IOException {
+        _assertNotNull("in", in);
+        return _jsonFactory.createParser(in);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonParser}
+     * to read content using specified {@link Reader}.
+     * Parser is not managed (or "owned") by ObjectMapper: caller is responsible
+     * for properly closing it once content reading is complete.
+     *
+     * @since 2.11
+     */
+    public JsonParser createParser(Reader r) throws IOException {
+        _assertNotNull("r", r);
+        return _jsonFactory.createParser(r);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonParser}
+     * to read content from specified byte array.
+     * Parser is not managed (or "owned") by ObjectMapper: caller is responsible
+     * for properly closing it once content reading is complete.
+     *
+     * @since 2.11
+     */
+    public JsonParser createParser(byte[] content) throws IOException {
+        _assertNotNull("content", content);
+        return _jsonFactory.createParser(content);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonParser}
+     * to read content from specified byte array.
+     * Parser is not managed (or "owned") by ObjectMapper: caller is responsible
+     * for properly closing it once content reading is complete.
+     *
+     * @since 2.11
+     */
+    public JsonParser createParser(byte[] content, int offset, int len) throws IOException {
+        _assertNotNull("content", content);
+        return _jsonFactory.createParser(content, offset, len);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonParser}
+     * to read content from specified String.
+     * Parser is not managed (or "owned") by ObjectMapper: caller is responsible
+     * for properly closing it once content reading is complete.
+     *
+     * @since 2.11
+     */
+    public JsonParser createParser(String content) throws IOException {
+        _assertNotNull("content", content);
+        return _jsonFactory.createParser(content);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonParser}
+     * to read content from specified character array
+     * Parser is not managed (or "owned") by ObjectMapper: caller is responsible
+     * for properly closing it once content reading is complete.
+     *
+     * @since 2.11
+     */
+    public JsonParser createParser(char[] content) throws IOException {
+        _assertNotNull("content", content);
+        return _jsonFactory.createParser(content);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonParser}
+     * to read content from specified character array.
+     * Parser is not managed (or "owned") by ObjectMapper: caller is responsible
+     * for properly closing it once content reading is complete.
+     *
+     * @since 2.11
+     */
+    public JsonParser createParser(char[] content, int offset, int len) throws IOException {
+        _assertNotNull("content", content);
+        return _jsonFactory.createParser(content, offset, len);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonParser}
+     * to read content using specified {@link DataInput}.
+     * Parser is not managed (or "owned") by ObjectMapper: caller is responsible
+     * for properly closing it once content reading is complete.
+     *
+     * @since 2.11
+     */
+    public JsonParser createParser(DataInput content) throws IOException {
+        _assertNotNull("content", content);
+        return _jsonFactory.createParser(content);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonParser}
+     * to read content using non-blocking (asynchronous) mode.
+     * Parser is not managed (or "owned") by ObjectMapper: caller is responsible
+     * for properly closing it once content reading is complete.
+     *
+     * @since 2.11
+     */
+    public JsonParser createNonBlockingByteArrayParser() throws IOException {
+        return _jsonFactory.createNonBlockingByteArrayParser();
+    }
+
+    /*
+    /**********************************************************
     /* Configuration: main config object access
     /**********************************************************
      */
@@ -1608,7 +1835,7 @@ public class ObjectMapper
     /**
      * Convenience method that is equivalent to calling
      *<pre>
-     *  enableDefaultTyping(ptv, DefaultTyping.OBJECT_AND_NON_CONCRETE);
+     *  activateDefaultTyping(ptv, DefaultTyping.OBJECT_AND_NON_CONCRETE);
      *</pre>
      *<p>
      * NOTE: choice of {@link PolymorphicTypeValidator} to pass is critical for security
@@ -1626,7 +1853,7 @@ public class ObjectMapper
     /**
      * Convenience method that is equivalent to calling
      *<pre>
-     *  enableDefaultTyping(ptv, dti, JsonTypeInfo.As.WRAPPER_ARRAY);
+     *  activateDefaultTyping(ptv, dti, JsonTypeInfo.As.WRAPPER_ARRAY);
      *</pre>
      *<p>
      * NOTE: choice of {@link PolymorphicTypeValidator} to pass is critical for security
@@ -1645,11 +1872,11 @@ public class ObjectMapper
     }
 
     /**
-     * Method for enabling automatic inclusion of type information, needed
-     * for proper deserialization of polymorphic types (unless types
+     * Method for enabling automatic inclusion of type information ("Default Typing"),
+     * needed for proper deserialization of polymorphic types (unless types
      * have been annotated with {@link com.fasterxml.jackson.annotation.JsonTypeInfo}).
      *<P>
-     * NOTE: use of <code>JsonTypeInfo.As#EXTERNAL_PROPERTY</code> <b>NOT SUPPORTED</b>;
+     * NOTE: use of {@code JsonTypeInfo.As#EXTERNAL_PROPERTY} <b>NOT SUPPORTED</b>;
      * and attempts of do so will throw an {@link IllegalArgumentException} to make
      * this limitation explicit.
      *<p>
@@ -1681,8 +1908,8 @@ public class ObjectMapper
     }
 
     /**
-     * Method for enabling automatic inclusion of type information -- needed
-     * for proper deserialization of polymorphic types (unless types
+     * Method for enabling automatic inclusion of type information ("Default Typing")
+     * -- needed for proper deserialization of polymorphic types (unless types
      * have been annotated with {@link com.fasterxml.jackson.annotation.JsonTypeInfo}) --
      * using "As.PROPERTY" inclusion mechanism and specified property name
      * to use for inclusion (default being "@class" since default type information
@@ -1717,14 +1944,16 @@ public class ObjectMapper
      * explicitly annotated types (ones with
      * {@link com.fasterxml.jackson.annotation.JsonTypeInfo}) will have
      * additional embedded type information.
+     *
+     * @since 2.10
      */
     public ObjectMapper deactivateDefaultTyping() {
         return setDefaultTyping(null);
     }
 
     /**
-     * Method for enabling automatic inclusion of type information, using
-     * specified handler object for determining which types this affects,
+     * Method for enabling automatic inclusion of type information ("Default Typing"),
+     * using specified handler object for determining which types this affects,
      * as well as details of how information is embedded.
      *<p>
      * NOTE: use of Default Typing can be a potential security risk if incoming
@@ -1799,7 +2028,7 @@ public class ObjectMapper
      * Accessor for getting a mutable configuration override object for
      * given type, needed to add or change per-type overrides applied
      * to properties of given type.
-     * Usage is through returned object by colling "setter" methods, which
+     * Usage is through returned object by calling "setter" methods, which
      * directly modify override object and take effect directly.
      * For example you can do
      *<pre>
@@ -3338,8 +3567,7 @@ public class ObjectMapper
     public void writeValue(File resultFile, Object value)
         throws IOException, JsonGenerationException, JsonMappingException
     {
-        _assertNotNull("resultFile", resultFile);
-        _configAndWriteValue(_jsonFactory.createGenerator(resultFile, JsonEncoding.UTF8), value);
+        _configAndWriteValue(createGenerator(resultFile, JsonEncoding.UTF8), value);
     }
 
     /**
@@ -3356,8 +3584,7 @@ public class ObjectMapper
     public void writeValue(OutputStream out, Object value)
         throws IOException, JsonGenerationException, JsonMappingException
     {
-        _assertNotNull("out", out);
-        _configAndWriteValue(_jsonFactory.createGenerator(out, JsonEncoding.UTF8), value);
+        _configAndWriteValue(createGenerator(out, JsonEncoding.UTF8), value);
     }
 
     /**
@@ -3365,8 +3592,7 @@ public class ObjectMapper
      */
     public void writeValue(DataOutput out, Object value) throws IOException
     {
-        _assertNotNull("out", out);
-        _configAndWriteValue(_jsonFactory.createGenerator(out, JsonEncoding.UTF8), value);
+        _configAndWriteValue(createGenerator(out), value);
     }
 
     /**
@@ -3382,8 +3608,7 @@ public class ObjectMapper
     public void writeValue(Writer w, Object value)
         throws IOException, JsonGenerationException, JsonMappingException
     {
-        _assertNotNull("w", w);
-        _configAndWriteValue(_jsonFactory.createGenerator(w), value);
+        _configAndWriteValue(createGenerator(w), value);
     }
 
     /**
@@ -3401,7 +3626,7 @@ public class ObjectMapper
         // alas, we have to pull the recycler directly here...
         SegmentedStringWriter sw = new SegmentedStringWriter(_jsonFactory._getBufferRecycler());
         try {
-            _configAndWriteValue(_jsonFactory.createGenerator(sw), value);
+            _configAndWriteValue(createGenerator(sw), value);
         } catch (JsonProcessingException e) {
             throw e;
         } catch (IOException e) { // shouldn't really happen, but is declared as possibility so:
@@ -3425,7 +3650,7 @@ public class ObjectMapper
     {
         ByteArrayBuilder bb = new ByteArrayBuilder(_jsonFactory._getBufferRecycler());
         try {
-            _configAndWriteValue(_jsonFactory.createGenerator(bb, JsonEncoding.UTF8), value);
+            _configAndWriteValue(createGenerator(bb, JsonEncoding.UTF8), value);
         } catch (JsonProcessingException e) { // to support [JACKSON-758]
             throw e;
         } catch (IOException e) { // shouldn't really happen, but is declared as possibility so:
@@ -3728,6 +3953,54 @@ public class ObjectMapper
 
     /**
      * Factory method for constructing {@link ObjectReader} that will
+     * read values of a type {@code List<type>}.
+     * Functionally same as:
+     *<pre>
+     *    readerFor(type[].class);
+     *</pre>
+     *
+     * @since 2.11
+     */
+    public ObjectReader readerForArrayOf(Class<?> type) {
+        return _newReader(getDeserializationConfig(),
+                _typeFactory.constructArrayType(type), null,
+                null, _injectableValues);
+    }
+
+    /**
+     * Factory method for constructing {@link ObjectReader} that will
+     * read or update instances of a type {@code List<type>}.
+     * Functionally same as:
+     *<pre>
+     *    readerFor(new TypeReference&lt;List&lt;type&gt;&gt;() { });
+     *</pre>
+     *
+     * @since 2.11
+     */
+    public ObjectReader readerForListOf(Class<?> type) {
+        return _newReader(getDeserializationConfig(),
+                _typeFactory.constructCollectionType(List.class, type), null,
+                null, _injectableValues);
+    }
+
+    /**
+     * Factory method for constructing {@link ObjectReader} that will
+     * read or update instances of a type {@code Map<String, type>}
+     * Functionally same as:
+     *<pre>
+     *    readerFor(new TypeReference&lt;Map&lt;String, type&gt;&gt;() { });
+     *</pre>
+     *
+     * @since 2.11
+     */
+    public ObjectReader readerForMapOf(Class<?> type) {
+        return _newReader(getDeserializationConfig(),
+                _typeFactory.constructMapType(Map.class, String.class, type), null,
+                null, _injectableValues);
+    }
+
+    /**
+     * Factory method for constructing {@link ObjectReader} that will
      * use specified {@link JsonNodeFactory} for constructing JSON trees.
      */
     public ObjectReader reader(JsonNodeFactory f) {
@@ -3821,8 +4094,8 @@ public class ObjectMapper
 
     /**
      * Convenience method for doing two-step conversion from given value, into
-     * instance of given value type, if (but only if!) conversion is needed.
-     * If given value is already of requested type, value is returned as is.
+     * instance of given value type, by writing value into temporary buffer
+     * and reading from the buffer into specified target type.
      *<p>
      * This method is functionally similar to first
      * serializing given value into JSON, and then binding JSON data into value
@@ -3831,14 +4104,21 @@ public class ObjectMapper
      * However, same converters (serializers, deserializers) will be used as for
      * data binding, meaning same object mapper configuration works.
      *<p>
-     * Note that it is possible that in some cases behavior does differ from
-     * full serialize-then-deserialize cycle: in most case differences are
-     * unintentional (that is, flaws to fix) and should be reported.
-     * It is not guaranteed, however, that the behavior is 100% the same:
-     * the goal is just to allow efficient value conversions for structurally
+     * Note that behavior changed slightly between Jackson 2.9 and 2.10 so that
+     * whereas earlier some optimizations were used to avoid write/read cycle
+     * in case input was of target type, from 2.10 onwards full processing is
+     * always performed. See
+     * <a href="https://github.com/FasterXML/jackson-databind/issues/2220">databind#2220</a>
+     * for full details of the change.
+     *<p>
+     * Further note that it is possible that in some cases behavior does differ
+     * from full serialize-then-deserialize cycle: in most case differences are
+     * unintentional (that is, flaws to fix) and should be reported, but
+     * the behavior is not guaranteed to be 100% the same:
+     * the goal is to allow efficient value conversions for structurally
      * compatible Objects, according to standard Jackson configuration.
      *<p>
-     * Further note that functianality is not designed to support "advanced" use
+     * Finally, this functionality is not designed to support "advanced" use
      * cases, such as conversion of polymorphic values, or cases where Object Identity
      * is used.
      *      
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ObjectReader.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ObjectReader.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ObjectReader.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ObjectReader.java	2020-06-25 02:44:21.000000000 +0000
@@ -442,12 +442,17 @@ public class ObjectReader
     /*
     /**********************************************************
     /* Life-cycle, fluent factory methods for JsonParser.Features
+    /* (to be deprecated in 2.12?)
     /**********************************************************
      */
 
     /**
      * Method for constructing a new reader instance that is configured
      * with specified feature enabled.
+     *
+     * @param feature Feature to enable
+     *
+     * @return Reader instance with specified feature enabled
      */
     public ObjectReader with(JsonParser.Feature feature) {
         return _with(_config.with(feature));
@@ -456,6 +461,10 @@ public class ObjectReader
     /**
      * Method for constructing a new reader instance that is configured
      * with specified features enabled.
+     *
+     * @param features Features to enable
+     *
+     * @return Reader instance with specified features enabled
      */
     public ObjectReader withFeatures(JsonParser.Feature... features) {
         return _with(_config.withFeatures(features));
@@ -464,6 +473,10 @@ public class ObjectReader
     /**
      * Method for constructing a new reader instance that is configured
      * with specified feature disabled.
+     *
+     * @param feature Feature to disable
+     *
+     * @return Reader instance with specified feature disabled
      */
     public ObjectReader without(JsonParser.Feature feature) {
         return _with(_config.without(feature)); 
@@ -472,12 +485,46 @@ public class ObjectReader
     /**
      * Method for constructing a new reader instance that is configured
      * with specified features disabled.
+     *
+     * @param features Features to disable
+     *
+     * @return Reader instance with specified features disabled
      */
     public ObjectReader withoutFeatures(JsonParser.Feature... features) {
         return _with(_config.withoutFeatures(features));
     }
 
     /*
+    /**********************************************************************
+    /* Life-cycle, fluent factory methods for StreamReadFeatures (added in 2.11)
+    /**********************************************************************
+     */
+
+    /**
+     * Method for constructing a new reader instance that is configured
+     * with specified feature enabled.
+     *
+     * @return Reader instance with specified feature enabled
+     *
+     * @since 2.11
+     */
+    public ObjectReader with(StreamReadFeature feature) {
+        return _with(_config.with(feature.mappedFeature()));
+    }
+
+    /**
+     * Method for constructing a new reader instance that is configured
+     * with specified feature disabled.
+     *
+     * @return Reader instance with specified feature enabled
+     *
+     * @since 2.11
+     */
+    public ObjectReader without(StreamReadFeature feature) {
+        return _with(_config.without(feature.mappedFeature()));
+    }
+
+    /*
     /**********************************************************
     /* Life-cycle, fluent factory methods for FormatFeature (2.7)
     /**********************************************************
@@ -915,6 +962,13 @@ public class ObjectReader
     }
 
     /**
+     * @since 2.11
+     */
+    public boolean isEnabled(StreamReadFeature f) {
+        return _config.isEnabled(f.mappedFeature(), _parserFactory);
+    }
+
+    /**
      * @since 2.2
      */
     public DeserializationConfig getConfig() {
@@ -956,6 +1010,154 @@ public class ObjectReader
 
     /*
     /**********************************************************
+    /* Factory methods for creating JsonParsers (added in 2.11)
+    /**********************************************************
+     */
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonParser}
+     * to read content from specified {@link File}.
+     * Parser is not managed (or "owned") by ObjectReader: caller is responsible
+     * for properly closing it once content reading is complete.
+     *
+     * @since 2.11
+     */
+    public JsonParser createParser(File src) throws IOException {
+        _assertNotNull("src", src);
+        return _parserFactory.createParser(src);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonParser}
+     * to read content from specified {@link File}.
+     * Parser is not managed (or "owned") by ObjectReader: caller is responsible
+     * for properly closing it once content reading is complete.
+     *
+     * @since 2.11
+     */
+    public JsonParser createParser(URL src) throws IOException {
+        _assertNotNull("src", src);
+        return _parserFactory.createParser(src);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonParser}
+     * to read content using specified {@link InputStream}.
+     * Parser is not managed (or "owned") by ObjectReader: caller is responsible
+     * for properly closing it once content reading is complete.
+     *
+     * @since 2.11
+     */
+    public JsonParser createParser(InputStream in) throws IOException {
+        _assertNotNull("in", in);
+        return _parserFactory.createParser(in);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonParser}
+     * to read content using specified {@link Reader}.
+     * Parser is not managed (or "owned") by ObjectReader: caller is responsible
+     * for properly closing it once content reading is complete.
+     *
+     * @since 2.11
+     */
+    public JsonParser createParser(Reader r) throws IOException {
+        _assertNotNull("r", r);
+        return _parserFactory.createParser(r);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonParser}
+     * to read content from specified byte array.
+     * Parser is not managed (or "owned") by ObjectReader: caller is responsible
+     * for properly closing it once content reading is complete.
+     *
+     * @since 2.11
+     */
+    public JsonParser createParser(byte[] content) throws IOException {
+        _assertNotNull("content", content);
+        return _parserFactory.createParser(content);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonParser}
+     * to read content from specified byte array.
+     * Parser is not managed (or "owned") by ObjectReader: caller is responsible
+     * for properly closing it once content reading is complete.
+     *
+     * @since 2.11
+     */
+    public JsonParser createParser(byte[] content, int offset, int len) throws IOException {
+        _assertNotNull("content", content);
+        return _parserFactory.createParser(content, offset, len);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonParser}
+     * to read content from specified String.
+     * Parser is not managed (or "owned") by ObjectReader: caller is responsible
+     * for properly closing it once content reading is complete.
+     *
+     * @since 2.11
+     */
+    public JsonParser createParser(String content) throws IOException {
+        _assertNotNull("content", content);
+        return _parserFactory.createParser(content);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonParser}
+     * to read content from specified character array
+     * Parser is not managed (or "owned") by ObjectReader: caller is responsible
+     * for properly closing it once content reading is complete.
+     *
+     * @since 2.11
+     */
+    public JsonParser createParser(char[] content) throws IOException {
+        _assertNotNull("content", content);
+        return _parserFactory.createParser(content);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonParser}
+     * to read content from specified character array.
+     * Parser is not managed (or "owned") by ObjectReader: caller is responsible
+     * for properly closing it once content reading is complete.
+     *
+     * @since 2.11
+     */
+    public JsonParser createParser(char[] content, int offset, int len) throws IOException {
+        _assertNotNull("content", content);
+        return _parserFactory.createParser(content, offset, len);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonParser}
+     * to read content using specified {@link DataInput}.
+     * Parser is not managed (or "owned") by ObjectReader: caller is responsible
+     * for properly closing it once content reading is complete.
+     *
+     * @since 2.11
+     */
+    public JsonParser createParser(DataInput content) throws IOException {
+        _assertNotNull("content", content);
+        return _parserFactory.createParser(content);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonParser}
+     * to read content using non-blocking (asynchronous) mode.
+     * Parser is not managed (or "owned") by ObjectReader: caller is responsible
+     * for properly closing it once content reading is complete.
+     *
+     * @since 2.11
+     */
+    public JsonParser createNonBlockingByteArrayParser() throws IOException {
+        return _parserFactory.createNonBlockingByteArrayParser();
+    }
+
+    /*
+    /**********************************************************
     /* Deserialization methods; basic ones to support ObjectCodec first
     /* (ones that take JsonParser)
     /**********************************************************
@@ -1217,15 +1419,31 @@ public class ObjectReader
      * using configuration of this reader.
      * Value return is either newly constructed, or root value that
      * was specified with {@link #withValueToUpdate(Object)}.
+     *
+     * @param src Source to read content from
      */
     @SuppressWarnings("unchecked")
     public <T> T readValue(InputStream src) throws IOException
     {
-        _assertNotNull("src", src);
         if (_dataFormatReaders != null) {
             return (T) _detectBindAndClose(_dataFormatReaders.findFormat(src), false);
         }
-        return (T) _bindAndClose(_considerFilter(_parserFactory.createParser(src), false));
+        return (T) _bindAndClose(_considerFilter(createParser(src), false));
+    }
+
+    /**
+     * Same as {@link #readValue(InputStream)} except that target value type
+     * overridden as {@code valueType}
+     *
+     * @param src Source to read content from
+     * @param valueType Target type to bind content to
+     *
+     * @since 2.11
+     */
+    @SuppressWarnings("unchecked")
+    public <T> T readValue(InputStream src, Class<T> valueType) throws IOException
+    {
+        return (T) forType(valueType).readValue(src);
     }
 
     /**
@@ -1233,15 +1451,31 @@ public class ObjectReader
      * using configuration of this reader.
      * Value return is either newly constructed, or root value that
      * was specified with {@link #withValueToUpdate(Object)}.
+     *
+     * @param src Source to read content from
      */
     @SuppressWarnings("unchecked")
     public <T> T readValue(Reader src) throws IOException
     {
-        _assertNotNull("src", src);
         if (_dataFormatReaders != null) {
             _reportUndetectableSource(src);
         }
-        return (T) _bindAndClose(_considerFilter(_parserFactory.createParser(src), false));
+        return (T) _bindAndClose(_considerFilter(createParser(src), false));
+    }
+
+    /**
+     * Same as {@link #readValue(Reader)} except that target value type
+     * overridden as {@code valueType}
+     *
+     * @param src Source to read content from
+     * @param valueType Target type to bind content to
+     *
+     * @since 2.11
+     */
+    @SuppressWarnings("unchecked")
+    public <T> T readValue(Reader src, Class<T> valueType) throws IOException
+    {
+        return (T) forType(valueType).readValue(src);
     }
 
     /**
@@ -1249,16 +1483,17 @@ public class ObjectReader
      * using configuration of this reader.
      * Value return is either newly constructed, or root value that
      * was specified with {@link #withValueToUpdate(Object)}.
+     *
+     * @param src String that contains content to read
      */
     @SuppressWarnings("unchecked")
     public <T> T readValue(String src) throws JsonProcessingException, JsonMappingException
     {
-        _assertNotNull("src", src);
         if (_dataFormatReaders != null) {
             _reportUndetectableSource(src);
         }
         try { // since 2.10 remove "impossible" IOException as per [databind#1675]
-            return (T) _bindAndClose(_considerFilter(_parserFactory.createParser(src), false));
+            return (T) _bindAndClose(_considerFilter(createParser(src), false));
         } catch (JsonProcessingException e) {
             throw e;
         } catch (IOException e) { // shouldn't really happen but being declared need to
@@ -1267,19 +1502,50 @@ public class ObjectReader
     }
 
     /**
+     * Same as {@link #readValue(String)} except that target value type
+     * overridden as {@code valueType}
+     *
+     * @param src String that contains content to read
+     * @param valueType Target type to bind content to
+     *
+     * @since 2.11
+     */
+    @SuppressWarnings("unchecked")
+    public <T> T readValue(String src, Class<T> valueType) throws IOException
+    {
+        return (T) forType(valueType).readValue(src);
+    }
+
+    /**
      * Method that binds content read from given byte array,
      * using configuration of this reader.
      * Value return is either newly constructed, or root value that
      * was specified with {@link #withValueToUpdate(Object)}.
+     *
+     * @param content Byte array that contains encoded content to read
      */
     @SuppressWarnings("unchecked")
-    public <T> T readValue(byte[] src) throws IOException
+    public <T> T readValue(byte[] content) throws IOException
     {
-        _assertNotNull("src", src);
         if (_dataFormatReaders != null) {
-            return (T) _detectBindAndClose(src, 0, src.length);
+            return (T) _detectBindAndClose(content, 0, content.length);
         }
-        return (T) _bindAndClose(_considerFilter(_parserFactory.createParser(src), false));
+        return (T) _bindAndClose(_considerFilter(createParser(content), false));
+    }
+
+    /**
+     * Same as {@link #readValue(byte[])} except that target value type
+     * overridden as {@code valueType}
+     *
+     * @param content Byte array that contains encoded content to read
+     * @param valueType Target type to bind content to
+     *
+     * @since 2.11
+     */
+    @SuppressWarnings("unchecked")
+    public <T> T readValue(byte[] content, Class<T> valueType) throws IOException
+    {
+        return (T) forType(valueType).readValue(content);
     }
 
     /**
@@ -1287,27 +1553,69 @@ public class ObjectReader
      * using configuration of this reader.
      * Value return is either newly constructed, or root value that
      * was specified with {@link #withValueToUpdate(Object)}.
+     *
+     * @param buffer Byte array that contains encoded content to read
+     * @param offset Offset of the first content byte in {@code buffer}
+     * @param length Length of content in {@code buffer}, in bytes
      */
     @SuppressWarnings("unchecked")
-    public <T> T readValue(byte[] src, int offset, int length) throws IOException
+    public <T> T readValue(byte[] buffer, int offset, int length) throws IOException
     {
-        _assertNotNull("src", src);
         if (_dataFormatReaders != null) {
-            return (T) _detectBindAndClose(src, offset, length);
+            return (T) _detectBindAndClose(buffer, offset, length);
         }
-        return (T) _bindAndClose(_considerFilter(_parserFactory.createParser(src, offset, length),
+        return (T) _bindAndClose(_considerFilter(createParser(buffer, offset, length),
                 false));
     }
-    
+
+    /**
+     * Same as {@link #readValue(byte[],int,int)} except that target value type
+     * overridden as {@code valueType}
+     *
+     * @param buffer Byte array that contains encoded content to read
+     * @param offset Offset of the first content byte in {@code buffer}
+     * @param length Length of content in {@code buffer}, in bytes
+     * @param valueType Target type to bind content to
+     *
+     * @since 2.11
+     */
+    @SuppressWarnings("unchecked")
+    public <T> T readValue(byte[] buffer, int offset, int length, Class<T> valueType) throws IOException
+    {
+        return (T) forType(valueType).readValue(buffer, offset, length);
+    }
+
+    /**
+     * Method that binds content read from given {@link File}
+     * using configuration of this reader.
+     * Value return is either newly constructed, or root value that
+     * was specified with {@link #withValueToUpdate(Object)}.
+     *
+     * @param src File that contains content to read
+     */
     @SuppressWarnings("unchecked")
     public <T> T readValue(File src) throws IOException
     {
-        _assertNotNull("src", src);
         if (_dataFormatReaders != null) {
             return (T) _detectBindAndClose(_dataFormatReaders.findFormat(_inputStream(src)), true);
         }
 
-        return (T) _bindAndClose(_considerFilter(_parserFactory.createParser(src), false));
+        return (T) _bindAndClose(_considerFilter(createParser(src), false));
+    }
+
+    /**
+     * Same as {@link #readValue(File)} except that target value type
+     * overridden as {@code valueType}
+     *
+     * @param src File that contains content to read
+     * @param valueType Target type to bind content to
+     *
+     * @since 2.11
+     */
+    @SuppressWarnings("unchecked")
+    public <T> T readValue(File src, Class<T> valueType) throws IOException
+    {
+        return (T) forType(valueType).readValue(src);
     }
 
     /**
@@ -1326,11 +1634,25 @@ public class ObjectReader
     @SuppressWarnings("unchecked")
     public <T> T readValue(URL src) throws IOException
     {
-        _assertNotNull("src", src);
         if (_dataFormatReaders != null) {
             return (T) _detectBindAndClose(_dataFormatReaders.findFormat(_inputStream(src)), true);
         }
-        return (T) _bindAndClose(_considerFilter(_parserFactory.createParser(src), false));
+        return (T) _bindAndClose(_considerFilter(createParser(src), false));
+    }
+
+    /**
+     * Same as {@link #readValue(URL)} except that target value type
+     * overridden as {@code valueType}
+     *
+     * @param src URL pointing to resource that contains content to read
+     * @param valueType Target type to bind content to
+     *
+     * @since 2.11
+     */
+    @SuppressWarnings("unchecked")
+    public <T> T readValue(URL src, Class<T> valueType) throws IOException
+    {
+        return (T) forType(valueType).readValue(src);
     }
 
     /**
@@ -1339,28 +1661,56 @@ public class ObjectReader
      *<pre>
      *   objectReader.readValue(src.traverse())
      *</pre>
+     *
+     * @param content Tree that contains content to convert
      */
-    @SuppressWarnings({ "unchecked", "resource" })
-    public <T> T readValue(JsonNode src) throws IOException
+    @SuppressWarnings({ "unchecked" })
+    public <T> T readValue(JsonNode content) throws IOException
     {
-        _assertNotNull("src", src);
+        _assertNotNull("content", content);
         if (_dataFormatReaders != null) {
-            _reportUndetectableSource(src);
+            _reportUndetectableSource(content);
         }
-        return (T) _bindAndClose(_considerFilter(treeAsTokens(src), false));
+        return (T) _bindAndClose(_considerFilter(treeAsTokens(content), false));
     }
 
     /**
-     * @since 2.8
+     * Same as {@link #readValue(JsonNode)} except that target value type
+     * overridden as {@code valueType}
+     *
+     * @param content Tree that contains content to convert
+     * @param valueType Target type to convert content to
+     *
+     * @since 2.11
      */
+    @SuppressWarnings({ "unchecked" })
+    public <T> T readValue(JsonNode content, Class<T> valueType) throws IOException
+    {
+        return (T) forType(valueType).readValue(content);
+    }
+
     @SuppressWarnings("unchecked")
     public <T> T readValue(DataInput src) throws IOException
     {
-        _assertNotNull("src", src);
         if (_dataFormatReaders != null) {
             _reportUndetectableSource(src);
         }
-        return (T) _bindAndClose(_considerFilter(_parserFactory.createParser(src), false));
+        return (T) _bindAndClose(_considerFilter(createParser(src), false));
+    }
+
+    /**
+     * Same as {@link #readValue(DataInput)} except that target value type
+     * overridden as {@code valueType}
+     *
+     * @param content DataInput that contains content to read
+     * @param valueType Target type to bind content to
+     *
+     * @since 2.11
+     */
+    @SuppressWarnings("unchecked")
+    public <T> T readValue(DataInput content, Class<T> valueType) throws IOException
+    {
+        return (T) forType(valueType).readValue(content);
     }
 
     /*
@@ -1388,11 +1738,10 @@ public class ObjectReader
      */
     public JsonNode readTree(InputStream src) throws IOException
     {
-        _assertNotNull("src", src);
         if (_dataFormatReaders != null) {
             return _detectBindAndCloseAsTree(src);
         }
-        return _bindAndCloseAsTree(_considerFilter(_parserFactory.createParser(src), false));
+        return _bindAndCloseAsTree(_considerFilter(createParser(src), false));
     }
     
     /**
@@ -1401,11 +1750,10 @@ public class ObjectReader
      */
     public JsonNode readTree(Reader src) throws IOException
     {
-        _assertNotNull("src", src);
         if (_dataFormatReaders != null) {
             _reportUndetectableSource(src);
         }
-        return _bindAndCloseAsTree(_considerFilter(_parserFactory.createParser(src), false));
+        return _bindAndCloseAsTree(_considerFilter(createParser(src), false));
     }
 
     /**
@@ -1414,12 +1762,11 @@ public class ObjectReader
      */
     public JsonNode readTree(String json) throws JsonProcessingException, JsonMappingException
     {
-        _assertNotNull("json", json);
         if (_dataFormatReaders != null) {
             _reportUndetectableSource(json);
         }
         try { // since 2.10 remove "impossible" IOException as per [databind#1675]
-            return _bindAndCloseAsTree(_considerFilter(_parserFactory.createParser(json), false));
+            return _bindAndCloseAsTree(_considerFilter(createParser(json), false));
         } catch (JsonProcessingException e) {
             throw e;
         } catch (IOException e) { // shouldn't really happen but being declared need to
@@ -1437,7 +1784,7 @@ public class ObjectReader
         if (_dataFormatReaders != null) {
             _reportUndetectableSource(json);
         }
-        return _bindAndCloseAsTree(_considerFilter(_parserFactory.createParser(json), false));
+        return _bindAndCloseAsTree(_considerFilter(createParser(json), false));
     }
     
     /**
@@ -1446,11 +1793,10 @@ public class ObjectReader
      */
     public JsonNode readTree(byte[] json, int offset, int len) throws IOException
     {
-        _assertNotNull("json", json);
         if (_dataFormatReaders != null) {
             _reportUndetectableSource(json);
         }
-        return _bindAndCloseAsTree(_considerFilter(_parserFactory.createParser(json, offset, len), false));
+        return _bindAndCloseAsTree(_considerFilter(createParser(json, offset, len), false));
     }
 
     /**
@@ -1459,11 +1805,10 @@ public class ObjectReader
      */
     public JsonNode readTree(DataInput src) throws IOException
     {
-        _assertNotNull("src", src);
         if (_dataFormatReaders != null) {
             _reportUndetectableSource(src);
         }
-        return _bindAndCloseAsTree(_considerFilter(_parserFactory.createParser(src), false));
+        return _bindAndCloseAsTree(_considerFilter(createParser(src), false));
     }
 
     /*
@@ -1513,12 +1858,11 @@ public class ObjectReader
      */
     public <T> MappingIterator<T> readValues(InputStream src) throws IOException
     {
-        _assertNotNull("src", src);
         if (_dataFormatReaders != null) {
             return _detectBindAndReadValues(_dataFormatReaders.findFormat(src), false);
         }
         
-        return _bindAndReadValues(_considerFilter(_parserFactory.createParser(src), true));
+        return _bindAndReadValues(_considerFilter(createParser(src), true));
     }
     
     /**
@@ -1527,11 +1871,10 @@ public class ObjectReader
     @SuppressWarnings("resource")
     public <T> MappingIterator<T> readValues(Reader src) throws IOException
     {
-        _assertNotNull("src", src);
         if (_dataFormatReaders != null) {
             _reportUndetectableSource(src);
         }
-        JsonParser p = _considerFilter(_parserFactory.createParser(src), true);
+        JsonParser p = _considerFilter(createParser(src), true);
         DeserializationContext ctxt = createDeserializationContext(p);
         _initForMultiRead(ctxt, p);
         p.nextToken();
@@ -1546,11 +1889,10 @@ public class ObjectReader
     @SuppressWarnings("resource")
     public <T> MappingIterator<T> readValues(String json) throws IOException
     {
-        _assertNotNull("json", json);
         if (_dataFormatReaders != null) {
             _reportUndetectableSource(json);
         }
-        JsonParser p = _considerFilter(_parserFactory.createParser(json), true);
+        JsonParser p = _considerFilter(createParser(json), true);
         DeserializationContext ctxt = createDeserializationContext(p);
         _initForMultiRead(ctxt, p);
         p.nextToken();
@@ -1562,11 +1904,10 @@ public class ObjectReader
      */
     public <T> MappingIterator<T> readValues(byte[] src, int offset, int length) throws IOException
     {
-        _assertNotNull("src", src);
         if (_dataFormatReaders != null) {
             return _detectBindAndReadValues(_dataFormatReaders.findFormat(src, offset, length), false);
         }
-        return _bindAndReadValues(_considerFilter(_parserFactory.createParser(src, offset, length),
+        return _bindAndReadValues(_considerFilter(createParser(src, offset, length),
                 true));
     }
 
@@ -1583,12 +1924,11 @@ public class ObjectReader
      */
     public <T> MappingIterator<T> readValues(File src) throws IOException
     {
-        _assertNotNull("src", src);
         if (_dataFormatReaders != null) {
             return _detectBindAndReadValues(
                     _dataFormatReaders.findFormat(_inputStream(src)), false);
         }
-        return _bindAndReadValues(_considerFilter(_parserFactory.createParser(src), true));
+        return _bindAndReadValues(_considerFilter(createParser(src), true));
     }
 
     /**
@@ -1604,12 +1944,11 @@ public class ObjectReader
      */
     public <T> MappingIterator<T> readValues(URL src) throws IOException
     {
-        _assertNotNull("src", src);
         if (_dataFormatReaders != null) {
             return _detectBindAndReadValues(
                     _dataFormatReaders.findFormat(_inputStream(src)), true);
         }
-        return _bindAndReadValues(_considerFilter(_parserFactory.createParser(src), true));
+        return _bindAndReadValues(_considerFilter(createParser(src), true));
     }
 
     /**
@@ -1617,11 +1956,10 @@ public class ObjectReader
      */
     public <T> MappingIterator<T> readValues(DataInput src) throws IOException
     {
-        _assertNotNull("src", src);
         if (_dataFormatReaders != null) {
             _reportUndetectableSource(src);
         }
-        return _bindAndReadValues(_considerFilter(_parserFactory.createParser(src), true));
+        return _bindAndReadValues(_considerFilter(createParser(src), true));
     }
 
     /*
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ObjectWriter.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ObjectWriter.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ObjectWriter.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ObjectWriter.java	2020-06-25 02:44:21.000000000 +0000
@@ -351,6 +351,26 @@ public class ObjectWriter
 
     /*
     /**********************************************************
+    /* Life-cycle, fluent factories for StreamWriteFeature (2.11)
+    /**********************************************************
+     */
+
+    /**
+     * @since 2.11
+     */
+    public ObjectWriter with(StreamWriteFeature feature)  {
+        return _new(this, _config.with(feature.mappedFeature()));
+    }
+
+    /**
+     * @since 2.11
+     */
+    public ObjectWriter without(StreamWriteFeature feature) {
+        return _new(this, _config.without(feature.mappedFeature()));
+    }
+
+    /*
+    /**********************************************************
     /* Life-cycle, fluent factories for FormatFeature (2.7)
     /**********************************************************
      */
@@ -641,6 +661,77 @@ public class ObjectWriter
 
     /*
     /**********************************************************
+    /* Factory methods for creating JsonGenerators (added in 2.11)
+    /**********************************************************
+     */
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonGenerator}
+     * to write content using specified {@link OutputStream}.
+     * Generator is not managed (or "owned") by ObjectWriter: caller is responsible
+     * for properly closing it once content generation is complete.
+     *
+     * @since 2.11
+     */
+    public JsonGenerator createGenerator(OutputStream out) throws IOException {
+        _assertNotNull("out", out);
+        return _generatorFactory.createGenerator(out, JsonEncoding.UTF8);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonGenerator}
+     * to write content using specified {@link OutputStream} and encoding.
+     * Generator is not managed (or "owned") by ObjectWriter: caller is responsible
+     * for properly closing it once content generation is complete.
+     *
+     * @since 2.11
+     */
+    public JsonGenerator createGenerator(OutputStream out, JsonEncoding enc) throws IOException {
+        _assertNotNull("out", out);
+        return _generatorFactory.createGenerator(out, enc);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonGenerator}
+     * to write content using specified {@link Writer}.
+     * Generator is not managed (or "owned") by ObjectWriter: caller is responsible
+     * for properly closing it once content generation is complete.
+     *
+     * @since 2.11
+     */
+    public JsonGenerator createGenerator(Writer w) throws IOException {
+        _assertNotNull("w", w);
+        return _generatorFactory.createGenerator(w);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonGenerator}
+     * to write content to specified {@link File}, using specified encoding.
+     * Generator is not managed (or "owned") by ObjectWriter: caller is responsible
+     * for properly closing it once content generation is complete.
+     *
+     * @since 2.11
+     */
+    public JsonGenerator createGenerator(File outputFile, JsonEncoding enc) throws IOException {
+        _assertNotNull("outputFile", outputFile);
+        return _generatorFactory.createGenerator(outputFile, enc);
+    }
+
+    /**
+     * Factory method for constructing properly initialized {@link JsonGenerator}
+     * to write content using specified {@link DataOutput}.
+     * Generator is not managed (or "owned") by ObjectWriter: caller is responsible
+     * for properly closing it once content generation is complete.
+     *
+     * @since 2.11
+     */
+    public JsonGenerator createGenerator(DataOutput out) throws IOException {
+        _assertNotNull("out", out);
+        return _generatorFactory.createGenerator(out);
+    }
+
+    /*
+    /**********************************************************
     /* Factory methods for sequence writers (2.5)
     /**********************************************************
      */
@@ -659,9 +750,7 @@ public class ObjectWriter
      * @since 2.5
      */
     public SequenceWriter writeValues(File out) throws IOException {
-        _assertNotNull("out", out);
-        return _newSequenceWriter(false,
-                _generatorFactory.createGenerator(out, JsonEncoding.UTF8), true);
+        return _newSequenceWriter(false, createGenerator(out, JsonEncoding.UTF8), true);
     }
 
     /**
@@ -699,9 +788,7 @@ public class ObjectWriter
      * @since 2.5
      */
     public SequenceWriter writeValues(Writer out) throws IOException {
-        _assertNotNull("out", out);
-        return _newSequenceWriter(false,
-                _generatorFactory.createGenerator(out), true);
+        return _newSequenceWriter(false, createGenerator(out), true);
     }
 
     /**
@@ -718,18 +805,14 @@ public class ObjectWriter
      * @since 2.5
      */
     public SequenceWriter writeValues(OutputStream out) throws IOException {
-        _assertNotNull("out", out);
-        return _newSequenceWriter(false,
-                _generatorFactory.createGenerator(out, JsonEncoding.UTF8), true);
+        return _newSequenceWriter(false, createGenerator(out, JsonEncoding.UTF8), true);
     }
 
     /**
      * @since 2.8
      */
     public SequenceWriter writeValues(DataOutput out) throws IOException {
-        _assertNotNull("out", out);
-        return _newSequenceWriter(false,
-                _generatorFactory.createGenerator(out), true);
+        return _newSequenceWriter(false, createGenerator(out), true);
     }
 
     /**
@@ -748,9 +831,7 @@ public class ObjectWriter
      * @since 2.5
      */
     public SequenceWriter writeValuesAsArray(File out) throws IOException {
-        _assertNotNull("out", out);
-        return _newSequenceWriter(true,
-                _generatorFactory.createGenerator(out, JsonEncoding.UTF8), true);
+        return _newSequenceWriter(true, createGenerator(out, JsonEncoding.UTF8), true);
     }
 
     /**
@@ -790,8 +871,7 @@ public class ObjectWriter
      * @since 2.5
      */
     public SequenceWriter writeValuesAsArray(Writer out) throws IOException {
-        _assertNotNull("out", out);
-        return _newSequenceWriter(true, _generatorFactory.createGenerator(out), true);
+        return _newSequenceWriter(true, createGenerator(out), true);
     }
 
     /**
@@ -810,17 +890,14 @@ public class ObjectWriter
      * @since 2.5
      */
     public SequenceWriter writeValuesAsArray(OutputStream out) throws IOException {
-        _assertNotNull("out", out);
-        return _newSequenceWriter(true,
-                _generatorFactory.createGenerator(out, JsonEncoding.UTF8), true);
+        return _newSequenceWriter(true, createGenerator(out, JsonEncoding.UTF8), true);
     }
 
     /**
      * @since 2.8
      */
     public SequenceWriter writeValuesAsArray(DataOutput out) throws IOException {
-        _assertNotNull("out", out);
-        return _newSequenceWriter(true, _generatorFactory.createGenerator(out), true);
+        return _newSequenceWriter(true, createGenerator(out), true);
     }
 
     /*
@@ -851,7 +928,14 @@ public class ObjectWriter
     public boolean isEnabled(JsonGenerator.Feature f) {
         return _generatorFactory.isEnabled(f);
     }
-    
+
+    /**
+     * @since 2.11
+     */
+    public boolean isEnabled(StreamWriteFeature f) {
+        return _generatorFactory.isEnabled(f);
+    }
+
     /**
      * @since 2.2
      */
@@ -938,8 +1022,7 @@ public class ObjectWriter
     public void writeValue(File resultFile, Object value)
         throws IOException, JsonGenerationException, JsonMappingException
     {
-        _assertNotNull("resultFile", resultFile);
-        _configAndWriteValue(_generatorFactory.createGenerator(resultFile, JsonEncoding.UTF8), value);
+        _configAndWriteValue(createGenerator(resultFile, JsonEncoding.UTF8), value);
     }
 
     /**
@@ -956,8 +1039,7 @@ public class ObjectWriter
     public void writeValue(OutputStream out, Object value)
         throws IOException, JsonGenerationException, JsonMappingException
     {
-        _assertNotNull("out", out);
-        _configAndWriteValue(_generatorFactory.createGenerator(out, JsonEncoding.UTF8), value);
+        _configAndWriteValue(createGenerator(out, JsonEncoding.UTF8), value);
     }
 
     /**
@@ -973,8 +1055,7 @@ public class ObjectWriter
     public void writeValue(Writer w, Object value)
         throws IOException, JsonGenerationException, JsonMappingException
     {
-        _assertNotNull("w", w);
-        _configAndWriteValue(_generatorFactory.createGenerator(w), value);
+        _configAndWriteValue(createGenerator(w), value);
     }
 
     /**
@@ -983,8 +1064,7 @@ public class ObjectWriter
     public void writeValue(DataOutput out, Object value)
         throws IOException
     {
-        _assertNotNull("out", out);
-        _configAndWriteValue(_generatorFactory.createGenerator(out), value);
+        _configAndWriteValue(createGenerator(out), value);
     }
 
     /**
@@ -1002,7 +1082,7 @@ public class ObjectWriter
         // alas, we have to pull the recycler directly here...
         SegmentedStringWriter sw = new SegmentedStringWriter(_generatorFactory._getBufferRecycler());
         try {
-            _configAndWriteValue(_generatorFactory.createGenerator(sw), value);
+            _configAndWriteValue(createGenerator(sw), value);
         } catch (JsonProcessingException e) {
             throw e;
         } catch (IOException e) { // shouldn't really happen, but is declared as possibility so:
@@ -1026,7 +1106,7 @@ public class ObjectWriter
     {
         ByteArrayBuilder bb = new ByteArrayBuilder(_generatorFactory._getBufferRecycler());
         try {
-            _configAndWriteValue(_generatorFactory.createGenerator(bb, JsonEncoding.UTF8), value);
+            _configAndWriteValue(createGenerator(bb, JsonEncoding.UTF8), value);
         } catch (JsonProcessingException e) { // to support [JACKSON-758]
             throw e;
         } catch (IOException e) { // shouldn't really happen, but is declared as possibility so:
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/AnyGetterWriter.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/AnyGetterWriter.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/AnyGetterWriter.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/AnyGetterWriter.java	2020-06-25 02:44:21.000000000 +0000
@@ -59,7 +59,7 @@ public class AnyGetterWriter
         }
         // 23-Feb-2015, tatu: Nasty, but has to do (for now)
         if (_mapSerializer != null) {
-            _mapSerializer.serializeFields((Map<?,?>) value, gen, provider);
+            _mapSerializer.serializeWithoutTypeInfo((Map<?,?>) value, gen, provider);
             return;
         }
         _serializer.serialize(value, gen, provider);
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/BasicSerializerFactory.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/BasicSerializerFactory.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/BasicSerializerFactory.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/BasicSerializerFactory.java	2020-06-25 02:44:21.000000000 +0000
@@ -198,18 +198,72 @@ public abstract class BasicSerializerFac
             JavaType type)
         throws JsonMappingException;
 
+    @Override // since 2.11
+    @SuppressWarnings("unchecked")
+    public JsonSerializer<Object> createKeySerializer(SerializerProvider ctxt,
+            JavaType keyType, JsonSerializer<Object> defaultImpl) throws JsonMappingException
+    {
+        // 16-Oct-2019, tatu: use to only introspect class annotations but we'll
+        //    need methods too for `@JsonValue` later; and custom lookup might want it, too
+        final SerializationConfig config = ctxt.getConfig();
+        BeanDescription beanDesc = config.introspect(keyType);
+        JsonSerializer<?> ser = null;
+        // Minor optimization: to avoid constructing beanDesc, bail out if none registered
+        if (_factoryConfig.hasKeySerializers()) {
+            // Only thing we have here are module-provided key serializers:
+            for (Serializers serializers : _factoryConfig.keySerializers()) {
+                ser = serializers.findSerializer(config, keyType, beanDesc);
+                if (ser != null) {
+                    break;
+                }
+            }
+        }
+        if (ser == null) {
+            // [databind#2452]: Support `@JsonSerialize(keyUsing = ...)` -- new in 2.11
+            ser = _findKeySerializer(ctxt, beanDesc.getClassInfo());
+            if (ser == null) {
+                ser = defaultImpl;
+                if (ser == null) {
+                    ser = StdKeySerializers.getStdKeySerializer(config, keyType.getRawClass(), false);
+                    // As per [databind#47], also need to support @JsonValue
+                    if (ser == null) {
+                        AnnotatedMember am = beanDesc.findJsonValueAccessor();
+                        if (am != null) {
+                            final Class<?> rawType = am.getRawType();
+                            JsonSerializer<?> delegate = StdKeySerializers.getStdKeySerializer(config,
+                                    rawType, true);
+                            if (config.canOverrideAccessModifiers()) {
+                                ClassUtil.checkAndFixAccess(am.getMember(),
+                                        config.isEnabled(MapperFeature.OVERRIDE_PUBLIC_ACCESS_MODIFIERS));
+                            }
+                            ser = new JsonValueSerializer(am, delegate);
+                        } else {
+                            ser = StdKeySerializers.getFallbackKeySerializer(config, keyType.getRawClass());
+                        }
+                    }
+                }
+            }
+        }
+
+        // [databind#120]: Allow post-processing
+        if (_factoryConfig.hasSerializerModifiers()) {
+            for (BeanSerializerModifier mod : _factoryConfig.serializerModifiers()) {
+                ser = mod.modifyKeySerializer(config, keyType, beanDesc, ser);
+            }
+        }
+        return (JsonSerializer<Object>) ser;
+    }
+
+    // Old method: to be removed from 3.0 -- similar to above but can't look for "keyUsing"
     @Override
     @SuppressWarnings("unchecked")
+    @Deprecated // since 2.11
     public JsonSerializer<Object> createKeySerializer(SerializationConfig config,
             JavaType keyType, JsonSerializer<Object> defaultImpl)
     {
-        // We should not need any member method info; at most class annotations for Map type
-        // ... at least, not here.
-        BeanDescription beanDesc = config.introspectClassAnnotations(keyType.getRawClass());
+        BeanDescription beanDesc = config.introspect(keyType);
         JsonSerializer<?> ser = null;
-        // Minor optimization: to avoid constructing beanDesc, bail out if none registered
         if (_factoryConfig.hasKeySerializers()) {
-            // Only thing we have here are module-provided key serializers:
             for (Serializers serializers : _factoryConfig.keySerializers()) {
                 ser = serializers.findSerializer(config, keyType, beanDesc);
                 if (ser != null) {
@@ -221,9 +275,7 @@ public abstract class BasicSerializerFac
             ser = defaultImpl;
             if (ser == null) {
                 ser = StdKeySerializers.getStdKeySerializer(config, keyType.getRawClass(), false);
-                // As per [databind#47], also need to support @JsonValue
                 if (ser == null) {
-                    beanDesc = config.introspect(keyType);
                     AnnotatedMember am = beanDesc.findJsonValueAccessor();
                     if (am != null) {
                         final Class<?> rawType = am.getRawType();
@@ -240,8 +292,6 @@ public abstract class BasicSerializerFac
                 }
             }
         }
-        
-        // [databind#120]: Allow post-processing
         if (_factoryConfig.hasSerializerModifiers()) {
             for (BeanSerializerModifier mod : _factoryConfig.serializerModifiers()) {
                 ser = mod.modifyKeySerializer(config, keyType, beanDesc, ser);
@@ -368,8 +418,11 @@ public abstract class BasicSerializerFac
             boolean staticTyping)
         throws JsonMappingException
     {
-        Class<?> raw = type.getRawClass();
-        
+        if (type.isEnumType()) {
+            return buildEnumSerializer(prov.getConfig(), type, beanDesc);
+        }
+
+        final Class<?> raw = type.getRawClass();
         // Then check for optional/external serializers 
         JsonSerializer<?> ser = findOptionalStdSerializer(prov, type, beanDesc, staticTyping);
         if (ser != null) {
@@ -421,9 +474,6 @@ public abstract class BasicSerializerFac
             }
             return NumberSerializer.instance;
         }
-        if (ClassUtil.isEnumType(raw) && raw != Enum.class) {
-            return buildEnumSerializer(prov.getConfig(), type, beanDesc);
-        }
         return null;
     }
 
@@ -664,7 +714,7 @@ public abstract class BasicSerializerFac
                     // this may or may not be available (Class doesn't; type of field/method does)
                     JavaType enumType = type.getContentType();
                     // and even if nominally there is something, only use if it really is enum
-                    if (!enumType.isEnumType()) {
+                    if (!enumType.isEnumImplType()) { // usually since it's `Enum.class`
                         enumType = null;
                     }
                     ser = buildEnumSetSerializer(enumType);
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/BeanPropertyWriter.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/BeanPropertyWriter.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/BeanPropertyWriter.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/BeanPropertyWriter.java	2020-06-25 02:44:21.000000000 +0000
@@ -1,5 +1,6 @@
 package com.fasterxml.jackson.databind.ser;
 
+import java.io.IOException;
 import java.lang.annotation.Annotation;
 import java.lang.reflect.Field;
 import java.lang.reflect.Method;
@@ -717,7 +718,7 @@ public class BeanPropertyWriter extends
         }
         // For non-nulls: simple check for direct cycles
         if (value == bean) {
-            // three choices: exception; handled by call; or pass-through
+            // four choices: exception; handled by call; pass-through or write null
             if (_handleSelfReference(bean, gen, prov, ser)) {
                 return;
             }
@@ -932,16 +933,30 @@ public class BeanPropertyWriter extends
      */
     protected boolean _handleSelfReference(Object bean, JsonGenerator gen,
             SerializerProvider prov, JsonSerializer<?> ser)
-            throws JsonMappingException {
-        if (prov.isEnabled(SerializationFeature.FAIL_ON_SELF_REFERENCES)
-                && !ser.usesObjectId()) {
-            // 05-Feb-2013, tatu: Usually a problem, but NOT if we are handling
-            // object id; this may be the case for BeanSerializers at least.
-            // 13-Feb-2014, tatu: another possible ok case: custom serializer
-            // (something
-            // OTHER than {@link BeanSerializerBase}
-            if (ser instanceof BeanSerializerBase) {
-                prov.reportBadDefinition(getType(), "Direct self-reference leading to cycle");
+            throws IOException
+    {
+        if (!ser.usesObjectId()) {
+            if (prov.isEnabled(SerializationFeature.FAIL_ON_SELF_REFERENCES)) {
+                // 05-Feb-2013, tatu: Usually a problem, but NOT if we are handling
+                // object id; this may be the case for BeanSerializers at least.
+                // 13-Feb-2014, tatu: another possible ok case: custom serializer
+                // (something OTHER than {@link BeanSerializerBase}
+                if (ser instanceof BeanSerializerBase) {
+                    prov.reportBadDefinition(getType(), "Direct self-reference leading to cycle");
+                }
+            } else if (prov.isEnabled(SerializationFeature.WRITE_SELF_REFERENCES_AS_NULL)) {
+                if (_nullSerializer != null) {
+                    // 23-Oct-2019, tatu: Tricky part -- caller does not specify if it's
+                    //   "as property" (in JSON Object) or "as element" (JSON array, via
+                    //   'POJO-as-array'). And since Afterburner calls method can not easily
+                    //   start passing info either. So check generator to see...
+                    //   (note: not considering ROOT context as possibility, does not seem legal)
+                    if (!gen.getOutputContext().inArray()) {
+                        gen.writeFieldName(_name);
+                    }
+                    _nullSerializer.serialize(null, gen, prov);
+                }
+                return true;
             }
         }
         return false;
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/BeanSerializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/BeanSerializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/BeanSerializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/BeanSerializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -63,11 +63,17 @@ public class BeanSerializer
             ObjectIdWriter objectIdWriter, Object filterId) {
         super(src, objectIdWriter, filterId);
     }
-    
+
     protected BeanSerializer(BeanSerializerBase src, Set<String> toIgnore) {
         super(src, toIgnore);
     }
 
+    // @since 2.11.1
+    protected BeanSerializer(BeanSerializerBase src,
+            BeanPropertyWriter[] properties, BeanPropertyWriter[] filteredProperties) {
+        super(src, properties, filteredProperties);
+    }
+
     /*
     /**********************************************************
     /* Life-cycle: factory methods, fluent factories
@@ -114,6 +120,12 @@ public class BeanSerializer
         return new BeanSerializer(this, toIgnore);
     }
 
+    @Override // @since 2.11.1
+    protected BeanSerializerBase withProperties(BeanPropertyWriter[] properties,
+            BeanPropertyWriter[] filteredProperties) {
+        return new BeanSerializer(this, properties, filteredProperties);
+    }
+
     /**
      * Implementation has to check whether as-array serialization
      * is possible reliably; if (and only if) so, will construct
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/ContainerSerializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/ContainerSerializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/ContainerSerializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/ContainerSerializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -80,7 +80,7 @@ public abstract class ContainerSerialize
      * known statically.
      * Note that for dynamic types this may return null; if so,
      * caller has to instead use {@link #getContentType()} and
-     * {@link com.fasterxml.jackson.databind.SerializerProvider#findValueSerializer}.
+     * {@link com.fasterxml.jackson.databind.SerializerProvider#findContentValueSerializer}.
      */
     public abstract JsonSerializer<?> getContentSerializer();
 
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/impl/BeanAsArraySerializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/impl/BeanAsArraySerializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/impl/BeanAsArraySerializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/impl/BeanAsArraySerializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -6,6 +6,7 @@ import java.util.Set;
 import com.fasterxml.jackson.core.JsonGenerator;
 import com.fasterxml.jackson.core.JsonToken;
 import com.fasterxml.jackson.core.type.WritableTypeId;
+
 import com.fasterxml.jackson.databind.*;
 import com.fasterxml.jackson.databind.jsontype.TypeSerializer;
 import com.fasterxml.jackson.databind.ser.BeanPropertyWriter;
@@ -111,12 +112,20 @@ public class BeanAsArraySerializer
         return new BeanAsArraySerializer(this, toIgnore);
     }
 
+    @Override // @since 2.11.1
+    protected BeanSerializerBase withProperties(BeanPropertyWriter[] properties,
+            BeanPropertyWriter[] filteredProperties) {
+        // 16-Jun-2020, tatu: Added for [databind#2759] but with as-array we
+        //    probably do not want to reorder anything; so actually leave unchanged
+        return this;
+    }
+
     @Override
     protected BeanSerializerBase asArraySerializer() {
         // already is one, so:
         return this;
     }
-    
+
     /*
     /**********************************************************
     /* JsonSerializer implementation that differs between impls
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/impl/MapEntrySerializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/impl/MapEntrySerializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/impl/MapEntrySerializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/impl/MapEntrySerializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -209,7 +209,7 @@ public class MapEntrySerializer
             //   we can consider it a static case as well.
             // 20-Aug-2013, tatu: Need to avoid trying to access serializer for java.lang.Object tho
             if (_valueTypeIsStatic && !_valueType.isJavaLangObject()) {
-                ser = provider.findValueSerializer(_valueType, property);
+                ser = provider.findContentValueSerializer(_valueType, property);
             }
         }
         if (keySer == null) {
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/impl/PropertySerializerMap.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/impl/PropertySerializerMap.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/impl/PropertySerializerMap.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/impl/PropertySerializerMap.java	2020-06-25 02:44:21.000000000 +0000
@@ -87,7 +87,7 @@ public abstract class PropertySerializer
             SerializerProvider provider, BeanProperty property)
         throws JsonMappingException
     {
-        JsonSerializer<Object> serializer = provider.findValueSerializer(type, property);
+        JsonSerializer<Object> serializer = provider.findContentValueSerializer(type, property);
         return new SerializerAndMapResult(serializer, newWith(type, serializer));
     }
 
@@ -95,7 +95,7 @@ public abstract class PropertySerializer
             SerializerProvider provider, BeanProperty property)
         throws JsonMappingException
     {
-        JsonSerializer<Object> serializer = provider.findValueSerializer(type, property);
+        JsonSerializer<Object> serializer = provider.findContentValueSerializer(type, property);
         return new SerializerAndMapResult(serializer, newWith(type.getRawClass(), serializer));
     }
 
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/impl/StringArraySerializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/impl/StringArraySerializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/impl/StringArraySerializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/impl/StringArraySerializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -109,7 +109,7 @@ public class StringArraySerializer
         // May have a content converter
         ser = findContextualConvertingSerializer(provider, property, ser);
         if (ser == null) {
-            ser = provider.findValueSerializer(String.class, property);
+            ser = provider.findContentValueSerializer(String.class, property);
         }
         // Optimization: default serializer just writes String, so we can avoid a call:
         if (isDefaultSerializer(ser)) {
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/impl/UnwrappingBeanSerializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/impl/UnwrappingBeanSerializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/impl/UnwrappingBeanSerializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/impl/UnwrappingBeanSerializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -1,6 +1,7 @@
 package com.fasterxml.jackson.databind.ser.impl;
 
 import com.fasterxml.jackson.core.JsonGenerator;
+
 import com.fasterxml.jackson.databind.*;
 import com.fasterxml.jackson.databind.jsontype.TypeSerializer;
 import com.fasterxml.jackson.databind.ser.BeanPropertyWriter;
@@ -54,6 +55,13 @@ public class UnwrappingBeanSerializer
         _nameTransformer = src._nameTransformer;
     }
 
+    // @since 2.11.1
+    protected UnwrappingBeanSerializer(UnwrappingBeanSerializer src,
+            BeanPropertyWriter[] properties, BeanPropertyWriter[] filteredProperties) {
+        super(src, properties, filteredProperties);
+        _nameTransformer = src._nameTransformer;
+    }
+
     /*
     /**********************************************************
     /* Life-cycle: factory methods, fluent factories
@@ -86,6 +94,12 @@ public class UnwrappingBeanSerializer
         return new UnwrappingBeanSerializer(this, toIgnore);
     }
 
+    @Override // @since 2.11.1
+    protected BeanSerializerBase withProperties(BeanPropertyWriter[] properties,
+            BeanPropertyWriter[] filteredProperties) {
+        return new UnwrappingBeanSerializer(this, properties, filteredProperties);
+    }
+
     /**
      * JSON Array output cannot be done if unwrapping operation is
      * requested; so implementation will simply return 'this'.
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/SerializerFactory.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/SerializerFactory.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/SerializerFactory.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/SerializerFactory.java	2020-06-25 02:44:21.000000000 +0000
@@ -78,7 +78,16 @@ public abstract class SerializerFactory
      * 
      * @return Serializer to use, if factory knows it; null if not (in which case default
      *   serializer is to be used)
+     *
+     * @since 2.11
      */
+    public JsonSerializer<Object> createKeySerializer(SerializerProvider prov,
+            JavaType type, JsonSerializer<Object> defaultImpl)
+        throws JsonMappingException {
+        return createKeySerializer(prov.getConfig(), type, defaultImpl);
+    }
+
+    @Deprecated // since 2.11
     public abstract JsonSerializer<Object> createKeySerializer(SerializationConfig config,
             JavaType type, JsonSerializer<Object> defaultImpl)
         throws JsonMappingException;
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/std/AsArraySerializerBase.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/std/AsArraySerializerBase.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/std/AsArraySerializerBase.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/std/AsArraySerializerBase.java	2020-06-25 02:44:21.000000000 +0000
@@ -198,7 +198,7 @@ public abstract class AsArraySerializerB
             //   we can consider it a static case as well.
             if (_elementType != null) {
                 if (_staticTyping && !_elementType.isJavaLangObject()) {
-                    ser = serializers.findValueSerializer(_elementType, property);
+                    ser = serializers.findContentValueSerializer(_elementType, property);
                 }
             }
         }
@@ -292,7 +292,7 @@ public abstract class AsArraySerializerB
             // 19-Oct-2016, tatu: Apparently we get null for untyped/raw `EnumSet`s... not 100%
             //   sure what'd be the clean way but let's try this for now:
             if (_elementType != null) {
-                valueSer = visitor.getProvider().findValueSerializer(_elementType, _property);
+                valueSer = visitor.getProvider().findContentValueSerializer(_elementType, _property);
             }
         }
         visitArrayFormat(visitor, typeHint, valueSer, _elementType);
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/std/BeanSerializerBase.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/std/BeanSerializerBase.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/std/BeanSerializerBase.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/std/BeanSerializerBase.java	2020-06-25 02:44:21.000000000 +0000
@@ -5,8 +5,10 @@ import java.lang.reflect.Type;
 import java.util.*;
 
 import com.fasterxml.jackson.annotation.*;
+
 import com.fasterxml.jackson.core.*;
 import com.fasterxml.jackson.core.type.WritableTypeId;
+
 import com.fasterxml.jackson.databind.*;
 import com.fasterxml.jackson.databind.introspect.AnnotatedMember;
 import com.fasterxml.jackson.databind.introspect.ObjectIdInfo;
@@ -23,7 +25,6 @@ import com.fasterxml.jackson.databind.se
 import com.fasterxml.jackson.databind.ser.impl.PropertyBasedObjectIdGenerator;
 import com.fasterxml.jackson.databind.ser.impl.WritableObjectId;
 import com.fasterxml.jackson.databind.util.ArrayBuilders;
-import com.fasterxml.jackson.databind.util.ClassUtil;
 import com.fasterxml.jackson.databind.util.Converter;
 import com.fasterxml.jackson.databind.util.NameTransformer;
 
@@ -132,7 +133,7 @@ public abstract class BeanSerializerBase
         }
     }
 
-    public BeanSerializerBase(BeanSerializerBase src,
+    protected BeanSerializerBase(BeanSerializerBase src,
             BeanPropertyWriter[] properties, BeanPropertyWriter[] filteredProperties)
     {
         super(src._handledType);
@@ -202,7 +203,7 @@ public abstract class BeanSerializerBase
         }
         _props = propsOut.toArray(new BeanPropertyWriter[propsOut.size()]);
         _filteredProps = (fpropsOut == null) ? null : fpropsOut.toArray(new BeanPropertyWriter[fpropsOut.size()]);
-        
+
         _typeId = src._typeId;
         _anyGetterWriter = src._anyGetterWriter;
         _objectIdWriter = src._objectIdWriter;
@@ -254,7 +255,25 @@ public abstract class BeanSerializerBase
      */
     @Override
     public abstract BeanSerializerBase withFilterId(Object filterId);
-    
+
+    /**
+     * Mutant factory used for creating a new instance with modified set
+     * of properties.
+     *<p>
+     * Note: in 2.11.x, need to keep non-abstract for slightly better compatibility
+     * (XML module extends)
+     * 
+     * @since 2.11.1
+     */
+    protected BeanSerializerBase withProperties(BeanPropertyWriter[] properties,
+            BeanPropertyWriter[] filteredProperties) {
+        return this;
+    }
+
+    // Should be this, will be with 2.12:
+//    protected abstract BeanSerializerBase withProperties(BeanPropertyWriter[] properties,
+//            BeanPropertyWriter[] filteredProperties);
+
     /**
      * Copy-constructor that is useful for sub-classes that just want to
      * copy all super-class properties without modifications.
@@ -290,7 +309,7 @@ public abstract class BeanSerializerBase
 
     /*
     /**********************************************************
-    /* Post-constriction processing: resolvable, contextual
+    /* Post-construction processing: resolvable, contextual
     /**********************************************************
      */
 
@@ -319,7 +338,7 @@ public abstract class BeanSerializerBase
                     }
                 }
             }
-            
+
             if (prop.hasSerializer()) {
                 continue;
             }
@@ -341,9 +360,8 @@ public abstract class BeanSerializerBase
                     }
                 }
                 ser = provider.findValueSerializer(type, prop);
-                /* 04-Feb-2010, tatu: We may have stashed type serializer for content types
-                 *   too, earlier; if so, it's time to connect the dots here:
-                 */
+                // 04-Feb-2010, tatu: We may have stashed type serializer for content types
+                //   too, earlier; if so, it's time to connect the dots here:
                 if (type.isContainerType()) {
                     TypeSerializer typeSer = type.getContentType().getTypeHandler();
                     if (typeSer != null) {
@@ -420,13 +438,13 @@ public abstract class BeanSerializerBase
 
         // Let's start with one big transmutation: Enums that are annotated
         // to serialize as Objects may want to revert
-        JsonFormat.Value format = findFormatOverrides(provider, property, handledType());
+        JsonFormat.Value format = findFormatOverrides(provider, property, _handledType);
         JsonFormat.Shape shape = null;
         if ((format != null) && format.hasShape()) {
             shape = format.getShape();
             // or, alternatively, asked to revert "back to" other representations...
             if ((shape != JsonFormat.Shape.ANY) && (shape != _serializationShape)) {
-                if (ClassUtil.isEnumType(_handledType)) {
+                if (_beanType.isEnumType()) {
                     switch (shape) {
                     case STRING:
                     case NUMBER:
@@ -459,6 +477,10 @@ public abstract class BeanSerializerBase
         }
 
         ObjectIdWriter oiw = _objectIdWriter;
+
+        // 16-Jun-2020, tatu: [databind#2759] means we need to handle reordering
+        //    at a later point
+        int idPropOrigIndex = 0;
         Set<String> ignoredProps = null;
         Object newFilterId = null;
 
@@ -483,7 +505,6 @@ public abstract class BeanSerializerBase
                 
                 // 2.1: allow modifications by "id ref" annotations as well:
                 objectIdInfo = intr.findObjectReferenceInfo(accessor, objectIdInfo);
-                ObjectIdGenerator<?> gen;
                 Class<?> implClass = objectIdInfo.getGeneratorType();
                 JavaType type = provider.constructType(implClass);
                 JavaType idType = provider.getTypeFactory().findTypeParameters(type, ObjectIdGenerator.class)[0];
@@ -491,7 +512,7 @@ public abstract class BeanSerializerBase
                 if (implClass == ObjectIdGenerators.PropertyGenerator.class) { // most special one, needs extra work
                     String propName = objectIdInfo.getPropertyName().getSimpleName();
                     BeanPropertyWriter idProp = null;
-
+                    
                     for (int i = 0, len = _props.length; ; ++i) {
                         if (i == len) {
                             provider.reportBadDefinition(_beanType, String.format(
@@ -501,25 +522,17 @@ public abstract class BeanSerializerBase
                         BeanPropertyWriter prop = _props[i];
                         if (propName.equals(prop.getName())) {
                             idProp = prop;
-                            // Let's force it to be the first property to output
+                            // Let's mark id prop to be moved as the first (may still get rearranged)
                             // (although it may still get rearranged etc)
-                            if (i > 0) { // note: must shuffle both regular properties and filtered
-                                System.arraycopy(_props, 0, _props, 1, i);
-                                _props[0] = idProp;
-                                if (_filteredProps != null) {
-                                    BeanPropertyWriter fp = _filteredProps[i];
-                                    System.arraycopy(_filteredProps, 0, _filteredProps, 1, i);
-                                    _filteredProps[0] = fp;
-                                }
-                            }
+                            idPropOrigIndex = i;
                             break;
                         }
                     }
                     idType = idProp.getType();
-                    gen = new PropertyBasedObjectIdGenerator(objectIdInfo, idProp);
+                    ObjectIdGenerator<?> gen = new PropertyBasedObjectIdGenerator(objectIdInfo, idProp);
                     oiw = ObjectIdWriter.construct(idType, (PropertyName) null, gen, objectIdInfo.getAlwaysAsId());
                 } else { // other types need to be simpler
-                    gen = provider.objectIdGeneratorInstance(accessor, objectIdInfo);
+                    ObjectIdGenerator<?> gen = provider.objectIdGeneratorInstance(accessor, objectIdInfo);
                     oiw = ObjectIdWriter.construct(idType, objectIdInfo.getPropertyName(), gen,
                             objectIdInfo.getAlwaysAsId());
                 }
@@ -535,6 +548,25 @@ public abstract class BeanSerializerBase
         }
         // either way, need to resolve serializer:
         BeanSerializerBase contextual = this;
+
+        // 16-Jun-2020, tatu: [databind#2759] must make copies, then reorder
+        if (idPropOrigIndex > 0) { // note: must shuffle both regular properties and filtered
+            final BeanPropertyWriter[] newProps = Arrays.copyOf(_props, _props.length);
+            BeanPropertyWriter bpw = newProps[idPropOrigIndex];
+            System.arraycopy(newProps, 0, newProps, 1, idPropOrigIndex);
+            newProps[0] = bpw;
+            final BeanPropertyWriter[] newFiltered;
+            if (_filteredProps == null) {
+                newFiltered = null;
+            } else {
+                newFiltered = Arrays.copyOf(_filteredProps, _filteredProps.length);
+                bpw = newFiltered[idPropOrigIndex];
+                System.arraycopy(newFiltered, 0, newFiltered, 1, idPropOrigIndex);
+                newFiltered[0] = bpw;
+            }
+            contextual = contextual.withProperties(newProps, newFiltered);
+        }
+
         if (oiw != null) {
             JsonSerializer<?> ser = provider.findValueSerializer(oiw.idType, property);
             oiw = oiw.withSerializer(ser);
@@ -549,6 +581,7 @@ public abstract class BeanSerializerBase
         if (newFilterId != null) {
             contextual = contextual.withFilterId(newFilterId);
         }
+
         if (shape == null) {
             shape = _serializationShape;
         }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/std/ByteBufferSerializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/std/ByteBufferSerializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/std/ByteBufferSerializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/std/ByteBufferSerializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -20,7 +20,8 @@ public class ByteBufferSerializer extend
     {
         // first, simple case when wrapping an array...
         if (bbuf.hasArray()) {
-            gen.writeBinary(bbuf.array(), bbuf.arrayOffset(), bbuf.limit());
+            final int pos = bbuf.position();
+            gen.writeBinary(bbuf.array(), bbuf.arrayOffset() + pos, bbuf.limit() - pos);
             return;
         }
         // the other case is more complicated however. Best to handle with InputStream wrapper.
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/std/EnumSetSerializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/std/EnumSetSerializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/std/EnumSetSerializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/std/EnumSetSerializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -79,7 +79,7 @@ public class EnumSetSerializer
             if (enumSer == null) {
                 // 12-Jan-2010, tatu: Since enums cannot be polymorphic, let's
                 //   not bother with typed serializer variant here
-                enumSer = provider.findValueSerializer(en.getDeclaringClass(), _property);
+                enumSer = provider.findContentValueSerializer(en.getDeclaringClass(), _property);
             }
             enumSer.serialize(en, gen, provider);
         }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/std/MapSerializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/std/MapSerializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/std/MapSerializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/std/MapSerializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -304,12 +304,18 @@ public class MapSerializer
             Object filterId)
     {
         JavaType keyType, valueType;
-        
+
         if (mapType == null) {
             keyType = valueType = UNSPECIFIED_TYPE;
         } else { 
             keyType = mapType.getKeyType();
-            valueType = mapType.getContentType();
+            if (mapType.hasRawClass(java.util.Properties.class)) {
+                // 25-Mar-2020, tatu: [databind#2657] Since non-standard Properties may actually
+                //     contain non-Strings, demote value type to raw `Object`
+                valueType = TypeFactory.unknownType();
+            } else {
+                valueType = mapType.getContentType();
+            }
         }
         // If value type is final, it's same as forcing static value typing:
         if (!staticValueType) {
@@ -421,7 +427,7 @@ public class MapSerializer
             //   we can consider it a static case as well.
             // 20-Aug-2013, tatu: Need to avoid trying to access serializer for java.lang.Object tho
             if (_valueTypeIsStatic && !_valueType.isJavaLangObject()) {
-                ser = provider.findValueSerializer(_valueType, property);
+                ser = provider.findContentValueSerializer(_valueType, property);
             }
         }
         if (keySer == null) {
@@ -628,21 +634,7 @@ public class MapSerializer
         throws IOException
     {
         gen.writeStartObject(value);
-        if (!value.isEmpty()) {
-            if (_sortKeys || provider.isEnabled(SerializationFeature.ORDER_MAP_ENTRIES_BY_KEYS)) {
-                value = _orderEntries(value, gen, provider);
-            }
-            PropertyFilter pf;
-            if ((_filterId != null) && (pf = findPropertyFilter(provider, _filterId, value)) != null) {
-                serializeFilteredFields(value, gen, provider, pf, _suppressableValue);
-            } else if ((_suppressableValue != null) || _suppressNulls) {
-                serializeOptionalFields(value, gen, provider, _suppressableValue);
-            } else if (_valueSerializer != null) {
-                serializeFieldsUsing(value, gen, provider, _valueSerializer);
-            } else {
-                serializeFields(value, gen, provider);
-            }
-        }
+        serializeWithoutTypeInfo(value, gen, provider);
         gen.writeEndObject();
     }
 
@@ -655,6 +647,25 @@ public class MapSerializer
         gen.setCurrentValue(value);
         WritableTypeId typeIdDef = typeSer.writeTypePrefix(gen,
                 typeSer.typeId(value, JsonToken.START_OBJECT));
+        serializeWithoutTypeInfo(value, gen, provider);
+        typeSer.writeTypeSuffix(gen, typeIdDef);
+    }
+
+    /*
+    /**********************************************************
+    /* Secondary serialization methods
+    /**********************************************************
+     */
+
+    /**
+     * General-purpose serialization for contents without writing object type. Will suppress, filter and
+     * use custom serializers.
+     *<p>
+     * Public since it also is called by {@code AnyGetterWriter}.
+     *
+     * @since 2.11
+     */
+    public void serializeWithoutTypeInfo(Map<?, ?> value, JsonGenerator gen, SerializerProvider provider) throws IOException {
         if (!value.isEmpty()) {
             if (_sortKeys || provider.isEnabled(SerializationFeature.ORDER_MAP_ENTRIES_BY_KEYS)) {
                 value = _orderEntries(value, gen, provider);
@@ -670,15 +681,8 @@ public class MapSerializer
                 serializeFields(value, gen, provider);
             }
         }
-        typeSer.writeTypeSuffix(gen, typeIdDef);
     }
 
-    /*
-    /**********************************************************
-    /* Secondary serialization methods
-    /**********************************************************
-     */
-    
     /**
      * General-purpose serialization for contents, where we do not necessarily know
      * the value serialization, but 
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/std/ObjectArraySerializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/std/ObjectArraySerializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/std/ObjectArraySerializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/std/ObjectArraySerializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -158,7 +158,7 @@ public class ObjectArraySerializer
             //   we can consider it a static case as well.
             if (_elementType != null) {
                 if (_staticTyping && !_elementType.isJavaLangObject()) {
-                    ser = serializers.findValueSerializer(_elementType, property);
+                    ser = serializers.findContentValueSerializer(_elementType, property);
                 }
             }
         }
@@ -327,7 +327,7 @@ public class ObjectArraySerializer
 */
             JsonSerializer<?> valueSer = _elementSerializer;
             if (valueSer == null) {
-                valueSer = visitor.getProvider().findValueSerializer(contentType, _property);
+                valueSer = visitor.getProvider().findContentValueSerializer(contentType, _property);
             }
             arrayVisitor.itemsFormat(valueSer, contentType);
         }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/std/ReferenceTypeSerializer.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/std/ReferenceTypeSerializer.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/std/ReferenceTypeSerializer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/std/ReferenceTypeSerializer.java	2020-06-25 02:44:21.000000000 +0000
@@ -19,7 +19,7 @@ import com.fasterxml.jackson.databind.ut
 /**
  * Base implementation for values of {@link ReferenceType}.
  * Implements most of functionality, only leaving couple of abstract
- * methods for sub-classes to implement
+ * methods for sub-classes to implement.
  *
  * @since 2.8
  */
@@ -130,7 +130,12 @@ public abstract class ReferenceTypeSeria
     public JsonSerializer<T> unwrappingSerializer(NameTransformer transformer) {
         JsonSerializer<Object> valueSer = _valueSerializer;
         if (valueSer != null) {
+            // 09-Dec-2019, tatu: [databind#2565] Can not assume that serializer in
+            //    question actually can unwrap
             valueSer = valueSer.unwrappingSerializer(transformer);
+            if (valueSer == _valueSerializer) {
+                return this;
+            }
         }
         NameTransformer unwrapper = (_unwrapper == null) ? transformer
                 : NameTransformer.chainedTransformer(transformer, _unwrapper);
@@ -454,9 +459,12 @@ public abstract class ReferenceTypeSeria
                 // [databind#1673] Must ensure we will resolve all available type information
                 //  so as not to miss generic declaration of, say, `List<GenericPojo>`...
                 JavaType fullType = provider.constructSpecializedType(_referredType, rawType);
-                ser = provider.findValueSerializer(fullType, _property);
+                // 23-Oct-2019, tatu: I _think_ we actually need to consider referenced
+                //    type as "primary" to allow applying various handlers -- done since 2.11
+                
+                ser = provider.findPrimaryPropertySerializer(fullType, _property);
             } else {
-                ser = provider.findValueSerializer(rawType, _property);
+                ser = provider.findPrimaryPropertySerializer(rawType, _property);
             }
             if (_unwrapper != null) {
                 ser = ser.unwrappingSerializer(_unwrapper);
@@ -474,6 +482,6 @@ public abstract class ReferenceTypeSeria
         // 15-Jan-2017, tatu: ... possibly because we need to access "secondary" serializer,
         //   not primary (primary being one for Reference type itself, not value)
 //        return provider.findTypedValueSerializer(type, true, prop);
-        return provider.findValueSerializer(type, prop);
+        return provider.findPrimaryPropertySerializer(type, prop);
     }
 }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/std/StaticListSerializerBase.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/std/StaticListSerializerBase.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/std/StaticListSerializerBase.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/std/StaticListSerializerBase.java	2020-06-25 02:44:21.000000000 +0000
@@ -83,7 +83,7 @@ public abstract class StaticListSerializ
         // [databind#124]: May have a content converter
         ser = findContextualConvertingSerializer(serializers, property, ser);
         if (ser == null) {
-            ser = serializers.findValueSerializer(String.class, property);
+            ser = serializers.findContentValueSerializer(String.class, property);
         }
         // Optimization: default serializer just writes String, so we can avoid a call:
         if (isDefaultSerializer(ser)) {
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/std/StdJdkSerializers.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/std/StdJdkSerializers.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/std/StdJdkSerializers.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/std/StdJdkSerializers.java	2020-06-25 02:44:21.000000000 +0000
@@ -60,7 +60,7 @@ public class StdJdkSerializers
         } catch (NoClassDefFoundError e) {
             // nothing much we can do here; could log, but probably not useful for now.
         }
-        
+
         return sers.entrySet();
     }
 
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/VirtualBeanPropertyWriter.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/VirtualBeanPropertyWriter.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/ser/VirtualBeanPropertyWriter.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/ser/VirtualBeanPropertyWriter.java	2020-06-25 02:44:21.000000000 +0000
@@ -176,7 +176,7 @@ public abstract class VirtualBeanPropert
             }
         }
         if (value == bean) { // simple check for direct cycles
-            // three choices: exception; handled by call; or pass-through
+            // four choices: exception; handled by call; or pass-through; write null
             if (_handleSelfReference(bean, gen, prov, ser)) {
                 return;
             }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/SerializationFeature.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/SerializationFeature.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/SerializationFeature.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/SerializationFeature.java	2020-06-25 02:44:21.000000000 +0000
@@ -115,6 +115,19 @@ public enum SerializationFeature impleme
      */
     FAIL_ON_UNWRAPPED_TYPE_IDENTIFIERS(true),
 
+    /**
+     * Feature that determines what happens when a direct self-reference is detected
+     * by a POJO (and no Object Id handling is enabled for it):
+     * if enabled write that reference as null; if disabled, default behavior is
+     * used (which will try to serialize usually resulting in exception).
+     * But if {@link SerializationFeature#FAIL_ON_SELF_REFERENCES} is enabled. this property is ignored.
+     * <p>
+     * Feature is disabled by default.
+     *
+     * @since 2.11
+     */
+    WRITE_SELF_REFERENCES_AS_NULL(false),
+
     /*
     /******************************************************
     /* Output life cycle features
@@ -162,32 +175,33 @@ public enum SerializationFeature impleme
     /**
      * Feature that determines whether Date (and date/time) values
      * (and Date-based things like {@link java.util.Calendar}s) are to be
-     * serialized as numeric timestamps (true; the default),
+     * serialized as numeric time stamps (true; the default),
      * or as something else (usually textual representation).
-     * If textual representation is used, the actual format is
-     * one returned by a call to
-     * {@link com.fasterxml.jackson.databind.SerializationConfig#getDateFormat}:
-     * the default setting being {@link com.fasterxml.jackson.databind.util.StdDateFormat},
-     * which corresponds to format String of "yyyy-MM-dd'T'HH:mm:ss.SSSZ"
+     * If textual representation is used, the actual format depends on configuration
+     * settings including possible per-property use of {@code @JsonFormat} annotation,
+     * globally configured {@link java.text.DateFormat}.
+     *<p>
+     * For "classic" JDK date types ({@link java.util.Date}, {@link java.util.Calendar})
+     * the default formatting is provided by {@link com.fasterxml.jackson.databind.util.StdDateFormat},
+     * and corresponds to format String of "yyyy-MM-dd'T'HH:mm:ss.SSSX"
      * (see {@link java.text.DateFormat} for details of format Strings).
-     *<p>
-     * Note: whether this feature affects handling of other date-related
+     * Whether this feature affects handling of other date-related
      * types depend on handlers of those types, although ideally they
      * should use this feature
      *<p>
      * Note: whether {@link java.util.Map} keys are serialized as Strings
-     * or not is controlled using {@link #WRITE_DATE_KEYS_AS_TIMESTAMPS}.
+     * or not is controlled using {@link #WRITE_DATE_KEYS_AS_TIMESTAMPS} instead of
+     * this feature.
      *<p>
      * Feature is enabled by default, so that date/time are by default
-     * serialized as timestamps.
+     * serialized as time stamps.
      */
     WRITE_DATES_AS_TIMESTAMPS(true),
 
     /**
      * Feature that determines whether {@link java.util.Date}s
      * (and sub-types) used as {@link java.util.Map} keys are serialized
-     * as timestamps or not (if not, will be serialized as textual
-     * values).
+     * as time stamps or not (if not, will be serialized as textual values).
      *<p>
      * Default value is 'false', meaning that Date-valued Map keys are serialized
      * as textual (ISO-8601) values.
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/SerializerProvider.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/SerializerProvider.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/SerializerProvider.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/SerializerProvider.java	2020-06-25 02:44:21.000000000 +0000
@@ -313,8 +313,7 @@ public abstract class SerializerProvider
         
     /*
     /**********************************************************
-    /* DatabindContext implementation (and closely related
-    /* but ser-specific)
+    /* DatabindContext implementation (and closely related but ser-specific)
     /**********************************************************
      */
 
@@ -334,6 +333,18 @@ public abstract class SerializerProvider
         return _config.getTypeFactory();
     }
 
+    @Override // since 2.11
+    public JavaType constructSpecializedType(JavaType baseType, Class<?> subclass)
+        throws IllegalArgumentException
+    {
+        if (baseType.hasRawClass(subclass)) {
+            return baseType;
+        }
+        // Need little bit different handling due to [databind#2632]; pass `true` for
+        // "relaxed" type assingment checks.
+        return getConfig().getTypeFactory().constructSpecializedType(baseType, subclass, true);
+    }
+
     @Override
     public final Class<?> getActiveView() { return _serializationView; }
     
@@ -624,6 +635,7 @@ public abstract class SerializerProvider
      * and method(s) called: this method should only be called when caller is
      * certain that this is the primary property value serializer.
      * 
+     * @param valueType Type of values to serialize
      * @param property Property that is being handled; will never be null, and its
      *    type has to match <code>valueType</code> parameter.
      * 
@@ -652,6 +664,8 @@ public abstract class SerializerProvider
     }
 
     /**
+     * See {@link #findPrimaryPropertySerializer(JavaType, BeanProperty)}
+     *
      * @since 2.3
      */
     @SuppressWarnings("unchecked")
@@ -678,7 +692,79 @@ public abstract class SerializerProvider
         }
         return (JsonSerializer<Object>) handlePrimaryContextualization(ser, property);
     }
-    
+
+    /**
+     * Alternative to {@link #findPrimaryPropertySerializer(JavaType, BeanProperty)} called not
+     * for primary value, but "content" of such primary serializer: element of an array or
+     * {@link java.util.Collection}, value of {@link java.util.Map} entry and so on.
+     * This means that {@code property} passed (if any) does NOT represent value for which
+     * serializer is requested but its secondary type (or secondary type of that type,
+     * recursively).
+     *<p>
+     * Serializer returned SHOULD NOT handle type information; caller will (have to) add
+     * suitable wrapping if necessary.
+     *<p>
+     * Note: this call will also contextualize serializer (call {@code createContextual()}
+     * before returning it, if applicable (implements {@code ContextualSerializer})
+     *
+     * @param valueType Type of values to serialize
+     * @param property Property that indirectly refers to value being serialized (optional,
+     *    may be {@code null} for root level serializers)
+     *
+     * @since 2.11
+     */
+    @SuppressWarnings("unchecked")
+    public JsonSerializer<Object> findContentValueSerializer(JavaType valueType, BeanProperty property)
+            throws JsonMappingException
+    {
+        JsonSerializer<Object> ser = _knownSerializers.untypedValueSerializer(valueType);
+        if (ser == null) {
+            ser = _serializerCache.untypedValueSerializer(valueType);
+            if (ser == null) {
+                ser = _createAndCacheUntypedSerializer(valueType);
+                if (ser == null) {
+                    ser = getUnknownTypeSerializer(valueType.getRawClass());
+                    // Should this be added to lookups?
+                    if (CACHE_UNKNOWN_MAPPINGS) {
+                        _serializerCache.addAndResolveNonTypedSerializer(valueType, ser, this);
+                    }
+                    return ser;
+                }
+            }
+        }
+        return (JsonSerializer<Object>) handleSecondaryContextualization(ser, property);
+    }
+
+    /**
+     * See {@link #findContentValueSerializer(JavaType, BeanProperty)}.
+     *
+     * @since 2.11
+     */
+    @SuppressWarnings("unchecked")
+    public JsonSerializer<Object> findContentValueSerializer(Class<?> valueType,
+            BeanProperty property)
+        throws JsonMappingException
+    {
+        JsonSerializer<Object> ser = _knownSerializers.untypedValueSerializer(valueType);
+        if (ser == null) {
+            ser = _serializerCache.untypedValueSerializer(valueType);
+            if (ser == null) {
+                ser = _serializerCache.untypedValueSerializer(_config.constructType(valueType));
+                if (ser == null) {
+                    ser = _createAndCacheUntypedSerializer(valueType);
+                    if (ser == null) {
+                        ser = getUnknownTypeSerializer(valueType);
+                        if (CACHE_UNKNOWN_MAPPINGS) {
+                            _serializerCache.addAndResolveNonTypedSerializer(valueType, ser, this);
+                        }
+                        return ser;
+                    }
+                }
+            }
+        }
+        return (JsonSerializer<Object>) handleSecondaryContextualization(ser, property);
+    }
+
     /**
      * Method called to locate regular serializer, matching type serializer,
      * and if both found, wrap them in a serializer that calls both in correct
@@ -791,7 +877,7 @@ public abstract class SerializerProvider
     public JsonSerializer<Object> findKeySerializer(JavaType keyType, BeanProperty property)
         throws JsonMappingException
     {
-        JsonSerializer<Object> ser = _serializerFactory.createKeySerializer(_config, keyType, _keySerializer);
+        JsonSerializer<Object> ser = _serializerFactory.createKeySerializer(this, keyType, _keySerializer);
         // 25-Feb-2011, tatu: As per [JACKSON-519], need to ensure contextuality works here, too
         return _handleContextualResolvable(ser, property);
     }
@@ -1383,10 +1469,10 @@ public abstract class SerializerProvider
         //    versions, likely due to concurrency fixes for `AnnotatedClass` introspection.
         //    This sync block could probably be removed; but to minimize any risk of
         //    regression sync block will only be removed from 3.0.
-        synchronized (_serializerCache) {
-            // 17-Feb-2013, tatu: Used to call deprecated method (that passed property)
+        // 23-Oct-2019, tatu: Due to continuation of 2.x line, removed from 2.11
+//        synchronized (_serializerCache) {
             return (JsonSerializer<Object>)_serializerFactory.createSerializer(this, type);
-        }
+//        }
     }
 
     /**
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/type/PlaceholderForType.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/type/PlaceholderForType.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/type/PlaceholderForType.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/type/PlaceholderForType.java	2020-06-25 02:44:21.000000000 +0000
@@ -83,8 +83,8 @@ public class PlaceholderForType extends
         return _unsupported();
     }
 
-    @SuppressWarnings("deprecation")
     @Override
+    @Deprecated // since 2.7
     protected JavaType _narrow(Class<?> subclass) {
         return _unsupported();
     }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/type/TypeFactory.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/type/TypeFactory.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/type/TypeFactory.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/type/TypeFactory.java	2020-06-25 02:44:21.000000000 +0000
@@ -359,8 +359,39 @@ public class TypeFactory // note: was fi
      * Can be used, for example, to get equivalent of "HashMap&lt;String,Integer&gt;"
      * from "Map&lt;String,Integer&gt;" by giving <code>HashMap.class</code>
      * as subclass.
+     * Short-cut for:
+     *<pre>
+     * constructSpecializedType(baseType, subclass, class);
+     *</pre>
+     * that is, will use "strict" compatibility checking, usually used for
+     * deserialization purposes (but often not for serialization).
      */
     public JavaType constructSpecializedType(JavaType baseType, Class<?> subclass)
+        throws IllegalArgumentException
+    {
+        return constructSpecializedType(baseType, subclass, false);
+    }
+
+    /**
+     * Factory method for creating a subtype of given base type, as defined
+     * by specified subclass; but retaining generic type information if any.
+     * Can be used, for example, to get equivalent of "HashMap&lt;String,Integer&gt;"
+     * from "Map&lt;String,Integer&gt;" by giving <code>HashMap.class</code>
+     * as subclass.
+     * 
+     * @param baseType Declared base type with resolved type parameters
+     * @param subclass Runtime subtype to use for resolving
+     * @param relaxedCompatibilityCheck Whether checking for type-assignment compatibility
+     *    should be "relaxed" ({@code true}) or "strict" ({@code false}): typically
+     *    serialization uses relaxed, deserialization strict checking.
+     *
+     * @return Resolved sub-type
+     *
+     * @since 2.11
+     */
+    public JavaType constructSpecializedType(JavaType baseType, Class<?> subclass,
+            boolean relaxedCompatibilityCheck)
+        throws IllegalArgumentException
     {
         // simple optimization to avoid costly introspection if type-erased type does NOT differ
         final Class<?> rawBase = baseType.getRawClass();
@@ -376,8 +407,9 @@ public class TypeFactory // note: was fi
                 break;
             }
             if (!rawBase.isAssignableFrom(subclass)) {
-                throw new IllegalArgumentException(String.format(
-                        "Class %s not subtype of %s", subclass.getName(), baseType));
+                throw new IllegalArgumentException(String.format("Class %s not subtype of %s",
+                        ClassUtil.nameOf(subclass), ClassUtil.getTypeDescription(baseType)
+                ));
             }
             // A few special cases where we can simplify handling:
 
@@ -421,7 +453,8 @@ public class TypeFactory // note: was fi
                 break;
             }
             // (4) If all else fails, do the full traversal using placeholders
-            TypeBindings tb = _bindingsForSubtype(baseType, typeParamCount, subclass);
+            TypeBindings tb = _bindingsForSubtype(baseType, typeParamCount,
+                    subclass, relaxedCompatibilityCheck);
             newType = _fromClass(null, subclass, tb);
 
         } while (false);
@@ -432,7 +465,8 @@ public class TypeFactory // note: was fi
         return newType;
     }
 
-    private TypeBindings _bindingsForSubtype(JavaType baseType, int typeParamCount, Class<?> subclass)
+    private TypeBindings _bindingsForSubtype(JavaType baseType, int typeParamCount,
+            Class<?> subclass, boolean relaxedCompatibilityCheck)
     {
         PlaceholderForType[] placeholders = new PlaceholderForType[typeParamCount];
         for (int i = 0; i < typeParamCount; ++i) {
@@ -451,8 +485,12 @@ public class TypeFactory // note: was fi
         // and traverse type hierarchies to both verify and to resolve placeholders
         String error = _resolveTypePlaceholders(baseType, baseWithPlaceholders);
         if (error != null) {
-            throw new IllegalArgumentException("Failed to specialize base type "+baseType.toCanonical()+" as "
-                    +subclass.getName()+", problem: "+error);
+            // 28-Mar-2020, tatu: As per [databind#2632], need to ignore the issue in
+            //   some cases. For now, just fully ignore; may need to refine in future
+            if (!relaxedCompatibilityCheck) {
+                throw new IllegalArgumentException("Failed to specialize base type "+baseType.toCanonical()+" as "
+                        +subclass.getName()+", problem: "+error);
+            }
         }
 
         final JavaType[] typeParams = new JavaType[typeParamCount];
@@ -474,9 +512,12 @@ public class TypeFactory // note: was fi
     {
         List<JavaType> expectedTypes = sourceType.getBindings().getTypeParameters();
         List<JavaType> actualTypes = actualType.getBindings().getTypeParameters();
-        for (int i = 0, len = expectedTypes.size(); i < len; ++i) {
+
+        final int actCount = actualTypes.size();
+
+        for (int i = 0, expCount = expectedTypes.size(); i < expCount; ++i) {
             JavaType exp = expectedTypes.get(i);
-            JavaType act = actualTypes.get(i);
+            JavaType act = (i < actCount) ? actualTypes.get(i) : unknownType();
 
             if (!_verifyAndResolvePlaceholders(exp, act)) {
                 // 14-May-2018, tatu: As per [databind#2034] it seems we better relax assignment
@@ -505,7 +546,7 @@ public class TypeFactory // note: was fi
                     }
                 }
                 return String.format("Type parameter #%d/%d differs; can not specialize %s with %s",
-                        (i+1), len, exp.toCanonical(), act.toCanonical());
+                        (i+1), expCount, exp.toCanonical(), act.toCanonical());
             }
         }
         return null;
@@ -977,7 +1018,7 @@ public class TypeFactory // note: was fi
     /**
      * Factory method for constructing {@link JavaType} that
      * represents a parameterized type. For example, to represent
-     * type {@code List<Set<Integer>>}, you could call
+     * type {@code List<Set<Integer>>}, you could
      *<pre>
      *  JavaType inner = TypeFactory.constructParametricType(Set.class, Set.class, Integer.class);
      *  return TypeFactory.constructParametricType(ArrayList.class, List.class, inner);
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/util/BeanUtil.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/util/BeanUtil.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/util/BeanUtil.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/util/BeanUtil.java	2020-06-25 02:44:21.000000000 +0000
@@ -260,9 +260,11 @@ public class BeanUtil
     }
 
     /**
+     * Note: public only since 2.11
+     *
      * @since 2.5
      */
-    protected static String stdManglePropertyName(final String basename, final int offset)
+    public static String stdManglePropertyName(final String basename, final int offset)
     {
         final int end = basename.length();
         if (end == offset) { // empty name, nope
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/util/ClassUtil.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/util/ClassUtil.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/util/ClassUtil.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/util/ClassUtil.java	2020-06-25 02:44:21.000000000 +0000
@@ -184,23 +184,24 @@ public final class ClassUtil
     {
         /* As per [JACKSON-187], GAE seems to throw SecurityExceptions
          * here and there... and GAE itself has a bug, too
-         * (see []). Bah. So we need to catch some wayward exceptions on GAE
+         * Bah. So we need to catch some wayward exceptions on GAE
          */
         try {
+            final boolean isStatic = Modifier.isStatic(type.getModifiers());
+
             // one more: method locals, anonymous, are not good:
-            if (hasEnclosingMethod(type)) {
+            // 23-Jun-2020, tatu: [databind#2758] With JDK14+ should allow
+            //    local Record types, however
+            if (!isStatic && hasEnclosingMethod(type)) {
                 return "local/anonymous";
             }
-            
             /* But how about non-static inner classes? Can't construct
              * easily (theoretically, we could try to check if parent
              * happens to be enclosing... but that gets convoluted)
              */
             if (!allowNonStatic) {
-                if (!Modifier.isStatic(type.getModifiers())) {
-                    if (getEnclosingClass(type) != null) {
-                        return "non-static member class";
-                    }
+                if (!isStatic && getEnclosingClass(type) != null) {
+                    return "non-static member class";
                 }
             }
         }
@@ -215,19 +216,18 @@ public final class ClassUtil
     public static Class<?> getOuterClass(Class<?> type)
     {
         // as above, GAE has some issues...
-        try {
-            // one more: method locals, anonymous, are not good:
-            if (hasEnclosingMethod(type)) {
-                return null;
-            }
-            if (!Modifier.isStatic(type.getModifiers())) {
+        if (!Modifier.isStatic(type.getModifiers())) {
+            try {
+                // one more: method locals, anonymous, are not good:
+                if (hasEnclosingMethod(type)) {
+                    return null;
+                }
                 return getEnclosingClass(type);
-            }
-        } catch (SecurityException e) { }
+            } catch (SecurityException e) { }
+        }
         return null;
     }
-    
-    
+
     /**
      * Helper method used to weed out dynamic Proxy types; types that do
      * not expose concrete method API that we could use to figure out
@@ -281,11 +281,6 @@ public final class ClassUtil
                 || cls == com.fasterxml.jackson.databind.annotation.NoClass.class);
     }
 
-    public static boolean isNonStaticInnerClass(Class<?> cls) {
-        return !Modifier.isStatic(cls.getModifiers())
-                && (getEnclosingClass(cls) != null);
-    }
-
     /**
      * @since 2.7
      */
@@ -1041,7 +1036,7 @@ public final class ClassUtil
      */
     public static <T extends Annotation> Enum<?> findFirstAnnotatedEnumValue(Class<Enum<?>> enumClass, Class<T> annotationClass)
     {
-        Field[] fields = getDeclaredFields(enumClass);
+        Field[] fields = enumClass.getDeclaredFields();
         for (Field field : fields) {
             if (field.isEnumConstant()) {
                 Annotation defaultValueAnnotation = field.getAnnotation(annotationClass);
@@ -1059,9 +1054,9 @@ public final class ClassUtil
     }
 
     /*
-    /**********************************************************
-    /* Jackson-specific stuff
-    /**********************************************************
+    /**********************************************************************
+    /* Methods for detecting special class categories
+    /**********************************************************************
      */
 
     /**
@@ -1082,6 +1077,17 @@ public final class ClassUtil
         return (implClass.getAnnotation(JacksonStdImpl.class) != null);
     }
 
+    /**
+     * Some aspects of handling need to be changed for JDK types (and possibly
+     * some extensions under {@code javax.}?): for example, forcing of access
+     * will not work well for future JDKs (12 and later).
+     *
+     * @since 2.11
+     */
+    public static boolean isJDKClass(Class<?> rawType) {
+        return rawType.getName().startsWith("java.");
+    }
+
     /*
     /**********************************************************
     /* Access to various Class definition aspects; possibly
@@ -1091,6 +1097,11 @@ public final class ClassUtil
     /**********************************************************
      */
 
+    public static boolean isNonStaticInnerClass(Class<?> cls) {
+        return !Modifier.isStatic(cls.getModifiers())
+                && (getEnclosingClass(cls) != null);
+    }
+
     /**
      * @since 2.7
      */
@@ -1107,15 +1118,17 @@ public final class ClassUtil
     }
 
     /**
-     * @since 2.7
+     * @deprecated since 2.11 (just call Class method directly)
      */
+    @Deprecated
     public static Field[] getDeclaredFields(Class<?> cls) {
         return cls.getDeclaredFields();
     }
 
     /**
-     * @since 2.7
+     * @deprecated since 2.11 (just call Class method directly)
      */
+    @Deprecated
     public static Method[] getDeclaredMethods(Class<?> cls) {
         return cls.getDeclaredMethods();
     }
@@ -1140,7 +1153,7 @@ public final class ClassUtil
     public static Method[] getClassMethods(Class<?> cls)
     {
         try {
-            return ClassUtil.getDeclaredMethods(cls);
+            return cls.getDeclaredMethods();
         } catch (final NoClassDefFoundError ex) {
             // One of the methods had a class that was not found in the cls.getClassLoader.
             // Maybe the developer was nice and has a different class loader for this context.
@@ -1269,7 +1282,7 @@ public final class ClassUtil
         {
             Field found = null;
     	        // First: let's see if we can find exact match:
-            Field[] fields = getDeclaredFields(fromClass);
+            Field[] fields = fromClass.getDeclaredFields();
     	        for (Field f : fields) {
     	            if (expectedName.equals(f.getName()) && f.getType() == type) {
     	                found = f;
@@ -1311,9 +1324,9 @@ public final class ClassUtil
     {
         public final Constructor<?> _ctor;
 
-        private Annotation[] _annotations;
+        private transient Annotation[] _annotations;
 
-        private  Annotation[][] _paramAnnotations;
+        private transient Annotation[][] _paramAnnotations;
         
         private int _paramCount = -1;
         
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/util/EnumResolver.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/util/EnumResolver.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/util/EnumResolver.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/util/EnumResolver.java	2020-06-25 02:44:21.000000000 +0000
@@ -21,7 +21,8 @@ public class EnumResolver implements jav
 
     protected final Enum<?> _defaultValue;
 
-    protected EnumResolver(Class<Enum<?>> enumClass, Enum<?>[] enums, HashMap<String, Enum<?>> map, Enum<?> defaultValue)
+    protected EnumResolver(Class<Enum<?>> enumClass, Enum<?>[] enums,
+            HashMap<String, Enum<?>> map, Enum<?> defaultValue)
     {
         _enumClass = enumClass;
         _enums = enums;
@@ -40,18 +41,28 @@ public class EnumResolver implements jav
             throw new IllegalArgumentException("No enum constants for class "+enumCls.getName());
         }
         String[] names = ai.findEnumValues(enumCls, enumValues, new String[enumValues.length]);
+        final String[][] allAliases = new String[names.length][];
+        ai.findEnumAliases(enumCls, enumValues, allAliases);
         HashMap<String, Enum<?>> map = new HashMap<String, Enum<?>>();
         for (int i = 0, len = enumValues.length; i < len; ++i) {
+            final Enum<?> enumValue = enumValues[i];
             String name = names[i];
             if (name == null) {
-                name = enumValues[i].name();
+                name = enumValue.name();
+            }
+            map.put(name, enumValue);
+            String[] aliases = allAliases[i];
+            if (aliases != null) {
+                for (String alias : aliases) {
+                    // TODO: JDK 1.8, use Map.putIfAbsent()
+                    // Avoid overriding any primary names
+                    if (!map.containsKey(alias)) {
+                        map.put(alias, enumValue);
+                    }
+                }
             }
-            map.put(name, enumValues[i]);
         }
-
-        Enum<?> defaultEnum = ai.findDefaultEnumValue(enumCls);
-
-        return new EnumResolver(enumCls, enumValues, map, defaultEnum);
+        return new EnumResolver(enumCls, enumValues, map,  ai.findDefaultEnumValue(enumCls));
     }
 
     /**
@@ -71,15 +82,27 @@ public class EnumResolver implements jav
     public static EnumResolver constructUsingToString(Class<Enum<?>> enumCls,
             AnnotationIntrospector ai)
     {
-        Enum<?>[] enumValues = enumCls.getEnumConstants();
+        Enum<?>[] enumConstants = enumCls.getEnumConstants();
         HashMap<String, Enum<?>> map = new HashMap<String, Enum<?>>();
+        final String[][] allAliases = new String[enumConstants.length][];
+        ai.findEnumAliases(enumCls, enumConstants, allAliases);
+
         // from last to first, so that in case of duplicate values, first wins
-        for (int i = enumValues.length; --i >= 0; ) {
-            Enum<?> e = enumValues[i];
-            map.put(e.toString(), e);
+        for (int i = enumConstants.length; --i >= 0; ) {
+            Enum<?> enumValue = enumConstants[i];
+            map.put(enumValue.toString(), enumValue);
+            String[] aliases = allAliases[i];
+            if (aliases != null) {
+                for (String alias : aliases) {
+                    // TODO: JDK 1.8, use Map.putIfAbsent()
+                    // Avoid overriding any primary names
+                    if (!map.containsKey(alias)) {
+                        map.put(alias, enumValue);
+                    }
+                }
+            }
         }
-        Enum<?> defaultEnum = (ai == null) ? null : ai.findDefaultEnumValue(enumCls);
-        return new EnumResolver(enumCls, enumValues, map, defaultEnum);
+        return new EnumResolver(enumCls, enumConstants, map, ai.findDefaultEnumValue(enumCls));
     }
 
     /**
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/util/EnumValues.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/util/EnumValues.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/util/EnumValues.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/util/EnumValues.java	2020-06-25 02:44:21.000000000 +0000
@@ -7,8 +7,8 @@ import com.fasterxml.jackson.databind.*;
 import com.fasterxml.jackson.databind.cfg.MapperConfig;
 
 /**
- * Helper class used for storing String serializations of
- * enumerations.
+ * Helper class used for storing String serializations of {@code Enum}s,
+ * to match to/from external representations.
  */
 public final class EnumValues
     implements java.io.Serializable
@@ -58,23 +58,44 @@ public final class EnumValues
             }
             textual[en.ordinal()] = config.compileString(name);
         }
-        return new EnumValues(enumClass, textual);
+        return construct(enumClass, textual);
     }
 
     public static EnumValues constructFromToString(MapperConfig<?> config, Class<Enum<?>> enumClass)
     {
         Class<? extends Enum<?>> cls = ClassUtil.findEnumType(enumClass);
         Enum<?>[] values = cls.getEnumConstants();
-        if (values != null) {
-            SerializableString[] textual = new SerializableString[values.length];
-            for (Enum<?> en : values) {
-                textual[en.ordinal()] = config.compileString(en.toString());
-            }
-            return new EnumValues(enumClass, textual);
+        if (values == null) { // can this ever occur?
+            throw new IllegalArgumentException("Cannot determine enum constants for Class "+enumClass.getName());
+        }
+        ArrayList<String> external = new ArrayList<>(values.length);
+        for (Enum<?> en : values) {
+            external.add(en.toString());
         }
-        throw new IllegalArgumentException("Cannot determine enum constants for Class "+enumClass.getName());
+        return construct(config, enumClass, external);
     }
 
+    /**
+     * @since 2.11
+     */
+    public static EnumValues construct(MapperConfig<?> config, Class<Enum<?>> enumClass,
+            List<String> externalValues) {
+        final int len = externalValues.size();
+        SerializableString[] textual = new SerializableString[len];
+        for (int i = 0; i < len; ++i) {
+            textual[i] = config.compileString(externalValues.get(i));
+        }
+        return construct(enumClass, textual);
+    }
+
+    /**
+     * @since 2.11
+     */
+    public static EnumValues construct(Class<Enum<?>> enumClass,
+            SerializableString[] externalValues) {
+        return new EnumValues(enumClass, externalValues);
+    }
+    
     public SerializableString serializedValueFor(Enum<?> key) {
         return _textual[key.ordinal()];
     }
diff -pruN 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/util/StdDateFormat.java 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/util/StdDateFormat.java
--- 2.10.2-1/src/main/java/com/fasterxml/jackson/databind/util/StdDateFormat.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/main/java/com/fasterxml/jackson/databind/util/StdDateFormat.java	2020-06-25 02:44:21.000000000 +0000
@@ -17,12 +17,14 @@ import com.fasterxml.jackson.core.io.Num
  * an ISO-8601 compliant format (format String "yyyy-MM-dd'T'HH:mm:ss.SSSZ")
  * and for deserialization, both ISO-8601 and RFC-1123.
  *<br>
- * Note that `Z` in format String refers to RFC-822 timezone notation which produces
- * values like "-0800" -- that is, full minute/hour combo without colon, and not using `Z`
- * as alias for "+0000".
- *<p>
- * Note also that to enable use of colon in timezone is possible by using method
- * {@link #withColonInTimeZone} for creating new differently configured format instance.
+ * Note that `Z` in format String refers to ISO-8601 time offset notation which produces
+ * values like "-08:00" -- that is, full minute/hour combo without colon, and not using `Z`
+ * as alias for "+00:00".
+ * Inclusion of colon as separator, as default setting, started in Jackson 2.11:
+ * prior versions omitted it.
+ * Note that it is possible to enable/disable use of colon in time offset by using method
+ * {@link #withColonInTimeZone} for creating new differently configured format instance,
+ * and configuring {@code ObjectMapper} with it.
  */
 @SuppressWarnings("serial")
 public class StdDateFormat
@@ -57,7 +59,7 @@ public class StdDateFormat
      * to ISO-8601 date formatting standard, when it includes basic undecorated
      * timezone definition.
      */
-    public final static String DATE_FORMAT_STR_ISO8601 = "yyyy-MM-dd'T'HH:mm:ss.SSSZ";
+    public final static String DATE_FORMAT_STR_ISO8601 = "yyyy-MM-dd'T'HH:mm:ss.SSSX";
 
     /**
      * ISO-8601 with just the Date part, no time: needed for error messages
@@ -94,8 +96,6 @@ public class StdDateFormat
 
     protected final static DateFormat DATE_FORMAT_RFC1123;
 
-    protected final static DateFormat DATE_FORMAT_ISO8601;
-
     /* Let's construct "blueprint" date format instances: cannot be used
      * as is, due to thread-safety issues, but can be used for constructing
      * actual instances more cheaply (avoids re-parsing).
@@ -105,8 +105,6 @@ public class StdDateFormat
         // baseline DataFormat objects
         DATE_FORMAT_RFC1123 = new SimpleDateFormat(DATE_FORMAT_STR_RFC1123, DEFAULT_LOCALE);
         DATE_FORMAT_RFC1123.setTimeZone(DEFAULT_TIMEZONE);
-        DATE_FORMAT_ISO8601 = new SimpleDateFormat(DATE_FORMAT_STR_ISO8601, DEFAULT_LOCALE);
-        DATE_FORMAT_ISO8601.setTimeZone(DEFAULT_TIMEZONE);
     }
 
     /**
@@ -147,18 +145,19 @@ public class StdDateFormat
      * @since 2.9.1
      */
     private transient Calendar _calendar;
-    
+
     private transient DateFormat _formatRFC1123;
 
     /** 
      * Whether the TZ offset must be formatted with a colon between hours and minutes ({@code HH:mm} format)
      *<p>
-     * Defaults to {@code false} for backwards compatibility reasons
+     * Defaults to {@code true} since 2.11: earlier versions defaulted to {@code false}
+     * for backwards compatibility reasons
      *
      * @since 2.9.1
      */
-    private boolean _tzSerializedWithColon = false;
-    
+    private boolean _tzSerializedWithColon = true;
+
     /*
     /**********************************************************
     /* Life cycle, accessing singleton "standard" formats
@@ -189,7 +188,7 @@ public class StdDateFormat
         _lenient = lenient;
         _tzSerializedWithColon = formatTzOffsetWithColon;
     }
-    
+
     public static TimeZone getDefaultTimeZone() {
         return DEFAULT_TIMEZONE;
     }
@@ -257,7 +256,7 @@ public class StdDateFormat
     
     @Override
     public StdDateFormat clone() {
-        // Although there is that much state to share, we do need to
+        // Although there isn't that much state to share, we do need to
         // orchestrate a bit, mostly since timezones may be changed
         return new StdDateFormat(_timezone, _locale, _lenient, _tzSerializedWithColon);
     }
@@ -273,7 +272,9 @@ public class StdDateFormat
      */
     @Deprecated // since 2.9
     public static DateFormat getISO8601Format(TimeZone tz, Locale loc) {
-        return _cloneFormat(DATE_FORMAT_ISO8601, DATE_FORMAT_STR_ISO8601, tz, loc, null);
+        DateFormat df = new SimpleDateFormat(DATE_FORMAT_STR_ISO8601, loc);
+        df.setTimeZone(DEFAULT_TIMEZONE);
+        return df;
     }
 
     /**
@@ -480,19 +481,20 @@ public class StdDateFormat
             buffer.append(offset < 0 ? '-' : '+');
             pad2(buffer, hours);
             if( _tzSerializedWithColon ) {
-            		buffer.append(':');
+                buffer.append(':');
             }
             pad2(buffer, minutes);
         } else {
             // 24-Jun-2017, tatu: While `Z` would be conveniently short, older specs
             //   mandate use of full `+0000`
+            // 06-Mar-2020, tatu: Actually statement should read "for compatibility reasons"
+            //   and not standards (unless it is wrt RFC-1123). This will change in 3.0 at latest
 //            formatted.append('Z');
-	        	if( _tzSerializedWithColon ) {
-	            buffer.append("+00:00");
-	        	}
-	        	else {
-	        		buffer.append("+0000");
-	        	}
+            if( _tzSerializedWithColon ) {
+                buffer.append("+00:00");
+            } else {
+                buffer.append("+0000");
+            }
         }
     }
 
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/BaseMapTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/BaseMapTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/BaseMapTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/BaseMapTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -234,7 +234,7 @@ public abstract class BaseMapTest
 
     // @since 2.10
     protected static ObjectMapper newJsonMapper() {
-        return new ObjectMapper();
+        return new JsonMapper();
     }
 
     // @since 2.10
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/BaseTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/BaseTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/BaseTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/BaseTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -147,7 +147,7 @@ public abstract class BaseTest
         if (!jp.hasCurrentToken()) {
             jp.nextToken();
         }
-        assertToken(JsonToken.START_OBJECT, jp.getCurrentToken()); // main object
+        assertToken(JsonToken.START_OBJECT, jp.currentToken()); // main object
 
         assertToken(JsonToken.FIELD_NAME, jp.nextToken()); // 'Image'
         if (verifyContents) {
@@ -253,18 +253,18 @@ public abstract class BaseTest
         }
     }
     
-    protected void verifyFieldName(JsonParser jp, String expName)
+    protected void verifyFieldName(JsonParser p, String expName)
         throws IOException
     {
-        assertEquals(expName, jp.getText());
-        assertEquals(expName, jp.getCurrentName());
+        assertEquals(expName, p.getText());
+        assertEquals(expName, p.currentName());
     }
 
-    protected void verifyIntValue(JsonParser jp, long expValue)
+    protected void verifyIntValue(JsonParser p, long expValue)
         throws IOException
     {
         // First, via textual
-        assertEquals(String.valueOf(expValue), jp.getText());
+        assertEquals(String.valueOf(expValue), p.getText());
     }
 
     /*
@@ -325,7 +325,7 @@ public abstract class BaseTest
 
     protected void assertToken(JsonToken expToken, JsonParser jp)
     {
-        assertToken(expToken, jp.getCurrentToken());
+        assertToken(expToken, jp.currentToken());
     }
 
     protected void assertType(Object ob, Class<?> expType)
@@ -374,7 +374,7 @@ public abstract class BaseTest
         String str = jp.getText();
 
         if (str.length() !=  actLen) {
-            fail("Internal problem (jp.token == "+jp.getCurrentToken()+"): jp.getText().length() ['"+str+"'] == "+str.length()+"; jp.getTextLength() == "+actLen);
+            fail("Internal problem (jp.token == "+jp.currentToken()+"): jp.getText().length() ['"+str+"'] == "+str.length()+"; jp.getTextLength() == "+actLen);
         }
         assertEquals("String access via getText(), getTextXxx() must be the same", str, str2);
 
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/convert/TestUpdateViaObjectReader.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/convert/TestUpdateViaObjectReader.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/convert/TestUpdateViaObjectReader.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/convert/TestUpdateViaObjectReader.java	2020-06-25 02:44:21.000000000 +0000
@@ -65,10 +65,10 @@ public class TestUpdateViaObjectReader e
 
         @Override
         public DataA deserialize(JsonParser p, DeserializationContext ctxt) throws IOException {
-            if (p.getCurrentToken() != JsonToken.START_OBJECT) {
+            if (p.currentToken() != JsonToken.START_OBJECT) {
                 ctxt.reportInputMismatch(DataA.class,
                         "Wrong current token, expected START_OBJECT, got: "
-                        +p.getCurrentToken());
+                        +p.currentToken());
                 // never gets here
             }
             /*JsonNode node =*/ p.readValueAsTree();
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/AnySetter349Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/AnySetter349Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/AnySetter349Test.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/AnySetter349Test.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,66 +0,0 @@
-package com.fasterxml.jackson.databind.deser;
-
-import java.util.*;
-
-import com.fasterxml.jackson.annotation.*;
-
-import com.fasterxml.jackson.databind.*;
-
-// test(s) for [databind#349]
-public class AnySetter349Test extends BaseMapTest
-{
-    static class Bean349
-    {
-        public String type;
-        public int x, y;
-    
-        private Map<String, Object> props = new HashMap<>();
-    
-        @JsonAnySetter
-        public void addProperty(String key, Object value) {
-            props.put(key, value);
-        }
-    
-        @JsonAnyGetter
-        public Map<String, Object> getProperties() {
-            return props;
-        }
-    
-        @JsonUnwrapped
-        public IdentityDTO349 identity;
-    }
-
-    static class IdentityDTO349 {
-        public int x, y;
-    }
-
-    final static String UNWRAPPED_JSON_349 = aposToQuotes(
-"{ 'type' : 'IST',\n"
-+" 'x' : 3,\n"
-//+" 'name' : 'BLAH-New',\n"
-//+" 'description' : 'namespace.name: X THIN FIR.DR-WD12-New',\n"
-+" 'ZoomLinks': [ 'foofoofoofoo', 'barbarbarbar' ],\n"
-+" 'y' : 4, 'z' : 8 }"
-            );
-    
-    public void testUnwrappedWithAny() throws Exception
-    {
-        final ObjectMapper mapper = objectMapper();
-        Bean349 value = mapper.readValue(UNWRAPPED_JSON_349,  Bean349.class);
-        assertNotNull(value);
-        assertEquals(3, value.x);
-        assertEquals(4, value.y);
-        assertEquals(2, value.props.size());
-    }
-
-    public void testUnwrappedWithAnyAsUpdate() throws Exception
-    {
-        final ObjectMapper mapper = objectMapper();
-        Bean349 bean = mapper.readerFor(Bean349.class)
-                .withValueToUpdate(new Bean349())
-                .readValue(UNWRAPPED_JSON_349);
-        assertEquals(3, bean.x);
-        assertEquals(4, bean.y);
-        assertEquals(2, bean.props.size());
-    }
-}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/AnySetterTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/AnySetterTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/AnySetterTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/AnySetterTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -215,7 +215,33 @@ public class AnySetterTest
         }
     }
 
-	/*
+    // [databind#349]
+    static class Bean349
+    {
+        public String type;
+        public int x, y;
+    
+        private Map<String, Object> props = new HashMap<>();
+    
+        @JsonAnySetter
+        public void addProperty(String key, Object value) {
+            props.put(key, value);
+        }
+    
+        @JsonAnyGetter
+        public Map<String, Object> getProperties() {
+            return props;
+        }
+    
+        @JsonUnwrapped
+        public IdentityDTO349 identity;
+    }
+
+    static class IdentityDTO349 {
+        public int x, y;
+    }
+    
+    /*
     /**********************************************************
     /* Test methods
     /**********************************************************
@@ -332,6 +358,38 @@ public class AnySetterTest
 		assertNull(result.other);
     }
 
+    final static String UNWRAPPED_JSON_349 = aposToQuotes(
+            "{ 'type' : 'IST',\n"
+                    +" 'x' : 3,\n"
+                    //+" 'name' : 'BLAH-New',\n"
+                    //+" 'description' : 'namespace.name: X THIN FIR.DR-WD12-New',\n"
+                    +" 'ZoomLinks': [ 'foofoofoofoo', 'barbarbarbar' ],\n"
+                    +" 'y' : 4, 'z' : 8 }"
+            );
+
+    // [databind#349]
+    public void testUnwrappedWithAny() throws Exception
+    {
+        final ObjectMapper mapper = objectMapper();
+        Bean349 value = mapper.readValue(UNWRAPPED_JSON_349,  Bean349.class);
+        assertNotNull(value);
+        assertEquals(3, value.x);
+        assertEquals(4, value.y);
+        assertEquals(2, value.props.size());
+    }
+
+    // [databind#349]
+    public void testUnwrappedWithAnyAsUpdate() throws Exception
+    {
+        final ObjectMapper mapper = objectMapper();
+        Bean349 bean = mapper.readerFor(Bean349.class)
+                .withValueToUpdate(new Bean349())
+                .readValue(UNWRAPPED_JSON_349);
+        assertEquals(3, bean.x);
+        assertEquals(4, bean.y);
+        assertEquals(2, bean.props.size());
+    }
+
     // [databind#1035]
     public void testGenericAnySetter() throws Exception
     {
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderAdvancedTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderAdvancedTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderAdvancedTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderAdvancedTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -1,7 +1,8 @@
 package com.fasterxml.jackson.databind.deser.builder;
 
 import com.fasterxml.jackson.annotation.*;
-
+import com.fasterxml.jackson.annotation.JsonTypeInfo.As;
+import com.fasterxml.jackson.annotation.JsonTypeInfo.Id;
 import com.fasterxml.jackson.databind.*;
 import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
 
@@ -42,12 +43,51 @@ public class BuilderAdvancedTest extends
         }
     }
 
+    @JsonDeserialize(builder=ExternalBuilder.class)
+    static class ExternalBean
+    {
+        @JsonTypeInfo(use=Id.NAME, include=As.EXTERNAL_PROPERTY, property="extType")
+        public Object value;
+
+        public ExternalBean(Object v) {
+            value = v;
+        }
+    }
+
+    @JsonSubTypes({ @JsonSubTypes.Type(ValueBean.class) })
+    static class BaseBean {
+    }
+    
+    @JsonTypeName("vbean")
+    static class ValueBean extends BaseBean
+    {
+        public int value;
+
+        public ValueBean() { }
+        public ValueBean(int v) { value = v; }
+    }
+
+    static class ExternalBuilder
+    {
+        BaseBean value;
+
+        @JsonTypeInfo(use=Id.NAME, include=As.EXTERNAL_PROPERTY, property="extType")
+        public ExternalBuilder withValue(BaseBean b) {
+            value = b;
+            return this;
+        }
+
+        public ExternalBean build() {
+              return new ExternalBean(value);
+        }
+    }
+
     /*
     /**********************************************************
     /* Unit tests
     /**********************************************************
      */
-    
+
     public void testWithInjectable() throws Exception
     {
         ObjectMapper mapper = new ObjectMapper();
@@ -60,4 +100,15 @@ public class BuilderAdvancedTest extends
         assertEquals(4, bean._y);
         assertEquals("stuffValue", bean._stuff);
     }
+
+    public void testWithExternalTypeId() throws Exception
+    {
+        ObjectMapper mapper = newJsonMapper();
+        final ExternalBean input = new ExternalBean(new ValueBean(13));
+        String json = mapper.writeValueAsString(input);
+        ExternalBean result = mapper.readValue(json, ExternalBean.class);
+        assertNotNull(result.value);
+        assertEquals(ValueBean.class, result.value.getClass());
+        assertEquals(13, ((ValueBean) result.value).value);
+    }
 }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderDeserializationTest2486.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderDeserializationTest2486.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderDeserializationTest2486.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderDeserializationTest2486.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,160 @@
+package com.fasterxml.jackson.databind.deser.builder;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.databind.BaseMapTest;
+import com.fasterxml.jackson.databind.ObjectMapper;
+import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
+
+import java.util.List;
+
+public class BuilderDeserializationTest2486
+        extends BaseMapTest
+{
+    @JsonDeserialize(builder = MyPOJOWithArrayCreator.Builder.class)
+    public static class MyPOJOWithArrayCreator {
+        private final int index;
+
+        private MyPOJOWithArrayCreator(int i) {
+            index = i;
+        }
+
+        public int getIndex() {
+            return index;
+        }
+
+        public static class Builder {
+            private int index;
+
+            public Builder() {
+                // Default constructor
+            }
+
+            @JsonCreator(mode = JsonCreator.Mode.DELEGATING)
+            public Builder(final List<Object> jsonArray) {
+                withIndex((int) jsonArray.get(0));
+            }
+
+            // When deserialized via builder
+            public Builder withIndex(int i) {
+                index = i;
+                return this;
+            }
+
+            // When deserialized into a builder
+            public Builder setIndex(int i) {
+                index = i;
+                return this;
+            }
+
+            public MyPOJOWithArrayCreator build() {
+                return new MyPOJOWithArrayCreator(index);
+            }
+        }
+    }
+
+    @JsonDeserialize(builder = MyPOJOWithPrimitiveCreator.Builder.class)
+    public static class MyPOJOWithPrimitiveCreator {
+        private final int index;
+
+        private MyPOJOWithPrimitiveCreator(int i) {
+            index = i;
+        }
+
+        public int getIndex() {
+            return index;
+        }
+
+        public static class Builder {
+            private int index;
+
+            public Builder() {
+                // Default constructor
+            }
+
+            @JsonCreator(mode = JsonCreator.Mode.DELEGATING)
+            public Builder(final int i) {
+                withIndex(i);
+            }
+
+            // When deserialized via builder
+            public Builder withIndex(int i) {
+                index = i;
+                return this;
+            }
+
+            // When deserialized into a builder
+            public Builder setIndex(int i) {
+                index = i;
+                return this;
+            }
+
+            public MyPOJOWithPrimitiveCreator build() {
+                return new MyPOJOWithPrimitiveCreator(index);
+            }
+        }
+    }
+
+    private final ObjectMapper MAPPER = newJsonMapper();
+    
+    // This test passes when the array based @JsonCreator is removed from the
+    // MyPOJOWithArrayCreator.Builder implementation. The presence of the creator
+    // in the case of arrays breaks deserialize from an object.
+    //
+    // Compare that to the analogous tests for MyPOJOWithPrimitiveCreator which
+    // pass in both cases.
+    //
+    // I left some notes in BeanDeserializerBase as to behavior.
+    public void testPOJOWithArrayCreatorFromObjectRepresentation() throws Exception {
+        final String json = aposToQuotes("{ 'index': 123 }");
+        final MyPOJOWithArrayCreator deserialized = MAPPER.readValue(json, MyPOJOWithArrayCreator.class);
+        assertEquals(123, deserialized.getIndex());
+    }
+
+    public void testPOJOWithArrayCreatorFromArrayRepresentation() throws Exception {
+        final String json = "[123]";
+        final MyPOJOWithArrayCreator deserialized = MAPPER.readValue(json, MyPOJOWithArrayCreator.class);
+        assertEquals(123, deserialized.getIndex());
+    }
+
+    public void testPOJOWithPrimitiveCreatorFromObjectRepresentation() throws Exception {
+        final String json = aposToQuotes("{ 'index': 123 }");
+        final MyPOJOWithPrimitiveCreator deserialized = MAPPER.readValue(json, MyPOJOWithPrimitiveCreator.class);
+        assertEquals(123, deserialized.getIndex());
+    }
+
+    public void testPOJOWithPrimitiveCreatorFromPrimitiveRepresentation() throws Exception {
+        final String json ="123";
+        final MyPOJOWithPrimitiveCreator deserialized = MAPPER.readValue(json, MyPOJOWithPrimitiveCreator.class);
+        assertEquals(123, deserialized.getIndex());
+    }
+
+    // Now let's try it without the builder by deserializing directly into an
+    // instance of the POJO Builder class instead of via it into the POJO.
+
+    // This fails the same as above. So the failure of default deserialization
+    // from an object shape in the presence of a @JsonCreator accepting an array
+    // is not specific to the use of Builders as an intermediary.
+    public void testPOJOBuilderWithArrayCreatorFromObjectRepresentation() throws Exception {
+        final String json = aposToQuotes("{ 'index': 123 }");
+        final MyPOJOWithArrayCreator.Builder deserialized = MAPPER.readValue(json, MyPOJOWithArrayCreator.Builder.class);
+        assertEquals(123, deserialized.index);
+    }
+
+    public void testPOJOBuilderWithArrayCreatorFromArrayRepresentation() throws Exception {
+        final String json = "[123]";
+        final MyPOJOWithArrayCreator.Builder deserialized = MAPPER.readValue(json, MyPOJOWithArrayCreator.Builder.class);
+        assertEquals(123, deserialized.index);
+    }
+
+    public void testPOJOBuilderWithPrimitiveCreatorFromObjectRepresentation() throws Exception {
+        final String json = aposToQuotes("{ 'index': 123 }");
+        final MyPOJOWithPrimitiveCreator.Builder deserialized = MAPPER.readValue(json, MyPOJOWithPrimitiveCreator.Builder.class);
+        assertEquals(123, deserialized.index);
+    }
+
+    public void testPOJOBuilderWithPrimitiveCreatorFromPrimitiveRepresentation() throws Exception {
+        final String json = "123";
+        final MyPOJOWithPrimitiveCreator.Builder deserialized = MAPPER.readValue(json, MyPOJOWithPrimitiveCreator.Builder.class);
+        assertEquals(123, deserialized.index);
+    }
+}
\ No newline at end of file
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderFailTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderFailTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderFailTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderFailTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -68,7 +68,7 @@ public class BuilderFailTest extends Bas
         final String json = "{\"x\":1}";
         try {
             MAPPER.readValue(json, ValueClassWrongBuildType.class);
-            fail("Missing expected JsonProcessingException exception");
+            fail("Missing expected InvalidDefinitionException exception");
         } catch (InvalidDefinitionException e) {
             verifyException(e, "Build method");
             verifyException(e, "has wrong return type");
@@ -80,7 +80,7 @@ public class BuilderFailTest extends Bas
         final String json = aposToQuotes("{'x':1,'y':2,'z':3}");
         try {
             MAPPER.readValue(json, ValueClassXY.class);
-            fail("should not pass");
+            fail("Missing expected UnrecognizedPropertyException exception");
         } catch (UnrecognizedPropertyException e) {
             verifyException(e, "Unrecognized field \"z\"");
         }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderSimpleTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderSimpleTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderSimpleTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderSimpleTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -128,7 +128,6 @@ public class BuilderSimpleTest extends B
         }
     }
 
-
     // for [databind#761]
 
     @JsonDeserialize(builder=ValueInterfaceBuilder.class)
@@ -269,13 +268,40 @@ public class BuilderSimpleTest extends B
         }
     }
 
+    // (related to) [databind#2354]: should be ok to have private inner class:
+
+    @JsonDeserialize(builder=Value2354.Value2354Builder.class)
+    static class Value2354
+    {
+        private final int value;
+
+        protected Value2354(int v) { value = v; }
+
+        public int value() { return value; }
+        
+        @SuppressWarnings("unused")
+        private static class Value2354Builder {
+            private int value;
+            
+            public Value2354Builder withValue(int v) {
+                value = v;
+                return this;
+            }
+
+            // should be ok for this to be private, too, since name is (pre)configured
+            private Value2354 build() {
+                return new Value2354(value);
+            }
+        }
+    }
+
     /*
     /**********************************************************
-    /* Unit tests
+    /* Test methods
     /**********************************************************
      */
 
-    private final ObjectMapper MAPPER = new ObjectMapper();
+    private final ObjectMapper MAPPER = newJsonMapper();
 
     public void testSimple() throws Exception
     {
@@ -396,4 +422,12 @@ public class BuilderSimpleTest extends B
         ValueFoo value = MAPPER.readValue(json, ValueFoo.class);
         assertEquals(1, value.value);
     }
+
+    // related to [databind#2354] (ensure private inner builder classes are ok)
+    public void testPrivateInnerBuilder() throws Exception
+    {
+        String json = aposToQuotes("{'value':13}");
+        Value2354 result = MAPPER.readValue(json, Value2354.class);
+        assertEquals(13, result.value());
+    }
 }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderWithUnwrappedSingleArray2608Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderWithUnwrappedSingleArray2608Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderWithUnwrappedSingleArray2608Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderWithUnwrappedSingleArray2608Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,78 @@
+package com.fasterxml.jackson.databind.deser.builder;
+
+import com.fasterxml.jackson.databind.*;
+import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
+import com.fasterxml.jackson.databind.annotation.JsonPOJOBuilder;
+import com.fasterxml.jackson.databind.json.JsonMapper;
+
+public class BuilderWithUnwrappedSingleArray2608Test extends BaseMapTest
+{
+    // [databind#2608]
+    @JsonDeserialize(builder = ExamplePOJO2608.ExamplePOJOBuilder.class)
+    static class ExamplePOJO2608 {
+      public int id;
+      public POJOValue2608 value;
+
+      public ExamplePOJO2608(int id, POJOValue2608 value) {
+          this.id = id;
+          this.value = value;
+      }
+
+      @JsonPOJOBuilder(withPrefix = "")
+      static class ExamplePOJOBuilder {
+          int id;
+          POJOValue2608 value;
+
+          public ExamplePOJOBuilder id(int i) {
+              this.id = i;
+              return this;
+          }
+
+          public ExamplePOJOBuilder value(POJOValue2608 v) {
+              this.value = v;
+              return this;
+          }
+
+          public ExamplePOJO2608 build() {
+              return new ExamplePOJO2608(id, value);
+          }
+      }
+    }
+
+    // [databind#2608]
+    @JsonDeserialize(builder = POJOValue2608.POJOValueBuilder.class)
+    static class POJOValue2608 {
+        public String subValue;
+
+        public POJOValue2608(String s) {
+            subValue = s;
+        }
+        
+      @JsonPOJOBuilder(withPrefix = "")
+      public static class POJOValueBuilder {
+          String v;
+
+          public POJOValueBuilder subValue(String s) {
+              v = s;
+              return this;
+          }
+
+          public POJOValue2608 build() {
+              return new POJOValue2608(v);
+          }
+      }
+    }
+
+    // [databind#2608]
+    public void testDeserializationAndFail() throws Exception {
+        final ObjectMapper mapper = JsonMapper.builder()
+                .enable(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS)
+                .build();
+
+// Regular POJO would work:
+//        final String serialized = "{\"value\": {\"subValue\": \"123\"}}";
+        final String serialized = "{\"value\": [ {\"subValue\": \"123\"} ]}";
+        final ExamplePOJO2608 result = mapper.readValue(serialized, ExamplePOJO2608.class);
+        assertNotNull(result);
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderWithUnwrappedTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderWithUnwrappedTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderWithUnwrappedTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/builder/BuilderWithUnwrappedTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -155,6 +155,59 @@ public class BuilderWithUnwrappedTest ex
         }
     }
 
+    @JsonDeserialize(builder = AnimalNoCreator.Builder.class)
+    final static class AnimalNoCreator {
+        private final long id;
+        private final Name name;
+        private final String age;
+
+        private AnimalNoCreator(Builder builder) {
+            id = builder.id;
+            name = builder.name;
+            age = builder.age;
+        }
+
+        long getId() {
+            return id;
+        }
+
+        Name getName() {
+            return name;
+        }
+
+        String getAge() {
+            return age;
+        }
+
+        @JsonPOJOBuilder(withPrefix = "set")
+        final static class Builder {
+            private long id;
+            private Name name;
+            private String age;
+
+            Builder() { }
+
+            @JsonProperty("animal_id") 
+            public void setId(long i) {
+                id = i;
+            }
+            
+            @JsonUnwrapped
+            void setName(Name name) {
+                this.name = name;
+            }
+
+            @JsonProperty("years_old")
+            void setAge(String age) {
+                this.age = age;
+            }
+
+            AnimalNoCreator build() {
+                return new AnimalNoCreator(this);
+            }
+        }
+    }
+
     /*
     /**********************************************************
     /* Unit tests
@@ -238,4 +291,16 @@ public class BuilderWithUnwrappedTest ex
         assertEquals(30, animal.getAge());
         assertEquals(true, animal.isAlive());
     }
+
+    public void testWithUnwrappedNoCreator() throws Exception {
+        final String json = aposToQuotes("{'first_name':'John','last_name':'Doe','years_old':'30','animal_id':1234}");
+
+        final ObjectMapper mapper = new ObjectMapper();
+        AnimalNoCreator animal = mapper.readValue(json, AnimalNoCreator.class);
+        assertEquals(1234, animal.getId());
+        assertNotNull(animal.getName());
+        assertEquals("John", animal.getName().getFirst());
+        assertEquals("Doe", animal.getName().getLast());
+        assertEquals("30", animal.getAge());
+    }
 }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/creators/InnerClassCreatorTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/creators/InnerClassCreatorTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/creators/InnerClassCreatorTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/creators/InnerClassCreatorTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -2,8 +2,9 @@ package com.fasterxml.jackson.databind.d
 
 import com.fasterxml.jackson.annotation.JsonCreator;
 import com.fasterxml.jackson.annotation.JsonProperty;
+
 import com.fasterxml.jackson.databind.*;
-import com.fasterxml.jackson.databind.exc.MismatchedInputException;
+import com.fasterxml.jackson.databind.exc.InvalidDefinitionException;
 
 // For [databind#1501], [databind#1502], [databind#1503]; mostly to
 // test that for non-static inner classes constructors are ignored
@@ -64,7 +65,7 @@ public class InnerClassCreatorTest exten
         try {
             MAPPER.readValue(ser, Something1501.class);
             fail("Should not pass");
-        } catch (MismatchedInputException e) {
+        } catch (InvalidDefinitionException e) {
             verifyException(e, "Cannot construct instance");
             verifyException(e, "InnerSomething1501");
             verifyException(e, "non-static inner classes like this can only by instantiated using default");
@@ -77,7 +78,7 @@ public class InnerClassCreatorTest exten
         try {
             MAPPER.readValue(ser, Something1502.class);
             fail("Should not pass");
-        } catch (MismatchedInputException e) {
+        } catch (InvalidDefinitionException e) {
             verifyException(e, "Cannot construct instance");
             verifyException(e, "InnerSomething1502");
             verifyException(e, "non-static inner classes like this can only by instantiated using default");
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/creators/RequiredCreatorTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/creators/RequiredCreatorTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/creators/RequiredCreatorTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/creators/RequiredCreatorTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -18,8 +18,45 @@ public class RequiredCreatorTest extends
         }
     }
 
-    private final ObjectReader POINT_READER = objectMapper().readerFor(FascistPoint.class);
-    
+    // [databind#2591]
+    static class LoginUserResponse {
+        private String otp;
+
+        private String userType;
+
+        @JsonCreator
+        public LoginUserResponse(@JsonProperty(value = "otp", required = true) String otp,
+                @JsonProperty(value = "userType", required = true) String userType) {
+            this.otp = otp;
+            this.userType = userType;
+        }
+
+        public String getOtp() {
+            return otp;
+        }
+
+        public void setOtp(String otp) {
+            this.otp = otp;
+        }
+
+        public String getUserType() {
+            return userType;
+        }
+
+        public void setUserType(String userType) {
+            this.userType = userType;
+        }
+    }
+
+    /*
+    /**********************************************************************
+    /* Test methods
+    /**********************************************************************
+     */
+
+    private final ObjectMapper MAPPER = newJsonMapper();
+    private final ObjectReader POINT_READER = MAPPER.readerFor(FascistPoint.class);
+
     public void testRequiredAnnotatedParam() throws Exception
     {
         FascistPoint p;
@@ -64,4 +101,16 @@ public class RequiredCreatorTest extends
             verifyException(e, "Missing creator property 'y' (index 1)");
         }
     }
+
+    // [databind#2591]
+    public void testRequiredViaParameter2591() throws Exception
+    {
+        final String input = aposToQuotes("{'status':'OK', 'message':'Sent Successfully!'}");
+        try {
+            /*LoginUserResponse resp =*/ MAPPER.readValue(input, LoginUserResponse.class);
+            fail("Shoud not pass");
+        } catch (JsonMappingException e) {
+            verifyException(e, "Missing required creator property 'otp'");
+        }
+    }
 }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/creators/TestCreatorsDelegating.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/creators/TestCreatorsDelegating.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/creators/TestCreatorsDelegating.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/creators/TestCreatorsDelegating.java	2020-06-25 02:44:21.000000000 +0000
@@ -172,11 +172,11 @@ public class TestCreatorsDelegating exte
         JsonParser jp = ((TokenBuffer) ob).asParser();
         assertToken(JsonToken.START_OBJECT, jp.nextToken());
         assertToken(JsonToken.FIELD_NAME, jp.nextToken());
-        assertEquals("a", jp.getCurrentName());
+        assertEquals("a", jp.currentName());
         assertToken(JsonToken.VALUE_NUMBER_INT, jp.nextToken());
         assertEquals(1, jp.getIntValue());
         assertToken(JsonToken.FIELD_NAME, jp.nextToken());
-        assertEquals("b", jp.getCurrentName());
+        assertEquals("b", jp.currentName());
         assertToken(JsonToken.VALUE_NUMBER_INT, jp.nextToken());
         assertEquals(2, jp.getIntValue());
         assertToken(JsonToken.END_OBJECT, jp.nextToken());
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/creators/TestValueInstantiator.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/creators/TestValueInstantiator.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/creators/TestValueInstantiator.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/creators/TestValueInstantiator.java	2020-06-25 02:44:21.000000000 +0000
@@ -117,7 +117,7 @@ public class TestValueInstantiator exten
         @Override
         public CreatorProperty[] getFromObjectArguments(DeserializationConfig config) {
             return  new CreatorProperty[] {
-                    new CreatorProperty(new PropertyName("type"), config.constructType(Class.class), null,
+                    CreatorProperty.construct(new PropertyName("type"), config.constructType(Class.class), null,
                             null, null, null, 0, null,
                             PropertyMetadata.STD_REQUIRED)
             };
@@ -147,7 +147,7 @@ public class TestValueInstantiator exten
         @Override
         public CreatorProperty[] getFromObjectArguments(DeserializationConfig config) {
             return  new CreatorProperty[] {
-                    new CreatorProperty(new PropertyName("name"), config.constructType(String.class), null,
+                    CreatorProperty.construct(new PropertyName("name"), config.constructType(String.class), null,
                             null, null, null, 0, null,
                             PropertyMetadata.STD_REQUIRED)
             };
@@ -427,12 +427,12 @@ public class TestValueInstantiator exten
                     @Override
                     public CreatorProperty[] getFromObjectArguments(DeserializationConfig config) {
                         return  new CreatorProperty[] {
-                                new CreatorProperty(new PropertyName("secret"), config.constructType(String.class), null,
+                                CreatorProperty.construct(new PropertyName("secret"), config.constructType(String.class), null,
                                         null, null, null, 0, null,
                                         PropertyMetadata.STD_REQUIRED)
                         };
                     }
-        
+
                     @Override
                     public Object createFromObjectWith(DeserializationContext ctxt, Object[] args) {
                         return new CreatorBean((String) args[0]);
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/CyclicTypesDeserTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/CyclicTypesDeserTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/CyclicTypesDeserTest.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/CyclicTypesDeserTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,113 @@
+package com.fasterxml.jackson.databind.deser;
+
+import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
+import com.fasterxml.jackson.databind.*;
+
+/**
+ * Simple unit tests to verify that it is possible to handle
+ * potentially cyclic structures, as long as object graph itself
+ * is not cyclic. This is the case for directed hierarchies like
+ * trees and DAGs.
+ */
+public class CyclicTypesDeserTest
+    extends BaseMapTest
+{
+    static class Bean
+    {
+        Bean _next;
+        String _name;
+
+        public Bean() { }
+
+        public void setNext(Bean b) { _next = b; }
+        public void setName(String n) { _name = n; }
+
+    }
+
+    static class LinkA {
+        public LinkB next;
+    }
+
+    static class LinkB {
+        protected LinkA a;
+
+        public void setA(LinkA a) { this.a = a; }
+        public LinkA getA() { return a; }
+    }
+
+    static class GenericLink<T> {
+        public GenericLink<T> next;
+    }
+
+    static class StringLink extends GenericLink<String> {
+    }
+
+    static class Selfie405 {
+        public int id;
+
+        @JsonIgnoreProperties({ "parent" })
+        public Selfie405 parent;
+        
+        public Selfie405(int id) { this.id = id; }
+    }
+    
+    /*
+    /**********************************************************
+    /* Unit tests
+    /**********************************************************
+     */
+
+    private final ObjectMapper MAPPER = newJsonMapper();
+    
+    public void testLinked() throws Exception
+    {
+        Bean first = MAPPER.readValue
+            ("{\"name\":\"first\", \"next\": { "
+             +" \"name\":\"last\", \"next\" : null }}",
+             Bean.class);
+
+        assertNotNull(first);
+        assertEquals("first", first._name);
+        Bean last = first._next;
+        assertNotNull(last);
+        assertEquals("last", last._name);
+        assertNull(last._next);
+    }
+
+    public void testLinkedGeneric() throws Exception
+    {
+        StringLink link = MAPPER.readValue("{\"next\":null}", StringLink.class);
+        assertNotNull(link);
+        assertNull(link.next);
+    }
+
+    public void testCycleWith2Classes() throws Exception
+    {
+        LinkA a = MAPPER.readValue("{\"next\":{\"a\":null}}", LinkA.class);
+        assertNotNull(a.next);
+        LinkB b = a.next;
+        assertNull(b.a);
+    }
+
+    // [Issue#405]: Should be possible to ignore cyclic ref
+    public void testIgnoredCycle() throws Exception
+    {
+        Selfie405 self1 = new Selfie405(1);
+        self1.parent = self1;
+
+        // First: exception with default settings:
+        assertTrue(MAPPER.isEnabled(SerializationFeature.FAIL_ON_SELF_REFERENCES));
+        try {
+            MAPPER.writeValueAsString(self1);
+            fail("Should fail with direct self-ref");
+        } catch (JsonMappingException e) {
+            verifyException(e, "Direct self-reference");
+        }
+        
+        ObjectWriter w = MAPPER.writer()
+                .without(SerializationFeature.FAIL_ON_SELF_REFERENCES);
+        String json = w.writeValueAsString(self1);
+        assertNotNull(json);
+        assertEquals(aposToQuotes("{'id':1,'parent':{'id':1}}"), json);
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/DeserializerFactoryTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/DeserializerFactoryTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/DeserializerFactoryTest.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/DeserializerFactoryTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,94 @@
+package com.fasterxml.jackson.databind.deser;
+
+import java.util.*;
+
+import com.fasterxml.jackson.databind.*;
+
+// Tests for [databind#2539] for checking whether given (raw) type has explicit
+// deserializer associated
+public class DeserializerFactoryTest extends BaseMapTest
+{
+    private final ObjectMapper MAPPER = sharedMapper();
+
+    static class POJO2539 { }
+
+    // [databind#2539]: check existence of deserializer for type
+    public void testJDKScalarDeserializerExistence() throws Exception
+    {
+        // First verify some basic types
+        _verifyIsFound(String.class);
+        _verifyIsFound(Float.class);
+        _verifyIsFound(java.math.BigDecimal.class);
+        _verifyIsFound(java.net.URL.class);
+        _verifyIsFound(UUID.class);
+
+        _verifyIsFound(Calendar.class);
+        _verifyIsFound(GregorianCalendar.class);
+        _verifyIsFound(Date.class);
+        
+        // "Untyped" as target is actually undefined: we could choose either way.
+        // It is valid target, which would support inclusion... but it is not actual
+        // final target (but convenient marker) and as such never to be included as
+        // type id. But more importantly there is possiblity of misuse to validate
+        // base types: {@link Object} should rarely if ever be allowed as that.
+//        _verifyIsFound(java.util.Object.class);
+    }
+
+    public void testJDKContainerDeserializerExistence() throws Exception
+    {
+        // Both general and specific container types should be considered supported
+        _verifyIsFound(Collection.class);
+        _verifyIsFound(List.class);
+        _verifyIsFound(Map.class);
+        _verifyIsFound(Set.class);
+
+        _verifyIsFound(ArrayList.class);
+        _verifyIsFound(HashMap.class);
+        _verifyIsFound(LinkedHashMap.class);
+        _verifyIsFound(HashSet.class);
+    }
+
+    public void testJDKArraysOfExistence() throws Exception
+    {
+        // Similarly, array types of all supported types should be allowed
+        _verifyIsFound(String[].class);
+        _verifyIsFound(java.math.BigDecimal[].class);
+        _verifyIsFound(java.net.URL[].class);
+        _verifyIsFound(UUID[].class);
+    }
+
+    public void testNoDeserTypes() throws Exception
+    {
+        // Types for which we should NOT have explicit deserializer
+
+
+        // In general, arbitrary POJOs do not...
+        _verifyNotFound(POJO2539.class);
+
+        // but also just in case someone found a way to abuse JDK types,
+        // we would not want to allow that
+        _verifyNotFound(java.lang.Process.class);
+        _verifyNotFound(java.lang.System.class);
+        _verifyNotFound(java.lang.Thread.class);
+    }
+
+    private void _verifyIsFound(Class<?> rawType) {
+        if (!_verifyDeserExistence(rawType)) {
+            fail("Should have explicit deserializer for "+rawType.getName());
+        }
+    }
+
+    private void _verifyNotFound(Class<?> rawType) {
+        if (_verifyDeserExistence(rawType)) {
+            fail("Should NOT have explicit deserializer for "+rawType.getName());
+        }
+    }
+
+    private boolean _verifyDeserExistence(Class<?> rawType) {
+        DeserializationContext ctxt = MAPPER.getDeserializationContext();
+        DeserializerFactory factory = ctxt.getFactory();
+        DeserializationConfig config = MAPPER.getDeserializationConfig();
+
+        return factory.hasExplicitDeserializerFor(config, rawType);
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/filter/IgnorePropertyOnDeserTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/filter/IgnorePropertyOnDeserTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/filter/IgnorePropertyOnDeserTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/filter/IgnorePropertyOnDeserTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -1,7 +1,10 @@
 package com.fasterxml.jackson.databind.deser.filter;
 
+import java.io.IOException;
+
 import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
 import com.fasterxml.jackson.annotation.JsonPropertyOrder;
+
 import com.fasterxml.jackson.databind.BaseMapTest;
 import com.fasterxml.jackson.databind.ObjectMapper;
 
@@ -35,6 +38,22 @@ public class IgnorePropertyOnDeserTest e
         public void setName(String name) { this.name = name; }
     }
 
+    // [databind#2627]
+
+    @JsonIgnoreProperties(ignoreUnknown = true)
+    static class MyPojoValue {
+        @JsonIgnoreProperties(ignoreUnknown = true)
+        MyPojo2627 value;
+
+        public MyPojo2627 getValue() {
+            return value;
+        }
+    }
+
+    static class MyPojo2627 {
+        public String name;
+    }
+
     /*
     /****************************************************************
     /* Unit tests
@@ -88,4 +107,16 @@ public class IgnorePropertyOnDeserTest e
         Simple1595 des = mapper.readValue(aposToQuotes("{'id':123,'name':'jack'}"), Simple1595.class);
         assertEquals("jack", des.getName());
     }
+
+    // [databind#2627]
+    public void testIgnoreUnknownOnField() throws IOException
+    {
+        ObjectMapper objectMapper = new ObjectMapper();
+        String json = "{\"value\": {\"name\": \"my_name\", \"extra\": \"val\"}, \"type\":\"Json\"}";
+        MyPojoValue value = objectMapper.readValue(json, MyPojoValue.class);
+        assertNotNull(value);
+        assertNotNull(value.getValue());
+        assertEquals("my_name", value.getValue().name);
+    }
 }
+
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/filter/ProblemHandler1767Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/filter/ProblemHandler1767Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/filter/ProblemHandler1767Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/filter/ProblemHandler1767Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,45 @@
+package com.fasterxml.jackson.databind.deser.filter;
+
+import com.fasterxml.jackson.databind.*;
+import com.fasterxml.jackson.databind.deser.DeserializationProblemHandler;
+
+public class ProblemHandler1767Test extends BaseMapTest
+{
+    static class IntHandler
+            extends DeserializationProblemHandler
+    {
+        @Override
+        public Object handleWeirdStringValue(DeserializationContext ctxt,
+                Class<?> targetType,
+                String valueToConvert,
+                String failureMsg)
+        {
+            if (targetType != Integer.TYPE) {
+                return NOT_HANDLED;
+            }
+            return 1;
+        }
+    }
+
+    static class TestBean {
+        int a;
+
+        public int getA() {
+            return a;
+        }
+
+        public void setA(int a) {
+            this.a = a;
+        }
+
+    }
+
+    public void testPrimitivePropertyWithHandler() throws Exception {
+        final ObjectMapper mapper = new ObjectMapper();
+        mapper.addHandler(new IntHandler());
+        TestBean result = mapper.readValue(aposToQuotes("{'a': 'not-a-number'}"), TestBean.class);
+        assertNotNull(result);
+        assertEquals(1, result.a);
+    }
+    
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/filter/ProblemHandlerTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/filter/ProblemHandlerTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/filter/ProblemHandlerTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/filter/ProblemHandlerTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -11,6 +11,7 @@ import com.fasterxml.jackson.databind.*;
 import com.fasterxml.jackson.databind.deser.DeserializationProblemHandler;
 import com.fasterxml.jackson.databind.deser.ValueInstantiator;
 import com.fasterxml.jackson.databind.exc.InvalidTypeIdException;
+import com.fasterxml.jackson.databind.exc.MismatchedInputException;
 import com.fasterxml.jackson.databind.exc.ValueInstantiationException;
 import com.fasterxml.jackson.databind.jsontype.TypeIdResolver;
 
@@ -352,5 +353,16 @@ public class ProblemHandlerTest extends
         ;
         Integer v = mapper.readValue("true", Integer.class);
         assertEquals(Integer.valueOf(13), v);
+
+        // Just for code coverage really...
+        mapper = newJsonMapper();
+        mapper.addHandler(new WeirdTokenHandler(Integer.valueOf(13)));
+        mapper.clearProblemHandlers();
+        try {
+            mapper.readValue("true", Integer.class);
+            fail("Should not pass");
+        } catch (MismatchedInputException e) {
+            verifyException(e, "out of VALUE_TRUE token");
+        }
     }
 }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/filter/TestUnknownPropertyDeserialization.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/filter/TestUnknownPropertyDeserialization.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/filter/TestUnknownPropertyDeserialization.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/filter/TestUnknownPropertyDeserialization.java	2020-06-25 02:44:21.000000000 +0000
@@ -52,7 +52,7 @@ public class TestUnknownPropertyDeserial
             throws IOException, JsonProcessingException
         {
             // very simple, just to verify that we do see correct token type
-            ((TestBean) bean).markUnknown(propertyName+":"+jp.getCurrentToken().toString());
+            ((TestBean) bean).markUnknown(propertyName+":"+jp.currentToken().toString());
             // Yup, we are good to go; must skip whatever value we'd have:
             jp.skipChildren();
             return true;
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/inject/InjectableWithoutDeser962Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/inject/InjectableWithoutDeser962Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/inject/InjectableWithoutDeser962Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/inject/InjectableWithoutDeser962Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,59 @@
+package com.fasterxml.jackson.databind.deser.inject;
+
+import com.fasterxml.jackson.annotation.JacksonInject;
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+import com.fasterxml.jackson.annotation.OptBoolean;
+import com.fasterxml.jackson.databind.*;
+
+// [databind#962]: "pure" Injectable that could not be deserialized
+public class InjectableWithoutDeser962Test extends BaseMapTest
+{
+    // [databind#962]
+    static class InjectMe
+    {
+        private String a;
+
+        public InjectMe(boolean dummy) { }
+
+        public void setA(Integer a) {
+            this.a = a.toString();
+        }
+
+        public void setA(InjectMe a) {
+            this.a = String.valueOf(a);
+        }
+        
+        public String getA() {
+            return a;
+        }
+    }
+
+    static class Injectee
+    {
+        private String b;
+
+        // Important! Prevent binding from data
+        @JsonCreator
+        public Injectee(@JacksonInject(useInput=OptBoolean.FALSE) InjectMe injectMe,
+                @JsonProperty("b") String b) {
+            this.b = b;
+        }
+
+        public String getB() {
+            return b;
+        }
+    }
+
+    // [databind#962]
+    public void testInjected() throws Exception
+    {
+        InjectMe im = new InjectMe(true);
+        ObjectMapper mapper = new ObjectMapper()
+            .setInjectableValues(new InjectableValues.Std().addValue(InjectMe.class, im));
+        String test = "{\"b\":\"bbb\"}";
+
+        Injectee actual = mapper.readValue(test, Injectee.class);
+        assertEquals("bbb", actual.getB());
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/CustomMapKeys2454Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/CustomMapKeys2454Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/CustomMapKeys2454Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/CustomMapKeys2454Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,56 @@
+package com.fasterxml.jackson.databind.deser.jdk;
+
+import java.io.IOException;
+import java.util.Collections;
+import java.util.Map;
+
+import com.fasterxml.jackson.core.JsonGenerator;
+import com.fasterxml.jackson.core.type.TypeReference;
+import com.fasterxml.jackson.databind.*;
+import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
+import com.fasterxml.jackson.databind.annotation.JsonSerialize;
+
+public class CustomMapKeys2454Test extends BaseMapTest
+{
+    @JsonDeserialize(keyUsing = Key2454Deserializer.class)
+    @JsonSerialize(keyUsing = Key2454Serializer.class)
+    static class Key2454 {
+        String id;
+
+        public Key2454(String id, boolean bogus) {
+            this.id = id;
+        }
+    }
+
+    static class Key2454Deserializer extends KeyDeserializer {
+        @Override
+        public Object deserializeKey(String key, DeserializationContext ctxt) {
+            return new Key2454(key, false);
+        }
+    }
+
+    static class Key2454Serializer extends JsonSerializer<Key2454> {
+        @Override
+        public void serialize(Key2454 value, JsonGenerator gen,
+                SerializerProvider serializers) throws IOException {
+            gen.writeFieldName("id="+value.id);
+        }
+    }
+
+    private final ObjectMapper MAPPER = newJsonMapper();
+
+    public void testCustomSerializer() throws Exception
+    {
+        assertEquals(aposToQuotes("{'id=a':'b'}"),
+                MAPPER.writeValueAsString(Collections.singletonMap(new Key2454("a", true), "b")));
+    }
+
+    public void testCustomDeserializer() throws Exception
+    {
+        Map<Key2454, String> result = MAPPER.readValue(aposToQuotes("{'a':'b'}"),
+                new TypeReference<Map<Key2454, String>>() { });
+        assertEquals(1, result.size());
+        Key2454 key = result.keySet().iterator().next();
+        assertEquals("a", key.id);
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/DateDeserializationTZ1153Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/DateDeserializationTZ1153Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/DateDeserializationTZ1153Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/DateDeserializationTZ1153Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,34 @@
+package com.fasterxml.jackson.databind.deser.jdk;
+
+import java.util.Date;
+import java.util.TimeZone;
+
+import com.fasterxml.jackson.databind.*;
+
+public class DateDeserializationTZ1153Test extends BaseMapTest
+{
+    private final ObjectMapper MAPPER = newJsonMapper();
+
+    // [databind#1153]
+    public void testWithTimezones1153() throws Exception
+    {
+        for (String tzStr : new String[] {
+                "UTC", "CET", "America/Los_Angeles", "Australia/Melbourne"
+        }) {
+            _testWithTimeZone(TimeZone.getTimeZone(tzStr));
+        }
+    }
+    
+    void _testWithTimeZone(TimeZone tz) throws Exception
+    {
+        ObjectReader r = MAPPER.readerFor(Date.class)
+                .with(tz);
+
+        String time = "2016-01-01T17:00:00.000Z";
+        long correctTime = 1451667600000l;
+        Date dateAccordingToJackson = r.readValue(quote(time));
+
+        assertEquals("ISO8601 decoding mismatch " + tz,
+                correctTime, dateAccordingToJackson.getTime());
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/EnumAliasDeser2352Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/EnumAliasDeser2352Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/EnumAliasDeser2352Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/EnumAliasDeser2352Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,91 @@
+package com.fasterxml.jackson.databind.deser.jdk;
+
+import com.fasterxml.jackson.annotation.JsonAlias;
+import com.fasterxml.jackson.annotation.JsonEnumDefaultValue;
+
+import com.fasterxml.jackson.databind.*;
+
+public class EnumAliasDeser2352Test extends BaseMapTest
+{
+    // for [databind#2352]: Support aliases on enum values
+    enum MyEnum2352_1 {
+        A,
+        @JsonAlias({"singleAlias"})
+        B,
+        @JsonAlias({"multipleAliases1", "multipleAliases2"})
+        C
+    }
+    // for [databind#2352]: Support aliases on enum values
+    enum MyEnum2352_2 {
+        A,
+        @JsonAlias({"singleAlias"})
+        B,
+        @JsonAlias({"multipleAliases1", "multipleAliases2"})
+        C;
+
+        @Override
+        public String toString() {
+            return name().toLowerCase();
+        }
+    }
+    // for [databind#2352]: Support aliases on enum values
+    enum MyEnum2352_3 {
+        A,
+        @JsonEnumDefaultValue
+        @JsonAlias({"singleAlias"})
+        B,
+        @JsonAlias({"multipleAliases1", "multipleAliases2"})
+        C
+    }
+
+    /*
+    /**********************************************************************
+    /* Test methods
+    /**********************************************************************
+     */
+
+    protected final ObjectMapper MAPPER = newJsonMapper();
+
+    // for [databind#2352]
+    public void testEnumWithAlias() throws Exception {
+        ObjectReader reader = MAPPER.readerFor(MyEnum2352_1.class);
+        MyEnum2352_1 nonAliased = reader.readValue(quote("A"));
+        assertEquals(MyEnum2352_1.A, nonAliased);
+        MyEnum2352_1 singleAlias = reader.readValue(quote("singleAlias"));
+        assertEquals(MyEnum2352_1.B, singleAlias);
+        MyEnum2352_1 multipleAliases1 = reader.readValue(quote("multipleAliases1"));
+        assertEquals(MyEnum2352_1.C, multipleAliases1);
+        MyEnum2352_1 multipleAliases2 = reader.readValue(quote("multipleAliases2"));
+        assertEquals(MyEnum2352_1.C, multipleAliases2);
+    }
+
+    // for [databind#2352]
+    public void testEnumWithAliasAndToStringSupported() throws Exception {
+        ObjectReader reader = MAPPER.readerFor(MyEnum2352_2.class)
+                .with(DeserializationFeature.READ_ENUMS_USING_TO_STRING);
+        MyEnum2352_2 nonAliased = reader.readValue(quote("a"));
+        assertEquals(MyEnum2352_2.A, nonAliased);
+        MyEnum2352_2 singleAlias = reader.readValue(quote("singleAlias"));
+        assertEquals(MyEnum2352_2.B, singleAlias);
+        MyEnum2352_2 multipleAliases1 = reader.readValue(quote("multipleAliases1"));
+        assertEquals(MyEnum2352_2.C, multipleAliases1);
+        MyEnum2352_2 multipleAliases2 = reader.readValue(quote("multipleAliases2"));
+        assertEquals(MyEnum2352_2.C, multipleAliases2);
+    }
+
+    // for [databind#2352]
+    public void testEnumWithAliasAndDefaultForUnknownValueEnabled() throws Exception {
+        ObjectReader reader = MAPPER.readerFor(MyEnum2352_3.class)
+                .with(DeserializationFeature.READ_UNKNOWN_ENUM_VALUES_USING_DEFAULT_VALUE);
+        MyEnum2352_3 nonAliased = reader.readValue(quote("A"));
+        assertEquals(MyEnum2352_3.A, nonAliased);
+        MyEnum2352_3 singleAlias = reader.readValue(quote("singleAlias"));
+        assertEquals(MyEnum2352_3.B, singleAlias);
+        MyEnum2352_3 defaulted = reader.readValue(quote("unknownValue"));
+        assertEquals(MyEnum2352_3.B, defaulted);
+        MyEnum2352_3 multipleAliases1 = reader.readValue(quote("multipleAliases1"));
+        assertEquals(MyEnum2352_3.C, multipleAliases1);
+        MyEnum2352_3 multipleAliases2 = reader.readValue(quote("multipleAliases2"));
+        assertEquals(MyEnum2352_3.C, multipleAliases2);
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/EnumAltIdTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/EnumAltIdTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/EnumAltIdTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/EnumAltIdTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -3,6 +3,8 @@ package com.fasterxml.jackson.databind.d
 import java.io.IOException;
 import java.util.EnumSet;
 
+import com.fasterxml.jackson.annotation.JsonAlias;
+import com.fasterxml.jackson.annotation.JsonEnumDefaultValue;
 import com.fasterxml.jackson.annotation.JsonFormat;
 import com.fasterxml.jackson.core.type.TypeReference;
 import com.fasterxml.jackson.databind.BaseMapTest;
@@ -33,7 +35,39 @@ public class EnumAltIdTest extends BaseM
         @JsonFormat(without={ JsonFormat.Feature.ACCEPT_CASE_INSENSITIVE_PROPERTIES })
         public TestEnum value;
     }
-    
+
+
+    // for [databind#2352]: Support aliases on enum values
+    enum MyEnum2352_1 {
+        A,
+        @JsonAlias({"singleAlias"})
+        B,
+        @JsonAlias({"multipleAliases1", "multipleAliases2"})
+        C
+    }
+    // for [databind#2352]: Support aliases on enum values
+    enum MyEnum2352_2 {
+        A,
+        @JsonAlias({"singleAlias"})
+        B,
+        @JsonAlias({"multipleAliases1", "multipleAliases2"})
+        C;
+
+        @Override
+        public String toString() {
+            return name().toLowerCase();
+        }
+    }
+    // for [databind#2352]: Support aliases on enum values
+    enum MyEnum2352_3 {
+        A,
+        @JsonEnumDefaultValue
+        @JsonAlias({"singleAlias"})
+        B,
+        @JsonAlias({"multipleAliases1", "multipleAliases2"})
+        C;
+    }
+
     /*
     /**********************************************************
     /* Test methods, basic
@@ -59,7 +93,7 @@ public class EnumAltIdTest extends BaseM
             verifyException(e, "[JACKSON, OK, RULES]");
         }
     }
-    
+
     public void testFailWhenCaseSensitiveAndToStringIsUpperCase() throws IOException {
         ObjectReader r = READER_DEFAULT.forType(LowerCaseEnum.class)
                 .with(DeserializationFeature.READ_ENUMS_USING_TO_STRING);
@@ -130,4 +164,53 @@ public class EnumAltIdTest extends BaseM
             verifyException(e, "[JACKSON, OK, RULES]");
         }
     }
+
+    /*
+    /**********************************************************
+    /* Test methods, Enum Aliases [databind#2352]
+    /**********************************************************
+     */
+
+    // for [databind#2352]
+    public void testEnumWithAlias() throws Exception {
+        ObjectReader reader = MAPPER.readerFor(MyEnum2352_1.class);
+        MyEnum2352_1 nonAliased = reader.readValue(quote("A"));
+        assertEquals(MyEnum2352_1.A, nonAliased);
+        MyEnum2352_1 singleAlias = reader.readValue(quote("singleAlias"));
+        assertEquals(MyEnum2352_1.B, singleAlias);
+        MyEnum2352_1 multipleAliases1 = reader.readValue(quote("multipleAliases1"));
+        assertEquals(MyEnum2352_1.C, multipleAliases1);
+        MyEnum2352_1 multipleAliases2 = reader.readValue(quote("multipleAliases2"));
+        assertEquals(MyEnum2352_1.C, multipleAliases2);
+    }
+
+    // for [databind#2352]
+    public void testEnumWithAliasAndToStringSupported() throws Exception {
+        ObjectReader reader = MAPPER.readerFor(MyEnum2352_2.class)
+                .with(DeserializationFeature.READ_ENUMS_USING_TO_STRING);
+        MyEnum2352_2 nonAliased = reader.readValue(quote("a"));
+        assertEquals(MyEnum2352_2.A, nonAliased);
+        MyEnum2352_2 singleAlias = reader.readValue(quote("singleAlias"));
+        assertEquals(MyEnum2352_2.B, singleAlias);
+        MyEnum2352_2 multipleAliases1 = reader.readValue(quote("multipleAliases1"));
+        assertEquals(MyEnum2352_2.C, multipleAliases1);
+        MyEnum2352_2 multipleAliases2 = reader.readValue(quote("multipleAliases2"));
+        assertEquals(MyEnum2352_2.C, multipleAliases2);
+    }
+
+    // for [databind#2352]
+    public void testEnumWithAliasAndDefaultForUnknownValueEnabled() throws Exception {
+        ObjectReader reader = MAPPER.readerFor(MyEnum2352_3.class)
+                .with(DeserializationFeature.READ_UNKNOWN_ENUM_VALUES_USING_DEFAULT_VALUE);
+        MyEnum2352_3 nonAliased = reader.readValue(quote("A"));
+        assertEquals(MyEnum2352_3.A, nonAliased);
+        MyEnum2352_3 singleAlias = reader.readValue(quote("singleAlias"));
+        assertEquals(MyEnum2352_3.B, singleAlias);
+        MyEnum2352_3 defaulted = reader.readValue(quote("unknownValue"));
+        assertEquals(MyEnum2352_3.B, defaulted);
+        MyEnum2352_3 multipleAliases1 = reader.readValue(quote("multipleAliases1"));
+        assertEquals(MyEnum2352_3.C, multipleAliases1);
+        MyEnum2352_3 multipleAliases2 = reader.readValue(quote("multipleAliases2"));
+        assertEquals(MyEnum2352_3.C, multipleAliases2);
+    }
 }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/EnumDeserializationTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/EnumDeserializationTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/EnumDeserializationTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/EnumDeserializationTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -228,7 +228,7 @@ public class EnumDeserializationTest
         // First "good" case with Strings
         String JSON = "\"OK\" \"RULES\"  null";
         // multiple main-level mappings, need explicit parser:
-        JsonParser jp = MAPPER.getFactory().createParser(JSON);
+        JsonParser jp = MAPPER.createParser(JSON);
 
         assertEquals(TestEnum.OK, MAPPER.readValue(jp, TestEnum.class));
         assertEquals(TestEnum.RULES, MAPPER.readValue(jp, TestEnum.class));
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/EnumMapDeserializationTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/EnumMapDeserializationTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/EnumMapDeserializationTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/EnumMapDeserializationTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -181,14 +181,6 @@ public class EnumMapDeserializationTest
                         ObjectMapper.DefaultTyping.NON_FINAL, "@type")
                 .build();
 
-        // 05-Mar-2018, tatu: Original issue had this; should not make difference:
-         /*
-        TypeResolverBuilder<?> mapTyperAsPropertyType = new ObjectMapper.DefaultTypeResolverBuilder(ObjectMapper.DefaultTyping.NON_FINAL);
-        mapTyperAsPropertyType.init(JsonTypeInfo.Id.CLASS, null);
-        mapTyperAsPropertyType.inclusion(JsonTypeInfo.As.PROPERTY);
-        mapper.setDefaultTyping(mapTyperAsPropertyType);
-         */
-
         String json = mapper.writeValueAsString(input);
         Pojo1859 result = mapper.readValue(json, Pojo1859.class);
         assertNotNull(result);
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/JDKAtomicTypesDeserTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/JDKAtomicTypesDeserTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/JDKAtomicTypesDeserTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/JDKAtomicTypesDeserTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -97,7 +97,7 @@ public class JDKAtomicTypesDeserTest
     // [databind#2303]
     static class MyBean2303 {
         public AtomicReference<AtomicReference<Integer>> refRef;
-    }    
+    }
 
     /*
     /**********************************************************
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/JDKScalarsTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/JDKScalarsTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/JDKScalarsTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/JDKScalarsTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -48,7 +48,7 @@ public class JDKScalarsTest
         long _v;
         void setV(long v) { _v = v; }
     }
-    
+
     final static class DoubleBean {
         double _v;
         void setV(double v) { _v = v; }
@@ -118,7 +118,7 @@ public class JDKScalarsTest
         public Void value;
     }
 
-    private final ObjectMapper MAPPER = new ObjectMapper();
+    private final ObjectMapper MAPPER = newJsonMapper();
 
     /*
     /**********************************************************
@@ -280,40 +280,6 @@ public class JDKScalarsTest
         assertNotNull(array);
         assertEquals(1, array.length);
         assertEquals(0, array[0]);
-        
-        // [databind#381]
-        final ObjectMapper mapper = new ObjectMapper();
-        mapper.disable(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS);
-        try {
-            mapper.readValue("{\"v\":[3]}", IntBean.class);
-            fail("Did not throw exception when reading a value from a single value array with the UNWRAP_SINGLE_VALUE_ARRAYS feature disabled");
-        } catch (MismatchedInputException exp) {
-            //Correctly threw exception
-        }
-        
-        mapper.enable(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS);
-        
-        result = mapper.readValue("{\"v\":[3]}", IntBean.class);
-        assertEquals(3, result._v);
-        
-        result = mapper.readValue("[{\"v\":[3]}]", IntBean.class);
-        assertEquals(3, result._v);
-        
-        try {
-            mapper.readValue("[{\"v\":[3,3]}]", IntBean.class);
-            fail("Did not throw exception while reading a value from a multi value array with UNWRAP_SINGLE_VALUE_ARRAY feature enabled");
-        } catch (MismatchedInputException exp) {
-            //threw exception as required
-        }
-        
-        result = mapper.readValue("{\"v\":[null]}", IntBean.class);
-        assertNotNull(result);
-        assertEquals(0, result._v);
-
-        array = mapper.readValue("[ [ null ] ]", int[].class);
-        assertNotNull(array);
-        assertEquals(1, array.length);
-        assertEquals(0, array[0]);
     }
 
     public void testLongWrapper() throws Exception
@@ -343,40 +309,6 @@ public class JDKScalarsTest
         assertNotNull(array);
         assertEquals(1, array.length);
         assertEquals(0, array[0]);
-        
-        // [databind#381]
-        final ObjectMapper mapper = new ObjectMapper();
-        mapper.disable(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS);
-        try {
-            mapper.readValue("{\"v\":[3]}", LongBean.class);
-            fail("Did not throw exception when reading a value from a single value array with the UNWRAP_SINGLE_VALUE_ARRAYS feature disabled");
-        } catch (MismatchedInputException exp) {
-            //Correctly threw exception
-        }
-        
-        mapper.enable(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS);
-        
-        result = mapper.readValue("{\"v\":[3]}", LongBean.class);
-        assertEquals(3, result._v);
-        
-        result = mapper.readValue("[{\"v\":[3]}]", LongBean.class);
-        assertEquals(3, result._v);
-        
-        try {
-            mapper.readValue("[{\"v\":[3,3]}]", LongBean.class);
-            fail("Did not throw exception while reading a value from a multi value array with UNWRAP_SINGLE_VALUE_ARRAY feature enabled");
-        } catch (MismatchedInputException exp) {
-            //threw exception as required
-        }
-        
-        result = mapper.readValue("{\"v\":[null]}", LongBean.class);
-        assertNotNull(result);
-        assertEquals(0, result._v);
-
-        array = mapper.readValue("[ [ null ] ]", long[].class);
-        assertNotNull(array);
-        assertEquals(1, array.length);
-        assertEquals(0, array[0]);
     }
 
     /**
@@ -464,44 +396,6 @@ public class JDKScalarsTest
         }
     }
 
-    public void testDoubleAsArray() throws Exception
-    {
-        final ObjectMapper mapper = new ObjectMapper();
-        mapper.disable(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS);
-        final double value = 0.016;
-        try {
-            mapper.readValue("{\"v\":[" + value + "]}", DoubleBean.class);
-            fail("Did not throw exception when reading a value from a single value array with the UNWRAP_SINGLE_VALUE_ARRAYS feature disabled");
-        } catch (JsonMappingException exp) {
-            //Correctly threw exception
-        }
-        
-        mapper.enable(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS);
-        
-        DoubleBean result = mapper.readValue("{\"v\":[" + value + "]}",
-                DoubleBean.class);
-        assertEquals(value, result._v);
-        
-        result = mapper.readValue("[{\"v\":[" + value + "]}]", DoubleBean.class);
-        assertEquals(value, result._v);
-        
-        try {
-            mapper.readValue("[{\"v\":[" + value + "," + value + "]}]", DoubleBean.class);
-            fail("Did not throw exception while reading a value from a multi value array with UNWRAP_SINGLE_VALUE_ARRAY feature enabled");
-        } catch (MismatchedInputException exp) {
-            //threw exception as required
-        }
-        
-        result = mapper.readValue("{\"v\":[null]}", DoubleBean.class);
-        assertNotNull(result);
-        assertEquals(0d, result._v);
-
-        double[] array = mapper.readValue("[ [ null ] ]", double[].class);
-        assertNotNull(array);
-        assertEquals(1, array.length);
-        assertEquals(0d, array[0]);
-    }
-
     public void testDoublePrimitiveNonNumeric() throws Exception
     {
         // first, simple case:
@@ -564,7 +458,7 @@ public class JDKScalarsTest
     public void testBase64Variants() throws Exception
     {
         final byte[] INPUT = "abcdefghijklmnopqrstuvwxyz1234567890abcdefghijklmnopqrstuvwxyz1234567890X".getBytes("UTF-8");
-        
+
         // default encoding is "MIME, no linefeeds", so:
         Assert.assertArrayEquals(INPUT, MAPPER.readValue(
                 quote("YWJjZGVmZ2hpamtsbW5vcHFyc3R1dnd4eXoxMjM0NTY3ODkwYWJjZGVmZ2hpamtsbW5vcHFyc3R1dnd4eXoxMjM0NTY3ODkwWA=="),
@@ -585,7 +479,7 @@ public class JDKScalarsTest
         Assert.assertArrayEquals(INPUT, (byte[]) reader.with(Base64Variants.PEM).readValue(
                 quote("YWJjZGVmZ2hpamtsbW5vcHFyc3R1dnd4eXoxMjM0NTY3ODkwYWJjZGVmZ2hpamts\\nbW5vcHFyc3R1dnd4eXoxMjM0NTY3ODkwWA=="
         )));
-    }    
+    }
 
     /*
     /**********************************************************
@@ -606,7 +500,7 @@ public class JDKScalarsTest
             sb.append(" ");
             sb.append(i);
         }
-        JsonParser jp = MAPPER.getFactory().createParser(sb.toString());
+        JsonParser jp = MAPPER.createParser(sb.toString());
         for (int i = 0; i < NR_OF_INTS; ++i) {
             Integer result = MAPPER.readValue(jp, Integer.class);
             assertEquals(Integer.valueOf(i), result);
@@ -857,14 +751,24 @@ public class JDKScalarsTest
         }
     }
 
-    // [databind#2197]
+    // [databind#2197], [databind#2679]
     public void testVoidDeser() throws Exception
     {
+        // First, `Void` as bean property
         VoidBean bean = MAPPER.readValue(aposToQuotes("{'value' : 123 }"),
                 VoidBean.class);
         assertNull(bean.value);
+
+        // Then `Void` and `void` (Void.TYPE) as root values
+        assertNull(MAPPER.readValue("{}", Void.class));
+        assertNull(MAPPER.readValue("1234", Void.class));
+        assertNull(MAPPER.readValue("[ 1, true ]", Void.class));
+
+        assertNull(MAPPER.readValue("{}", Void.TYPE));
+        assertNull(MAPPER.readValue("1234", Void.TYPE));
+        assertNull(MAPPER.readValue("[ 1, true ]", Void.TYPE));
     }
-    
+
     /*
     /**********************************************************
     /* Test for invalid String values
@@ -873,7 +777,7 @@ public class JDKScalarsTest
 
     public void testInvalidStringCoercionFail() throws IOException
     {
-        _testInvalidStringCoercionFail(boolean[].class);
+        _testInvalidStringCoercionFail(boolean[].class, "boolean");
         _testInvalidStringCoercionFail(byte[].class);
 
         // char[] is special, cannot use generalized test here
@@ -887,14 +791,19 @@ public class JDKScalarsTest
 
     private void _testInvalidStringCoercionFail(Class<?> cls) throws IOException
     {
+        _testInvalidStringCoercionFail(cls, cls.getSimpleName());
+    }
+
+    private void _testInvalidStringCoercionFail(Class<?> cls, String targetTypeName)
+            throws IOException
+    {
         final String JSON = "[ \"foobar\" ]";
-        final String SIMPLE_NAME = cls.getSimpleName();
 
         try {
             MAPPER.readerFor(cls).readValue(JSON);
             fail("Should not pass");
         } catch (JsonMappingException e) {
-            verifyException(e, "Cannot deserialize value of type `"+SIMPLE_NAME+"` from String \"foobar\"");
+            verifyException(e, "Cannot deserialize value of type `"+targetTypeName+"` from String \"foobar\"");
         }
     }
 }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/MapDeser2757Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/MapDeser2757Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/MapDeser2757Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/MapDeser2757Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,32 @@
+package com.fasterxml.jackson.databind.deser.jdk;
+
+import java.util.*;
+
+import com.fasterxml.jackson.databind.*;
+
+@SuppressWarnings("serial")
+public class MapDeser2757Test extends BaseMapTest
+{
+    static class MyMap extends LinkedHashMap<String, String> {
+        public MyMap() { }
+
+        public void setValue(StringWrapper w) { }
+        public void setValue(IntWrapper w) { }
+
+        public long getValue() { return 0L; }
+    }
+
+    // [databind#2757]: should allow deserialization as Map despite conflicting setters
+    public void testCanDeserializeMap() throws Exception
+    {
+        final ObjectMapper mapper = jsonMapperBuilder()
+                .build();
+
+        MyMap input = new MyMap();
+        input.put("a", "b");
+        final String json = mapper.writeValueAsString(input);
+        MyMap x = mapper.readValue(json, MyMap.class);
+        assertEquals(1, x.size());
+        assertEquals("b", input.get("a"));
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/MapKeyDeserializationTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/MapKeyDeserializationTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/MapKeyDeserializationTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/MapKeyDeserializationTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -1,11 +1,14 @@
 package com.fasterxml.jackson.databind.deser.jdk;
 
+import java.util.Collections;
 import java.util.Map;
 
 import com.fasterxml.jackson.annotation.JsonCreator;
 import com.fasterxml.jackson.annotation.JsonValue;
+
 import com.fasterxml.jackson.core.Base64Variants;
 import com.fasterxml.jackson.core.type.TypeReference;
+
 import com.fasterxml.jackson.databind.*;
 
 import org.junit.Assert;
@@ -37,6 +40,31 @@ public class MapKeyDeserializationTest e
         }
     }
 
+    // [databind#2725]
+    enum TestEnum2725 {
+        FOO(1);
+
+        private final int i;
+
+        TestEnum2725(final int i) {
+            this.i = i;
+        }
+
+        @JsonValue
+        public int getI() {
+            return i;
+        }
+
+        @JsonCreator
+        public static TestEnum2725 getByIntegerId(final Integer id) {
+            return id == FOO.i ? FOO : null;
+        }
+
+        @JsonCreator
+        public static TestEnum2725 getByStringId(final String id) {
+            return Integer.parseInt(id) == FOO.i ? FOO : null;
+        }
+    }    
     /*
     /**********************************************************
     /* Test methods, wrapper keys
@@ -138,4 +166,16 @@ public class MapKeyDeserializationTest e
         byte[] key = entry.getKey();
         Assert.assertArrayEquals(binary, key);
     }
+
+    // [databind#2725]
+    public void testEnumWithCreatorMapKeyDeserialization() throws Exception
+    {
+        final Map<TestEnum2725, String> input = Collections.singletonMap(TestEnum2725.FOO, "Hello");
+        final String json = MAPPER.writeValueAsString(input);
+        final Map<TestEnum2725, String> output = MAPPER.readValue(json,
+                new TypeReference<Map<TestEnum2725, String>>() { });
+
+        assertNotNull(output);
+        assertEquals(1, output.size());
+    }
 }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/TestEmptyArrayBlockingQueueDeser.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/TestEmptyArrayBlockingQueueDeser.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/TestEmptyArrayBlockingQueueDeser.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/TestEmptyArrayBlockingQueueDeser.java	2020-06-25 02:44:21.000000000 +0000
@@ -3,7 +3,6 @@ package com.fasterxml.jackson.databind.d
 import java.util.Collection;
 import java.util.concurrent.ArrayBlockingQueue;
 
-import com.fasterxml.jackson.core.JsonProcessingException;
 import com.fasterxml.jackson.databind.*;
 
 public class TestEmptyArrayBlockingQueueDeser extends BaseMapTest
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/TimestampDeserializationTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/TimestampDeserializationTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/TimestampDeserializationTest.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/TimestampDeserializationTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,61 @@
+package com.fasterxml.jackson.databind.deser.jdk;
+
+import java.text.DateFormat;
+import java.text.SimpleDateFormat;
+
+import com.fasterxml.jackson.databind.*;
+
+public class TimestampDeserializationTest
+    extends BaseMapTest
+{
+    private final ObjectMapper MAPPER = newJsonMapper();
+
+    // As for TestDateDeserialization except we don't need to test date conversion routines, so
+    // just check we pick up timestamp class
+
+    public void testTimestampUtil() throws Exception
+    {
+        long now = 123456789L;
+        java.sql.Timestamp value = new java.sql.Timestamp(now);
+
+        // First from long
+        assertEquals(value, MAPPER.readValue(""+now, java.sql.Timestamp.class));
+
+        String dateStr = serializeTimestampAsString(value);
+        java.sql.Timestamp result = MAPPER.readValue("\""+dateStr+"\"", java.sql.Timestamp.class);
+
+        assertEquals("Date: expect "+value+" ("+value.getTime()+"), got "+result+" ("+result.getTime()+")", value.getTime(), result.getTime());
+    }
+
+    public void testTimestampUtilSingleElementArray() throws Exception
+    {
+        final ObjectReader r = MAPPER.readerFor(java.sql.Timestamp.class)
+                .with(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS);
+        
+        long now = System.currentTimeMillis();
+        java.sql.Timestamp value = new java.sql.Timestamp(now);
+
+        // First from long
+        assertEquals(value, r.readValue("["+now+"]"));
+
+        String dateStr = serializeTimestampAsString(value);
+        java.sql.Timestamp result = r.readValue("[\""+dateStr+"\"]");
+
+        assertEquals("Date: expect "+value+" ("+value.getTime()+"), got "+result+" ("+result.getTime()+")", value.getTime(), result.getTime());
+    }
+
+    /*
+    /**********************************************************
+    /* Helper methods
+    /**********************************************************
+     */
+
+    private String serializeTimestampAsString(java.sql.Timestamp value)
+    {
+        /* Then from String. This is bit tricky, since JDK does not really
+         * suggest a 'standard' format. So let's try using something...
+         */
+        DateFormat df = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSSZ");
+        return df.format(value);
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/UntypedDeserializationTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/UntypedDeserializationTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/UntypedDeserializationTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/jdk/UntypedDeserializationTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -92,7 +92,7 @@ public class UntypedDeserializationTest
         {
             Map<String,Object> map = new LinkedHashMap<String,Object>();
             while (p.nextValue() != JsonToken.END_OBJECT) {
-                map.put(p.getCurrentName(), "Y"+p.getText());
+                map.put(p.currentName(), "Y"+p.getText());
             }
             return map;
         }
@@ -110,6 +110,9 @@ public class UntypedDeserializationTest
     static class WrappedPolymorphicUntyped {
         @JsonTypeInfo(use=JsonTypeInfo.Id.CLASS)
         public Object value;
+
+        protected WrappedPolymorphicUntyped() { }
+        public WrappedPolymorphicUntyped(Object o) { value = o; }
     }
 
     static class WrappedUntyped1460 {
@@ -127,7 +130,7 @@ public class UntypedDeserializationTest
     /**********************************************************
      */
 
-    private final ObjectMapper MAPPER = new ObjectMapper();
+    private final ObjectMapper MAPPER = newJsonMapper();
     
     @SuppressWarnings("unchecked")
     public void testSampleDoc() throws Exception
@@ -206,6 +209,22 @@ public class UntypedDeserializationTest
         assertNull(result.get(3));
     }
 
+    public void testSimpleVanillaScalars() throws IOException
+    {
+        assertEquals("foo", MAPPER.readValue(quote("foo"), Object.class));
+
+        assertEquals(Boolean.TRUE, MAPPER.readValue(" true ", Object.class));
+
+        assertEquals(Integer.valueOf(13), MAPPER.readValue("13 ", Object.class));
+        assertEquals(Double.valueOf(0.5), MAPPER.readValue("0.5 ", Object.class));
+    }
+
+    public void testSimpleVanillaStructured() throws IOException
+    {
+        List<?> list = (List<?>) MAPPER.readValue("[ 1, 2, 3]", Object.class);
+        assertEquals(Integer.valueOf(1), list.get(0));
+    }
+    
     public void testNestedUntypes() throws IOException
     {
         // 05-Apr-2014, tatu: Odd failures if using shared mapper; so work around:
@@ -264,39 +283,6 @@ public class UntypedDeserializationTest
         assertEquals(2, l.size());
         assertTrue(l.get(0) instanceof Map<?,?>);
         assertTrue(l.get(1) instanceof List<?>);
-
-        ObjectReader rDefault = mapper.readerFor(WrappedPolymorphicUntyped.class);
-        ObjectReader rAlt = rDefault
-                .with(DeserializationFeature.USE_BIG_DECIMAL_FOR_FLOATS,
-                        DeserializationFeature.USE_BIG_INTEGER_FOR_INTS);
-        WrappedPolymorphicUntyped w;
-
-        w = rDefault.readValue(aposToQuotes("{'value':10}"));
-        assertEquals(Integer.valueOf(10), w.value);
-        w = rAlt.readValue(aposToQuotes("{'value':10}"));
-        assertEquals(BigInteger.TEN, w.value);
-
-        w = rDefault.readValue(aposToQuotes("{'value':5.0}"));
-        assertEquals(Double.valueOf(5.0), w.value);
-        w = rAlt.readValue(aposToQuotes("{'value':5.0}"));
-        assertEquals(new BigDecimal("5.0"), w.value);
-
-        StringBuilder sb = new StringBuilder(100).append("[0");
-        for (int i = 1; i < 100; ++i) {
-            sb.append(", ").append(i);
-        }
-        sb.append("]");
-        final String INT_ARRAY_JSON = sb.toString();
-
-        // First read as-is, no type wrapping
-        Object ob = mapper.readerFor(Object.class)
-                .with(DeserializationFeature.USE_JAVA_ARRAY_FOR_JSON_ARRAY)
-                .readValue(INT_ARRAY_JSON);
-        assertTrue(ob instanceof Object[]);
-        Object[] obs = (Object[]) ob;
-        for (int i = 0; i < 100; ++i) {
-            assertEquals(Integer.valueOf(i), obs[i]);
-        }
     }
 
     public void testUntypedWithListDeser() throws IOException
@@ -354,8 +340,9 @@ public class UntypedDeserializationTest
         assertTrue(ob instanceof List<?>);
 
         // but can change to produce Object[]:
-        MAPPER.configure(DeserializationFeature.USE_JAVA_ARRAY_FOR_JSON_ARRAY, true);
-        ob = MAPPER.readValue("[1]", Object.class);
+        ob = MAPPER.readerFor(Object.class)
+            .with(DeserializationFeature.USE_JAVA_ARRAY_FOR_JSON_ARRAY)
+            .readValue("[1]");
         assertEquals(Object[].class, ob.getClass());
     }
 
@@ -395,6 +382,61 @@ public class UntypedDeserializationTest
 
     /*
     /**********************************************************
+    /* Test methods, merging
+    /**********************************************************
+     */
+    
+    public void testValueUpdateVanillaUntyped() throws Exception
+    {
+        Map<String, Object> map = new LinkedHashMap<>();
+        map.put("a", 42);
+
+        ObjectReader r = MAPPER.readerFor(Object.class).withValueToUpdate(map);
+        Object result = r.readValue(aposToQuotes("{'b' : 57}"));
+        assertSame(map, result);
+        assertEquals(2, map.size());
+        assertEquals(Integer.valueOf(57), map.get("b"));
+
+        // Try same with other types, too
+        List<Object> list = new ArrayList<>();
+        list.add(1);
+        r = MAPPER.readerFor(Object.class).withValueToUpdate(list);
+        result = r.readValue("[ 2, true ]");
+        assertSame(list, result);
+        assertEquals(3, list.size());
+        assertEquals(Boolean.TRUE, list.get(2));
+    }
+
+    public void testValueUpdateCustomUntyped() throws Exception
+    {
+        SimpleModule m = new SimpleModule("test-module")
+                .addDeserializer(String.class, new UCStringDeserializer());
+        final ObjectMapper customMapper = newJsonMapper()
+            .registerModule(m);
+        
+        Map<String, Object> map = new LinkedHashMap<>();
+        map.put("a", 42);
+
+        ObjectReader r = customMapper.readerFor(Object.class).withValueToUpdate(map);
+        Object result = r.readValue(aposToQuotes("{'b' : 'value', 'c' : 111222333444, 'enabled':true}"));
+        assertSame(map, result);
+        assertEquals(4, map.size());
+        assertEquals("VALUE", map.get("b"));
+        assertEquals(Long.valueOf(111222333444L), map.get("c"));
+        assertEquals(Boolean.TRUE, map.get("enabled"));
+
+        // Try same with other types, too
+        List<Object> list = new ArrayList<>();
+        list.add(1);
+        r = customMapper.readerFor(Object.class).withValueToUpdate(list);
+        result = r.readValue(aposToQuotes("[ 2, 'foobar' ]"));
+        assertSame(list, result);
+        assertEquals(3, list.size());
+        assertEquals("FOOBAR", list.get(2));
+    }
+    
+    /*
+    /**********************************************************
     /* Test methods, polymorphic
     /**********************************************************
      */
@@ -418,4 +460,72 @@ public class UntypedDeserializationTest
         assertSame(Long.class, n.getClass());
         assertEquals(Long.valueOf(VALUE), n);
     }
+
+    public void testPolymorphicUntypedVanilla() throws IOException
+    {
+        ObjectReader rDefault = MAPPER.readerFor(WrappedPolymorphicUntyped.class);
+        ObjectReader rAlt = rDefault
+                .with(DeserializationFeature.USE_BIG_DECIMAL_FOR_FLOATS,
+                        DeserializationFeature.USE_BIG_INTEGER_FOR_INTS);
+        WrappedPolymorphicUntyped w;
+
+        w = rDefault.readValue(aposToQuotes("{'value':10}"));
+        assertEquals(Integer.valueOf(10), w.value);
+        w = rAlt.readValue(aposToQuotes("{'value':10}"));
+        assertEquals(BigInteger.TEN, w.value);
+
+        w = rDefault.readValue(aposToQuotes("{'value':5.0}"));
+        assertEquals(Double.valueOf(5.0), w.value);
+        w = rAlt.readValue(aposToQuotes("{'value':5.0}"));
+        assertEquals(new BigDecimal("5.0"), w.value);
+
+        StringBuilder sb = new StringBuilder(100).append("[0");
+        for (int i = 1; i < 100; ++i) {
+            sb.append(", ").append(i);
+        }
+        sb.append("]");
+        final String INT_ARRAY_JSON = sb.toString();
+
+        // First read as-is, no type wrapping
+        Object ob = MAPPER.readerFor(Object.class)
+                .with(DeserializationFeature.USE_JAVA_ARRAY_FOR_JSON_ARRAY)
+                .readValue(INT_ARRAY_JSON);
+        assertTrue(ob instanceof Object[]);
+        Object[] obs = (Object[]) ob;
+        for (int i = 0; i < 100; ++i) {
+            assertEquals(Integer.valueOf(i), obs[i]);
+        }
+    }
+
+    public void testPolymorphicUntypedCustom() throws IOException
+    {
+        // register module just to override one deserializer, to prevent use of Vanilla deser
+        SimpleModule m = new SimpleModule("test-module")
+                .addDeserializer(String.class, new UCStringDeserializer());
+        final ObjectMapper customMapper = newJsonMapper()
+            .registerModule(m);
+        ObjectReader rDefault = customMapper.readerFor(WrappedPolymorphicUntyped.class);
+
+        WrappedPolymorphicUntyped w = rDefault.readValue(aposToQuotes("{'value':10}"));
+        assertEquals(Integer.valueOf(10), w.value);
+
+        w = rDefault.readValue(aposToQuotes("{'value':9988776655}"));
+        assertEquals(Long.valueOf(9988776655L), w.value);
+        w = rDefault.readValue(aposToQuotes("{'value':0.75}"));
+        assertEquals(Double.valueOf(0.75), w.value);
+
+        w = rDefault.readValue(aposToQuotes("{'value':'abc'}"));
+        assertEquals("ABC", w.value);
+        w = rDefault.readValue(aposToQuotes("{'value':false}"));
+        assertEquals(Boolean.FALSE, w.value);
+        w = rDefault.readValue(aposToQuotes("{'value':null}"));
+        assertNull(w.value);
+
+        // but... actually how about real type id?
+        final Object SHORT = Short.valueOf((short) 3);
+        String json = customMapper.writeValueAsString(new WrappedPolymorphicUntyped(SHORT));
+
+        WrappedPolymorphicUntyped result = rDefault.readValue(json);
+        assertEquals(SHORT, result.value);
+    }
 }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/PropertyAliasTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/PropertyAliasTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/PropertyAliasTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/PropertyAliasTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -6,7 +6,9 @@ import com.fasterxml.jackson.annotation.
 import com.fasterxml.jackson.annotation.JsonSubTypes;
 import com.fasterxml.jackson.annotation.JsonTypeInfo;
 import com.fasterxml.jackson.databind.BaseMapTest;
+import com.fasterxml.jackson.databind.MapperFeature;
 import com.fasterxml.jackson.databind.ObjectMapper;
+import com.fasterxml.jackson.databind.json.JsonMapper;
 
 public class PropertyAliasTest extends BaseMapTest
 {
@@ -58,6 +60,26 @@ public class PropertyAliasTest extends B
         public PolyWrapperForAlias(Object v) { value = v; }
     }
 
+    // [databind#2669]
+    static class Pojo2669 {
+        @JsonAlias({"nick", "name"})
+        private String name;
+
+        public String getName() {
+            return name;
+        }
+
+        public void setName(String name) {
+            this.name = name;
+        }
+    }
+
+    /*
+    /**********************************************************************
+    /* Test methods
+    /**********************************************************************
+     */
+
     private final ObjectMapper MAPPER = newJsonMapper();
 
     // [databind#1029]
@@ -107,4 +129,17 @@ public class PropertyAliasTest extends B
         assertEquals("a", bean.partitionId);
         assertEquals("123", bean._id);
     }
+
+    // [databind#2669]
+    public void testCaseInsensitiveAliases() throws Exception {
+
+        ObjectMapper mapper = JsonMapper.builder()
+                .enable(MapperFeature.ACCEPT_CASE_INSENSITIVE_PROPERTIES)
+                .build();
+
+        String text = "{\"name\":\"test\"}";
+        Pojo2669 pojo = mapper.readValue(text, Pojo2669.class);
+        assertNotNull(pojo);
+        assertEquals("test", pojo.getName());
+    }
 }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/TestArrayDeserialization.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/TestArrayDeserialization.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/TestArrayDeserialization.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/TestArrayDeserialization.java	2020-06-25 02:44:21.000000000 +0000
@@ -188,24 +188,24 @@ public class TestArrayDeserialization
     // [JACKSON-620]: allow "" to mean 'null' for Arrays, List and Maps
     public void testFromEmptyString() throws Exception
     {
-        ObjectMapper m = new ObjectMapper();
-        m.configure(DeserializationFeature.ACCEPT_EMPTY_STRING_AS_NULL_OBJECT, true);
-        assertNull(m.readValue(quote(""), Object[].class));
-        assertNull( m.readValue(quote(""), String[].class));
-        assertNull( m.readValue(quote(""), int[].class));
+        ObjectReader r = MAPPER.reader()
+                .with(DeserializationFeature.ACCEPT_EMPTY_STRING_AS_NULL_OBJECT);
+        assertNull(r.forType(Object[].class).readValue(quote("")));
+        assertNull(r.forType(String[].class).readValue(quote("")));
+        assertNull(r.forType(int[].class).readValue(quote("")));
     }
 
     // [JACKSON-620]: allow "" to mean 'null' for Arrays, List and Maps
     public void testFromEmptyString2() throws Exception
     {
-        ObjectMapper m = new ObjectMapper();
-        m.configure(DeserializationFeature.ACCEPT_EMPTY_STRING_AS_NULL_OBJECT, true);
-        m.configure(DeserializationFeature.ACCEPT_SINGLE_VALUE_AS_ARRAY, true);
-        Product p = m.readValue("{\"thelist\":\"\"}", Product.class);
+        ObjectReader r = MAPPER.readerFor(Product.class)
+                .with(DeserializationFeature.ACCEPT_EMPTY_STRING_AS_NULL_OBJECT,
+                        DeserializationFeature.ACCEPT_SINGLE_VALUE_AS_ARRAY);
+        Product p = r.readValue("{\"thelist\":\"\"}");
         assertNotNull(p);
         assertNull(p.thelist);
     }
-    
+
     /*
     /**********************************************************
     /* Arrays of arrays...
@@ -250,7 +250,7 @@ public class TestArrayDeserialization
             "a", "b", "abcd", "", "???", "\"quoted\"", "lf: \n",
         };
         StringWriter sw = new StringWriter();
-        JsonGenerator jg = MAPPER.getFactory().createGenerator(sw);
+        JsonGenerator jg = MAPPER.createGenerator(sw);
         jg.writeStartArray();
         for (String str : STRS) {
             jg.writeString(str);
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/TestConcurrency.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/TestConcurrency.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/TestConcurrency.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/TestConcurrency.java	2020-06-25 02:44:21.000000000 +0000
@@ -8,7 +8,7 @@ import com.fasterxml.jackson.databind.*;
 import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
 
 /**
- * Testing for [JACKSON-237] (NPE due to race condition)
+ * Testing for NPE due to race condition.
  */
 public class TestConcurrency extends BaseMapTest
 {
@@ -18,7 +18,7 @@ public class TestConcurrency extends Bas
     /**********************************************
      */
 
-    @JsonDeserialize(using=BeanDeserializer.class)
+    @JsonDeserialize(using=CustomBeanDeserializer.class)
     static class Bean
     {
         public int value = 42;
@@ -34,7 +34,7 @@ public class TestConcurrency extends Bas
      * Dummy deserializer used for verifying that partially handled (i.e. not yet
      * resolved) deserializers are not allowed to be used.
      */
-    static class BeanDeserializer
+    static class CustomBeanDeserializer
         extends JsonDeserializer<Bean>
         implements ResolvableDeserializer
     {
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/TestCustomDeserializers.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/TestCustomDeserializers.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/TestCustomDeserializers.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/TestCustomDeserializers.java	2020-06-25 02:44:21.000000000 +0000
@@ -65,14 +65,14 @@ public class TestCustomDeserializers
         public CustomBean deserialize(JsonParser p, DeserializationContext ctxt) throws IOException
         {
             int a = 0, b = 0;
-            JsonToken t = p.getCurrentToken();
+            JsonToken t = p.currentToken();
             if (t == JsonToken.START_OBJECT) {
                 t = p.nextToken();
             } else if (t != JsonToken.FIELD_NAME) {
                 throw new Error();
             }
             while(t == JsonToken.FIELD_NAME) {
-                final String fieldName = p.getCurrentName();
+                final String fieldName = p.currentName();
                 t = p.nextToken();
                 if (t != JsonToken.VALUE_NUMBER_INT) {
                     throw new JsonParseException(p, "expecting number got "+ t);
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/TestCustomFactory.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/TestCustomFactory.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/TestCustomFactory.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/TestCustomFactory.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,140 +0,0 @@
-package com.fasterxml.jackson.databind.deser;
-
-import java.io.*;
-import java.util.*;
-
-
-import com.fasterxml.jackson.core.*;
-import com.fasterxml.jackson.databind.*;
-import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
-import com.fasterxml.jackson.databind.deser.std.StdDeserializer;
-
-/**
- * Test to check that customizations work as expected.
- */
-@SuppressWarnings("serial")
-public class TestCustomFactory
-    extends BaseMapTest
-{
-    /*
-    /**********************************************************
-    /* Helper classes
-    /**********************************************************
-     */
-
-    static class DummyDeserializer<T>
-        extends StdDeserializer<T>
-    {
-        final T value;
-
-        public DummyDeserializer(T v, Class<T> cls) {
-            super(cls);
-            value = v;
-        }
-
-        @Override
-        public T deserialize(JsonParser jp, DeserializationContext ctxt)
-            throws IOException, JsonProcessingException
-        {
-            // need to skip, if structured...
-            jp.skipChildren();
-            return value;
-        }
-    }
-
-    static class TestBeans {
-        public List<TestBean> beans;
-    }
-    static class TestBean {
-        public CustomBean c;
-        public String d;
-    }
-    @JsonDeserialize(using=CustomBeanDeserializer.class)
-    static class CustomBean {
-        protected final int a, b;
-        public CustomBean(int a, int b) {
-            this.a = a;
-            this.b = b;
-        }
-    }
-
-    static class CustomBeanDeserializer extends JsonDeserializer<CustomBean>
-    {
-        @Override
-        public CustomBean deserialize(JsonParser jp, DeserializationContext ctxt) throws IOException
-        {
-            int a = 0, b = 0;
-            JsonToken t = jp.getCurrentToken();
-            if (t == JsonToken.START_OBJECT) {
-                t = jp.nextToken();
-            } else if (t != JsonToken.FIELD_NAME) {
-                throw new Error();
-            }
-            while(t == JsonToken.FIELD_NAME) {
-                final String fieldName = jp.getCurrentName();
-                t = jp.nextToken();
-                if (t != JsonToken.VALUE_NUMBER_INT) {
-                    throw new JsonParseException(jp, "expecting number got "+ t);
-                }
-                if (fieldName.equals("a")) {
-                    a = jp.getIntValue();
-                } else if (fieldName.equals("b")) {
-                    b = jp.getIntValue();
-                } else {
-                    throw new Error();
-                }
-                t = jp.nextToken();
-            }
-            return new CustomBean(a, b);
-        }
-    }
-
-    
-    /*
-    /**********************************************************
-    /* Unit tests
-    /**********************************************************
-     */
-
-    public void testCustomBeanDeserializer() throws Exception
-    {
-
-        final ObjectMapper map = new ObjectMapper();
-        String json = "{\"beans\":[{\"c\":{\"a\":10,\"b\":20},\"d\":\"hello, tatu\"}]}";
-        TestBeans beans = map.readValue(json, TestBeans.class);
-
-        assertNotNull(beans);
-        List<TestBean> results = beans.beans;
-        assertNotNull(results);
-        assertEquals(1, results.size());
-        TestBean bean = results.get(0);
-        assertEquals("hello, tatu", bean.d);
-        CustomBean c = bean.c;
-        assertNotNull(c);
-        assertEquals(10, c.a);
-        assertEquals(20, c.b);
-
-        json = "{\"beans\":[{\"c\":{\"b\":3,\"a\":-4},\"d\":\"\"},"
-            +"{\"d\":\"abc\", \"c\":{\"b\":15}}]}";
-        beans = map.readValue(json, TestBeans.class);
-
-        assertNotNull(beans);
-        results = beans.beans;
-        assertNotNull(results);
-        assertEquals(2, results.size());
-
-        bean = results.get(0);
-        assertEquals("", bean.d);
-        c = bean.c;
-        assertNotNull(c);
-        assertEquals(-4, c.a);
-        assertEquals(3, c.b);
-
-        bean = results.get(1);
-        assertEquals("abc", bean.d);
-        c = bean.c;
-        assertNotNull(c);
-        assertEquals(0, c.a);
-        assertEquals(15, c.b);
-    }
-}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/TestCyclicTypes.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/TestCyclicTypes.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/TestCyclicTypes.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/TestCyclicTypes.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,120 +0,0 @@
-package com.fasterxml.jackson.databind.deser;
-
-import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
-import com.fasterxml.jackson.databind.*;
-
-/**
- * Simple unit tests to verify that it is possible to handle
- * potentially cyclic structures, as long as object graph itself
- * is not cyclic. This is the case for directed hierarchies like
- * trees and DAGs.
- */
-public class TestCyclicTypes
-    extends BaseMapTest
-{
-    /*
-    /**********************************************************
-    /* Helper bean classes
-    /**********************************************************
-     */
-
-    static class Bean
-    {
-        Bean _next;
-        String _name;
-
-        public Bean() { }
-
-        public void setNext(Bean b) { _next = b; }
-        public void setName(String n) { _name = n; }
-
-    }
-
-    static class LinkA {
-        public LinkB next;
-    }
-
-    static class LinkB {
-        protected LinkA a;
-
-        public void setA(LinkA a) { this.a = a; }
-        public LinkA getA() { return a; }
-    }
-
-    static class GenericLink<T> {
-        public GenericLink<T> next;
-    }
-
-    static class StringLink extends GenericLink<String> {
-    }
-
-    static class Selfie405 {
-        public int id;
-
-        @JsonIgnoreProperties({ "parent" })
-        public Selfie405 parent;
-        
-        public Selfie405(int id) { this.id = id; }
-    }
-    
-    /*
-    /**********************************************************
-    /* Unit tests
-    /**********************************************************
-     */
-
-    private final ObjectMapper MAPPER = objectMapper();
-    
-    public void testLinked() throws Exception
-    {
-        Bean first = MAPPER.readValue
-            ("{\"name\":\"first\", \"next\": { "
-             +" \"name\":\"last\", \"next\" : null }}",
-             Bean.class);
-
-        assertNotNull(first);
-        assertEquals("first", first._name);
-        Bean last = first._next;
-        assertNotNull(last);
-        assertEquals("last", last._name);
-        assertNull(last._next);
-    }
-
-    public void testLinkedGeneric() throws Exception
-    {
-        StringLink link = MAPPER.readValue("{\"next\":null}", StringLink.class);
-        assertNotNull(link);
-        assertNull(link.next);
-    }
-
-    public void testCycleWith2Classes() throws Exception
-    {
-        LinkA a = MAPPER.readValue("{\"next\":{\"a\":null}}", LinkA.class);
-        assertNotNull(a.next);
-        LinkB b = a.next;
-        assertNull(b.a);
-    }
-
-    // [Issue#405]: Should be possible to ignore cyclic ref
-    public void testIgnoredCycle() throws Exception
-    {
-        Selfie405 self1 = new Selfie405(1);
-        self1.parent = self1;
-
-        // First: exception with default settings:
-        assertTrue(MAPPER.isEnabled(SerializationFeature.FAIL_ON_SELF_REFERENCES));
-        try {
-            MAPPER.writeValueAsString(self1);
-            fail("Should fail with direct self-ref");
-        } catch (JsonMappingException e) {
-            verifyException(e, "Direct self-reference");
-        }
-        
-        ObjectWriter w = MAPPER.writer()
-                .without(SerializationFeature.FAIL_ON_SELF_REFERENCES);
-        String json = w.writeValueAsString(self1);
-        assertNotNull(json);
-        assertEquals(aposToQuotes("{'id':1,'parent':{'id':1}}"), json);
-    }
-
-}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/TestGenerics.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/TestGenerics.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/TestGenerics.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/TestGenerics.java	2020-06-25 02:44:21.000000000 +0000
@@ -94,11 +94,8 @@ public class TestGenerics
         assertEquals(13, bean.x);
     }
 
-    /**
-     * Unit test for verifying that we can use different
-     * type bindings for individual generic types;
-     * problem with [JACKSON-190]
-     */
+    // Test for verifying that we can use different
+    // type bindings for individual generic types.
     public void testMultipleWrappers() throws Exception
     {
         ObjectMapper mapper = new ObjectMapper();
@@ -119,7 +116,7 @@ public class TestGenerics
         assertEquals(new Wrapper<Long>(7L), result3);
     }
     
-    //[Issue#381]
+    //[databind#381]
     public void testMultipleWrappersSingleValueArray() throws Exception
     {
         ObjectMapper mapper = new ObjectMapper();
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/TestJacksonTypes.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/TestJacksonTypes.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/TestJacksonTypes.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/TestJacksonTypes.java	2020-06-25 02:44:21.000000000 +0000
@@ -113,7 +113,7 @@ public class TestJacksonTypes
     // [databind#2398]
     public void testDeeplyNestedArrays() throws Exception
     {
-        try (JsonParser p = MAPPER.tokenStreamFactory().createParser(_createNested(RECURSION_2398 * 2,
+        try (JsonParser p = MAPPER.createParser(_createNested(RECURSION_2398 * 2,
                 "[", " 123 ", "]"))) {
             p.nextToken();
             TokenBuffer b = new TokenBuffer(p);
@@ -124,7 +124,7 @@ public class TestJacksonTypes
 
     public void testDeeplyNestedObjects() throws Exception
     {
-        try (JsonParser p = MAPPER.tokenStreamFactory().createParser(_createNested(RECURSION_2398,
+        try (JsonParser p = MAPPER.createParser(_createNested(RECURSION_2398,
                 "{\"a\":", "42", "}"))) {
             p.nextToken();
             TokenBuffer b = new TokenBuffer(p);
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/TestTimestampDeserialization.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/TestTimestampDeserialization.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/deser/TestTimestampDeserialization.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/deser/TestTimestampDeserialization.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,60 +0,0 @@
-package com.fasterxml.jackson.databind.deser;
-
-import java.text.DateFormat;
-import java.text.SimpleDateFormat;
-
-
-import com.fasterxml.jackson.databind.*;
-
-public class TestTimestampDeserialization
-    extends BaseMapTest
-{
-    // As for TestDateDeserialization except we don't need to test date conversion routines, so
-    // just check we pick up timestamp class
-
-    public void testTimestampUtil() throws Exception
-    {
-        long now = 123456789L;
-        java.sql.Timestamp value = new java.sql.Timestamp(now);
-
-        // First from long
-        assertEquals(value, new ObjectMapper().readValue(""+now, java.sql.Timestamp.class));
-
-        String dateStr = serializeTimestampAsString(value);
-        java.sql.Timestamp result = new ObjectMapper().readValue("\""+dateStr+"\"", java.sql.Timestamp.class);
-
-        assertEquals("Date: expect "+value+" ("+value.getTime()+"), got "+result+" ("+result.getTime()+")", value.getTime(), result.getTime());
-    }
-    
-    public void testTimestampUtilSingleElementArray() throws Exception
-    {
-        final ObjectMapper mapper = new ObjectMapper();
-        mapper.enable(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS);
-        
-        long now = System.currentTimeMillis();
-        java.sql.Timestamp value = new java.sql.Timestamp(now);
-
-        // First from long
-        assertEquals(value, mapper.readValue("["+now+"]", java.sql.Timestamp.class));
-
-        String dateStr = serializeTimestampAsString(value);
-        java.sql.Timestamp result = mapper.readValue("[\""+dateStr+"\"]", java.sql.Timestamp.class);
-
-        assertEquals("Date: expect "+value+" ("+value.getTime()+"), got "+result+" ("+result.getTime()+")", value.getTime(), result.getTime());
-    }
-
-    /*
-    /**********************************************************
-    /* Helper methods
-    /**********************************************************
-     */
-
-    private String serializeTimestampAsString(java.sql.Timestamp value)
-    {
-        /* Then from String. This is bit tricky, since JDK does not really
-         * suggest a 'standard' format. So let's try using something...
-         */
-        DateFormat df = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSSZ");
-        return df.format(value);
-    }
-}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/exc/BasicExceptionTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/exc/BasicExceptionTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/exc/BasicExceptionTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/exc/BasicExceptionTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -1,20 +1,19 @@
 package com.fasterxml.jackson.databind.exc;
 
 import java.io.StringWriter;
+import java.util.ArrayList;
 import java.util.Collection;
 import java.util.Collections;
-import java.util.Map;
 
 import com.fasterxml.jackson.core.*;
-import com.fasterxml.jackson.core.type.TypeReference;
 import com.fasterxml.jackson.databind.*;
 import com.fasterxml.jackson.databind.introspect.BeanPropertyDefinition;
 import com.fasterxml.jackson.databind.type.TypeFactory;
 
 public class BasicExceptionTest extends BaseMapTest
 {
-    final ObjectMapper MAPPER = new ObjectMapper();
-    final JsonFactory JSON_F = MAPPER.getFactory();
+    private final ObjectMapper MAPPER = newJsonMapper();
+    private final JsonFactory JSON_F = MAPPER.getFactory();
 
     public void testBadDefinition() throws Exception
     {
@@ -114,18 +113,30 @@ public class BasicExceptionTest extends
     }
 
     // [databind#2128]: ensure Location added once and only once
+    // [databind#2482]: ensure Location is the original one
     public void testLocationAddition() throws Exception
     {
+        String problemJson = "{\n\t\"userList\" : [\n\t{\n\t user : \"1\"\n\t},\n\t{\n\t \"user\" : \"2\"\n\t}\n\t]\n}";
         try {
-            /*Map<?,?> map =*/ MAPPER.readValue("{\"value\":\"foo\"}",
-                    new TypeReference<Map<ABC, Integer>>() { });
+            MAPPER.readValue(problemJson, Users.class);
             fail("Should not pass");
-        } catch (MismatchedInputException e) {
+        } catch (JsonMappingException e) { // becomes "generic" due to wrapping for passing path info
             String msg = e.getMessage();
             String[] str = msg.split(" at \\[");
             if (str.length != 2) {
                 fail("Should only get one 'at [' marker, got "+(str.length-1)+", source: "+msg);
             }
+            JsonLocation loc = e.getLocation();
+//          String expectedLocation = "line: 4, column: 4";
+            assertEquals(4, loc.getLineNr());
+            assertEquals(4, loc.getColumnNr());
         }
     }
+    static class User {
+        public String user;
+    }
+
+    static class Users {
+        public ArrayList<User> userList;
+    }
 }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/exc/DeserExceptionTypeTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/exc/DeserExceptionTypeTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/exc/DeserExceptionTypeTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/exc/DeserExceptionTypeTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -75,7 +75,7 @@ public class DeserExceptionTypeTest
         throws Exception
     {
         BrokenStringReader r = new BrokenStringReader("[ 1, ", "TEST");
-        JsonParser p = MAPPER.getFactory().createParser(r);
+        JsonParser p = MAPPER.createParser(r);
         try {
             @SuppressWarnings("unused")
             Object ob = MAPPER.readValue(p, Object.class);
@@ -90,7 +90,7 @@ public class DeserExceptionTypeTest
 
     public void testExceptionWithEOF() throws Exception
     {
-        JsonParser p = MAPPER.getFactory().createParser("  3");
+        JsonParser p = MAPPER.createParser("  3");
 
         Integer I = MAPPER.readValue(p, Integer.class);
         assertEquals(3, I.intValue());
@@ -103,7 +103,7 @@ public class DeserExceptionTypeTest
             verifyException(e, MismatchedInputException.class, "No content");
         }
         // also: should have no current token after end-of-input
-        JsonToken t = p.getCurrentToken();
+        JsonToken t = p.currentToken();
         if (t != null) {
             fail("Expected current token to be null after end-of-stream, was: "+t);
         }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/exc/ExceptionSerializationTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/exc/ExceptionSerializationTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/exc/ExceptionSerializationTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/exc/ExceptionSerializationTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -70,7 +70,7 @@ public class ExceptionSerializationTest
     // to double-check [databind#1413]
     public void testSimpleOther() throws Exception
     {
-        JsonParser p = MAPPER.getFactory().createParser("{ }");
+        JsonParser p = MAPPER.createParser("{ }");
         InvalidFormatException exc = InvalidFormatException.from(p, "Test", getClass(), String.class);
         String json = MAPPER.writeValueAsString(exc);
         p.close();
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ext/TestCoreXMLTypes.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ext/TestCoreXMLTypes.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ext/TestCoreXMLTypes.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ext/TestCoreXMLTypes.java	2020-06-25 02:44:21.000000000 +0000
@@ -74,6 +74,9 @@ public class TestCoreXMLTypes
         if (dateStr.endsWith("+0000")) {
             return dateStr.substring(0, dateStr.length()-5);
         }
+        if (dateStr.endsWith("+00:00")) {
+            return dateStr.substring(0, dateStr.length()-6);
+        }
         return dateStr;
     }
     
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/filter/ProblemHandler1767Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/filter/ProblemHandler1767Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/filter/ProblemHandler1767Test.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/filter/ProblemHandler1767Test.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,45 +0,0 @@
-package com.fasterxml.jackson.databind.filter;
-
-import com.fasterxml.jackson.databind.*;
-import com.fasterxml.jackson.databind.deser.DeserializationProblemHandler;
-
-public class ProblemHandler1767Test extends BaseMapTest
-{
-    static class IntHandler
-            extends DeserializationProblemHandler
-    {
-        @Override
-        public Object handleWeirdStringValue(DeserializationContext ctxt,
-                Class<?> targetType,
-                String valueToConvert,
-                String failureMsg)
-        {
-            if (targetType != Integer.TYPE) {
-                return NOT_HANDLED;
-            }
-            return 1;
-        }
-    }
-
-    static class TestBean {
-        int a;
-
-        public int getA() {
-            return a;
-        }
-
-        public void setA(int a) {
-            this.a = a;
-        }
-
-    }
-
-    public void testPrimitivePropertyWithHandler() throws Exception {
-        final ObjectMapper mapper = new ObjectMapper();
-        mapper.addHandler(new IntHandler());
-        TestBean result = mapper.readValue(aposToQuotes("{'a': 'not-a-number'}"), TestBean.class);
-        assertNotNull(result);
-        assertEquals(1, result.a);
-    }
-    
-}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/format/EnumFormatShapeTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/format/EnumFormatShapeTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/format/EnumFormatShapeTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/format/EnumFormatShapeTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -73,6 +73,14 @@ public class EnumFormatShapeTest
         }
     }
 
+    // [databind#2365]
+    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
+    public enum Enum2365 {
+        A, B, C;
+
+        public String getMainValue() { return name()+"-x"; }
+    }
+
     // [databind#2576]
     @JsonFormat(shape = JsonFormat.Shape.OBJECT)
     public enum Enum2576 {
@@ -135,6 +143,15 @@ public class EnumFormatShapeTest
                 MAPPER.writeValueAsString(new ColorWrapper(Color.GREEN)));
     }
 
+    // [databind#2365]
+    public void testEnumWithNamingStrategy() throws Exception {
+        final ObjectMapper mapper = jsonMapperBuilder()
+                .propertyNamingStrategy(PropertyNamingStrategy.SNAKE_CASE)
+                .build();
+        String json = mapper.writeValueAsString(Enum2365.B);
+        assertEquals(aposToQuotes("{'main_value':'B-x'}"), json);
+    }
+
     // [databind#2576]
     public void testEnumWithMethodOverride() throws Exception {
         String stringResult = MAPPER.writeValueAsString(Enum2576.ATTRIBUTES);
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/format/MapFormatShapeTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/format/MapFormatShapeTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/format/MapFormatShapeTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/format/MapFormatShapeTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -1,7 +1,6 @@
 package com.fasterxml.jackson.databind.format;
 
 import java.util.Collection;
-import java.util.HashMap;
 import java.util.LinkedHashMap;
 import java.util.Map;
 import java.util.Set;
@@ -11,6 +10,7 @@ import com.fasterxml.jackson.annotation.
 import com.fasterxml.jackson.annotation.JsonInclude;
 import com.fasterxml.jackson.annotation.JsonPropertyOrder;
 import com.fasterxml.jackson.databind.*;
+import com.fasterxml.jackson.databind.json.JsonMapper;
 
 @SuppressWarnings("serial")
 public class MapFormatShapeTest extends BaseMapTest
@@ -64,7 +64,7 @@ public class MapFormatShapeTest extends
     @JsonPropertyOrder({ "property", "map" })
     static class Map1540Implementation implements Map<Integer, Integer> {
         public int property;
-        public Map<Integer, Integer> map = new HashMap<>();
+        public Map<Integer, Integer> map = new LinkedHashMap<>();
  
         public Map<Integer, Integer> getMap() {
             return map;
@@ -184,10 +184,10 @@ public class MapFormatShapeTest extends
         input.property = 55;
         input.put(12, 45);
         input.put(6, 88);
+        JsonMapper mapper = JsonMapper.builder().enable(MapperFeature.SORT_PROPERTIES_ALPHABETICALLY).build();
+        String json = mapper.writeValueAsString(input);
 
-        String json = MAPPER.writeValueAsString(input);
-
-        assertEquals(aposToQuotes("{'property':55,'map':{'6':88,'12':45}}"), json);
+        assertEquals(aposToQuotes("{'property':55,'map':{'12':45,'6':88}}"), json);
 
         Map1540Implementation result = MAPPER.readValue(json, Map1540Implementation.class);
         assertEquals(result.property, input.property);
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/introspect/IsGetterRenaming2527Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/introspect/IsGetterRenaming2527Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/introspect/IsGetterRenaming2527Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/introspect/IsGetterRenaming2527Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,111 @@
+package com.fasterxml.jackson.databind.introspect;
+
+import java.util.Collections;
+import java.util.Map;
+
+import com.fasterxml.jackson.annotation.JsonProperty;
+import com.fasterxml.jackson.databind.*;
+import com.fasterxml.jackson.databind.cfg.MapperConfig;
+import com.fasterxml.jackson.databind.introspect.AnnotatedField;
+import com.fasterxml.jackson.databind.introspect.JacksonAnnotationIntrospector;
+import com.fasterxml.jackson.databind.util.BeanUtil;
+
+// [databind#2527] Support Kotlin-style "is" properties
+public class IsGetterRenaming2527Test extends BaseMapTest
+{
+    static class POJO2527 {
+        private boolean isEnabled;
+
+        protected POJO2527() { }
+        public POJO2527(boolean b) {
+            isEnabled = b;
+        }
+
+        public boolean getEnabled() { return isEnabled; }
+        public void setEnabled(boolean b) { isEnabled = b; }
+    }
+
+    static class POJO2527PublicField {
+        public boolean isEnabled;
+
+        protected POJO2527PublicField() { }
+        public POJO2527PublicField(boolean b) {
+            isEnabled = b;
+        }
+
+        public boolean getEnabled() { return isEnabled; }
+        public void setEnabled(boolean b) { isEnabled = b; }
+    }
+
+    static class POJO2527Creator {
+        private final boolean isEnabled;
+
+        public POJO2527Creator(@JsonProperty("enabled") boolean b) {
+            isEnabled = b;
+        }
+
+        public boolean getEnabled() { return isEnabled; }
+    }
+
+    @SuppressWarnings("serial")
+    static class MyIntrospector extends JacksonAnnotationIntrospector
+    {
+        @Override
+        public PropertyName findRenameByField(MapperConfig<?> config,
+                AnnotatedField f, PropertyName implName)
+        {
+            final String origSimple = implName.getSimpleName();
+            if (origSimple.startsWith("is")) {
+                String mangledName = BeanUtil.stdManglePropertyName(origSimple, 2);
+                // Needs to be valid ("is" -> null), and different from original
+                if ((mangledName != null) && !mangledName.equals(origSimple)) {
+                    return PropertyName.construct(mangledName);
+                }
+            }
+            return null;
+        }
+    }
+    
+    private final ObjectMapper MAPPER = jsonMapperBuilder()
+            .annotationIntrospector(new MyIntrospector())
+            .build();
+
+    public void testIsPropertiesStdKotlin() throws Exception
+    {
+        POJO2527 input = new POJO2527(true);
+        final String json = MAPPER.writeValueAsString(input);
+
+        Map<?, ?> props = MAPPER.readValue(json, Map.class);
+        assertEquals(Collections.singletonMap("isEnabled", Boolean.TRUE),
+                props);
+        
+        POJO2527 output = MAPPER.readValue(json, POJO2527.class);
+        assertEquals(input.isEnabled, output.isEnabled);
+    }
+
+    public void testIsPropertiesWithPublicField() throws Exception
+    {
+        POJO2527PublicField input = new POJO2527PublicField(true);
+        final String json = MAPPER.writeValueAsString(input);
+
+        Map<?, ?> props = MAPPER.readValue(json, Map.class);
+        assertEquals(Collections.singletonMap("isEnabled", Boolean.TRUE),
+                props);
+        
+        POJO2527PublicField output = MAPPER.readValue(json, POJO2527PublicField.class);
+        assertEquals(input.isEnabled, output.isEnabled);
+    }
+
+    public void testIsPropertiesViaCreator() throws Exception
+    {
+        POJO2527Creator input = new POJO2527Creator(true);
+        final String json = MAPPER.writeValueAsString(input);
+
+        Map<?, ?> props = MAPPER.readValue(json, Map.class);
+        assertEquals(Collections.singletonMap("isEnabled", Boolean.TRUE),
+                props);
+        
+        POJO2527Creator output = MAPPER.readValue(json, POJO2527Creator.class);
+        assertEquals(input.isEnabled, output.isEnabled);
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsonschema/TestReadJsonSchema.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsonschema/TestReadJsonSchema.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsonschema/TestReadJsonSchema.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsonschema/TestReadJsonSchema.java	2020-06-25 02:44:21.000000000 +0000
@@ -3,12 +3,10 @@ package com.fasterxml.jackson.databind.j
 import java.util.*;
 
 import com.fasterxml.jackson.databind.*;
-import com.fasterxml.jackson.databind.jsonschema.JsonSchema;
 
 /**
  * Trivial test to ensure <code>JsonSchema</code> can be also deserialized
  */
-@SuppressWarnings("deprecation")
 public class TestReadJsonSchema
     extends com.fasterxml.jackson.databind.BaseMapTest
 {
@@ -48,6 +46,7 @@ public class TestReadJsonSchema
      * Verifies that a simple schema that is serialized can be
      * deserialized back to equal schema instance
      */
+    @SuppressWarnings("deprecation")
     public void testDeserializeSimple() throws Exception
     {
         ObjectMapper mapper = new ObjectMapper();
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/deftyping/DefaultTypeResolver2472Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/deftyping/DefaultTypeResolver2472Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/deftyping/DefaultTypeResolver2472Test.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/deftyping/DefaultTypeResolver2472Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -20,8 +20,9 @@ public class DefaultTypeResolver2472Test
         legacyTyper.init(JsonTypeInfo.Id.CLASS, null);
         legacyTyper.inclusion(JsonTypeInfo.As.PROPERTY);
 
-        final ObjectMapper mapper = JsonMapper.builder().build();
-        mapper.setDefaultTyping(legacyTyper);
+        final ObjectMapper mapper = JsonMapper.builder()
+                .setDefaultTyping(legacyTyper)
+                .build();
 
         String json = mapper.writeValueAsString(Arrays.asList("foo"));
         assertNotNull(json);
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/deftyping/DefaultTypeResolverForLong2753Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/deftyping/DefaultTypeResolverForLong2753Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/deftyping/DefaultTypeResolverForLong2753Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/deftyping/DefaultTypeResolverForLong2753Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,62 @@
+package com.fasterxml.jackson.databind.jsontype.deftyping;
+
+import java.util.HashMap;
+import java.util.Map;
+
+import com.fasterxml.jackson.annotation.*;
+
+import com.fasterxml.jackson.databind.*;
+import com.fasterxml.jackson.databind.annotation.JsonTypeResolver;
+import com.fasterxml.jackson.databind.cfg.MapperConfig;
+import com.fasterxml.jackson.databind.jsontype.impl.StdTypeResolverBuilder;
+
+public class DefaultTypeResolverForLong2753Test extends BaseMapTest
+{
+    static class Data {
+        private Long key;
+
+        @JsonCreator
+        private Data(@JsonProperty("key") Long key) {
+            this.key = key;
+        }
+
+        @JsonTypeInfo(use = JsonTypeInfo.Id.CLASS, include = JsonTypeInfo.As.PROPERTY, property = "@class")
+        @JsonTypeResolver(MyTypeResolverBuilder.class)
+        public long key() {
+            return key;
+        }
+    }
+
+    static class MyTypeResolverBuilder extends StdTypeResolverBuilder {
+        @Override
+        protected boolean allowPrimitiveTypes(MapperConfig<?> config,
+                JavaType baseType) {
+            return true;
+        }
+    }
+    
+    public void testDefaultTypingWithLong() throws Exception
+    {
+        Data data = new Data(1L);
+        Map<String, Object> mapData = new HashMap<>();
+        mapData.put("longInMap", 2L);
+        mapData.put("longAsField", data);
+
+        // Configure Jackson to preserve types
+//        StdTypeResolverBuilder resolver = new MyTypeResolverBuilder();
+//        resolver.init(JsonTypeInfo.Id.CLASS, null);
+//        resolver.inclusion(JsonTypeInfo.As.PROPERTY);
+//        resolver.typeProperty("__t");
+        ObjectMapper mapper = jsonMapperBuilder()
+//                .setDefaultTyping(resolver)
+                .enable(SerializationFeature.INDENT_OUTPUT)
+                .build();
+
+        // Serialize
+        String json = mapper.writeValueAsString(mapData);
+//System.err.println("JSON:\n"+json);
+        Map<?,?> result = mapper.readValue(json, Map.class);
+        assertNotNull(result);
+        assertEquals(2, result.size());
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/deftyping/TestDefaultForScalars.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/deftyping/TestDefaultForScalars.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/deftyping/TestDefaultForScalars.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/deftyping/TestDefaultForScalars.java	2020-06-25 02:44:21.000000000 +0000
@@ -128,13 +128,14 @@ public class TestDefaultForScalars
         mapData.put("longAsField", data);
 
         // Configure Jackson to preserve types
-        ObjectMapper mapper = new ObjectMapper();
         StdTypeResolverBuilder resolver = new StdTypeResolverBuilder();
         resolver.init(JsonTypeInfo.Id.CLASS, null);
         resolver.inclusion(JsonTypeInfo.As.PROPERTY);
         resolver.typeProperty("__t");
-        mapper.setDefaultTyping(resolver);
-        mapper.enable(SerializationFeature.INDENT_OUTPUT);
+        ObjectMapper mapper = jsonMapperBuilder()
+                .setDefaultTyping(resolver)
+                .enable(SerializationFeature.INDENT_OUTPUT)
+                .build();
 
         // Serialize
         String json = mapper.writeValueAsString(mapData);
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeCustomResolverTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeCustomResolverTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeCustomResolverTest.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeCustomResolverTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,446 @@
+package com.fasterxml.jackson.databind.jsontype.ext;
+
+import java.util.UUID;
+
+import com.fasterxml.jackson.annotation.JsonPropertyOrder;
+import com.fasterxml.jackson.annotation.JsonTypeInfo;
+import com.fasterxml.jackson.annotation.JsonTypeInfo.Id;
+
+import com.fasterxml.jackson.databind.*;
+
+import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
+import com.fasterxml.jackson.databind.annotation.JsonPOJOBuilder;
+import com.fasterxml.jackson.databind.annotation.JsonTypeIdResolver;
+import com.fasterxml.jackson.databind.jsontype.impl.TypeIdResolverBase;
+
+@SuppressWarnings("hiding")
+public class ExternalTypeCustomResolverTest extends BaseMapTest
+{
+    // [databind#1288]
+    public static class ClassesWithoutBuilder {
+        
+        public static class CreditCardDetails implements PaymentDetails {
+            
+            protected String cardHolderFirstName;
+            protected String cardHolderLastName;
+            protected String number;
+            protected String expiryDate;
+            protected int csc;
+            protected String address;
+            protected String zipCode;
+            protected String city;
+            protected String province;
+            
+            protected String countryCode;
+            
+            protected String description;
+
+            public void setCardHolderFirstName(String cardHolderFirstName) {
+                this.cardHolderFirstName = cardHolderFirstName;
+            }
+
+            public void setCardHolderLastName(String cardHolderLastName) {
+                this.cardHolderLastName = cardHolderLastName;
+            }
+
+            public void setNumber(String number) {
+                this.number = number;
+            }
+
+            public void setExpiryDate(String expiryDate) {
+                this.expiryDate = expiryDate;
+            }
+
+            public void setCsc(int csc) {
+                this.csc = csc;
+            }
+
+            public void setAddress(String address) {
+                this.address = address;
+            }
+
+            public void setZipCode(String zipCode) {
+                this.zipCode = zipCode;
+            }
+
+            public void setCity(String city) {
+                this.city = city;
+            }
+
+            public void setProvince(String province) {
+                this.province = province;
+            }
+
+            public void setCountryCode(String countryCode) {
+                this.countryCode = countryCode;
+            }
+
+            public void setDescription(String description) {
+                this.description = description;
+            }
+            
+            
+        }
+        
+        public static class EncryptedCreditCardDetails implements PaymentDetails {
+            
+            protected UUID paymentInstrumentID;
+            
+            protected String name;
+
+            public void setPaymentInstrumentID(UUID paymentInstrumentID) {
+                this.paymentInstrumentID = paymentInstrumentID;
+            }
+
+            public void setName (String name) {
+                this.name = name;
+            }
+
+        }
+        
+        public enum FormOfPayment {
+            INDIVIDUAL_CREDIT_CARD (CreditCardDetails.class), COMPANY_CREDIT_CARD (
+                    CreditCardDetails.class), INSTRUMENTED_CREDIT_CARD (EncryptedCreditCardDetails.class);
+            
+            private final Class<? extends PaymentDetails> clazz;
+            
+            FormOfPayment(final Class<? extends PaymentDetails> clazz) {
+                this.clazz = clazz;
+            }
+            
+            @SuppressWarnings("unchecked")
+            public <T extends PaymentDetails> Class<T> getDetailsClass () {
+                return (Class<T>) this.clazz;
+            }
+            
+            public static FormOfPayment fromDetailsClass(Class<PaymentDetails> detailsClass) {
+                for (FormOfPayment fop : FormOfPayment.values ()) {
+                    if (fop.clazz == detailsClass) {
+                        return fop;
+                    }
+                }
+                throw new IllegalArgumentException("not found");
+            }
+        }
+        
+        public interface PaymentDetails {
+            public interface Builder {
+                PaymentDetails build();
+            }
+        }
+        
+        public static class PaymentMean {
+            
+            FormOfPayment formOfPayment;
+            
+            PaymentDetails paymentDetails;
+
+            public void setFormOfPayment(FormOfPayment formOfPayment) {
+                this.formOfPayment = formOfPayment;
+            }
+
+            @JsonTypeInfo(use = JsonTypeInfo.Id.CUSTOM, include = JsonTypeInfo.As.EXTERNAL_PROPERTY, property = "form_of_payment", visible = true)
+            @JsonTypeIdResolver(PaymentDetailsTypeIdResolver.class)
+            public void setPaymentDetails(PaymentDetails paymentDetails) {
+                this.paymentDetails = paymentDetails;
+            }
+        }
+        
+        public static class PaymentDetailsTypeIdResolver extends TypeIdResolverBase {
+            @SuppressWarnings("unchecked")
+            @Override
+            public String idFromValue (Object value) {
+                if (! (value instanceof PaymentDetails)) {
+                    return null;
+                }
+                return FormOfPayment.fromDetailsClass ((Class<PaymentDetails>) value.getClass ()).name ();
+            }
+            
+            @Override
+            public String idFromValueAndType (Object value, Class<?> suggestedType) {
+                return this.idFromValue (value);
+            }
+
+            @Override
+            public JavaType typeFromId (DatabindContext context, String id) {
+                return context.getTypeFactory().constructType(FormOfPayment.valueOf(id).getDetailsClass ());
+            }
+
+            @Override
+            public String getDescForKnownTypeIds () {
+                return "PaymentDetails";
+            }
+            
+            @Override
+            public Id getMechanism () {
+                return JsonTypeInfo.Id.CUSTOM;
+            }
+        }
+    }
+    
+    public static class ClassesWithBuilder {
+        
+        @JsonDeserialize (builder = CreditCardDetails.IndividualCreditCardDetailsBuilder.class)
+        public static class CreditCardDetails implements PaymentDetails {
+            @JsonPOJOBuilder(withPrefix = "")
+            public static class CompanyCreditCardDetailsBuilder implements Builder {
+                private String cardHolderFirstName;
+                private String cardHolderLastName;
+                private String number;
+                private int csc;
+                
+                @Override
+                public CreditCardDetails build() {
+                    return new CreditCardDetails (cardHolderFirstName, cardHolderLastName, number, csc,
+                            "COMPANY CREDIT CARD");
+                }
+                
+                public CompanyCreditCardDetailsBuilder cardHolderFirstName(final String cardHolderFirstName) {
+                    this.cardHolderFirstName = cardHolderFirstName;
+                    return this;
+                }
+                
+                public CompanyCreditCardDetailsBuilder cardHolderLastName(final String cardHolderLastName) {
+                    this.cardHolderLastName = cardHolderLastName;
+                    return this;
+                }
+                
+                public CompanyCreditCardDetailsBuilder csc(final int csc) {
+                    this.csc = csc;
+                    return this;
+                }
+                
+                public CompanyCreditCardDetailsBuilder number(final String number) {
+                    this.number = number;
+                    return this;
+                }
+            }
+            
+            @JsonPOJOBuilder (withPrefix = "")
+            public static class IndividualCreditCardDetailsBuilder implements Builder {
+                private String cardHolderFirstName;
+                private String cardHolderLastName;
+                private String number;
+                private int    csc;
+                private String description;
+
+                @Override
+                public CreditCardDetails build () {
+                    return new CreditCardDetails(cardHolderFirstName, cardHolderLastName, number, csc,
+                            description);
+                }
+                
+                public IndividualCreditCardDetailsBuilder cardHolderFirstName(final String cardHolderFirstName) {
+                    this.cardHolderFirstName = cardHolderFirstName;
+                    return this;
+                }
+                
+                public IndividualCreditCardDetailsBuilder cardHolderLastName(final String cardHolderLastName) {
+                    this.cardHolderLastName = cardHolderLastName;
+                    return this;
+                }
+
+                public IndividualCreditCardDetailsBuilder csc (final int csc) {
+                    this.csc = csc;
+                    return this;
+                }
+                
+                public IndividualCreditCardDetailsBuilder description (final String description) {
+                    this.description = description;
+                    return this;
+                }
+
+                public IndividualCreditCardDetailsBuilder number (final String number) {
+                    this.number = number;
+                    return this;
+                }
+            }
+            
+            protected final String cardHolderFirstName;
+            protected final String cardHolderLastName;
+            protected final String number;
+            protected final int    csc;
+            
+            protected final String description;
+            
+            public CreditCardDetails (final String cardHolderFirstName, final String cardHolderLastName,
+                    final String number, final int csc,
+                    final String description) {
+                super();
+                this.cardHolderFirstName = cardHolderFirstName;
+                this.cardHolderLastName = cardHolderLastName;
+                this.number = number;
+                this.csc = csc;
+                this.description = description;
+            }
+        }
+        
+        @JsonDeserialize (builder = EncryptedCreditCardDetails.InstrumentedCreditCardBuilder.class)
+        public static class EncryptedCreditCardDetails implements PaymentDetails {
+            @JsonPOJOBuilder (withPrefix = "")
+            public static class InstrumentedCreditCardBuilder implements Builder {
+                private UUID   paymentInstrumentID;
+                private String name;
+                
+                @Override
+                public EncryptedCreditCardDetails build () {
+                    return new EncryptedCreditCardDetails (this.paymentInstrumentID, this.name);
+                }
+                
+                public InstrumentedCreditCardBuilder name (final String name) {
+                    this.name = name;
+                    return this;
+                }
+                
+                public InstrumentedCreditCardBuilder paymentInstrumentID (final UUID paymentInstrumentID) {
+                    this.paymentInstrumentID = paymentInstrumentID;
+                    return this;
+                }
+            }
+
+            protected final UUID paymentInstrumentID;
+            protected final String name;
+
+            private EncryptedCreditCardDetails (final UUID paymentInstrumentID, final String name) {
+                super ();
+                this.paymentInstrumentID = paymentInstrumentID;
+                this.name = name;
+            }
+        }
+        
+        public enum FormOfPayment {
+            INDIVIDUAL_CREDIT_CARD (CreditCardDetails.IndividualCreditCardDetailsBuilder.class), COMPANY_CREDIT_CARD (
+                    CreditCardDetails.CompanyCreditCardDetailsBuilder.class), INSTRUMENTED_CREDIT_CARD (EncryptedCreditCardDetails.InstrumentedCreditCardBuilder.class);
+            
+            private final Class<? extends PaymentDetails.Builder> builderClass;
+            
+            FormOfPayment(final Class<? extends PaymentDetails.Builder> builderClass) {
+                this.builderClass = builderClass;
+            }
+            
+            @SuppressWarnings ("unchecked")
+            public <T extends PaymentDetails> Class<T> getDetailsClass() {
+                return (Class<T>) this.builderClass.getEnclosingClass();
+            }
+            
+            public static FormOfPayment fromDetailsClass(Class<PaymentDetails> detailsClass) {
+                for (FormOfPayment fop : FormOfPayment.values()) {
+                    if (fop.builderClass.getEnclosingClass() == detailsClass) {
+                        return fop;
+                    }
+                }
+                throw new IllegalArgumentException("not found");
+            }
+        }
+        
+        public interface PaymentDetails {
+            public interface Builder {
+                PaymentDetails build();
+            }
+        }
+        
+        @JsonDeserialize(builder = PaymentMean.Builder.class)
+        public static class PaymentMean {
+            @JsonPOJOBuilder(withPrefix = "")
+            @JsonPropertyOrder({ "form_of_payment", "payment_details" })
+            public static class Builder {
+                private FormOfPayment  formOfPayment;
+                private PaymentDetails paymentDetails;
+                
+                public PaymentMean build () {
+                    return new PaymentMean (this.formOfPayment, this.paymentDetails);
+                }
+                
+                // if you annotate with @JsonIgnore, it works, but the value
+                // disappears in the constructor
+                public Builder formOfPayment (final FormOfPayment val) {
+                    this.formOfPayment = val;
+                    return this;
+                }
+
+                @JsonTypeInfo (use = JsonTypeInfo.Id.CUSTOM, include = JsonTypeInfo.As.EXTERNAL_PROPERTY, property = "form_of_payment", visible = true)
+                @JsonTypeIdResolver (PaymentDetailsTypeIdResolver.class)
+                public Builder paymentDetails (final PaymentDetails val) {
+                    this.paymentDetails = val;
+                    return this;
+                }
+            }
+            
+            public static Builder create() {
+                return new Builder();
+            }
+
+            protected final FormOfPayment  formOfPayment;
+            protected final PaymentDetails paymentDetails;
+
+            private PaymentMean (final FormOfPayment formOfPayment, final PaymentDetails paymentDetails) {
+                super ();
+                this.formOfPayment = formOfPayment;
+                this.paymentDetails = paymentDetails;
+            }
+        }
+        
+        public static class PaymentDetailsTypeIdResolver extends TypeIdResolverBase {
+            @SuppressWarnings ("unchecked")
+            @Override
+            public String idFromValue (Object value) {
+                if (! (value instanceof PaymentDetails)) {
+                    return null;
+                }
+                return FormOfPayment.fromDetailsClass ((Class<PaymentDetails>) value.getClass ()).name ();
+            }
+            
+            @Override
+            public String idFromValueAndType (Object value, Class<?> suggestedType) {
+                return this.idFromValue (value);
+            }
+
+            @Override
+            public JavaType typeFromId(DatabindContext context, String id) {
+                return context.getTypeFactory().constructType(FormOfPayment.valueOf (id).getDetailsClass ());
+            }
+            
+            @Override
+            public String getDescForKnownTypeIds() {
+                return "PaymentDetails";
+            }
+            
+            @Override
+            public Id getMechanism() {
+                return JsonTypeInfo.Id.CUSTOM;
+            }
+        }
+    }
+
+    private final ObjectMapper MAPPER = jsonMapperBuilder()
+            .propertyNamingStrategy(PropertyNamingStrategy.SNAKE_CASE)
+            .build();
+
+    // [databind#1288]
+    public void testExternalWithCustomResolver() throws Exception
+    {
+        // given
+        final String asJson1 = aposToQuotes(
+"{'form_of_payment':'INDIVIDUAL_CREDIT_CARD', 'payment_details':{'card_holder_first_name':'John',\n"
++"'card_holder_last_name':'Doe',  'number':'XXXXXXXXXXXXXXXX', 'expiry_date':'MM/YY',\n"
++ "'csc':666,'address':'10 boulevard de Sebastopol','zip_code':'75001','city':'Paris',\n"
++"'province':'Ile-de-France','country_code':'FR','description':'John Doe personal credit card'}}"
+        );
+        ClassesWithoutBuilder.PaymentMean ob1 = MAPPER.readValue(asJson1, ClassesWithoutBuilder.PaymentMean.class);
+        assertNotNull(ob1);
+    }
+
+    // [databind#1288]
+    public void testExternalWithCustomResolverAndBuilder() throws Exception
+    {
+        final String asJson2 = aposToQuotes(
+"{'form_of_payment':'INSTRUMENTED_CREDIT_CARD',\n"
++"'payment_details':{\n"
++"'payment_instrument_id':'00000000-0000-0000-0000-000000000000',\n"
++" 'name':'Mr John Doe encrypted credit card'}}"
+        );
+
+        ClassesWithBuilder.PaymentMean ob2 = MAPPER.readValue(asJson2, ClassesWithBuilder.PaymentMean.class);
+        assertNotNull(ob2);
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeId1198Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeId1198Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeId1198Test.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeId1198Test.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,71 +0,0 @@
-package com.fasterxml.jackson.databind.jsontype.ext;
-
-import com.fasterxml.jackson.annotation.JsonCreator;
-import com.fasterxml.jackson.annotation.JsonSubTypes;
-import com.fasterxml.jackson.annotation.JsonTypeInfo;
-
-import com.fasterxml.jackson.databind.*;
-
-// [databind#1198]
-public class ExternalTypeId1198Test extends BaseMapTest
-{
-    public enum Attacks { KICK, PUNCH }
-
-    static class Character {
-        public String name;
-        public Attacks preferredAttack;
-
-        @JsonTypeInfo(use=JsonTypeInfo.Id.NAME, defaultImpl=Kick.class,
-                include=JsonTypeInfo.As.EXTERNAL_PROPERTY, property="preferredAttack")
-        @JsonSubTypes({
-            @JsonSubTypes.Type(value=Kick.class, name="KICK"),
-            @JsonSubTypes.Type(value=Punch.class, name="PUNCH")
-        })
-        public Attack attack;
-    }
-
-    public static abstract class Attack {
-        public String side;
-
-        @JsonCreator
-        public Attack(String side) {
-            this.side = side;
-        }
-    }
-
-    public static class Kick extends Attack {
-        @JsonCreator
-        public Kick(String side) {
-            super(side);
-        }
-    }
-
-    public static class Punch extends Attack {
-        @JsonCreator
-        public Punch(String side) {
-            super(side);
-        }
-    }
-
-    final ObjectMapper MAPPER = new ObjectMapper();
-
-    public void testFails() throws Exception {
-        String json = "{ \"name\": \"foo\", \"attack\":\"right\" } }";
-
-        Character character = MAPPER.readValue(json, Character.class);
-
-        assertNotNull(character);
-        assertNotNull(character.attack);
-        assertEquals("foo", character.name);
-    }
-
-    public void testWorks() throws Exception {
-        String json = "{ \"name\": \"foo\", \"preferredAttack\": \"KICK\", \"attack\":\"right\" } }";
-
-        Character character = MAPPER.readValue(json, Character.class);
-
-        assertNotNull(character);
-        assertNotNull(character.attack);
-        assertEquals("foo", character.name);
-    }
-}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeId2588Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeId2588Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeId2588Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeId2588Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,100 @@
+package com.fasterxml.jackson.databind.jsontype.ext;
+
+import com.fasterxml.jackson.annotation.*;
+
+import com.fasterxml.jackson.databind.*;
+import com.fasterxml.jackson.databind.annotation.JsonTypeIdResolver;
+import com.fasterxml.jackson.databind.jsontype.impl.TypeIdResolverBase;
+
+// [databind#2588] / [databind#2610]
+public class ExternalTypeId2588Test extends BaseMapTest
+{
+    // [databind#2588]
+    interface Animal { }
+
+    static class Cat implements Animal { }
+
+    public static class Dog implements Animal { }
+
+    @JsonIgnoreProperties(ignoreUnknown = true)
+    static class Pet {
+        final String type;
+
+        @JsonTypeInfo(use = JsonTypeInfo.Id.NAME,
+                include = JsonTypeInfo.As.EXTERNAL_PROPERTY,
+                property = "type")
+        @JsonTypeIdResolver(AnimalTypeIdResolver.class)
+        private final Animal animal;
+
+        @JsonCreator
+        public Pet(@JsonProperty("type") String type,
+                   @JsonProperty("animal") Animal animal) {
+            this.type = type;
+            this.animal = animal;
+        }
+    }
+
+    static class AnimalTypeIdResolver extends TypeIdResolverBase {
+        @Override
+        public String idFromValue(Object value) {
+            return idFromValueAndType(value, value.getClass());
+        }
+
+        @Override
+        public String idFromValueAndType(Object value, Class<?> suggestedType) {
+            if (suggestedType.isAssignableFrom(Cat.class)) {
+                return "cat";
+            } else if (suggestedType.isAssignableFrom(Dog.class)) {
+                return "dog";
+            }
+            return null;
+        }
+
+        @Override
+        public JavaType typeFromId(DatabindContext context, String id) {
+            if ("cat".equals(id)) {
+                return context.constructType(Cat.class);
+            } else if ("dog".equals(id)) {
+                return context.constructType(Dog.class);
+            }
+            return null;
+        }
+
+        @Override
+        public JsonTypeInfo.Id getMechanism() {
+            return JsonTypeInfo.Id.NAME;
+        }
+    }
+
+    // [databind#2588]
+    public void testExternalTypeId2588() throws Exception
+    {
+        final ObjectMapper mapper = newJsonMapper();
+        Pet pet;
+
+        // works?
+        
+        pet = mapper.readValue(aposToQuotes(
+"{\n" + 
+"  'type': 'cat',\n" + 
+"  'animal': { },\n" + 
+"  'ignoredObject\": {\n" + 
+"    'someField': 'someValue'\n" + 
+"  }"+
+"}"
+                ), Pet.class);
+        assertNotNull(pet);
+        
+        // fails:
+        pet = mapper.readValue(aposToQuotes(
+"{\n" + 
+"  'animal\": { },\n" + 
+"  'ignoredObject': {\n" + 
+"    'someField': 'someValue'\n" + 
+"  },\n" + 
+"  'type': 'cat'\n" + 
+"}"
+                ), Pet.class);
+        assertNotNull(pet);
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeId999Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeId999Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeId999Test.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeId999Test.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,55 +0,0 @@
-package com.fasterxml.jackson.databind.jsontype.ext;
-
-import com.fasterxml.jackson.annotation.*;
-import com.fasterxml.jackson.core.type.TypeReference;
-import com.fasterxml.jackson.databind.*;
-
-public class ExternalTypeId999Test extends BaseMapTest
-{
-    public static interface Payload { }
-
-    @JsonTypeName("foo")
-    public static class FooPayload implements Payload { }
-
-    @JsonTypeName("bar")
-    public static class BarPayload implements Payload { }
-
-    public static class Message<P extends Payload>
-    {
-        final String type;
-
-        @JsonTypeInfo(use = JsonTypeInfo.Id.NAME,
-                visible = true,
-                include = JsonTypeInfo.As.EXTERNAL_PROPERTY, property = "type")
-        @JsonSubTypes({
-                @JsonSubTypes.Type(FooPayload.class),
-                @JsonSubTypes.Type(BarPayload.class) })
-        private final P payload;
-
-        @JsonCreator
-        public Message(@JsonProperty("type") String type,
-                @JsonProperty("payload") P payload)
-        {
-            this.type = type;
-            this.payload = payload;
-        }
-    }
-
-    private final ObjectMapper MAPPER = objectMapper();
-
-    public void testExternalTypeId() throws Exception
-    {
-        TypeReference<Message<FooPayload>> type = new TypeReference<Message<FooPayload>>() { };
-
-        Message<?> msg = MAPPER.readValue(aposToQuotes("{ 'type':'foo', 'payload': {} }"), type);
-        assertNotNull(msg);
-        assertNotNull(msg.payload);
-        assertEquals("foo", msg.type);
-
-        // and then with different order
-        msg = MAPPER.readValue(aposToQuotes("{'payload': {}, 'type':'foo' }"), type);
-        assertNotNull(msg);
-        assertNotNull(msg.payload);
-        assertEquals("foo", msg.type);
-    }
-}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeIdTest1288.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeIdTest1288.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeIdTest1288.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeIdTest1288.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,513 +0,0 @@
-package com.fasterxml.jackson.databind.jsontype.ext;
-
-import java.util.UUID;
-
-import com.fasterxml.jackson.annotation.JsonPropertyOrder;
-import com.fasterxml.jackson.annotation.JsonTypeInfo;
-import com.fasterxml.jackson.annotation.JsonTypeInfo.Id;
-
-import com.fasterxml.jackson.databind.*;
-import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
-import com.fasterxml.jackson.databind.annotation.JsonPOJOBuilder;
-import com.fasterxml.jackson.databind.annotation.JsonTypeIdResolver;
-import com.fasterxml.jackson.databind.jsontype.impl.TypeIdResolverBase;
-
-@SuppressWarnings("hiding")
-public class ExternalTypeIdTest1288 extends BaseMapTest
-{
-    public static class ClassesWithoutBuilder {
-        
-        public static class CreditCardDetails implements PaymentDetails {
-            
-            protected String cardHolderFirstName;
-            protected String cardHolderLastName;
-            protected String number;
-            protected String expiryDate;
-            protected int csc;
-            protected String address;
-            protected String zipCode;
-            protected String city;
-            protected String province;
-            
-            protected String countryCode;
-            
-            protected String description;
-
-            public void setCardHolderFirstName (String cardHolderFirstName) {
-                this.cardHolderFirstName = cardHolderFirstName;
-            }
-
-            public void setCardHolderLastName (String cardHolderLastName) {
-                this.cardHolderLastName = cardHolderLastName;
-            }
-
-            public void setNumber (String number) {
-                this.number = number;
-            }
-
-            public void setExpiryDate (String expiryDate) {
-                this.expiryDate = expiryDate;
-            }
-
-            public void setCsc (int csc) {
-                this.csc = csc;
-            }
-
-            public void setAddress (String address) {
-                this.address = address;
-            }
-
-            public void setZipCode (String zipCode) {
-                this.zipCode = zipCode;
-            }
-
-            public void setCity (String city) {
-                this.city = city;
-            }
-
-            public void setProvince (String province) {
-                this.province = province;
-            }
-
-            public void setCountryCode (String countryCode) {
-                this.countryCode = countryCode;
-            }
-
-            public void setDescription (String description) {
-                this.description = description;
-            }
-            
-            
-        }
-        
-        public static class EncryptedCreditCardDetails implements PaymentDetails {
-            
-            protected UUID paymentInstrumentID;
-            
-            protected String name;
-
-            public void setPaymentInstrumentID (UUID paymentInstrumentID) {
-                this.paymentInstrumentID = paymentInstrumentID;
-            }
-
-            public void setName (String name) {
-                this.name = name;
-            }
-
-        }
-        
-        public enum FormOfPayment {
-            INDIVIDUAL_CREDIT_CARD (CreditCardDetails.class), COMPANY_CREDIT_CARD (
-                    CreditCardDetails.class), INSTRUMENTED_CREDIT_CARD (EncryptedCreditCardDetails.class);
-            
-            private final Class<? extends PaymentDetails> clazz;
-            
-            FormOfPayment (final Class<? extends PaymentDetails> clazz) {
-                this.clazz = clazz;
-            }
-            
-            @SuppressWarnings ("unchecked")
-            public <T extends PaymentDetails> Class<T> getDetailsClass () {
-                return (Class<T>) this.clazz;
-            }
-            
-            public static FormOfPayment fromDetailsClass (Class<PaymentDetails> detailsClass) {
-                for (FormOfPayment fop : FormOfPayment.values ()) {
-                    if (fop.clazz == detailsClass) {
-                        return fop;
-                    }
-                }
-                throw new IllegalArgumentException ("not found");
-            }
-        }
-        
-        public interface PaymentDetails {
-            public interface Builder {
-                PaymentDetails build ();
-            }
-        }
-        
-        public static class PaymentMean {
-            
-            FormOfPayment formOfPayment;
-            
-            PaymentDetails paymentDetails;
-
-            public void setFormOfPayment (FormOfPayment formOfPayment) {
-                this.formOfPayment = formOfPayment;
-            }
-
-            @JsonTypeInfo (use = JsonTypeInfo.Id.CUSTOM, include = JsonTypeInfo.As.EXTERNAL_PROPERTY, property = "form_of_payment", visible = true)
-            @JsonTypeIdResolver (PaymentDetailsTypeIdResolver.class)
-            public void setPaymentDetails (PaymentDetails paymentDetails) {
-                this.paymentDetails = paymentDetails;
-            }
-            
-        }
-        
-        public static class PaymentDetailsTypeIdResolver extends TypeIdResolverBase {
-            @SuppressWarnings ("unchecked")
-            @Override
-            public String idFromValue (Object value) {
-                if (! (value instanceof PaymentDetails)) {
-                    return null;
-                }
-                return FormOfPayment.fromDetailsClass ((Class<PaymentDetails>) value.getClass ()).name ();
-            }
-            
-            @Override
-            public String idFromValueAndType (Object value, Class<?> suggestedType) {
-                return this.idFromValue (value);
-            }
-
-            @Override
-            public JavaType typeFromId (DatabindContext context, String id) {
-                return context.getTypeFactory().constructType(FormOfPayment.valueOf(id).getDetailsClass ());
-            }
-
-            @Override
-            public String getDescForKnownTypeIds () {
-                return "PaymentDetails";
-            }
-            
-            @Override
-            public Id getMechanism () {
-                return JsonTypeInfo.Id.CUSTOM;
-            }
-        }
-    }
-    
-    public static class ClassesWithBuilder {
-        
-        @JsonDeserialize (builder = CreditCardDetails.IndividualCreditCardDetailsBuilder.class)
-        public static class CreditCardDetails implements PaymentDetails {
-            @JsonPOJOBuilder (withPrefix = "")
-            public static class CompanyCreditCardDetailsBuilder implements Builder {
-                private String cardHolderFirstName;
-                private String cardHolderLastName;
-                private String number;
-                private String expiryDate;
-                private int csc;
-                private String address;
-                private String zipCode;
-                private String city;
-                private String province;
-                private String countryCode;
-                
-                public CompanyCreditCardDetailsBuilder address (final String a) {
-                    address = a;
-                    return this;
-                }
-                
-                @Override
-                public CreditCardDetails build() {
-                    return new CreditCardDetails (this.cardHolderFirstName, this.cardHolderLastName, this.number, this.expiryDate, this.csc, this.address, this.zipCode, this.city,
-                            this.province, this.countryCode, "COMPANY CREDIT CARD");
-                }
-                
-                public CompanyCreditCardDetailsBuilder cardHolderFirstName(final String cardHolderFirstName) {
-                    this.cardHolderFirstName = cardHolderFirstName;
-                    return this;
-                }
-                
-                public CompanyCreditCardDetailsBuilder cardHolderLastName (final String cardHolderLastName) {
-                    this.cardHolderLastName = cardHolderLastName;
-                    return this;
-                }
-                
-                public CompanyCreditCardDetailsBuilder city (final String city) {
-                    this.city = city;
-                    return this;
-                }
-                
-                public CompanyCreditCardDetailsBuilder countryCode (final String countryCode) {
-                    this.countryCode = countryCode;
-                    return this;
-                }
-                
-                public CompanyCreditCardDetailsBuilder csc (final int csc) {
-                    this.csc = csc;
-                    return this;
-                }
-                
-                public CompanyCreditCardDetailsBuilder expiryDate (final String expiryDate) {
-                    this.expiryDate = expiryDate;
-                    return this;
-                }
-                
-                public CompanyCreditCardDetailsBuilder number (final String number) {
-                    this.number = number;
-                    return this;
-                }
-                
-                public CompanyCreditCardDetailsBuilder province (final String province) {
-                    this.province = province;
-                    return this;
-                }
-                
-                public CompanyCreditCardDetailsBuilder zipCode (final String zipCode) {
-                    this.zipCode = zipCode;
-                    return this;
-                }
-            }
-            
-            @JsonPOJOBuilder (withPrefix = "")
-            public static class IndividualCreditCardDetailsBuilder implements Builder {
-                private String cardHolderFirstName;
-                private String cardHolderLastName;
-                private String number;
-                private String expiryDate;
-                private int    csc;
-                private String address;
-                private String zipCode;
-                private String city;
-                private String province;
-                private String countryCode;
-                private String description;
-                
-                public IndividualCreditCardDetailsBuilder address (final String address) {
-                    this.address = address;
-                    return this;
-                }
-                
-                @Override
-                public CreditCardDetails build () {
-                    return new CreditCardDetails (this.cardHolderFirstName, this.cardHolderLastName, this.number, this.expiryDate, this.csc, this.address, this.zipCode, this.city,
-                            this.province, this.countryCode, this.description);
-                }
-                
-                public IndividualCreditCardDetailsBuilder cardHolderFirstName (final String cardHolderFirstName) {
-                    this.cardHolderFirstName = cardHolderFirstName;
-                    return this;
-                }
-                
-                public IndividualCreditCardDetailsBuilder cardHolderLastName (final String cardHolderLastName) {
-                    this.cardHolderLastName = cardHolderLastName;
-                    return this;
-                }
-                
-                public IndividualCreditCardDetailsBuilder city (final String city) {
-                    this.city = city;
-                    return this;
-                }
-                
-                public IndividualCreditCardDetailsBuilder countryCode (final String countryCode) {
-                    this.countryCode = countryCode;
-                    return this;
-                }
-                
-                public IndividualCreditCardDetailsBuilder csc (final int csc) {
-                    this.csc = csc;
-                    return this;
-                }
-                
-                public IndividualCreditCardDetailsBuilder description (final String description) {
-                    this.description = description;
-                    return this;
-                }
-                
-                public IndividualCreditCardDetailsBuilder expiryDate (final String expiryDate) {
-                    this.expiryDate = expiryDate;
-                    return this;
-                }
-                
-                public IndividualCreditCardDetailsBuilder number (final String number) {
-                    this.number = number;
-                    return this;
-                }
-                
-                public IndividualCreditCardDetailsBuilder province (final String p) {
-                    province = p;
-                    return this;
-                }
-                
-                public IndividualCreditCardDetailsBuilder zipCode (final String z) {
-                    zipCode = z;
-                    return this;
-                }
-                
-            }
-            
-            protected final String cardHolderFirstName;
-            protected final String cardHolderLastName;
-            protected final String number;
-            protected final String expiryDate;
-            protected final int    csc;
-            protected final String address;
-            protected final String zipCode;
-            protected final String city;
-            protected final String province;
-            
-            protected final String countryCode;
-            
-            protected final String description;
-            
-            public CreditCardDetails (final String cardHolderFirstName, final String cardHolderLastName, final String number, final String expiryDate, final int csc,
-                    final String address, final String zipCode, final String city, final String province, final String countryCode, final String description) {
-                super ();
-                this.cardHolderFirstName = cardHolderFirstName;
-                this.cardHolderLastName = cardHolderLastName;
-                this.number = number;
-                this.expiryDate = expiryDate;
-                this.csc = csc;
-                this.address = address;
-                this.zipCode = zipCode;
-                this.city = city;
-                this.province = province;
-                this.countryCode = countryCode;
-                this.description = description;
-            }
-        }
-        
-        @JsonDeserialize (builder = EncryptedCreditCardDetails.InstrumentedCreditCardBuilder.class)
-        public static class EncryptedCreditCardDetails implements PaymentDetails {
-            @JsonPOJOBuilder (withPrefix = "")
-            public static class InstrumentedCreditCardBuilder implements Builder {
-                private UUID   paymentInstrumentID;
-                private String name;
-                
-                @Override
-                public EncryptedCreditCardDetails build () {
-                    return new EncryptedCreditCardDetails (this.paymentInstrumentID, this.name);
-                }
-                
-                public InstrumentedCreditCardBuilder name (final String name) {
-                    this.name = name;
-                    return this;
-                }
-                
-                public InstrumentedCreditCardBuilder paymentInstrumentID (final UUID paymentInstrumentID) {
-                    this.paymentInstrumentID = paymentInstrumentID;
-                    return this;
-                }
-            }
-
-            protected final UUID paymentInstrumentID;
-            protected final String name;
-
-            private EncryptedCreditCardDetails (final UUID paymentInstrumentID, final String name) {
-                super ();
-                this.paymentInstrumentID = paymentInstrumentID;
-                this.name = name;
-            }
-        }
-        
-        public enum FormOfPayment {
-            INDIVIDUAL_CREDIT_CARD (CreditCardDetails.IndividualCreditCardDetailsBuilder.class), COMPANY_CREDIT_CARD (
-                    CreditCardDetails.CompanyCreditCardDetailsBuilder.class), INSTRUMENTED_CREDIT_CARD (EncryptedCreditCardDetails.InstrumentedCreditCardBuilder.class);
-            
-            private final Class<? extends PaymentDetails.Builder> builderClass;
-            
-            FormOfPayment (final Class<? extends PaymentDetails.Builder> builderClass) {
-                this.builderClass = builderClass;
-            }
-            
-            @SuppressWarnings ("unchecked")
-            public <T extends PaymentDetails> Class<T> getDetailsClass () {
-                return (Class<T>) this.builderClass.getEnclosingClass ();
-            }
-            
-            public static FormOfPayment fromDetailsClass (Class<PaymentDetails> detailsClass) {
-                for (FormOfPayment fop : FormOfPayment.values ()) {
-                    if (fop.builderClass.getEnclosingClass () == detailsClass) {
-                        return fop;
-                    }
-                }
-                throw new IllegalArgumentException ("not found");
-            }
-        }
-        
-        public interface PaymentDetails {
-            public interface Builder {
-                PaymentDetails build ();
-            }
-        }
-        
-        @JsonDeserialize (builder = PaymentMean.Builder.class)
-        public static class PaymentMean {
-            
-            @JsonPOJOBuilder (withPrefix = "")
-            @JsonPropertyOrder ({ "form_of_payment", "payment_details" })
-            public static class Builder {
-                private FormOfPayment  formOfPayment;
-                private PaymentDetails paymentDetails;
-                
-                public PaymentMean build () {
-                    return new PaymentMean (this.formOfPayment, this.paymentDetails);
-                }
-                
-                // if you annotate with @JsonIgnore, it works, but the value
-                // disappears in the constructor
-                public Builder formOfPayment (final FormOfPayment val) {
-                    this.formOfPayment = val;
-                    return this;
-                }
-
-                @JsonTypeInfo (use = JsonTypeInfo.Id.CUSTOM, include = JsonTypeInfo.As.EXTERNAL_PROPERTY, property = "form_of_payment", visible = true)
-                @JsonTypeIdResolver (PaymentDetailsTypeIdResolver.class)
-                public Builder paymentDetails (final PaymentDetails val) {
-                    this.paymentDetails = val;
-                    return this;
-                }
-            }
-            
-            public static Builder create() {
-                return new Builder();
-            }
-
-            protected final FormOfPayment  formOfPayment;
-            protected final PaymentDetails paymentDetails;
-
-            private PaymentMean (final FormOfPayment formOfPayment, final PaymentDetails paymentDetails) {
-                super ();
-                this.formOfPayment = formOfPayment;
-                this.paymentDetails = paymentDetails;
-            }
-        }
-        
-        public static class PaymentDetailsTypeIdResolver extends TypeIdResolverBase {
-            @SuppressWarnings ("unchecked")
-            @Override
-            public String idFromValue (Object value) {
-                if (! (value instanceof PaymentDetails)) {
-                    return null;
-                }
-                return FormOfPayment.fromDetailsClass ((Class<PaymentDetails>) value.getClass ()).name ();
-            }
-            
-            @Override
-            public String idFromValueAndType (Object value, Class<?> suggestedType) {
-                return this.idFromValue (value);
-            }
-
-            @Override
-            public JavaType typeFromId (DatabindContext context, String id) {
-                return context.getTypeFactory().constructType(FormOfPayment.valueOf (id).getDetailsClass ());
-            }
-            
-            @Override
-            public String getDescForKnownTypeIds () {
-                return "PaymentDetails";
-            }
-            
-            @Override
-            public Id getMechanism () {
-                return JsonTypeInfo.Id.CUSTOM;
-            }
-        }
-    }
-
-    public void testVisibleExternalTypeId1288() throws Exception
-    {
-        // given
-        final String asJson1 = "{\"form_of_payment\":\"INDIVIDUAL_CREDIT_CARD\", \"payment_details\":{\"card_holder_first_name\":\"John\", \"card_holder_last_name\":\"Doe\",  \"number\":\"XXXXXXXXXXXXXXXX\", \"expiry_date\":\"MM/YY\","
-                + "\"csc\":666,\"address\":\"10 boulevard de Sebastopol\",\"zip_code\":\"75001\",\"city\":\"Paris\",\"province\":\"Ile-de-France\",\"country_code\":\"FR\",\"description\":\"John Doe personal credit card\"}}";
-        final String asJson2 = "{\"form_of_payment\":\"INSTRUMENTED_CREDIT_CARD\",\"payment_details\":{\"payment_instrument_id\":\"00000000-0000-0000-0000-000000000000\", \"name\":\"Mr John Doe encrypted credit card\"}}";
-        final ObjectMapper objectMapper = new ObjectMapper ().setPropertyNamingStrategy (PropertyNamingStrategy.SNAKE_CASE);
-
-        ClassesWithoutBuilder.PaymentMean ob1 = objectMapper.readValue (asJson1, ClassesWithoutBuilder.PaymentMean.class);
-        assertNotNull(ob1);
-        ClassesWithBuilder.PaymentMean ob2 = objectMapper.readValue (asJson2, ClassesWithBuilder.PaymentMean.class);
-        assertNotNull(ob2);
-    }
-}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeIdTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeIdTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeIdTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeIdTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -8,7 +8,9 @@ import com.fasterxml.jackson.annotation.
 import com.fasterxml.jackson.annotation.JsonTypeInfo.Id;
 import com.fasterxml.jackson.databind.BaseMapTest;
 import com.fasterxml.jackson.databind.DeserializationFeature;
+import com.fasterxml.jackson.databind.MapperFeature;
 import com.fasterxml.jackson.databind.ObjectMapper;
+import com.fasterxml.jackson.databind.json.JsonMapper;
 
 // Tests for External type id, one that exists at same level as typed Object,
 // that is, property is not within typed object but a member of its parent.
@@ -486,10 +488,10 @@ public class ExternalTypeIdTest extends
     // for [databind#222]
     public void testExternalTypeWithProp222() throws Exception
     {
-        final ObjectMapper mapper = new ObjectMapper();
+        JsonMapper mapper = JsonMapper.builder().enable(MapperFeature.SORT_PROPERTIES_ALPHABETICALLY).build();
         Issue222Bean input = new Issue222Bean(13);
         String json = mapper.writeValueAsString(input);
-        assertEquals("{\"value\":{\"x\":13},\"type\":\"foo\"}", json);
+        assertEquals("{\"type\":\"foo\",\"value\":{\"x\":13}}", json);
     }
 
     // [databind#928]
@@ -514,7 +516,6 @@ public class ExternalTypeIdTest extends
     // for [databind#965]
     public void testBigDecimal965() throws Exception
     {
-
         Wrapper965 w = new Wrapper965();
         w.typeEnum = Type965.BIG_DECIMAL;
         final String NUM_STR = "-10000000000.0000000001";
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeIdWithCreatorTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeIdWithCreatorTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeIdWithCreatorTest.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeIdWithCreatorTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,126 @@
+package com.fasterxml.jackson.databind.jsontype.ext;
+
+import com.fasterxml.jackson.annotation.*;
+import com.fasterxml.jackson.core.type.TypeReference;
+import com.fasterxml.jackson.databind.*;
+
+public class ExternalTypeIdWithCreatorTest extends BaseMapTest
+{
+    // [databind#1198]
+    
+    public enum Attacks { KICK, PUNCH }
+
+    static class Character {
+        public String name;
+        public Attacks preferredAttack;
+
+        @JsonTypeInfo(use=JsonTypeInfo.Id.NAME, defaultImpl=Kick.class,
+                include=JsonTypeInfo.As.EXTERNAL_PROPERTY, property="preferredAttack")
+        @JsonSubTypes({
+            @JsonSubTypes.Type(value=Kick.class, name="KICK"),
+            @JsonSubTypes.Type(value=Punch.class, name="PUNCH")
+        })
+        public Attack attack;
+    }
+
+    public static abstract class Attack {
+        public String side;
+
+        @JsonCreator
+        public Attack(String side) {
+            this.side = side;
+        }
+    }
+
+    public static class Kick extends Attack {
+        @JsonCreator
+        public Kick(String side) {
+            super(side);
+        }
+    }
+
+    public static class Punch extends Attack {
+        @JsonCreator
+        public Punch(String side) {
+            super(side);
+        }
+    }
+
+    // [databind#999]
+
+    public static interface Payload999 { }
+
+    @JsonTypeName("foo")
+    public static class FooPayload999 implements Payload999 { }
+
+    @JsonTypeName("bar")
+    public static class BarPayload999 implements Payload999 { }
+
+    public static class Message<P extends Payload999>
+    {
+        final String type;
+
+        @JsonTypeInfo(use = JsonTypeInfo.Id.NAME,
+                visible = true,
+                include = JsonTypeInfo.As.EXTERNAL_PROPERTY, property = "type")
+        @JsonSubTypes({
+                @JsonSubTypes.Type(FooPayload999.class),
+                @JsonSubTypes.Type(BarPayload999.class) })
+        private final P payload;
+
+        @JsonCreator
+        public Message(@JsonProperty("type") String type,
+                @JsonProperty("payload") P payload)
+        {
+            this.type = type;
+            this.payload = payload;
+        }
+    }
+    
+    /*
+    /********************************************************************** 
+    /* Test methods
+    /********************************************************************** 
+     */
+
+    private final ObjectMapper MAPPER = new ObjectMapper();
+
+    // [databind#1198]
+    public void testFails() throws Exception {
+        String json = "{ \"name\": \"foo\", \"attack\":\"right\" } }";
+
+        Character character = MAPPER.readValue(json, Character.class);
+
+        assertNotNull(character);
+        assertNotNull(character.attack);
+        assertEquals("foo", character.name);
+    }
+
+    // [databind#1198]
+    public void testWorks() throws Exception {
+        String json = "{ \"name\": \"foo\", \"preferredAttack\": \"KICK\", \"attack\":\"right\" } }";
+
+        Character character = MAPPER.readValue(json, Character.class);
+
+        assertNotNull(character);
+        assertNotNull(character.attack);
+        assertEquals("foo", character.name);
+    }
+
+    // [databind#999]
+    public void testExternalTypeId() throws Exception
+    {
+        TypeReference<Message<FooPayload999>> type = new TypeReference<Message<FooPayload999>>() { };
+
+        Message<?> msg = MAPPER.readValue(aposToQuotes("{ 'type':'foo', 'payload': {} }"), type);
+        assertNotNull(msg);
+        assertNotNull(msg.payload);
+        assertEquals("foo", msg.type);
+
+        // and then with different order
+        msg = MAPPER.readValue(aposToQuotes("{'payload': {}, 'type':'foo' }"), type);
+        assertNotNull(msg);
+        assertNotNull(msg.payload);
+        assertEquals("foo", msg.type);
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeIdWithIgnoreUnknownTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeIdWithIgnoreUnknownTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeIdWithIgnoreUnknownTest.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/ext/ExternalTypeIdWithIgnoreUnknownTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,59 @@
+package com.fasterxml.jackson.databind.jsontype.ext;
+
+import java.util.List;
+
+import com.fasterxml.jackson.annotation.*;
+import com.fasterxml.jackson.core.type.TypeReference;
+import com.fasterxml.jackson.databind.*;
+
+public class ExternalTypeIdWithIgnoreUnknownTest extends BaseMapTest
+{
+    // [databind#2611]
+    @JsonIgnoreProperties(ignoreUnknown = true)
+    static class Wrapper2611 {
+        private String type;
+
+        @JsonTypeInfo(
+                use = JsonTypeInfo.Id.NAME,
+                include = JsonTypeInfo.As.EXTERNAL_PROPERTY,
+                property = "type",
+                defaultImpl = Default2611.class
+        )
+        private Default2611 data;
+
+        @JsonCreator
+        public Wrapper2611(
+                @JsonProperty(value = "type", required = true) String type,
+                @JsonProperty(value = "data", required = true) Default2611 data
+        ) {
+            this.type = type;
+            this.data = data;
+        }
+
+        String getType() {
+            return type;
+        }
+
+        Default2611 getData() {
+            return data;
+        }
+    }
+
+    static class Default2611 {}
+
+    private final ObjectMapper MAPPER = newJsonMapper();
+
+    // [databind#2611]
+    public void testDeserialization() throws Exception
+    {
+        final String data = aposToQuotes("[{'type': 'test','data': {},'additional': {}}]");
+
+        List<Wrapper2611> result = MAPPER.readValue(data, new TypeReference<List<Wrapper2611>>() {});
+
+        assertEquals(1, result.size());
+
+        Wrapper2611 item = result.get(0);
+        assertEquals("test", item.getType());
+        assertNotNull(item.getData());
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/GenericNestedType2331Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/GenericNestedType2331Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/GenericNestedType2331Test.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/GenericNestedType2331Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -29,7 +29,8 @@ public class GenericNestedType2331Test e
             return children;
         }
     }    
-    
+
+    @SuppressWarnings({ "rawtypes", "unchecked" })
     public void testGeneric2331() throws Exception {
         Node root = new Node();
         root.children.add(new Node());
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/JsonTypeInfoCaseInsensitive1983Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/JsonTypeInfoCaseInsensitive1983Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/JsonTypeInfoCaseInsensitive1983Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/JsonTypeInfoCaseInsensitive1983Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,68 @@
+package com.fasterxml.jackson.databind.jsontype;
+
+import com.fasterxml.jackson.annotation.JsonSubTypes;
+import com.fasterxml.jackson.annotation.JsonTypeInfo;
+
+import com.fasterxml.jackson.databind.*;
+import com.fasterxml.jackson.databind.exc.InvalidTypeIdException;
+
+// Tests wrt [databind#1983]
+public class JsonTypeInfoCaseInsensitive1983Test extends BaseMapTest
+{
+    @JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.EXTERNAL_PROPERTY,
+            property = "Operation")
+    @JsonSubTypes({
+            @JsonSubTypes.Type(value = Equal.class, name = "eq"),
+            @JsonSubTypes.Type(value = NotEqual.class, name = "notEq"),
+    })
+    static abstract class Filter {
+    }
+
+    static class Equal extends Filter { }
+
+    static class NotEqual extends Filter { }
+
+    // verify failures when exact matching required:
+    private final ObjectMapper MAPPER = newJsonMapper();
+    
+    public void testReadMixedCaseSubclass() throws Exception
+    {
+        final String serialised = "{\"Operation\":\"NoTeQ\"}";
+
+        // first: mismatch with value unless case-sensitivity disabled:
+        try {
+            MAPPER.readValue(serialised, Filter.class);
+            fail("Should not pass");
+        } catch (InvalidTypeIdException e) {
+            verifyException(e, "Could not resolve type id 'NoTeQ'");
+        }
+
+        ObjectMapper mapper = jsonMapperBuilder()
+                .enable(MapperFeature.ACCEPT_CASE_INSENSITIVE_VALUES)
+                .build();
+        // Type id ("value") mismatch, should work now:
+        Filter result = mapper.readValue(serialised, Filter.class);
+
+        assertEquals(NotEqual.class, result.getClass());
+    }
+
+    public void testReadMixedCasePropertyName() throws Exception
+    {
+        final String serialised = "{\"oPeRaTioN\":\"notEq\"}";
+        // first: mismatch with property name unless case-sensitivity disabled:
+        try {
+            MAPPER.readValue(serialised, Filter.class);
+            fail("Should not pass");
+        } catch (InvalidTypeIdException e) {
+            verifyException(e, "Missing type id when trying to resolve subtype");
+        }
+
+        ObjectMapper mapper = jsonMapperBuilder()
+                .enable(MapperFeature.ACCEPT_CASE_INSENSITIVE_PROPERTIES)
+                .build();
+        // Type property name mismatch (but value match); should work:
+        Filter result = mapper.readValue(serialised, Filter.class);
+
+        assertEquals(NotEqual.class, result.getClass());
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/PolymorphicDeserErrorHandlingTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/PolymorphicDeserErrorHandlingTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/PolymorphicDeserErrorHandlingTest.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/PolymorphicDeserErrorHandlingTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,65 @@
+package com.fasterxml.jackson.databind.jsontype;
+
+import com.fasterxml.jackson.annotation.JsonSubTypes;
+import com.fasterxml.jackson.annotation.JsonTypeInfo;
+
+import com.fasterxml.jackson.databind.*;
+
+public class PolymorphicDeserErrorHandlingTest extends BaseMapTest
+{
+    @JsonTypeInfo(use = JsonTypeInfo.Id.CLASS, include = JsonTypeInfo.As.PROPERTY,
+            property = "clazz")
+    abstract static class BaseForUnknownClass {
+    }
+
+    static class BaseUnknownWrapper {
+        public BaseForUnknownClass value;
+    }
+
+    // [databind#2668]
+    @JsonTypeInfo(use = JsonTypeInfo.Id.NAME, property = "type")
+    @JsonSubTypes({
+        @JsonSubTypes.Type(value = Child1.class, name = "child1"),
+        @JsonSubTypes.Type(value = Child2.class, name = "child2")
+    })
+    static class Parent2668 {
+    }
+
+    static class Child1 extends Parent2668 {
+        public String bar;
+    }
+
+    static class Child2 extends Parent2668 {
+        public String baz;
+    }
+
+    /*
+    /**********************************************************************
+    /* Test methods
+    /**********************************************************************
+     */
+    
+    private final ObjectMapper MAPPER = newJsonMapper();
+
+    public void testUnknownClassAsSubtype() throws Exception
+    {
+        ObjectReader reader = MAPPER.readerFor(BaseUnknownWrapper.class)
+                .without(DeserializationFeature.FAIL_ON_INVALID_SUBTYPE);
+        BaseUnknownWrapper w = reader.readValue(aposToQuotes
+                ("{'value':{'clazz':'com.foobar.Nothing'}}'"));
+        assertNotNull(w);
+    }
+
+    // [databind#2668]
+    public void testSubType2668() throws Exception
+    {
+        String json = "{\"type\": \"child2\", \"baz\":\"1\"}"; // JSON for Child2
+
+        try {
+            /*Child1 c =*/ MAPPER.readValue(json, Child1.class); // Deserializing into Child1
+            fail("Should not pass");
+        } catch (JsonMappingException e) {
+            verifyException(e, "not subtype of");
+        }
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/SubTypeResolution1964Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/SubTypeResolution1964Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/SubTypeResolution1964Test.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/SubTypeResolution1964Test.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,106 +0,0 @@
-package com.fasterxml.jackson.databind.jsontype;
-
-import java.util.*;
-
-import com.fasterxml.jackson.annotation.JsonProperty;
-import com.fasterxml.jackson.databind.*;
-
-/**
- * Test for [databind#1964], wherein slightly incompatible type hierarchy,
- * where `Map` key is downcast from `String` to `Object` (via use of "raw"
- * types to force compiler to ignore incompatibility) causes exception
- * during serialization. Although ideally code would not force round peg
- * through square hole, it makes sense to add specific exception to allow
- * such downcast just for Map key types (for now at least).
- */
-@SuppressWarnings("serial")
-public class SubTypeResolution1964Test extends BaseMapTest
-{
-    // [databind#1964]
-    static class AccessModel {
-        private Map<String, Collection<String>> repositoryPrivileges;
-
-        public AccessModel() {
-            repositoryPrivileges = new HashMap<>();
-        }
-
-        // 19-Apr-2018, tatu; this would prevent issues
-//        @JsonSerialize(typing = JsonSerialize.Typing.STATIC)
-        public Map<String, Collection<String>> getRepositoryPrivileges() {
-            return repositoryPrivileges;
-        }
-
-        public void setRepositoryPrivileges(Map<String, Collection<String>> repositoryPrivileges) {
-            this.repositoryPrivileges = repositoryPrivileges;
-        }
-    }
-    static class CustomMap<T> extends LinkedHashMap<Object, T> { }
-
-    // [databind#2034]: specialization from `Object` to other types probably should
-    // just be allowed (at least in serialization case)
-    interface Dummy {
-      List<String> getStrings();
-    }
-
-    static class MetaModel<M, B> extends AbstractMetaValue<M, M, B> {
-
-        @JsonProperty
-        protected final Map<String, AbstractMetaValue<M, ?, B>> attributes = new HashMap<>();
-
-        public <V> ListMetaAttribute<M, V, B> describeList(final String attributeName) {
-          final ListMetaAttribute<M, V, B> metaAttribute = new ListMetaAttribute<>();
-          attributes.put(attributeName, metaAttribute);
-          return metaAttribute;
-        }
-      }
-
-    static abstract class AbstractMetaValue<M, V, B> {
-        public int getBogus() { return 3; }
-    }
-
-    static class ListMetaAttribute<M, V, B> extends MetaAttribute<M, List<V>, B> {
-        public ListMetaAttribute() { }
-    }
-
-    static class MetaAttribute<M, V, B> extends AbstractMetaValue<M, V, B> {
-        public MetaAttribute() { }
-      }
-    
-    /*
-    /**********************************************************************
-    /* Unit tests
-    /**********************************************************************
-     */
-
-    final ObjectMapper MAPPER = newJsonMapper();
-
-    // [databind#1964]
-    public void testTypeCompatibility1964() throws Exception
-    {
-        // Important! Must use raw type since assignment requires effectively
-        // casting due incompatible type parameters.
-        @SuppressWarnings({ "unchecked", "rawtypes" })
-        Map<String, Collection<String>> repoPrivilegesMap = new CustomMap();
-        String key = "/storages/storage0/releases";
-        Collection<String> values = new HashSet<>();
-        values.add("ARTIFACTS_RESOLVE");
-        repoPrivilegesMap.put(key, values);
-        
-        AccessModel accessModel = new AccessModel();
-        accessModel.setRepositoryPrivileges(repoPrivilegesMap);
-
-        String jsonStr = MAPPER.writeValueAsString(accessModel);
-        // ... could/should verify more, perhaps, but for now let it be.
-        assertNotNull(jsonStr);
-    }
-
-    // [databind#2034]
-    public void testTypeSpecialization2034() throws Exception
-    {
-        MetaModel<Dummy, Dummy> metaModel = new MetaModel<>();
-        metaModel.describeList("a1");
-        String jsonStr = MAPPER.writeValueAsString(metaModel);
-        // ... could/should verify more, perhaps, but for now let it be.
-        assertNotNull(jsonStr);
-    }
-}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/SubTypeResolutionTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/SubTypeResolutionTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/SubTypeResolutionTest.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/SubTypeResolutionTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,135 @@
+package com.fasterxml.jackson.databind.jsontype;
+
+import java.util.*;
+
+import com.fasterxml.jackson.annotation.JsonProperty;
+import com.fasterxml.jackson.annotation.JsonSubTypes;
+import com.fasterxml.jackson.annotation.JsonTypeInfo;
+
+import com.fasterxml.jackson.databind.*;
+
+/**
+ * Originally test for [databind#1964], wherein slightly incompatible type hierarchy,
+ * where `Map` key is downcast from `String` to `Object` (via use of "raw"
+ * types to force compiler to ignore incompatibility) causes exception
+ * during serialization. Although ideally code would not force round peg
+ * through square hole, it makes sense to add specific exception to allow
+ * such downcast just for Map key types (for now at least).
+ */
+@SuppressWarnings("serial")
+public class SubTypeResolutionTest extends BaseMapTest
+{
+    // [databind#1964]
+    static class AccessModel {
+        private Map<String, Collection<String>> repositoryPrivileges;
+
+        public AccessModel() {
+            repositoryPrivileges = new HashMap<>();
+        }
+
+        // 19-Apr-2018, tatu; this would prevent issues
+//        @JsonSerialize(typing = JsonSerialize.Typing.STATIC)
+        public Map<String, Collection<String>> getRepositoryPrivileges() {
+            return repositoryPrivileges;
+        }
+
+        public void setRepositoryPrivileges(Map<String, Collection<String>> repositoryPrivileges) {
+            this.repositoryPrivileges = repositoryPrivileges;
+        }
+    }
+    static class CustomMap<T> extends LinkedHashMap<Object, T> { }
+
+    // [databind#2034]: specialization from `Object` to other types probably should
+    // just be allowed (at least in serialization case)
+    interface Dummy {
+      List<String> getStrings();
+    }
+
+    static class MetaModel<M, B> extends AbstractMetaValue<M, M, B> {
+
+        @JsonProperty
+        protected final Map<String, AbstractMetaValue<M, ?, B>> attributes = new HashMap<>();
+
+        public <V> ListMetaAttribute<M, V, B> describeList(final String attributeName) {
+          final ListMetaAttribute<M, V, B> metaAttribute = new ListMetaAttribute<>();
+          attributes.put(attributeName, metaAttribute);
+          return metaAttribute;
+        }
+      }
+
+    static abstract class AbstractMetaValue<M, V, B> {
+        public int getBogus() { return 3; }
+    }
+
+    static class ListMetaAttribute<M, V, B> extends MetaAttribute<M, List<V>, B> {
+        public ListMetaAttribute() { }
+    }
+
+    static class MetaAttribute<M, V, B> extends AbstractMetaValue<M, V, B> {
+        public MetaAttribute() { }
+      }
+
+    // [databind#2632]: fail to specialize type-erased
+    @SuppressWarnings("rawtypes")
+    @JsonTypeInfo(use = JsonTypeInfo.Id.NAME)
+    @JsonSubTypes(value = {
+                    @JsonSubTypes.Type(value = Either.Left.class, name = "left"),
+                    @JsonSubTypes.Type(value = Either.Right.class, name = "right")
+    })
+    static class Either<L, R> {
+        static class Left<T> extends Either {   }
+        static class Right<T> extends Either {  }
+    }
+
+    static class Foo {
+        @SuppressWarnings("unchecked")
+        public Either<String, String> getEither() {
+            return new Either.Right<String>();
+        }
+    }
+
+    /*
+    /**********************************************************************
+    /* Unit tests
+    /**********************************************************************
+     */
+
+    final ObjectMapper MAPPER = newJsonMapper();
+
+    // [databind#1964]
+    public void testTypeCompatibility1964() throws Exception
+    {
+        // Important! Must use raw type since assignment requires effectively
+        // casting due incompatible type parameters.
+        @SuppressWarnings({ "unchecked", "rawtypes" })
+        Map<String, Collection<String>> repoPrivilegesMap = new CustomMap();
+        String key = "/storages/storage0/releases";
+        Collection<String> values = new HashSet<>();
+        values.add("ARTIFACTS_RESOLVE");
+        repoPrivilegesMap.put(key, values);
+        
+        AccessModel accessModel = new AccessModel();
+        accessModel.setRepositoryPrivileges(repoPrivilegesMap);
+
+        String jsonStr = MAPPER.writeValueAsString(accessModel);
+        // ... could/should verify more, perhaps, but for now let it be.
+        assertNotNull(jsonStr);
+    }
+
+    // [databind#2034]
+    public void testTypeSpecialization2034() throws Exception
+    {
+        MetaModel<Dummy, Dummy> metaModel = new MetaModel<>();
+        metaModel.describeList("a1");
+        String jsonStr = MAPPER.writeValueAsString(metaModel);
+        // ... could/should verify more, perhaps, but for now let it be.
+        assertNotNull(jsonStr);
+    }
+
+    // [databind#2632]: fail to specialize type-erased
+    public void testSpecializeIncompatibleRawType() throws Exception
+    {
+        String json = MAPPER.writeValueAsString(new Foo());
+        assertNotNull(json);
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/TestAbstractContainers.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/TestAbstractContainers.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/TestAbstractContainers.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/TestAbstractContainers.java	2020-06-25 02:44:21.000000000 +0000
@@ -44,14 +44,14 @@ public class TestAbstractContainers exte
     public interface IDataValueList extends List<String> { }
 
     static class DataValueList extends LinkedList<String> implements IDataValueList { }
-   
+
     /*
     /**********************************************************
     /* Test methods
     /**********************************************************
      */
 
-    private final ObjectMapper MAPPER = new ObjectMapper();
+    private final ObjectMapper MAPPER = newJsonMapper();
     
     public void testAbstractLists() throws Exception
     {
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/TestEnumTyping.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/TestEnumTyping.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/TestEnumTyping.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/TestEnumTyping.java	2020-06-25 02:44:21.000000000 +0000
@@ -46,22 +46,39 @@ public class TestEnumTyping extends Base
             value = o;
         }
     }
-    
+
+    // for [databind#2605]
+    static class EnumContaintingClass<ENUM_TYPE extends Enum<ENUM_TYPE>> {
+        @JsonTypeInfo(
+            use = JsonTypeInfo.Id.CLASS,
+            include = JsonTypeInfo.As.PROPERTY,
+            property = "@class"
+        )
+        public ENUM_TYPE selected;
+
+        protected EnumContaintingClass() { }
+
+        public EnumContaintingClass(ENUM_TYPE selected) {
+          this.selected = selected;
+        }
+    }
+
     /*
     /**********************************************************
     /* Unit tests
     /**********************************************************
      */
 
+    private final ObjectMapper MAPPER = newJsonMapper();
+
     public void testTagList() throws Exception
     {
-        ObjectMapper m = new ObjectMapper();
         TagList list = new TagList();
         list.add(Tag.A);
         list.add(Tag.B);
-        String json = m.writeValueAsString(list);
+        String json = MAPPER.writeValueAsString(list);
 
-        TagList result = m.readValue(json, TagList.class);
+        TagList result = MAPPER.readValue(json, TagList.class);
         assertEquals(2, result.size());
         assertSame(Tag.A, result.get(0));
         assertSame(Tag.B, result.get(1));
@@ -69,21 +86,19 @@ public class TestEnumTyping extends Base
 
     public void testEnumInterface() throws Exception
     {
-        ObjectMapper m = new ObjectMapper();
-        String json = m.writeValueAsString(Tag.B);
-        EnumInterface result = m.readValue(json, EnumInterface.class);
+        String json = MAPPER.writeValueAsString(Tag.B);
+        EnumInterface result = MAPPER.readValue(json, EnumInterface.class);
         assertSame(Tag.B, result);
     }
 
     public void testEnumInterfaceList() throws Exception
     {
-        ObjectMapper m = new ObjectMapper();
         EnumInterfaceList list = new EnumInterfaceList();
         list.add(Tag.A);
         list.add(Tag.B);
-        String json = m.writeValueAsString(list);
+        String json = MAPPER.writeValueAsString(list);
         
-        EnumInterfaceList result = m.readValue(json, EnumInterfaceList.class);
+        EnumInterfaceList result = MAPPER.readValue(json, EnumInterfaceList.class);
         assertEquals(2, result.size());
         assertSame(Tag.A, result.get(0));
         assertSame(Tag.B, result.get(1));
@@ -91,14 +106,22 @@ public class TestEnumTyping extends Base
 
     public void testUntypedEnum() throws Exception
     {
-        ObjectMapper mapper = new ObjectMapper();
-        String str = mapper.writeValueAsString(new UntypedEnumBean(TestEnum.B));
-        UntypedEnumBean result = mapper.readValue(str, UntypedEnumBean.class);
+        String str = MAPPER.writeValueAsString(new UntypedEnumBean(TestEnum.B));
+        UntypedEnumBean result = MAPPER.readValue(str, UntypedEnumBean.class);
         assertNotNull(result);
         assertNotNull(result.value);
         Object ob = result.value;
         assertSame(TestEnum.class, ob.getClass());
         assertEquals(TestEnum.B, result.value);
     }
-    
+
+    // for [databind#2605]
+    public void testRoundtrip() throws Exception
+    {
+        EnumContaintingClass<TestEnum> input = new EnumContaintingClass<TestEnum>(TestEnum.B);
+        String json = MAPPER.writeValueAsString(input);
+//      Object o = MAPPER.readerFor(EnumContaintingClass.class).readValue(json);
+        Object o = MAPPER.readValue(json, EnumContaintingClass.class);
+        assertNotNull(o);
+    }
 }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/TestSubtypes.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/TestSubtypes.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/TestSubtypes.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/TestSubtypes.java	2020-06-25 02:44:21.000000000 +0000
@@ -4,6 +4,7 @@ import com.fasterxml.jackson.core.Versio
 
 import java.util.*;
 
+import com.fasterxml.jackson.annotation.JsonProperty;
 import com.fasterxml.jackson.annotation.JsonSubTypes;
 import com.fasterxml.jackson.annotation.JsonTypeInfo;
 import com.fasterxml.jackson.annotation.JsonTypeName;
@@ -38,7 +39,7 @@ public class TestSubtypes extends com.fa
     // "Empty" bean
     @JsonTypeInfo(use=JsonTypeInfo.Id.NAME)
     static abstract class BaseBean { }
-    
+
     static class EmptyBean extends BaseBean { }
 
     static class EmptyNonFinal { }
@@ -49,7 +50,7 @@ public class TestSubtypes extends com.fa
     {
         @JsonTypeInfo(use=JsonTypeInfo.Id.NAME)
         public SuperType value;
-        
+
         public PropertyBean() { this(null); }
         public PropertyBean(SuperType v) { value = v; }
     }
@@ -70,6 +71,28 @@ public class TestSubtypes extends com.fa
         public int a;
     }
 
+    static class Sub extends SuperTypeWithoutDefault {
+        public int a;
+
+        public Sub(){}
+        public Sub(int a) {
+            this.a = a;
+        }
+    }
+
+    static class POJOWrapper {
+        @JsonProperty
+        Sub sub1;
+        @JsonProperty
+        Sub sub2;
+
+        public POJOWrapper(){}
+        public POJOWrapper(Sub sub1, Sub sub2) {
+            this.sub1 = sub1;
+            this.sub2 = sub2;
+        }
+    }
+
     @JsonTypeInfo(use=JsonTypeInfo.Id.NAME, include=As.PROPERTY, property="type")
     @JsonSubTypes({ @JsonSubTypes.Type(ImplX.class),
           @JsonSubTypes.Type(ImplY.class) })
@@ -118,7 +141,7 @@ public class TestSubtypes extends com.fa
         public Issue1125Wrapper() { }
         public Issue1125Wrapper(Base1125 v) { value = v; }
     }
-    
+
     @JsonTypeInfo(use=JsonTypeInfo.Id.NAME, defaultImpl=Default1125.class)
     @JsonSubTypes({ @JsonSubTypes.Type(Interm1125.class) })
     static class Base1125 {
@@ -204,7 +227,7 @@ public class TestSubtypes extends com.fa
         result = mapper.readValue(json, PropertyBean.class);
         assertSame(SubC.class, result.value.getClass());
     }
-    
+
     public void testSerialization() throws Exception
     {
         // serialization can detect type name ok without anything extra:
@@ -217,7 +240,17 @@ public class TestSubtypes extends com.fa
         assertEquals("{\"@type\":\"typeB\",\"b\":1}", mapper.writeValueAsString(bean));
 
         // and default name ought to be simple class name; with context
-        assertEquals("{\"@type\":\"TestSubtypes$SubD\",\"d\":0}", mapper.writeValueAsString(new SubD()));  
+        assertEquals("{\"@type\":\"TestSubtypes$SubD\",\"d\":0}", mapper.writeValueAsString(new SubD()));
+    }
+
+    public void testSerializationWithDuplicateRegisteredSubtypes() throws Exception {
+        ObjectMapper mapper = new ObjectMapper();
+        mapper.registerSubtypes(new NamedType(Sub.class, "sub1"));
+        mapper.registerSubtypes(new NamedType(Sub.class, "sub2"));
+
+        // the first registered type name is used for serialization
+        Sub sub = new Sub(15);
+        assertEquals("{\"#type\":\"sub1\",\"a\":15}", mapper.writeValueAsString(sub));
     }
 
     public void testDeserializationNonNamed() throws Exception
@@ -247,6 +280,28 @@ public class TestSubtypes extends com.fa
         assertEquals(-4, ((SubD) bean).d);
     }
 
+    public void testDeserializationWithDuplicateRegisteredSubtypes()
+        throws Exception {
+        ObjectMapper mapper = new ObjectMapper();
+
+        // We can register the same class with different names
+        mapper.registerSubtypes(new NamedType(Sub.class, "sub1"));
+        mapper.registerSubtypes(new NamedType(Sub.class, "sub2"));
+
+        // fields of a POJO will be deserialized correctly according to their field name
+        POJOWrapper pojoWrapper = mapper.readValue("{\"sub1\":{\"#type\":\"sub1\",\"a\":10},\"sub2\":{\"#type\":\"sub2\",\"a\":50}}", POJOWrapper.class);
+        assertEquals(10, pojoWrapper.sub1.a);
+        assertEquals(50, pojoWrapper.sub2.a);
+
+        // Instances of the same object can be deserialized with multiple names
+        SuperTypeWithoutDefault sub1 = mapper.readValue("{\"#type\":\"sub1\", \"a\":20}", SuperTypeWithoutDefault.class);
+        assertSame(Sub.class, sub1.getClass());
+        assertEquals(20, ((Sub) sub1).a);
+        SuperTypeWithoutDefault sub2 = mapper.readValue("{\"#type\":\"sub2\", \"a\":30}", SuperTypeWithoutDefault.class);
+        assertSame(Sub.class, sub2.getClass());
+        assertEquals(30, ((Sub) sub2).a);
+    }
+
     // Trying to reproduce [JACKSON-366]
     public void testEmptyBean() throws Exception
     {
@@ -295,7 +350,7 @@ public class TestSubtypes extends com.fa
     public void testDefaultImplViaModule() throws Exception
     {
         final String JSON = "{\"a\":123}";
-        
+
         // first: without registration etc, epic fail:
         try {
             MAPPER.readValue(JSON, SuperTypeWithoutDefault.class);
@@ -317,7 +372,7 @@ public class TestSubtypes extends com.fa
         bean = mapper.readValue("{\"#type\":\"foobar\"}", SuperTypeWithoutDefault.class);
         assertEquals(DefaultImpl505.class, bean.getClass());
         assertEquals(0, ((DefaultImpl505) bean).a);
-    
+
     }
 
     public void testErrorMessage() throws Exception {
@@ -361,7 +416,7 @@ public class TestSubtypes extends com.fa
     public void testIssue1125NonDefault() throws Exception
     {
         String json = MAPPER.writeValueAsString(new Issue1125Wrapper(new Impl1125(1, 2, 3)));
-        
+
         Issue1125Wrapper result = MAPPER.readValue(json, Issue1125Wrapper.class);
         assertNotNull(result.value);
         assertEquals(Impl1125.class, result.value.getClass());
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/UnknownSubClassTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/UnknownSubClassTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/UnknownSubClassTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/UnknownSubClassTest.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,27 +0,0 @@
-package com.fasterxml.jackson.databind.jsontype;
-
-import com.fasterxml.jackson.annotation.JsonTypeInfo;
-
-import com.fasterxml.jackson.databind.*;
-
-public class UnknownSubClassTest extends BaseMapTest
-{
-    @JsonTypeInfo(use = JsonTypeInfo.Id.CLASS, include = JsonTypeInfo.As.PROPERTY,
-            property = "clazz")
-    abstract static class BaseClass {
-    }    
-
-    static class BaseWrapper {
-        public BaseClass value;
-    }
-    
-    public void testUnknownClassAsSubtype() throws Exception
-    {
-        ObjectMapper mapper = new ObjectMapper();
-        mapper.configure(DeserializationFeature.FAIL_ON_INVALID_SUBTYPE, false);
-        BaseWrapper w = mapper.readValue(aposToQuotes
-                ("{'value':{'clazz':'com.foobar.Nothing'}}'"),
-                BaseWrapper.class);
-        assertNotNull(w);
-    }
-}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/vld/AnnotatedPolymorphicValidationTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/vld/AnnotatedPolymorphicValidationTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/vld/AnnotatedPolymorphicValidationTest.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/vld/AnnotatedPolymorphicValidationTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,97 @@
+package com.fasterxml.jackson.databind.jsontype.vld;
+
+import java.io.*;
+
+import com.fasterxml.jackson.annotation.JsonTypeInfo;
+
+import com.fasterxml.jackson.databind.*;
+import com.fasterxml.jackson.databind.cfg.MapperConfig;
+import com.fasterxml.jackson.databind.exc.InvalidDefinitionException;
+import com.fasterxml.jackson.databind.json.JsonMapper;
+import com.fasterxml.jackson.databind.jsontype.DefaultBaseTypeLimitingValidator;
+
+/**
+ * Unit tests for verifying that "unsafe" base type(s) for polymorphic deserialization
+ * are correctly handled wrt {@link MapperFeature#BLOCK_UNSAFE_POLYMORPHIC_BASE_TYPES}.
+ */
+public class AnnotatedPolymorphicValidationTest
+    extends BaseMapTest
+{
+    static class WrappedPolymorphicUntyped {
+        @JsonTypeInfo(use=JsonTypeInfo.Id.CLASS)
+        public Object value;
+
+        protected WrappedPolymorphicUntyped() { }
+    }
+
+    static class WrappedPolymorphicUntypedSer {
+        @JsonTypeInfo(use=JsonTypeInfo.Id.CLASS)
+        public java.io.Serializable value;
+
+        protected WrappedPolymorphicUntypedSer() { }
+    }
+
+    static class NumbersAreOkValidator extends DefaultBaseTypeLimitingValidator
+    {
+        private static final long serialVersionUID = 1L;
+
+        @Override
+        protected boolean isUnsafeBaseType(MapperConfig<?> config, JavaType baseType)
+        {
+            // only override handling for `Object`
+            if (baseType.hasRawClass(Object.class)) {
+                return false;
+            }
+            return super.isUnsafeBaseType(config, baseType);
+        }
+
+        @Override
+        protected boolean isSafeSubType(MapperConfig<?> config,
+                JavaType baseType, JavaType subType) {
+            return baseType.isTypeOrSubTypeOf(Number.class);
+        }
+    }
+    
+    /*
+    /**********************************************************
+    /* Test methods
+    /**********************************************************
+     */
+
+    private final ObjectMapper MAPPER = jsonMapperBuilder()
+            .enable(MapperFeature.BLOCK_UNSAFE_POLYMORPHIC_BASE_TYPES)
+            .build();
+
+    public void testPolymorphicWithUnsafeBaseType() throws IOException
+    {
+        final String JSON = aposToQuotes("{'value':10}");
+        // by default, we should NOT be allowed to deserialize due to unsafe base type
+        try {
+            /*w =*/ MAPPER.readValue(JSON, WrappedPolymorphicUntyped.class);
+            fail("Should not pass");
+        } catch (InvalidDefinitionException e) {
+            verifyException(e, "Configured");
+            verifyException(e, "all subtypes of base type");
+        }
+
+        // but may with proper validator
+        ObjectMapper customMapper = JsonMapper.builder()
+                .enable(MapperFeature.BLOCK_UNSAFE_POLYMORPHIC_BASE_TYPES)
+                .polymorphicTypeValidator(new NumbersAreOkValidator())
+                .build();
+        
+        WrappedPolymorphicUntyped w = customMapper.readValue(JSON, WrappedPolymorphicUntyped.class);
+        assertEquals(Integer.valueOf(10), w.value);
+
+        // but yet again, it is not opening up all types (just as an example)
+        
+        try {
+            customMapper.readValue(JSON, WrappedPolymorphicUntypedSer.class);
+            fail("Should not pass");
+        } catch (InvalidDefinitionException e) {
+            verifyException(e, "Configured");
+            verifyException(e, "all subtypes of base type");
+            verifyException(e, "java.io.Serializable");
+        }
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/vld/CustomPTVMatchersTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/vld/CustomPTVMatchersTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/jsontype/vld/CustomPTVMatchersTest.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/jsontype/vld/CustomPTVMatchersTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,112 @@
+package com.fasterxml.jackson.databind.jsontype.vld;
+
+import java.net.URL;
+
+import com.fasterxml.jackson.databind.BaseMapTest;
+import com.fasterxml.jackson.databind.ObjectMapper;
+import com.fasterxml.jackson.databind.ObjectMapper.DefaultTyping;
+import com.fasterxml.jackson.databind.cfg.MapperConfig;
+import com.fasterxml.jackson.databind.exc.InvalidTypeIdException;
+import com.fasterxml.jackson.databind.jsontype.BasicPolymorphicTypeValidator;
+import com.fasterxml.jackson.databind.jsontype.PolymorphicTypeValidator;
+
+public class CustomPTVMatchersTest extends BaseMapTest
+{
+    static abstract class CustomBase {
+        public int x = 3;
+    }
+
+    static class CustomGood extends CustomBase {
+        protected CustomGood() { }
+        public CustomGood(int x) {
+            super();
+            this.x = x;
+        }
+    }
+
+    static class CustomBad extends CustomBase {
+        protected CustomBad() { }
+        public CustomBad(int x) {
+            super();
+            this.x = x;
+        }
+    }
+
+    static final class ObjectWrapper {
+        public Object value;
+
+        protected ObjectWrapper() { }
+        public ObjectWrapper(Object v) { value = v; }
+    }
+
+    /*
+    /**********************************************************************
+    /* Test methods
+    /**********************************************************************
+     */
+
+    public void testCustomBaseMatchers() throws Exception
+    {
+        PolymorphicTypeValidator ptv = BasicPolymorphicTypeValidator.builder()
+                .allowIfBaseType(new BasicPolymorphicTypeValidator.TypeMatcher() {
+                    @Override
+                    public boolean match(MapperConfig<?> ctxt, Class<?> base) {
+                        // Allow types within our packages
+                        return base.getName().startsWith("com.fasterxml.");
+                    }
+                })
+                .build();
+        ObjectMapper mapper = jsonMapperBuilder()
+                .activateDefaultTyping(ptv, DefaultTyping.EVERYTHING)
+                .build();
+        // First: in this case, allow "Bad" one too (note: default typing based on
+        // runtime type here)
+        final String goodJson = mapper.writeValueAsString(new CustomBad(42) );
+        CustomBase result = mapper.readValue(goodJson, CustomBase.class);
+        assertEquals(CustomBad.class, result.getClass());
+
+        // but other types not so good
+        final String badJson = mapper.writeValueAsString(new URL("http://localhost") );
+        try {
+            mapper.readValue(badJson, URL.class);
+            fail("Should not pass");
+        } catch (InvalidTypeIdException e) {
+            verifyException(e, "Could not resolve type id 'java.net.URL'");
+            verifyException(e, "as a subtype of");
+        }
+        assertEquals(CustomBad.class, result.getClass());
+    }
+
+    public void testCustomSubtypeMatchers() throws Exception
+    {
+        PolymorphicTypeValidator ptv = BasicPolymorphicTypeValidator.builder()
+                .allowIfSubType(new BasicPolymorphicTypeValidator.TypeMatcher() {
+                    @Override
+                    public boolean match(MapperConfig<?> ctxt, Class<?> clazz) {
+                        // Allow anything that looks "Good" :)
+                        return clazz.getSimpleName().endsWith("Good");
+                    }
+                })
+                .build();
+        ObjectMapper mapper = jsonMapperBuilder()
+                .activateDefaultTyping(ptv, DefaultTyping.NON_FINAL)
+                .build();        
+
+        // First: allow "Good" one:
+        final String goodJson = mapper.writeValueAsString(new ObjectWrapper(new CustomGood(42) ));
+        ObjectWrapper w = mapper.readValue(goodJson, ObjectWrapper.class);
+        assertNotNull(w);
+        assertNotNull(w.value);
+        assertEquals(CustomGood.class, w.value.getClass());
+
+        // Then something else
+        final String badJson = mapper.writeValueAsString(new ObjectWrapper(new CustomBad(42) ));
+        try {
+            mapper.readValue(badJson, ObjectWrapper.class);
+            fail("Should not pass");
+        } catch (InvalidTypeIdException e) {
+            verifyException(e, "Could not resolve type id 'com.fasterxml.jackson.");
+            verifyException(e, "as a subtype of");
+        }
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/misc/BeanPropertyMapTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/misc/BeanPropertyMapTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/misc/BeanPropertyMapTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/misc/BeanPropertyMapTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -32,7 +32,8 @@ public class BeanPropertyMapTest extends
         props.add(new ObjectIdValueProperty(new MyObjectIdReader("pk"), md));
         props.add(new ObjectIdValueProperty(new MyObjectIdReader("firstName"), md));
         BeanPropertyMap propMap = new BeanPropertyMap(false, props,
-                new HashMap<String,List<PropertyName>>());
+                new HashMap<String,List<PropertyName>>(),
+                Locale.getDefault());
         propMap = propMap.withProperty(new ObjectIdValueProperty(new MyObjectIdReader("@id"), md));
         assertNotNull(propMap);
     }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/misc/CaseInsensitiveDeser953Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/misc/CaseInsensitiveDeser953Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/misc/CaseInsensitiveDeser953Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/misc/CaseInsensitiveDeser953Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,62 @@
+package com.fasterxml.jackson.databind.misc;
+
+import java.util.Locale;
+
+import com.fasterxml.jackson.annotation.JsonProperty;
+import com.fasterxml.jackson.databind.*;
+
+public class CaseInsensitiveDeser953Test extends BaseMapTest
+{
+    static class Id953 {
+        @JsonProperty("someId")
+        public int someId;
+    }
+
+    private final Locale LOCALE_EN = new Locale("en", "US");
+    
+    private final ObjectMapper INSENSITIVE_MAPPER_EN = jsonMapperBuilder()
+            .enable(MapperFeature.ACCEPT_CASE_INSENSITIVE_PROPERTIES)
+            .defaultLocale(LOCALE_EN)
+            .build();
+    
+    private final Locale LOCALE_TR = new Locale("tr", "TR");
+
+    private final ObjectMapper INSENSITIVE_MAPPER_TR = jsonMapperBuilder()
+            .enable(MapperFeature.ACCEPT_CASE_INSENSITIVE_PROPERTIES)
+            .defaultLocale(LOCALE_TR)
+            .build();
+
+    public void testTurkishILetterDeserializationWithEn() throws Exception {
+        _testTurkishILetterDeserialization(INSENSITIVE_MAPPER_EN, LOCALE_EN);
+    }
+
+    public void testTurkishILetterDeserializationWithTr() throws Exception {
+        _testTurkishILetterDeserialization(INSENSITIVE_MAPPER_TR, LOCALE_TR);
+    }
+    
+    private void _testTurkishILetterDeserialization(ObjectMapper mapper, Locale locale) throws Exception
+    {
+        // Sanity check first
+        assertEquals(locale, mapper.getDeserializationConfig().getLocale());
+        
+        final String ORIGINAL_KEY = "someId";
+        
+        Id953 result;
+        result = mapper.readValue("{\""+ORIGINAL_KEY+"\":1}", Id953.class);
+        assertEquals(1, result.someId);
+
+        result = mapper.readValue("{\""+ORIGINAL_KEY.toUpperCase(locale)+"\":1}", Id953.class);
+        assertEquals(1, result.someId);
+
+        result = mapper.readValue("{\""+ORIGINAL_KEY.toLowerCase(locale)+"\":1}", Id953.class);
+        assertEquals(1, result.someId);
+
+        // and finally round-trip too...
+        final Id953 input = new Id953();
+        input.someId = 1;
+        final String json = mapper.writeValueAsString(input);
+
+        result = mapper.readValue(json, Id953.class);
+        assertEquals(1, result.someId);
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/misc/ParsingContext2525Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/misc/ParsingContext2525Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/misc/ParsingContext2525Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/misc/ParsingContext2525Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,237 @@
+package com.fasterxml.jackson.databind.misc;
+
+import java.io.IOException;
+
+import com.fasterxml.jackson.core.JsonParser;
+import com.fasterxml.jackson.core.JsonPointer;
+import com.fasterxml.jackson.core.JsonToken;
+
+import com.fasterxml.jackson.databind.*;
+import com.fasterxml.jackson.databind.util.TokenBuffer;
+
+public class ParsingContext2525Test extends BaseMapTest
+{
+    private final ObjectMapper MAPPER = sharedMapper();
+
+    private final String MINIMAL_ARRAY_DOC = "[ 42 ]";
+    
+    private final String MINIMAL_OBJECT_DOC = "{\"answer\" : 42 }";
+
+    private final String FULL_DOC = aposToQuotes("{'a':123,'array':[1,2,[3],5,{'obInArray':4}],"
+            +"'ob':{'first':[false,true],'second':{'sub':37}},'b':true}");
+
+    /*
+    /**********************************************************************
+    /* Baseline sanity check first
+    /**********************************************************************
+     */
+
+    public void testAllWithRegularParser() throws Exception
+    {
+        try (JsonParser p = MAPPER.createParser(MINIMAL_ARRAY_DOC)) {
+            _testSimpleArrayUsingPathAsPointer(p);
+        }
+        try (JsonParser p = MAPPER.createParser(MINIMAL_OBJECT_DOC)) {
+            _testSimpleObjectUsingPathAsPointer(p);
+        }
+        try (JsonParser p = MAPPER.createParser(FULL_DOC)) {
+            _testFullDocUsingPathAsPointer(p);
+        }
+    }
+
+    /*
+    /**********************************************************************
+    /* Then TokenBuffer-backed tests
+    /**********************************************************************
+     */
+
+    public void testSimpleArrayWithBuffer() throws Exception
+    {
+        try (TokenBuffer buf = _readAsTokenBuffer(MINIMAL_ARRAY_DOC)) {
+            _testSimpleArrayUsingPathAsPointer(buf.asParser());
+        }
+    }
+
+    public void testSimpleObjectWithBuffer() throws Exception
+    {
+        try (TokenBuffer buf = _readAsTokenBuffer(MINIMAL_OBJECT_DOC)) {
+            _testSimpleObjectUsingPathAsPointer(buf.asParser());
+        }
+    }
+
+    public void testFullDocWithBuffer() throws Exception
+    {
+        try (TokenBuffer buf = _readAsTokenBuffer(FULL_DOC)) {
+            _testFullDocUsingPathAsPointer(buf.asParser());
+        }
+    }
+
+    private TokenBuffer _readAsTokenBuffer(String doc) throws IOException
+    {
+        try (JsonParser p = MAPPER.createParser(doc)) {
+            p.nextToken();
+            return TokenBuffer.asCopyOfValue(p)
+                    .overrideParentContext(null);
+        }
+    }
+
+    /*
+    /**********************************************************************
+    /* And Tree-backed tests
+    /**********************************************************************
+     */
+
+    public void testSimpleArrayWithTree() throws Exception
+    {
+        JsonNode root = MAPPER.readTree(MINIMAL_ARRAY_DOC);
+        try (JsonParser p = root.traverse(null)) {
+            _testSimpleArrayUsingPathAsPointer(p);
+        }
+    }
+
+    public void testSimpleObjectWithTree() throws Exception
+    {
+        JsonNode root = MAPPER.readTree(MINIMAL_OBJECT_DOC);
+        try (JsonParser p = root.traverse(null)) {
+            _testSimpleObjectUsingPathAsPointer(p);
+        }
+    }
+
+    public void testFullDocWithTree() throws Exception
+    {
+        JsonNode root = MAPPER.readTree(FULL_DOC);
+        try (JsonParser p = root.traverse(null)) {
+            _testFullDocUsingPathAsPointer(p);
+        }
+    }
+
+    /*
+    /**********************************************************************
+    /* Shared helper methods
+    /**********************************************************************
+     */
+    
+    private void _testSimpleArrayUsingPathAsPointer(JsonParser p) throws Exception
+    {
+        assertSame(JsonPointer.empty(), p.getParsingContext().pathAsPointer());
+        assertTrue(p.getParsingContext().inRoot());
+
+        assertToken(JsonToken.START_ARRAY, p.nextToken());
+        assertSame(JsonPointer.empty(), p.getParsingContext().pathAsPointer());
+        assertTrue(p.getParsingContext().inArray());
+
+        assertToken(JsonToken.VALUE_NUMBER_INT, p.nextToken());
+        assertEquals("/0", p.getParsingContext().pathAsPointer().toString());
+        
+        assertToken(JsonToken.END_ARRAY, p.nextToken());
+        assertSame(JsonPointer.empty(), p.getParsingContext().pathAsPointer());
+        assertTrue(p.getParsingContext().inRoot());
+
+        assertNull(p.nextToken());
+    }
+
+    private void _testSimpleObjectUsingPathAsPointer(JsonParser p) throws Exception
+    {
+        assertSame(JsonPointer.empty(), p.getParsingContext().pathAsPointer());
+        assertTrue(p.getParsingContext().inRoot());
+
+        assertToken(JsonToken.START_OBJECT, p.nextToken());
+        assertSame(JsonPointer.empty(), p.getParsingContext().pathAsPointer());
+        assertTrue(p.getParsingContext().inObject());
+
+        assertToken(JsonToken.FIELD_NAME, p.nextToken());
+        assertEquals("/answer", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.VALUE_NUMBER_INT, p.nextToken());
+        assertEquals(42, p.getIntValue());
+        assertEquals("/answer", p.getParsingContext().pathAsPointer().toString());
+        
+        assertToken(JsonToken.END_OBJECT, p.nextToken());
+        assertSame(JsonPointer.empty(), p.getParsingContext().pathAsPointer());
+        assertTrue(p.getParsingContext().inRoot());
+
+        assertNull(p.nextToken());
+    }
+    
+    private void _testFullDocUsingPathAsPointer(JsonParser p) throws Exception
+    {
+        // by default should just get "empty"
+        assertSame(JsonPointer.empty(), p.getParsingContext().pathAsPointer());
+        assertTrue(p.getParsingContext().inRoot());
+
+        // let's just traverse, then:
+        assertToken(JsonToken.START_OBJECT, p.nextToken());
+        assertSame(JsonPointer.empty(), p.getParsingContext().pathAsPointer());
+        assertTrue(p.getParsingContext().inObject());
+
+        assertToken(JsonToken.FIELD_NAME, p.nextToken()); // a
+        assertEquals("/a", p.getParsingContext().pathAsPointer().toString());
+
+        assertToken(JsonToken.VALUE_NUMBER_INT, p.nextToken());
+        assertEquals("/a", p.getParsingContext().pathAsPointer().toString());
+
+        assertToken(JsonToken.FIELD_NAME, p.nextToken()); // array
+        assertEquals("/array", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.START_ARRAY, p.nextToken());
+        assertEquals("/array", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.VALUE_NUMBER_INT, p.nextToken()); // 1
+        assertEquals("/array/0", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.VALUE_NUMBER_INT, p.nextToken()); // 2
+        assertEquals("/array/1", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.START_ARRAY, p.nextToken());
+        assertEquals("/array/2", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.VALUE_NUMBER_INT, p.nextToken()); // 3
+        assertEquals("/array/2/0", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.END_ARRAY, p.nextToken());
+        assertEquals("/array/2", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.VALUE_NUMBER_INT, p.nextToken()); // 5
+        assertEquals("/array/3", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.START_OBJECT, p.nextToken());
+        assertEquals("/array/4", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.FIELD_NAME, p.nextToken()); // obInArray
+        assertEquals("/array/4/obInArray", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.VALUE_NUMBER_INT, p.nextToken()); // 4
+        assertEquals("/array/4/obInArray", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.END_OBJECT, p.nextToken());
+        assertEquals("/array/4", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.END_ARRAY, p.nextToken()); // /array
+        assertEquals("/array", p.getParsingContext().pathAsPointer().toString());
+
+        assertToken(JsonToken.FIELD_NAME, p.nextToken()); // ob
+        assertEquals("/ob", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.START_OBJECT, p.nextToken());
+        assertEquals("/ob", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.FIELD_NAME, p.nextToken()); // first
+        assertEquals("/ob/first", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.START_ARRAY, p.nextToken());
+        assertEquals("/ob/first", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.VALUE_FALSE, p.nextToken());
+        assertEquals("/ob/first/0", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.VALUE_TRUE, p.nextToken());
+        assertEquals("/ob/first/1", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.END_ARRAY, p.nextToken());
+        assertEquals("/ob/first", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.FIELD_NAME, p.nextToken()); // second
+        assertEquals("/ob/second", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.START_OBJECT, p.nextToken());
+        assertEquals("/ob/second", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.FIELD_NAME, p.nextToken()); // sub
+        assertEquals("/ob/second/sub", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.VALUE_NUMBER_INT, p.nextToken()); // 37
+        assertEquals("/ob/second/sub", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.END_OBJECT, p.nextToken());
+        assertEquals("/ob/second", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.END_OBJECT, p.nextToken()); // /ob
+        assertEquals("/ob", p.getParsingContext().pathAsPointer().toString());
+
+        assertToken(JsonToken.FIELD_NAME, p.nextToken()); // b
+        assertEquals("/b", p.getParsingContext().pathAsPointer().toString());
+        assertToken(JsonToken.VALUE_TRUE, p.nextToken());
+        assertEquals("/b", p.getParsingContext().pathAsPointer().toString());
+
+        assertToken(JsonToken.END_OBJECT, p.nextToken());
+        assertSame(JsonPointer.empty(), p.getParsingContext().pathAsPointer());
+        assertTrue(p.getParsingContext().inRoot());
+
+        assertNull(p.nextToken());
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/module/TestDuplicateRegistration.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/module/TestDuplicateRegistration.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/module/TestDuplicateRegistration.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/module/TestDuplicateRegistration.java	2020-06-25 02:44:21.000000000 +0000
@@ -28,7 +28,6 @@ public class TestDuplicateRegistration e
         }
     }
 
-    @SuppressWarnings("deprecation")
     public void testDuplicateRegistration() throws Exception
     {
         // by default, duplicate registration should be prevented
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/module/TestTypeModifiers.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/module/TestTypeModifiers.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/module/TestTypeModifiers.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/module/TestTypeModifiers.java	2020-06-25 02:44:21.000000000 +0000
@@ -157,12 +157,12 @@ public class TestTypeModifiers extends B
     {
         @Override
         public MapMarker<?,?> deserialize(JsonParser jp, DeserializationContext ctxt) throws IOException {
-            if (jp.getCurrentToken() != JsonToken.START_OBJECT) throw new IOException("Wrong token: "+jp.getCurrentToken());
-            if (jp.nextToken() != JsonToken.FIELD_NAME) throw new IOException("Wrong token: "+jp.getCurrentToken());
-            String key = jp.getCurrentName();
-            if (jp.nextToken() != JsonToken.VALUE_NUMBER_INT) throw new IOException("Wrong token: "+jp.getCurrentToken());
+            if (jp.currentToken() != JsonToken.START_OBJECT) throw new IOException("Wrong token: "+jp.currentToken());
+            if (jp.nextToken() != JsonToken.FIELD_NAME) throw new IOException("Wrong token: "+jp.currentToken());
+            String key = jp.currentName();
+            if (jp.nextToken() != JsonToken.VALUE_NUMBER_INT) throw new IOException("Wrong token: "+jp.currentToken());
             int value = jp.getIntValue();
-            if (jp.nextToken() != JsonToken.END_OBJECT) throw new IOException("Wrong token: "+jp.getCurrentToken());
+            if (jp.nextToken() != JsonToken.END_OBJECT) throw new IOException("Wrong token: "+jp.currentToken());
             return new MyMapLikeType(key, value);
         }        
     }
@@ -180,10 +180,10 @@ public class TestTypeModifiers extends B
     {
         @Override
         public MyCollectionLikeType deserialize(JsonParser jp, DeserializationContext ctxt) throws IOException {
-            if (jp.getCurrentToken() != JsonToken.START_ARRAY) throw new IOException("Wrong token: "+jp.getCurrentToken());
-            if (jp.nextToken() != JsonToken.VALUE_NUMBER_INT) throw new IOException("Wrong token: "+jp.getCurrentToken());
+            if (jp.currentToken() != JsonToken.START_ARRAY) throw new IOException("Wrong token: "+jp.currentToken());
+            if (jp.nextToken() != JsonToken.VALUE_NUMBER_INT) throw new IOException("Wrong token: "+jp.currentToken());
             int value = jp.getIntValue();
-            if (jp.nextToken() != JsonToken.END_ARRAY) throw new IOException("Wrong token: "+jp.getCurrentToken());
+            if (jp.nextToken() != JsonToken.END_ARRAY) throw new IOException("Wrong token: "+jp.currentToken());
             return new MyCollectionLikeType(value);
         }        
     }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/node/ArrayNodeTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/node/ArrayNodeTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/node/ArrayNodeTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/node/ArrayNodeTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -260,7 +260,7 @@ public class ArrayNodeTest
         p.setCodec(null);
         assertNull(p.getCodec());
         assertNotNull(p.getParsingContext());
-//        assertTrue(p.getParsingContext().inRoot());
+        assertTrue(p.getParsingContext().inRoot());
         assertNotNull(p.getTokenLocation());
         assertNotNull(p.getCurrentLocation());
         assertNull(p.getEmbeddedObject());
@@ -272,7 +272,7 @@ public class ArrayNodeTest
         assertNotNull(p.getParsingContext());
         assertTrue(p.getParsingContext().inArray());
         p.skipChildren();
-        assertToken(JsonToken.END_ARRAY, p.getCurrentToken());
+        assertToken(JsonToken.END_ARRAY, p.currentToken());
         p.close();
 
         p = new TreeTraversingParser(n, null);
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/node/EmptyContentAsTreeTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/node/EmptyContentAsTreeTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/node/EmptyContentAsTreeTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/node/EmptyContentAsTreeTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -25,32 +25,32 @@ public class EmptyContentAsTreeTest exte
 
     public void testNullFromEOFWithParserAndMapper() throws Exception
     {
-        try (JsonParser p = MAPPER.getFactory().createParser(EMPTY0)) {
+        try (JsonParser p = MAPPER.createParser(EMPTY0)) {
             _assertNullTree(MAPPER.readTree(p));
         }
-        try (JsonParser p = MAPPER.getFactory().createParser(EMPTY1)) {
+        try (JsonParser p = MAPPER.createParser(EMPTY1)) {
             _assertNullTree(MAPPER.readTree(p));
         }
-        try (JsonParser p = MAPPER.getFactory().createParser(new StringReader(EMPTY0))) {
+        try (JsonParser p = MAPPER.createParser(new StringReader(EMPTY0))) {
             _assertNullTree(MAPPER.readTree(p));
         }
-        try (JsonParser p = MAPPER.getFactory().createParser(new StringReader(EMPTY1))) {
+        try (JsonParser p = MAPPER.createParser(new StringReader(EMPTY1))) {
             _assertNullTree(MAPPER.readTree(p));
         }
 
-        try (JsonParser p = MAPPER.getFactory().createParser(EMPTY0_BYTES)) {
+        try (JsonParser p = MAPPER.createParser(EMPTY0_BYTES)) {
             _assertNullTree(MAPPER.readTree(p));
         }
-        try (JsonParser p = MAPPER.getFactory().createParser(EMPTY1_BYTES)) {
+        try (JsonParser p = MAPPER.createParser(EMPTY1_BYTES)) {
             _assertNullTree(MAPPER.readTree(p));
         }
-        try (JsonParser p = MAPPER.getFactory().createParser(EMPTY1_BYTES, 0, EMPTY1_BYTES.length)) {
+        try (JsonParser p = MAPPER.createParser(EMPTY1_BYTES, 0, EMPTY1_BYTES.length)) {
             _assertNullTree(MAPPER.readTree(p));
         }
-        try (JsonParser p = MAPPER.getFactory().createParser(new ByteArrayInputStream(EMPTY0_BYTES))) {
+        try (JsonParser p = MAPPER.createParser(new ByteArrayInputStream(EMPTY0_BYTES))) {
             _assertNullTree(MAPPER.readTree(p));
         }
-        try (JsonParser p = MAPPER.getFactory().createParser(new ByteArrayInputStream(EMPTY1_BYTES))) {
+        try (JsonParser p = MAPPER.createParser(new ByteArrayInputStream(EMPTY1_BYTES))) {
             _assertNullTree(MAPPER.readTree(p));
         }
     }
@@ -58,33 +58,33 @@ public class EmptyContentAsTreeTest exte
     // [databind#1406]
     public void testNullFromEOFWithParserAndReader() throws Exception
     {
-        try (JsonParser p = MAPPER.getFactory().createParser(EMPTY0)) {
+        try (JsonParser p = MAPPER.createParser(EMPTY0)) {
             _assertNullTree(MAPPER.reader().readTree(p));
         }
-        try (JsonParser p = MAPPER.getFactory().createParser(EMPTY1)) {
+        try (JsonParser p = MAPPER.createParser(EMPTY1)) {
             _assertNullTree(MAPPER.reader().readTree(p));
         }
-        try (JsonParser p = MAPPER.getFactory().createParser(new StringReader(EMPTY0))) {
+        try (JsonParser p = MAPPER.createParser(new StringReader(EMPTY0))) {
             _assertNullTree(MAPPER.reader().readTree(p));
         }
-        try (JsonParser p = MAPPER.getFactory().createParser(new StringReader(EMPTY1))) {
+        try (JsonParser p = MAPPER.createParser(new StringReader(EMPTY1))) {
             _assertNullTree(MAPPER.reader().readTree(p));
         }
 
-        try (JsonParser p = MAPPER.getFactory().createParser(EMPTY0_BYTES)) {
+        try (JsonParser p = MAPPER.createParser(EMPTY0_BYTES)) {
             _assertNullTree(MAPPER.reader().readTree(p));
         }
-        try (JsonParser p = MAPPER.getFactory().createParser(EMPTY1_BYTES)) {
+        try (JsonParser p = MAPPER.createParser(EMPTY1_BYTES)) {
             _assertNullTree(MAPPER.reader().readTree(p));
         }
-        try (JsonParser p = MAPPER.getFactory().createParser(EMPTY1_BYTES, 0, EMPTY1_BYTES.length)) {
+        try (JsonParser p = MAPPER.createParser(EMPTY1_BYTES, 0, EMPTY1_BYTES.length)) {
             _assertNullTree(MAPPER.reader().readTree(p));
         }
 
-        try (JsonParser p = MAPPER.getFactory().createParser(new ByteArrayInputStream(EMPTY0_BYTES))) {
+        try (JsonParser p = MAPPER.createParser(new ByteArrayInputStream(EMPTY0_BYTES))) {
             _assertNullTree(MAPPER.reader().readTree(p));
         }
-        try (JsonParser p = MAPPER.getFactory().createParser(new ByteArrayInputStream(EMPTY1_BYTES))) {
+        try (JsonParser p = MAPPER.createParser(new ByteArrayInputStream(EMPTY1_BYTES))) {
             _assertNullTree(MAPPER.reader().readTree(p));
         }
     }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/node/NodeContext2049Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/node/NodeContext2049Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/node/NodeContext2049Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/node/NodeContext2049Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,183 @@
+package com.fasterxml.jackson.databind.node;
+
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.Iterator;
+import java.util.List;
+
+import com.fasterxml.jackson.core.*;
+
+import com.fasterxml.jackson.databind.*;
+import com.fasterxml.jackson.databind.deser.*;
+import com.fasterxml.jackson.databind.deser.std.CollectionDeserializer;
+import com.fasterxml.jackson.databind.deser.std.DelegatingDeserializer;
+import com.fasterxml.jackson.databind.type.CollectionLikeType;
+
+public class NodeContext2049Test extends BaseMapTest
+{
+    public interface HasParent {
+        void setParent(Parent parent);
+        Parent getParent();
+    }
+
+    static class Child implements HasParent {
+        public Parent parent;
+        public String property;
+
+        @Override
+        public void setParent(Parent p) { parent = p; }
+        @Override
+        public Parent getParent() { return parent; }
+    }
+
+    static class Parent {
+        public List<Child> children;
+        public Child singleChild;
+    }
+
+    static class ListValueInstantiator extends ValueInstantiator {
+        @Override
+        public String getValueTypeDesc() {
+             return List.class.getName();
+        }
+
+        @Override
+        public Object createUsingDefault(DeserializationContext ctxt) throws IOException {
+             return new ArrayList<>();
+        }
+    }
+
+    static class ParentSettingDeserializerModifier extends BeanDeserializerModifier {
+        @Override
+        public BeanDeserializerBuilder updateBuilder(DeserializationConfig config, BeanDescription beanDesc,
+                  BeanDeserializerBuilder builder) {
+             for (Iterator<SettableBeanProperty> propertyIt = builder.getProperties(); propertyIt.hasNext(); ) {
+                  SettableBeanProperty property = propertyIt.next();
+                  builder.addOrReplaceProperty(property.withValueDeserializer(new ParentSettingDeserializerContextual()), false);
+             }
+             return builder;
+        }
+    }
+
+    @SuppressWarnings("serial")
+    static class ParentSettingDeserializer extends DelegatingDeserializer {
+        public ParentSettingDeserializer(JsonDeserializer<?> delegatee) {
+             super(delegatee);
+        }
+
+        @Override
+        public Object deserialize(JsonParser jp, DeserializationContext ctxt) throws IOException, JsonProcessingException {
+             Object retValue = super.deserialize(jp, ctxt);
+             if (retValue instanceof HasParent) {
+                  HasParent obj = (HasParent) retValue;
+                  Parent parent = null;
+                  JsonStreamContext parsingContext = jp.getParsingContext();
+                  while (parent == null && parsingContext != null) {
+                       Object currentValue = parsingContext.getCurrentValue();
+                       if (currentValue != null && currentValue instanceof Parent) {
+                            parent = (Parent) currentValue;
+                       }
+                       parsingContext = parsingContext.getParent();
+                  }
+                  if (parent != null) {
+                       obj.setParent(parent);
+                  }
+             }
+             return retValue;
+        }
+
+        @Override
+        protected JsonDeserializer<?> newDelegatingInstance(JsonDeserializer<?> newDelegatee) {
+             return new ParentSettingDeserializer(newDelegatee);
+        }
+
+   }
+    
+    static class ParentSettingDeserializerContextual extends JsonDeserializer<Object> implements ContextualDeserializer {
+
+        @Override
+        public JsonDeserializer<?> createContextual(DeserializationContext ctxt, BeanProperty property)
+                  throws JsonMappingException {
+             JavaType propertyType = property.getType();
+             JavaType contentType = propertyType;
+             if (propertyType.isCollectionLikeType()) {
+                  contentType = propertyType.getContentType();
+             }
+             JsonDeserializer<Object> delegatee = ctxt.findNonContextualValueDeserializer(contentType);
+             JsonDeserializer<Object> objectDeserializer = new ParentSettingDeserializer(delegatee);
+             JsonDeserializer<?> retValue;
+             if (propertyType.isCollectionLikeType()) {
+                  CollectionLikeType collectionType = ctxt.getTypeFactory().constructCollectionLikeType(propertyType.getRawClass(),
+                            contentType);
+                  ValueInstantiator instantiator = new ListValueInstantiator();
+                  retValue = new CollectionDeserializer(collectionType, objectDeserializer, null, instantiator);
+             } else {
+                  retValue = objectDeserializer;
+             }
+             return retValue;
+        }
+
+        @Override
+        public Object deserialize(JsonParser p, DeserializationContext ctxt) throws IOException, JsonProcessingException {
+             // TODO Auto-generated method stub
+             return null;
+        }
+
+   }
+    
+    /*
+    /**********************************************************************
+    /* Test methods
+    /**********************************************************************
+     */
+    
+    private ObjectMapper objectMapper;
+    {
+        objectMapper = new ObjectMapper();
+        objectMapper.registerModule(new com.fasterxml.jackson.databind.Module() {
+              @Override
+              public String getModuleName() {
+                   return "parentSetting";
+              }
+              @Override
+              public Version version() {
+                   return Version.unknownVersion();
+              }
+              @Override
+              public void setupModule(SetupContext context) {
+                   context.addBeanDeserializerModifier(new ParentSettingDeserializerModifier());
+              }
+         });
+    }
+
+    final static String JSON = "{\n" + 
+            "     \"children\": [\n" + 
+            "          {\n" + 
+            "               \"property\": \"value1\"\n" + 
+            "          },\n" + 
+            "          {\n" + 
+            "               \"property\": \"value2\"\n" + 
+            "          }\n" + 
+            "     ],\n" + 
+            "     \"singleChild\": {\n" + 
+            "          \"property\": \"value3\"\n" + 
+            "     }\n" + 
+            "}";
+
+    public void testReadNoBuffering() throws IOException {
+        Parent obj = objectMapper.readerFor(Parent.class).readValue(JSON);
+        assertSame(obj, obj.singleChild.getParent());
+        for (Child child : obj.children) {
+            assertSame(obj, child.getParent());
+        }
+    }
+
+    public void testReadFromTree() throws IOException {
+        JsonNode tree = objectMapper.readTree(JSON);
+        Parent obj = objectMapper.reader().forType(Parent.class).readValue(tree);
+        assertSame(obj, obj.singleChild.getParent());
+        for (Child child : obj.children) {
+            assertSame(obj, child.getParent());
+        }
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/node/TestTreeTraversingParser.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/node/TestTreeTraversingParser.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/node/TestTreeTraversingParser.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/node/TestTreeTraversingParser.java	2020-06-25 02:44:21.000000000 +0000
@@ -48,58 +48,58 @@ public class TestTreeTraversingParser
         JsonNode tree = MAPPER.readTree(JSON);
         JsonParser p = tree.traverse();
 
-        assertNull(p.getCurrentToken());
-        assertNull(p.getCurrentName());
+        assertNull(p.currentToken());
+        assertNull(p.currentName());
 
         assertToken(JsonToken.START_OBJECT, p.nextToken());
-        assertNull(p.getCurrentName());
+        assertNull(p.currentName());
         assertEquals("Expected START_OBJECT", JsonToken.START_OBJECT.asString(), p.getText());
 
         assertToken(JsonToken.FIELD_NAME, p.nextToken());
-        assertEquals("a", p.getCurrentName());
+        assertEquals("a", p.currentName());
         assertEquals("a", p.getText());
 
         assertToken(JsonToken.VALUE_NUMBER_INT, p.nextToken());
-        assertEquals("a", p.getCurrentName());
+        assertEquals("a", p.currentName());
         assertEquals(123, p.getIntValue());
         assertEquals("123", p.getText());
 
         assertToken(JsonToken.FIELD_NAME, p.nextToken());
-        assertEquals("list", p.getCurrentName());
+        assertEquals("list", p.currentName());
         assertEquals("list", p.getText());
 
         assertToken(JsonToken.START_ARRAY, p.nextToken());
-        assertEquals("list", p.getCurrentName());
+        assertEquals("list", p.currentName());
         assertEquals(JsonToken.START_ARRAY.asString(), p.getText());
 
         assertToken(JsonToken.VALUE_NUMBER_FLOAT, p.nextToken());
-        assertNull(p.getCurrentName());
+        assertNull(p.currentName());
         assertEquals(12.25, p.getDoubleValue(), 0);
         assertEquals("12.25", p.getText());
 
         assertToken(JsonToken.VALUE_NULL, p.nextToken());
-        assertNull(p.getCurrentName());
+        assertNull(p.currentName());
         assertEquals(JsonToken.VALUE_NULL.asString(), p.getText());
 
         assertToken(JsonToken.VALUE_TRUE, p.nextToken());
-        assertNull(p.getCurrentName());
+        assertNull(p.currentName());
         assertTrue(p.getBooleanValue());
         assertEquals(JsonToken.VALUE_TRUE.asString(), p.getText());
 
         assertToken(JsonToken.START_OBJECT, p.nextToken());
-        assertNull(p.getCurrentName());
+        assertNull(p.currentName());
         assertToken(JsonToken.END_OBJECT, p.nextToken());
-        assertNull(p.getCurrentName());
+        assertNull(p.currentName());
 
         assertToken(JsonToken.START_ARRAY, p.nextToken());
-        assertNull(p.getCurrentName());
+        assertNull(p.currentName());
         assertToken(JsonToken.END_ARRAY, p.nextToken());
-        assertNull(p.getCurrentName());
+        assertNull(p.currentName());
 
         assertToken(JsonToken.END_ARRAY, p.nextToken());
 
         assertToken(JsonToken.END_OBJECT, p.nextToken());
-        assertNull(p.getCurrentName());
+        assertNull(p.currentName());
 
         assertNull(p.nextToken());
 
@@ -180,7 +180,7 @@ public class TestTreeTraversingParser
         POJONode n = new POJONode(inputBinary);
         JsonParser p = n.traverse();
 
-        assertNull(p.getCurrentToken());
+        assertNull(p.currentToken());
         assertToken(JsonToken.VALUE_EMBEDDED_OBJECT, p.nextToken());
         byte[] data = p.getBinaryValue();
         assertNotNull(data);
@@ -196,7 +196,7 @@ public class TestTreeTraversingParser
         BinaryNode n = new BinaryNode(inputBinary);
         JsonParser p = n.traverse();
 
-        assertNull(p.getCurrentToken());
+        assertNull(p.currentToken());
         // exposed as POJO... not as VALUE_STRING
         assertToken(JsonToken.VALUE_EMBEDDED_OBJECT, p.nextToken());
         byte[] data = p.getBinaryValue();
@@ -214,7 +214,7 @@ public class TestTreeTraversingParser
     {
         TextNode n = new TextNode("   APs=\n");
         JsonParser p = n.traverse();
-        assertNull(p.getCurrentToken());
+        assertNull(p.currentToken());
         assertToken(JsonToken.VALUE_STRING, p.nextToken());
         byte[] data = p.getBinaryValue();
         assertNotNull(data);
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/node/TreeFromIncompleteJsonTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/node/TreeFromIncompleteJsonTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/node/TreeFromIncompleteJsonTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/node/TreeFromIncompleteJsonTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -13,7 +13,7 @@ public class TreeFromIncompleteJsonTest
     public void testErrorHandling() throws IOException {
 
       String json = "{\"A\":{\"B\":\n";
-      JsonParser parser = MAPPER.getFactory().createParser(json);
+      JsonParser parser = MAPPER.createParser(json);
       try {
           parser.readValueAsTree();
       } catch (JsonEOFException e) {
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/objectid/ObjectId2759Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/objectid/ObjectId2759Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/objectid/ObjectId2759Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/objectid/ObjectId2759Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,73 @@
+package com.fasterxml.jackson.databind.objectid;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import com.fasterxml.jackson.annotation.JsonIdentityInfo;
+import com.fasterxml.jackson.annotation.JsonIdentityReference;
+import com.fasterxml.jackson.annotation.JsonProperty;
+import com.fasterxml.jackson.annotation.ObjectIdGenerators;
+
+import com.fasterxml.jackson.databind.*;
+
+public class ObjectId2759Test extends BaseMapTest
+{
+    static class Hive {
+        public String name;
+        public List<Bee> bees = new ArrayList<>();
+
+        public Long id;
+
+        Hive() { }
+
+        public Hive(Long id, String name) {
+            this.id = id;
+            this.name = name;
+        }
+
+        public void addBee(Bee bee) {
+            bees.add(bee);
+        }
+    }
+
+    static class Bee {
+        public Long id;
+
+        @JsonIdentityInfo(generator = ObjectIdGenerators.PropertyGenerator.class, property = "id")
+        @JsonIdentityReference(alwaysAsId = true)
+        @JsonProperty("hiveId")
+        Hive hive;
+
+        public Bee() { }
+
+        public Bee(Long id, Hive hive) {
+            this.id = id;
+            this.hive = hive;
+        }
+
+        public Hive getHive() {
+            return hive;
+        }
+
+        public void setHive(Hive hive) {
+            this.hive = hive;
+        }
+    }
+
+    public void testObjectId2759() throws Exception
+    {
+        Hive hive = new Hive(100500L, "main hive");
+        hive.addBee(new Bee(1L, hive));
+
+        ObjectMapper mapper = newJsonMapper();
+        final String json = mapper.writerWithDefaultPrettyPrinter()
+                .writeValueAsString(hive);
+        try {
+            mapper.readerFor(JsonNode.class)
+                .with(DeserializationFeature.FAIL_ON_READING_DUP_TREE_KEY)
+                .readValue(json);
+        } catch (JsonMappingException e) {
+            fail("Should not have duplicates, but JSON content has: "+json);
+        }
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/objectid/TestObjectId.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/objectid/TestObjectId.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/objectid/TestObjectId.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/objectid/TestObjectId.java	2020-06-25 02:44:21.000000000 +0000
@@ -6,6 +6,7 @@ import java.util.List;
 import com.fasterxml.jackson.annotation.*;
 
 import com.fasterxml.jackson.databind.*;
+import com.fasterxml.jackson.databind.json.JsonMapper;
 
 public class TestObjectId extends BaseMapTest
 {
@@ -156,11 +157,12 @@ public class TestObjectId extends BaseMa
         comp.add(e1);
         comp.add(e2);
 
-        String json = MAPPER.writeValueAsString(comp);
+        JsonMapper mapper = JsonMapper.builder().enable(MapperFeature.SORT_PROPERTIES_ALPHABETICALLY).build();
+        String json = mapper.writeValueAsString(comp);
         
         assertEquals("{\"employees\":["
-                +"{\"id\":1,\"name\":\"First\",\"manager\":null,\"reports\":[2]},"
-                +"{\"id\":2,\"name\":\"Second\",\"manager\":1,\"reports\":[]}"
+                +"{\"id\":1,\"manager\":null,\"name\":\"First\",\"reports\":[2]},"
+                +"{\"id\":2,\"manager\":1,\"name\":\"Second\",\"reports\":[]}"
                 +"]}",
                 json);
     }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/objectid/TestObjectIdSerialization.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/objectid/TestObjectIdSerialization.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/objectid/TestObjectIdSerialization.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/objectid/TestObjectIdSerialization.java	2020-06-25 02:44:21.000000000 +0000
@@ -5,6 +5,7 @@ import com.fasterxml.jackson.annotation.
 import com.fasterxml.jackson.annotation.JsonPropertyOrder;
 import com.fasterxml.jackson.annotation.ObjectIdGenerators;
 import com.fasterxml.jackson.databind.*;
+import com.fasterxml.jackson.databind.json.JsonMapper;
 
 /**
  * Unit test to verify handling of Object Id deserialization
@@ -184,7 +185,7 @@ public class TestObjectIdSerialization e
     /*****************************************************
      */
 
-    private final static String EXP_SIMPLE_INT_CLASS = "{\"id\":1,\"value\":13,\"next\":1}";
+    private final static String EXP_SIMPLE_INT_CLASS = "{\"id\":1,\"next\":1,\"value\":13}";
     
     private final ObjectMapper MAPPER = objectMapper();
 
@@ -194,16 +195,17 @@ public class TestObjectIdSerialization e
         src.next = src;
         
         // First, serialize:
-        String json = MAPPER.writeValueAsString(src);
+        JsonMapper mapper = JsonMapper.builder().enable(MapperFeature.SORT_PROPERTIES_ALPHABETICALLY).build();
+        String json = mapper.writeValueAsString(src);
         assertEquals(EXP_SIMPLE_INT_CLASS, json);
 
         // and ensure that state is cleared in-between as well:
-        json = MAPPER.writeValueAsString(src);
+        json = mapper.writeValueAsString(src);
         assertEquals(EXP_SIMPLE_INT_CLASS, json);
     }
     
     // Bit more complex, due to extra wrapping etc:
-    private final static String EXP_SIMPLE_INT_PROP = "{\"node\":{\"@id\":1,\"value\":7,\"next\":{\"node\":1}}}";
+    private final static String EXP_SIMPLE_INT_PROP = "{\"node\":{\"@id\":1,\"next\":{\"node\":1},\"value\":7}}";
 
     public void testSimpleSerializationProperty() throws Exception
     {
@@ -211,10 +213,11 @@ public class TestObjectIdSerialization e
         src.node.next = src;
         
         // First, serialize:
-        String json = MAPPER.writeValueAsString(src);
+        JsonMapper mapper = JsonMapper.builder().enable(MapperFeature.SORT_PROPERTIES_ALPHABETICALLY).build();
+        String json = mapper.writeValueAsString(src);
         assertEquals(EXP_SIMPLE_INT_PROP, json);
         // and second time too, for a good measure
-        json = MAPPER.writeValueAsString(src);
+        json = mapper.writeValueAsString(src);
         assertEquals(EXP_SIMPLE_INT_PROP, json);
     }
 
@@ -260,34 +263,35 @@ public class TestObjectIdSerialization e
     /*****************************************************
      */
 
-    private final static String EXP_CUSTOM_PROP = "{\"customId\":123,\"value\":-19,\"next\":123}";
+    private final static String EXP_CUSTOM_PROP = "{\"customId\":123,\"next\":123,\"value\":-19}";
     // Test for verifying that custom
     public void testCustomPropertyForClass() throws Exception
     {
         IdentifiableWithProp src = new IdentifiableWithProp(123, -19);
         src.next = src;
-        
+
+        JsonMapper mapper =  JsonMapper.builder().enable(MapperFeature.SORT_PROPERTIES_ALPHABETICALLY).build();
         // First, serialize:
-        String json = MAPPER.writeValueAsString(src);
+        String json = mapper.writeValueAsString(src);
         assertEquals(EXP_CUSTOM_PROP, json);
 
         // and ensure that state is cleared in-between as well:
-        json = MAPPER.writeValueAsString(src);
+        json = mapper.writeValueAsString(src);
         assertEquals(EXP_CUSTOM_PROP, json);
     }
 
-    private final static String EXP_CUSTOM_PROP_VIA_REF = "{\"node\":{\"id\":123,\"value\":7,\"next\":{\"node\":123}}}";
+    private final static String EXP_CUSTOM_PROP_VIA_REF = "{\"node\":{\"id\":123,\"next\":{\"node\":123},\"value\":7}}";
     // Test for verifying that custom
     public void testCustomPropertyViaProperty() throws Exception
     {
         IdWrapperCustom src = new IdWrapperCustom(123, 7);
         src.node.next = src;
-        
+        JsonMapper mapper = JsonMapper.builder().enable(MapperFeature.SORT_PROPERTIES_ALPHABETICALLY).build();
         // First, serialize:
-        String json = MAPPER.writeValueAsString(src);
+        String json = mapper.writeValueAsString(src);
         assertEquals(EXP_CUSTOM_PROP_VIA_REF, json);
         // and second time too, for a good measure
-        json = MAPPER.writeValueAsString(src);
+        json = mapper.writeValueAsString(src);
         assertEquals(EXP_CUSTOM_PROP_VIA_REF, json);
     }
 
@@ -302,10 +306,10 @@ public class TestObjectIdSerialization e
         TreeNode root = new TreeNode(null, 1, "root");     
         TreeNode leaf = new TreeNode(root, 2, "leaf");
         root.child = leaf;
-        String json = MAPPER.writeValueAsString(root);
-//        System.out.println(json);
-        assertEquals("{\"id\":1,\"name\":\"root\",\"parent\":null,\"child\":"
-                +"{\"id\":2,\"name\":\"leaf\",\"parent\":1,\"child\":null}}",
+        JsonMapper mapper = JsonMapper.builder().enable(MapperFeature.SORT_PROPERTIES_ALPHABETICALLY).build();
+        String json = mapper.writeValueAsString(root);
+        assertEquals("{\"id\":1,\"child\":"
+                +"{\"id\":2,\"child\":null,\"name\":\"leaf\",\"parent\":1},\"name\":\"root\",\"parent\":null}",
                 json);
         		
     }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ObjectMapperTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ObjectMapperTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ObjectMapperTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ObjectMapperTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -133,9 +133,11 @@ public class ObjectMapperTest extends Ba
         assertFalse(m2.isEnabled(DeserializationFeature.UNWRAP_ROOT_VALUE));
 
         // // Also, underlying JsonFactory instances should be distinct
-        
         assertNotSame(m.getFactory(), m2.getFactory());
 
+        // [databind#2755]: also need to copy this:
+        assertNotSame(m.getSubtypeResolver(), m2.getSubtypeResolver());
+
         // [databind#122]: Need to ensure mix-ins are not shared
         assertEquals(0, m.getSerializationConfig().mixInCount());
         assertEquals(0, m2.getSerializationConfig().mixInCount());
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ObjectReaderTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ObjectReaderTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ObjectReaderTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ObjectReaderTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -2,17 +2,17 @@ package com.fasterxml.jackson.databind;
 
 import java.io.IOException;
 import java.io.StringWriter;
-import java.util.Collections;
-import java.util.List;
-import java.util.Map;
-import java.util.Set;
+import java.util.*;
 
 import com.fasterxml.jackson.annotation.JsonCreator;
 import com.fasterxml.jackson.annotation.JsonProperty;
+
 import com.fasterxml.jackson.core.*;
 import com.fasterxml.jackson.core.json.JsonReadFeature;
+
 import com.fasterxml.jackson.databind.cfg.ContextAttributes;
 import com.fasterxml.jackson.databind.deser.DeserializationProblemHandler;
+import com.fasterxml.jackson.databind.exc.MismatchedInputException;
 import com.fasterxml.jackson.databind.json.JsonMapper;
 import com.fasterxml.jackson.databind.node.ArrayNode;
 import com.fasterxml.jackson.databind.node.JsonNodeFactory;
@@ -29,7 +29,7 @@ public class ObjectReaderTest extends Ba
     public void testSimpleViaParser() throws Exception
     {
         final String JSON = "[1]";
-        JsonParser p = MAPPER.getFactory().createParser(JSON);
+        JsonParser p = MAPPER.createParser(JSON);
         Object ob = MAPPER.readerFor(Object.class)
                 .readValue(p);
         p.close();
@@ -48,9 +48,48 @@ public class ObjectReaderTest extends Ba
                 .readValue(BYTES, 0, BYTES.length);
         assertTrue(ob instanceof List<?>);
         assertEquals(1, ((List<?>) ob).size());
+
+        // but also failure mode(s)
+        try {
+            MAPPER.readerFor(Object.class)
+                .readValue(new byte[0]);
+            fail("Should not pass");
+        } catch (MismatchedInputException e) {
+            verifyException(e, "No content to map due to end-of-input");
+        }
+    }
+
+    // [databind#2693]: convenience read methods:
+    public void testReaderForArrayOf() throws Exception
+    {
+        Object value = MAPPER.readerForArrayOf(ABC.class)
+                .readValue("[ \"A\", \"C\" ]");
+        assertEquals(ABC[].class, value.getClass());
+        ABC[] abcs = (ABC[]) value;
+        assertEquals(2, abcs.length);
+        assertEquals(ABC.A, abcs[0]);
+        assertEquals(ABC.C, abcs[1]);
     }
 
-    public void testParserFeatures() throws Exception
+    // [databind#2693]: convenience read methods:
+    public void testReaderForListOf() throws Exception
+    {
+        Object value = MAPPER.readerForListOf(ABC.class)
+                .readValue("[ \"B\", \"C\" ]");
+        assertEquals(ArrayList.class, value.getClass());
+        assertEquals(Arrays.asList(ABC.B, ABC.C), value);
+    }
+
+    // [databind#2693]: convenience read methods:
+    public void testReaderForMapOf() throws Exception
+    {
+        Object value = MAPPER.readerForMapOf(ABC.class)
+                .readValue("{\"key\" : \"B\" }");
+        assertEquals(LinkedHashMap.class, value.getClass());
+        assertEquals(Collections.singletonMap("key", ABC.B), value);
+    }
+
+    public void testParserFeaturesComments() throws Exception
     {
         final String JSON = "[ /* foo */ 7 ]";
         // default won't accept comments, let's change that:
@@ -71,6 +110,36 @@ public class ObjectReaderTest extends Ba
         }
     }
 
+    public void testParserFeaturesCtrlChars() throws Exception
+    {
+        String FIELD = "a\tb";
+        String VALUE = "\t";
+        String JSON = "{ "+quote(FIELD)+" : "+quote(VALUE)+"}";
+        Map<?, ?> result;
+
+        // First: by default, unescaped control characters should not work
+        try {
+            result = MAPPER.readValue(JSON, Map.class);
+            fail("Should not pass with defaylt settings");
+        } catch (JsonParseException e) {
+            verifyException(e, "Illegal unquoted character");
+        }
+
+        // But both ObjectReader:
+        result = MAPPER.readerFor(Map.class)
+                .with(JsonReadFeature.ALLOW_UNESCAPED_CONTROL_CHARS)
+                .readValue(JSON);
+        assertEquals(1, result.size());
+
+        // and new mapper should work
+        ObjectMapper mapper2 = JsonMapper.builder()
+                .enable(JsonReadFeature.ALLOW_UNESCAPED_CONTROL_CHARS)
+                .build();
+        result = mapper2.readerFor(Map.class)
+                .readValue(JSON);
+        assertEquals(1, result.size());
+    }
+
     public void testNodeHandling() throws Exception
     {
         JsonNodeFactory nodes = new JsonNodeFactory(true);
@@ -99,6 +168,17 @@ public class ObjectReaderTest extends Ba
         // alternative method too... can't recall why two
         assertSame(r, r.with(DeserializationFeature.FAIL_ON_IGNORED_PROPERTIES,
                 DeserializationFeature.FAIL_ON_INVALID_SUBTYPE));
+
+        // and another one
+        assertSame(r, r.with(r.getConfig()));
+
+        // and with StreamReadFeatures
+        r = MAPPER.reader();
+        assertFalse(r.isEnabled(StreamReadFeature.IGNORE_UNDEFINED));
+        ObjectReader r2 = r.with(StreamReadFeature.IGNORE_UNDEFINED);
+        assertTrue(r2.isEnabled(StreamReadFeature.IGNORE_UNDEFINED));
+        ObjectReader r3 = r2.without(StreamReadFeature.IGNORE_UNDEFINED);
+        assertFalse(r3.isEnabled(StreamReadFeature.IGNORE_UNDEFINED));
     }
 
     public void testFeatureSettingsDeprecated() throws Exception
@@ -290,6 +370,24 @@ public class ObjectReaderTest extends Ba
         public Set<String> set2;
     }    
 
+    // [databind#2636]
+    public void testCanPassResultToOverloadedMethod() throws Exception {
+        final String source = "{\"foo\":{\"bar\":{\"caller\":{\"name\":{\"value\":1234}}}}}";
+
+        ObjectReader reader = MAPPER.readerFor(POJO.class).at("/foo/bar/caller");
+
+        process(reader.readValue(source, POJO.class));
+    }
+
+    void process(POJO pojo) {
+        // do nothing - just used to show that the compiler can choose the correct method overloading to invoke
+    }
+
+    void process(String pojo) {
+        // do nothing - just used to show that the compiler can choose the correct method overloading to invoke
+        throw new Error();
+    }
+    
     /*
     /**********************************************************
     /* Test methods, ObjectCodec
@@ -308,7 +406,7 @@ public class ObjectReaderTest extends Ba
     public void testCodecUnsupportedWrites() throws Exception
     {
         ObjectReader r = MAPPER.readerFor(String.class);
-        JsonGenerator g = MAPPER.getFactory().createGenerator(new StringWriter());
+        JsonGenerator g = MAPPER.createGenerator(new StringWriter());
         ObjectNode n = MAPPER.createObjectNode();
         try {
             r.writeTree(g, n);
@@ -323,8 +421,6 @@ public class ObjectReaderTest extends Ba
             ;
         }
         g.close();
-
-        g.close();
     }
 
     /*
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ObjectReaderValueOfWithValueTypeTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ObjectReaderValueOfWithValueTypeTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ObjectReaderValueOfWithValueTypeTest.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ObjectReaderValueOfWithValueTypeTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,153 @@
+package com.fasterxml.jackson.databind;
+
+import java.io.*;
+import java.net.URL;
+import java.util.Map;
+
+import org.junit.Before;
+import org.junit.Test;
+import org.mockito.Mock;
+import org.mockito.MockitoAnnotations;
+
+import com.fasterxml.jackson.databind.json.JsonMapper;
+import com.fasterxml.jackson.databind.node.TextNode;
+
+import static org.junit.Assert.*;
+
+import static org.mockito.ArgumentMatchers.any;
+import static org.mockito.Mockito.verify;
+import static org.mockito.Mockito.when;
+
+// for [databind#2636]
+public class ObjectReaderValueOfWithValueTypeTest
+{
+    final ObjectMapper MAPPER = JsonMapper.builder().build();
+
+    static class POJO {
+        public Map<String, Object> name;
+    }
+
+    private final POJO pojo = new POJO();
+
+    @Mock
+    ObjectReader objectReader;
+
+
+    @Before
+    public void before() {
+        MockitoAnnotations.initMocks(this);
+    }
+
+    @Test
+    public void testValueOfStringWithValueType() throws IOException {
+        when(objectReader.readValue((String) any())).thenReturn(pojo);
+        when(objectReader.forType((Class<?>) any())).thenReturn(objectReader);
+        when(objectReader.readValue((String) any(), (Class<?>) any())).thenCallRealMethod();
+
+        String source = "";
+        POJO result = objectReader.readValue(source, POJO.class);
+
+        assertEquals(result, pojo);
+        verify(objectReader).forType(POJO.class);
+        verify(objectReader).readValue(source);
+    }
+
+
+    @Test
+    public void testValueOfByteArrayWithValueType() throws IOException {
+        when(objectReader.forType((Class<?>) any())).thenReturn(objectReader);
+        when(objectReader.readValue((byte[]) any())).thenReturn(pojo);
+        when(objectReader.readValue((byte[]) any(), (Class<?>) any())).thenCallRealMethod();
+
+        byte[] source = "{}".getBytes();
+        POJO result = objectReader.readValue(source, POJO.class);
+
+        assertEquals(result, pojo);
+        verify(objectReader).forType(POJO.class);
+        verify(objectReader).readValue(source);
+    }
+
+    @Test
+    public void testValueOfDataInputWithValueType() throws IOException {
+        when(objectReader.forType((Class<?>) any())).thenReturn(objectReader);
+        when(objectReader.readValue((DataInput) any())).thenReturn(pojo);
+        when(objectReader.readValue((DataInput) any(), (Class<?>) any())).thenCallRealMethod();
+
+        DataInput source = new DataInputStream(new ByteArrayInputStream("{}".getBytes()));
+        POJO result = objectReader.readValue(source, POJO.class);
+
+        assertEquals(result, pojo);
+        verify(objectReader).forType(POJO.class);
+        verify(objectReader).readValue(source);
+    }
+
+    @Test
+    public void testValueOfFileWithValueType() throws IOException {
+        when(objectReader.forType((Class<?>) any())).thenReturn(objectReader);
+        when(objectReader.readValue((File) any())).thenReturn(pojo);
+        when(objectReader.readValue((File) any(), (Class<?>) any())).thenCallRealMethod();
+
+        File source = new File("unknownpath");
+        POJO result = objectReader.readValue(source, POJO.class);
+
+        assertEquals(result, pojo);
+        verify(objectReader).forType(POJO.class);
+        verify(objectReader).readValue(source);
+    }
+
+    @Test
+    public void testValueOfInputStreamWithValueType() throws IOException {
+        when(objectReader.forType((Class<?>) any())).thenReturn(objectReader);
+        when(objectReader.readValue((InputStream) any())).thenReturn(pojo);
+        when(objectReader.readValue((InputStream) any(), (Class<?>) any())).thenCallRealMethod();
+
+        InputStream source = new ByteArrayInputStream("{}".getBytes());
+        POJO result = objectReader.readValue(source, POJO.class);
+
+        assertEquals(result, pojo);
+        verify(objectReader).forType(POJO.class);
+        verify(objectReader).readValue(source);
+    }
+
+    @Test
+    public void testValueOfJsonNodeWithValueType() throws IOException {
+        when(objectReader.forType((Class<?>) any())).thenReturn(objectReader);
+        when(objectReader.readValue((JsonNode) any())).thenReturn(pojo);
+        when(objectReader.readValue((JsonNode) any(), (Class<?>) any())).thenCallRealMethod();
+
+        JsonNode source = new TextNode("{}");
+        POJO result = objectReader.readValue(source, POJO.class);
+
+        assertEquals(result, pojo);
+        verify(objectReader).forType(POJO.class);
+        verify(objectReader).readValue(source);
+    }
+
+    @Test
+    public void testValueOfReaderWithValueType() throws IOException {
+        when(objectReader.forType((Class<?>) any())).thenReturn(objectReader);
+        when(objectReader.readValue((Reader) any())).thenReturn(pojo);
+        when(objectReader.readValue((Reader) any(), (Class<?>) any())).thenCallRealMethod();
+
+        Reader source = new StringReader("{}");
+        POJO result = objectReader.readValue(source, POJO.class);
+
+        assertEquals(result, pojo);
+        verify(objectReader).forType(POJO.class);
+        verify(objectReader).readValue(source);
+    }
+
+    @Test
+    public void testValueOfURLWithValueType() throws IOException {
+        when(objectReader.forType((Class<?>) any())).thenReturn(objectReader);
+        when(objectReader.readValue((URL) any())).thenReturn(pojo);
+        when(objectReader.readValue((URL) any(), (Class<?>) any())).thenCallRealMethod();
+
+        URL source = new URL("http://www.test.com");
+        POJO result = objectReader.readValue(source, POJO.class);
+
+        assertEquals(result, pojo);
+        verify(objectReader).forType(POJO.class);
+        verify(objectReader).readValue(source);
+    }
+}
\ No newline at end of file
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ObjectWriterTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ObjectWriterTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ObjectWriterTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ObjectWriterTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -149,7 +149,7 @@ public class ObjectWriterTest
         input.close();
 
         // and via explicitly passed generator
-        JsonGenerator g = MAPPER.getFactory().createGenerator(new StringWriter());
+        JsonGenerator g = MAPPER.createGenerator(new StringWriter());
         input = new CloseableValue();
         assertFalse(input.closed);
         w.writeValue(g, input);
@@ -234,6 +234,8 @@ public class ObjectWriterTest
         ObjectWriter w = MAPPER.writer();
         assertFalse(w.isEnabled(MapperFeature.ACCEPT_CASE_INSENSITIVE_PROPERTIES));
         assertFalse(w.isEnabled(JsonGenerator.Feature.STRICT_DUPLICATE_DETECTION));
+        assertFalse(w.isEnabled(StreamWriteFeature.STRICT_DUPLICATE_DETECTION));
+
         ObjectWriter newW = w.with(SerializationFeature.FAIL_ON_UNWRAPPED_TYPE_IDENTIFIERS,
                 SerializationFeature.INDENT_OUTPUT);
         assertNotSame(w, newW);
@@ -267,8 +269,11 @@ public class ObjectWriterTest
         assertTrue(w.isEnabled(JsonGenerator.Feature.AUTO_CLOSE_TARGET));
         assertNotSame(w, w.without(JsonGenerator.Feature.AUTO_CLOSE_TARGET));
         assertNotSame(w, w.withoutFeatures(JsonGenerator.Feature.AUTO_CLOSE_TARGET));
+
+        assertFalse(w.isEnabled(StreamWriteFeature.STRICT_DUPLICATE_DETECTION));
+        assertNotSame(w, w.with(StreamWriteFeature.STRICT_DUPLICATE_DETECTION));
     }
-    
+
     /*
     /**********************************************************
     /* Test methods, failures
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/seq/ReadValuesTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/seq/ReadValuesTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/seq/ReadValuesTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/seq/ReadValuesTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -166,7 +166,7 @@ public class ReadValuesTest extends Base
     public void testRootBeansWithParser() throws Exception
     {
         final String JSON = "{\"a\":3}{\"a\":27}  ";
-        JsonParser jp = MAPPER.getFactory().createParser(JSON);
+        JsonParser jp = MAPPER.createParser(JSON);
         
         Iterator<Bean> it = jp.readValuesAs(Bean.class);
 
@@ -182,7 +182,7 @@ public class ReadValuesTest extends Base
     public void testRootArraysWithParser() throws Exception
     {
         final String JSON = "[1][3]";
-        JsonParser jp = MAPPER.getFactory().createParser(JSON);
+        JsonParser jp = MAPPER.createParser(JSON);
 
         // NOTE: We must point JsonParser to the first element; if we tried to
         // use "managed" accessor, it would try to advance past START_ARRAY.
@@ -202,7 +202,7 @@ public class ReadValuesTest extends Base
 
     public void testHasNextWithEndArray() throws Exception {
         final String JSON = "[1,3]";
-        JsonParser jp = MAPPER.getFactory().createParser(JSON);
+        JsonParser jp = MAPPER.createParser(JSON);
 
         // NOTE: We must point JsonParser to the first element; if we tried to
         // use "managed" accessor, it would try to advance past START_ARRAY.
@@ -243,7 +243,7 @@ public class ReadValuesTest extends Base
     public void testNonRootBeans() throws Exception
     {
         final String JSON = "{\"leaf\":[{\"a\":3},{\"a\":27}]}";
-        JsonParser jp = MAPPER.getFactory().createParser(JSON);
+        JsonParser jp = MAPPER.createParser(JSON);
         assertToken(JsonToken.START_OBJECT, jp.nextToken());
         assertToken(JsonToken.FIELD_NAME, jp.nextToken());
         assertToken(JsonToken.START_ARRAY, jp.nextToken());
@@ -267,7 +267,7 @@ public class ReadValuesTest extends Base
     public void testNonRootMapsWithParser() throws Exception
     {
         final String JSON = "[{\"a\":3},{\"a\":27}]";
-        JsonParser jp = MAPPER.getFactory().createParser(JSON);
+        JsonParser jp = MAPPER.createParser(JSON);
         assertToken(JsonToken.START_ARRAY, jp.nextToken());
 
         // can either advance to first START_OBJECT, or clear current token;
@@ -311,7 +311,7 @@ public class ReadValuesTest extends Base
     public void testNonRootArraysUsingParser() throws Exception
     {
         final String JSON = "[[1],[3]]";
-        JsonParser p = MAPPER.getFactory().createParser(JSON);
+        JsonParser p = MAPPER.createParser(JSON);
         assertToken(JsonToken.START_ARRAY, p.nextToken());
         
         // Important: as of 2.1, START_ARRAY can only be skipped if the
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/seq/SequenceWriterTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/seq/SequenceWriterTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/seq/SequenceWriterTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/seq/SequenceWriterTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -13,6 +13,7 @@ import com.fasterxml.jackson.core.JsonGe
 import com.fasterxml.jackson.core.io.SerializedString;
 
 import com.fasterxml.jackson.databind.*;
+import com.fasterxml.jackson.databind.json.JsonMapper;
 
 public class SequenceWriterTest extends BaseMapTest
 {
@@ -108,7 +109,7 @@ public class SequenceWriterTest extends
                 strw.toString());
 
         strw = new StringWriter();
-        JsonGenerator gen = WRITER.getFactory().createGenerator(strw);
+        JsonGenerator gen = WRITER.createGenerator(strw);
         w = WRITER
                 .withRootValueSeparator(new SerializedString("/"))
                 .writeValues(gen);
@@ -132,7 +133,7 @@ public class SequenceWriterTest extends
                 strw.toString());
 
         strw = new StringWriter();
-        JsonGenerator gen = WRITER.getFactory().createGenerator(strw);
+        JsonGenerator gen = WRITER.createGenerator(strw);
         w = WRITER.writeValuesAsArray(gen);
         Collection<Bean> bean = Collections.singleton(new Bean(3));
         w.write(new Bean(1))
@@ -194,7 +195,8 @@ public class SequenceWriterTest extends
     @SuppressWarnings("resource")
     public void testSimpleCloseable() throws Exception
     {
-        ObjectWriter w = MAPPER.writer()
+        JsonMapper mapper = JsonMapper.builder().enable(MapperFeature.SORT_PROPERTIES_ALPHABETICALLY).build();
+        ObjectWriter w = mapper.writer()
                 .with(SerializationFeature.CLOSE_CLOSEABLE);
         CloseableValue input = new CloseableValue();
         assertFalse(input.closed);
@@ -206,7 +208,7 @@ public class SequenceWriterTest extends
         assertTrue(input.closed);
         seq.close();
         input.close();
-        assertEquals(aposToQuotes("{'x':0,'closed':false}"), out.toString());
+        assertEquals(aposToQuotes("{'closed':false,'x':0}"), out.toString());
     }
 
     public void testWithExplicitType() throws Exception
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/AnyGetterTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/AnyGetterTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/AnyGetterTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/AnyGetterTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -6,6 +6,7 @@ import java.util.*;
 import com.fasterxml.jackson.annotation.*;
 import com.fasterxml.jackson.core.JsonGenerator;
 import com.fasterxml.jackson.databind.*;
+import com.fasterxml.jackson.databind.ser.impl.*;
 import com.fasterxml.jackson.databind.annotation.JsonSerialize;
 import com.fasterxml.jackson.databind.ser.std.StdScalarSerializer;
 import com.fasterxml.jackson.databind.ser.std.StdSerializer;
@@ -131,6 +132,37 @@ public class AnyGetterTest extends BaseM
         }
     }
 
+    static class Bean2592NoAnnotations
+    {
+        protected Map<String, String> properties = new HashMap<>();
+
+        @JsonAnyGetter
+        public Map<String, String> getProperties() {
+            return properties;
+        }
+
+        public void setProperties(Map<String, String> properties) {
+            this.properties = properties;
+        }
+
+        public void add(String key, String value) {
+            properties.put(key, value);
+        }
+    }
+
+    static class Bean2592PropertyIncludeNonEmpty extends Bean2592NoAnnotations
+    {
+        @JsonInclude(content = JsonInclude.Include.NON_EMPTY)
+        @JsonAnyGetter
+        @Override
+        public Map<String, String> getProperties() {
+            return properties;
+        }
+    }
+
+    @JsonFilter("Bean2592")
+    static class Bean2592WithFilter extends Bean2592NoAnnotations {}
+
     /*
     /**********************************************************
     /* Test methods
@@ -196,4 +228,62 @@ public class AnyGetterTest extends BaseM
         String json = mapper.writeValueAsString(input);
         assertEquals("{\"key\":\"VALUE\"}", json);
     }
+
+    // [databind#2592]
+    public void testAnyGetterWithMapperDefaultIncludeNonEmpty() throws Exception
+    {
+        ObjectMapper mapper = new ObjectMapper()
+                .setSerializationInclusion(JsonInclude.Include.NON_EMPTY);
+        Bean2592NoAnnotations input = new Bean2592NoAnnotations();
+        input.add("non-empty", "property");
+        input.add("empty", "");
+        input.add("null", null);
+        String json = mapper.writeValueAsString(input);
+        assertEquals("{\"non-empty\":\"property\"}", json);
+    }
+
+    // [databind#2592]
+    public void testAnyGetterWithMapperDefaultIncludeNonEmptyAndFilterOnBean() throws Exception
+    {
+        FilterProvider filters = new SimpleFilterProvider()
+                .addFilter("Bean2592", SimpleBeanPropertyFilter.serializeAllExcept("something"));
+        ObjectMapper mapper = new ObjectMapper()
+                .setSerializationInclusion(JsonInclude.Include.NON_EMPTY)
+                .setFilterProvider(filters);
+        Bean2592WithFilter input = new Bean2592WithFilter();
+        input.add("non-empty", "property");
+        input.add("empty", "");
+        input.add("null", null);
+        String json = mapper.writeValueAsString(input);
+        // Unfortunately path for bean with filter is different. It still skips nulls.
+        assertEquals("{\"non-empty\":\"property\",\"empty\":\"\"}", json);
+    }
+
+    // [databind#2592]
+    public void testAnyGetterWithPropertyIncludeNonEmpty() throws Exception
+    {
+        ObjectMapper mapper = new ObjectMapper();
+        Bean2592PropertyIncludeNonEmpty input = new Bean2592PropertyIncludeNonEmpty();
+        input.add("non-empty", "property");
+        input.add("empty", "");
+        input.add("null", null);
+        String json = mapper.writeValueAsString(input);
+        assertEquals("{\"non-empty\":\"property\"}", json);
+    }
+
+    // [databind#2592]
+    public void testAnyGetterConfigIncludeNonEmpty() throws Exception
+    {
+        ObjectMapper mapper = new ObjectMapper();
+        mapper.configOverride(Map.class).setInclude(JsonInclude.Value.construct(
+                JsonInclude.Include.USE_DEFAULTS,
+                JsonInclude.Include.NON_EMPTY
+        ));
+        Bean2592NoAnnotations input = new Bean2592NoAnnotations();
+        input.add("non-empty", "property");
+        input.add("empty", "");
+        input.add("null", null);
+        String json = mapper.writeValueAsString(input);
+        assertEquals("{\"non-empty\":\"property\"}", json);
+    }
 }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/CyclicTypeSerTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/CyclicTypeSerTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/CyclicTypeSerTest.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/CyclicTypeSerTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,103 @@
+package com.fasterxml.jackson.databind.ser;
+
+import java.util.*;
+
+import com.fasterxml.jackson.annotation.JsonFormat;
+import com.fasterxml.jackson.annotation.JsonPropertyOrder;
+
+import com.fasterxml.jackson.databind.*;
+
+/**
+ * Simple unit tests to verify that it is possible to handle
+ * potentially cyclic structures, as long as object graph itself
+ * is not cyclic. This is the case for directed hierarchies like
+ * trees and DAGs.
+ */
+public class CyclicTypeSerTest
+    extends BaseMapTest
+{
+    static class Bean
+    {
+        Bean _next;
+        final String _name;
+
+        public Bean(Bean next, String name) {
+            _next = next;
+            _name = name;
+        }
+
+        public Bean getNext() { return _next; }
+        public String getName() { return _name; }
+
+        public void assignNext(Bean n) { _next = n; }
+    }
+
+    @JsonPropertyOrder({ "id", "parent" })
+    static class Selfie2501 {
+        public int id;
+
+        public Selfie2501 parent;
+        
+        public Selfie2501(int id) { this.id = id; }
+    }
+
+    @JsonFormat(shape = JsonFormat.Shape.ARRAY)
+    static class Selfie2501AsArray extends Selfie2501 {
+        public Selfie2501AsArray(int id) { super(id); }
+    }
+
+    /*
+    /**********************************************************
+    /* Types
+    /**********************************************************
+     */
+
+    private final ObjectMapper MAPPER = newJsonMapper();
+
+    public void testLinkedButNotCyclic() throws Exception
+    {
+        Bean last = new Bean(null, "last");
+        Bean first = new Bean(last, "first");
+        Map<String,Object> map = writeAndMap(MAPPER, first);
+
+        assertEquals(2, map.size());
+        assertEquals("first", map.get("name"));
+
+        @SuppressWarnings("unchecked")
+        Map<String,Object> map2 = (Map<String,Object>) map.get("next");
+        assertNotNull(map2);
+        assertEquals(2, map2.size());
+        assertEquals("last", map2.get("name"));
+        assertNull(map2.get("next"));
+    }
+
+    public void testSimpleDirectSelfReference() throws Exception
+    {
+        Bean selfRef = new Bean(null, "self-refs");
+        Bean first = new Bean(selfRef, "first");
+        selfRef.assignNext(selfRef);
+        Bean[] wrapper = new Bean[] { first };
+        try {
+            writeAndMap(MAPPER, wrapper);
+        } catch (JsonMappingException e) {
+            verifyException(e, "Direct self-reference leading to cycle");
+        }
+    }
+
+    // [databind#2501]: Should be possible to replace null cyclic ref
+    public void testReplacedCycle() throws Exception
+    {
+        Selfie2501 self1 = new Selfie2501(1);
+        self1.parent = self1;
+        ObjectWriter w = MAPPER.writer()
+                .without(SerializationFeature.FAIL_ON_SELF_REFERENCES)
+                .with(SerializationFeature.WRITE_SELF_REFERENCES_AS_NULL)
+                ;
+        assertEquals(aposToQuotes("{'id':1,'parent':null}"), w.writeValueAsString(self1));
+
+        // Also consider a variant of cyclic POJO in container
+        Selfie2501AsArray self2 = new Selfie2501AsArray(2);
+        self2.parent = self2;
+        assertEquals(aposToQuotes("[2,null]"), w.writeValueAsString(self2));
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/FieldSerializationTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/FieldSerializationTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/FieldSerializationTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/FieldSerializationTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -131,7 +131,7 @@ public class FieldSerializationTest
     /**********************************************************
      */
 
-    private final ObjectMapper MAPPER = new ObjectMapper();
+    private final ObjectMapper MAPPER = newJsonMapper();
 
     public void testSimpleAutoDetect() throws Exception
     {
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/jdk/AtomicTypeSerializationTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/jdk/AtomicTypeSerializationTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/jdk/AtomicTypeSerializationTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/jdk/AtomicTypeSerializationTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -5,6 +5,7 @@ import java.util.*;
 import java.util.concurrent.atomic.*;
 
 import com.fasterxml.jackson.annotation.*;
+
 import com.fasterxml.jackson.databind.BaseMapTest;
 import com.fasterxml.jackson.databind.ObjectMapper;
 import com.fasterxml.jackson.databind.annotation.JsonSerialize;
@@ -64,13 +65,19 @@ public class AtomicTypeSerializationTest
         }
     }
 
+    // [databind#2565]: problems with JsonUnwrapped, non-unwrappable type
+    static class MyBean2565 {
+        @JsonUnwrapped
+        public AtomicReference<String> maybeText = new AtomicReference<>("value");
+    }
+
     /*
     /**********************************************************
     /* Test methods
     /**********************************************************
      */
 
-    private final ObjectMapper MAPPER = objectMapper();
+    private final ObjectMapper MAPPER = newJsonMapper();
     
     public void testAtomicBoolean() throws Exception
     {
@@ -135,4 +142,11 @@ public class AtomicTypeSerializationTest
         String json = MAPPER.writeValueAsString(new ContainerB());
         assertEquals("{\"strategy\":[" + EXPECTED + "]}", json);
     }
+
+    // [databind#2565]: problems with JsonUnwrapped, non-unwrappable type
+    public void testWithUnwrappableUnwrapped() throws Exception
+    {
+        assertEquals(aposToQuotes("{'maybeText':'value'}"),
+                MAPPER.writeValueAsString(new MyBean2565()));
+    }
 }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/jdk/DateSerializationTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/jdk/DateSerializationTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/jdk/DateSerializationTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/jdk/DateSerializationTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -117,13 +117,18 @@ public class DateSerializationTest
         ObjectMapper mapper = new ObjectMapper();
         mapper.configure(SerializationFeature.WRITE_DATES_AS_TIMESTAMPS, false);
 
-        serialize(mapper, judate(1970, 1, 1,  02, 00, 00, 0, "GMT+2"), "1970-01-01T00:00:00.000+0000");
-        serialize(mapper, judate(1970, 1, 1,  00, 00, 00, 0, "UTC"),   "1970-01-01T00:00:00.000+0000");
+        serialize(mapper, judate(1970, 1, 1,  02, 00, 00, 0, "GMT+2"),
+                "1970-01-01T00:00:00.000+"+zoneOffset("0000"));
+        serialize(mapper, judate(1970, 1, 1,  00, 00, 00, 0, "UTC"),
+                "1970-01-01T00:00:00.000+"+zoneOffset("0000"));
 
         // 22-Nov-2018, tatu: Also ensure we use padding...
-        serialize(mapper, judate(911, 1, 1,  00, 00, 00, 0, "UTC"),   "0911-01-01T00:00:00.000+0000");
-        serialize(mapper, judate(87, 1, 1,  00, 00, 00, 0, "UTC"),   "0087-01-01T00:00:00.000+0000");
-        serialize(mapper, judate(1, 1, 1,  00, 00, 00, 0, "UTC"),   "0001-01-01T00:00:00.000+0000");
+        serialize(mapper, judate(911, 1, 1,  00, 00, 00, 0, "UTC"),
+                "0911-01-01T00:00:00.000+"+zoneOffset("0000"));
+        serialize(mapper, judate(87, 1, 1,  00, 00, 00, 0, "UTC"),
+                "0087-01-01T00:00:00.000+"+zoneOffset("0000"));
+        serialize(mapper, judate(1, 1, 1,  00, 00, 00, 0, "UTC"),
+                "0001-01-01T00:00:00.000+"+zoneOffset("0000"));
     }
 
     // [databind#2167]: beyond year 9999 needs special handling
@@ -131,9 +136,11 @@ public class DateSerializationTest
     {
         ObjectWriter w = MAPPER.writer()
                 .without(SerializationFeature.WRITE_DATES_AS_TIMESTAMPS);
-        serialize(w, judate(10204, 1, 1,  00, 00, 00, 0, "UTC"),   "+10204-01-01T00:00:00.000+0000");
+        serialize(w, judate(10204, 1, 1,  00, 00, 00, 0, "UTC"),
+                "+10204-01-01T00:00:00.000+"+zoneOffset("0000"));
         // and although specification lacks for beyond 5 digits (well, actually even 5...), let's do our best:
-        serialize(w, judate(123456, 1, 1,  00, 00, 00, 0, "UTC"),   "+123456-01-01T00:00:00.000+0000");
+        serialize(w, judate(123456, 1, 1,  00, 00, 00, 0, "UTC"),
+                "+123456-01-01T00:00:00.000+"+zoneOffset("0000"));
     }
 
     // [databind#2167]: dates before Common Era (CE), that is, BCE, need special care:
@@ -145,12 +152,12 @@ public class DateSerializationTest
         // First: I _think_ BCE-1 is what you get with year 0, and should become "+0000"
         // and from further back in time, it'll be "-0001" (BCE-2) etc)
 
-        serialize(w, judate(0, 1, 1,  00, 00, 00, 0, "UTC"),   "+0000-01-01T00:00:00.000+0000");
-        serialize(w, judate(-1, 1, 1,  00, 00, 00, 0, "UTC"),   "-0001-01-01T00:00:00.000+0000");
-        serialize(w, judate(-49, 1, 1,  00, 00, 00, 0, "UTC"),   "-0049-01-01T00:00:00.000+0000"); // All hail Caesar
-        serialize(w, judate(-264, 1, 1,  00, 00, 00, 0, "UTC"),   "-0264-01-01T00:00:00.000+0000"); // Carthage FTW?
+        serialize(w, judate(0, 1, 1,  00, 00, 00, 0, "UTC"),   "+0000-01-01T00:00:00.000+"+zoneOffset("0000"));
+        serialize(w, judate(-1, 1, 1,  00, 00, 00, 0, "UTC"),   "-0001-01-01T00:00:00.000+"+zoneOffset("0000"));
+        serialize(w, judate(-49, 1, 1,  00, 00, 00, 0, "UTC"),   "-0049-01-01T00:00:00.000+"+zoneOffset("0000")); // All hail Caesar
+        serialize(w, judate(-264, 1, 1,  00, 00, 00, 0, "UTC"),   "-0264-01-01T00:00:00.000+"+zoneOffset("0000")); // Carthage FTW?
     }
-    
+
     /**
      * Use a default TZ other than UTC. Dates must be serialized using that TZ.
      */
@@ -160,28 +167,31 @@ public class DateSerializationTest
         mapper.configure(SerializationFeature.WRITE_DATES_AS_TIMESTAMPS, false);
         mapper.setTimeZone(TimeZone.getTimeZone("GMT+2"));
 
-        serialize( mapper, judate(1970, 1, 1,  00, 00, 00, 0, "GMT+2"), "1970-01-01T00:00:00.000+0200");
-        serialize( mapper, judate(1970, 1, 1,  00, 00, 00, 0, "UTC"),   "1970-01-01T02:00:00.000+0200");
+        serialize(mapper, judate(1970, 1, 1,  00, 00, 00, 0, "GMT+2"),
+                "1970-01-01T00:00:00.000+"+zoneOffset("0200"));
+        serialize(mapper, judate(1970, 1, 1,  00, 00, 00, 0, "UTC"),
+                "1970-01-01T02:00:00.000+"+zoneOffset("0200"));
     }
 
     /**
      * Configure the StdDateFormat to serialize TZ offset with a colon between hours and minutes
      *
-     * See [databind#1744]
+     * See [databind#1744], [databind#2643]
      */
     public void testDateISO8601_colonInTZ() throws IOException
     {
+        // with [databind#2643], default now is to include
         StdDateFormat dateFormat = new StdDateFormat();
-        assertFalse(dateFormat.isColonIncludedInTimeZone());
-        dateFormat = dateFormat.withColonInTimeZone(true);
         assertTrue(dateFormat.isColonIncludedInTimeZone());
+        // but we can disable it
+        dateFormat = dateFormat.withColonInTimeZone(false);
 
         ObjectMapper mapper = new ObjectMapper();
         mapper.configure(SerializationFeature.WRITE_DATES_AS_TIMESTAMPS, false);
         mapper.setDateFormat(dateFormat);
         
-        serialize( mapper, judate(1970, 1, 1,  02, 00, 00, 0, "GMT+2"), "1970-01-01T00:00:00.000+00:00");
-        serialize( mapper, judate(1970, 1, 1,  00, 00, 00, 0, "UTC"),   "1970-01-01T00:00:00.000+00:00");
+        serialize(mapper, judate(1970, 1, 1,  02, 00, 00, 0, "GMT+2"), "1970-01-01T00:00:00.000+0000");
+        serialize(mapper, judate(1970, 1, 1,  00, 00, 00, 0, "UTC"),   "1970-01-01T00:00:00.000+0000");
     }
 
     public void testDateOther() throws IOException
@@ -232,7 +242,7 @@ public class DateSerializationTest
         assertFalse(mapper.isEnabled(SerializationFeature.WRITE_DATE_KEYS_AS_TIMESTAMPS));
         map.put(new Date(0L), Integer.valueOf(1));
         // by default will serialize as ISO-8601 values...
-        assertEquals("{\"1970-01-01T00:00:00.000+0000\":1}", mapper.writeValueAsString(map));
+        assertEquals("{\"1970-01-01T00:00:00.000+"+zoneOffset("0000")+"\":1}", mapper.writeValueAsString(map));
         
         // but can change to use timestamps too
         mapper.configure(SerializationFeature.WRITE_DATE_KEYS_AS_TIMESTAMPS, true);
@@ -264,7 +274,7 @@ public class DateSerializationTest
 
         // and with default (ISO8601) format (databind#1109)
         json = mapper.writeValueAsString(new DateAsDefaultStringBean(0L));
-        assertEquals("{\"date\":\"1970-01-01T00:00:00.000+0000\"}", json);
+        assertEquals("{\"date\":\"1970-01-01T00:00:00.000+"+zoneOffset("0000")+"\"}", json);
     }
 
     /**
@@ -286,10 +296,12 @@ public class DateSerializationTest
         serialize( mapper, judate(1969, 12, 31, 16, 00, 00, 00, "PST"), "1969-12-31/16:00 PST");
 
         // Also: should be able to dynamically change timezone:
-        ObjectWriter w = mapper.writer();
-        w = w.with(TimeZone.getTimeZone("EST"));
-        String json = w.writeValueAsString(new Date(0));
-        assertEquals(quote("1969-12-31/19:00 EST"), json);
+        ObjectWriter w = mapper.writer().with(TimeZone.getTimeZone("EST"));
+        assertEquals(quote("1969-12-31/"+zoneOffset("1900")+" EST"), w.writeValueAsString(new Date(0)));
+
+        // wrt [databind#2643]
+        w = mapper.writer().with(TimeZone.getTimeZone("Asia/Tehran"));
+        assertEquals(quote("1970-01-01/"+zoneOffset("0330")+" IRST"), w.writeValueAsString(new Date(0)));
     }
 
     /**
@@ -305,7 +317,7 @@ public class DateSerializationTest
         assertEquals(aposToQuotes("{'date':0}"), json);
         mapper.disable(SerializationFeature.WRITE_DATES_AS_TIMESTAMPS);
         json = mapper.writeValueAsString(new DateAsDefaultBean(0L));
-        assertEquals(aposToQuotes("{'date':'1970-01-01T00:00:00.000+0000'}"), json);
+        assertEquals(aposToQuotes("{'date':'1970-01-01T00:00:00.000+"+zoneOffset("0000")+"'}"), json);
 
         // Empty @JsonFormat => default to user config
         mapper.enable(SerializationFeature.WRITE_DATES_AS_TIMESTAMPS);
@@ -313,7 +325,7 @@ public class DateSerializationTest
         assertEquals(aposToQuotes("{'date':0}"), json);
         mapper.disable(SerializationFeature.WRITE_DATES_AS_TIMESTAMPS);
         json = mapper.writeValueAsString(new DateAsDefaultBeanWithEmptyJsonFormat(0L));
-        assertEquals(aposToQuotes("{'date':'1970-01-01T00:00:00.000+0000'}"), json);
+        assertEquals(aposToQuotes("{'date':'1970-01-01T00:00:00.000+"+zoneOffset("0000")+"'}"), json);
 
         // @JsonFormat with Shape.ANY and pattern => STRING shape, regardless of user config
         mapper.enable(SerializationFeature.WRITE_DATES_AS_TIMESTAMPS);
@@ -326,18 +338,18 @@ public class DateSerializationTest
         // @JsonFormat with Shape.ANY and locale => STRING shape, regardless of user config
         mapper.enable(SerializationFeature.WRITE_DATES_AS_TIMESTAMPS);
         json = mapper.writeValueAsString(new DateAsDefaultBeanWithLocale(0L));
-        assertEquals(aposToQuotes("{'date':'1970-01-01T00:00:00.000+0000'}"), json);
+        assertEquals(aposToQuotes("{'date':'1970-01-01T00:00:00.000+"+zoneOffset("0000")+"'}"), json);
         mapper.disable(SerializationFeature.WRITE_DATES_AS_TIMESTAMPS);
         json = mapper.writeValueAsString(new DateAsDefaultBeanWithLocale(0L));
-        assertEquals(aposToQuotes("{'date':'1970-01-01T00:00:00.000+0000'}"), json);
+        assertEquals(aposToQuotes("{'date':'1970-01-01T00:00:00.000+"+zoneOffset("0000")+"'}"), json);
 
         // @JsonFormat with Shape.ANY and timezone => STRING shape, regardless of user config
         mapper.enable(SerializationFeature.WRITE_DATES_AS_TIMESTAMPS);
         json = mapper.writeValueAsString(new DateAsDefaultBeanWithTimezone(0L));
-        assertEquals(aposToQuotes("{'date':'1970-01-01T01:00:00.000+0100'}"), json);
+        assertEquals(aposToQuotes("{'date':'1970-01-01T01:00:00.000+"+zoneOffset("0100")+"'}"), json);
         mapper.disable(SerializationFeature.WRITE_DATES_AS_TIMESTAMPS);
         json = mapper.writeValueAsString(new DateAsDefaultBeanWithTimezone(0L));
-        assertEquals(aposToQuotes("{'date':'1970-01-01T01:00:00.000+0100'}"), json);
+        assertEquals(aposToQuotes("{'date':'1970-01-01T01:00:00.000+"+zoneOffset("0100")+"'}"), json);
     }
 
     // [databind#1648]: contextual default format should be used
@@ -372,4 +384,10 @@ public class DateSerializationTest
     private void serialize(ObjectWriter w, Object date, String expected) throws IOException {
         Assert.assertEquals(quote(expected), w.writeValueAsString(date));
     }
+
+    private String zoneOffset(String raw) {
+        // Add colon or not -- difference between 2.10 and earlier, 2.11 and later
+        return raw.substring(0, 2) + ":" + raw.substring(2); // 2.11 and later
+//        return raw; // 2.10 and earlier
+    }
 }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/jdk/JDKTypeSerializationTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/jdk/JDKTypeSerializationTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/jdk/JDKTypeSerializationTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/jdk/JDKTypeSerializationTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -150,13 +150,36 @@ public class JDKTypeSerializationTest
     public void testSlicedByteBuffer() throws IOException
     {
         final byte[] INPUT_BYTES = new byte[] { 1, 2, 3, 4, 5 };
-        String exp = MAPPER.writeValueAsString(new byte[] { 3, 4, 5 });
         ByteBuffer bbuf = ByteBuffer.wrap(INPUT_BYTES);
 
         bbuf.position(2);
         ByteBuffer slicedBuf = bbuf.slice();
 
-        assertEquals(exp, MAPPER.writeValueAsString(slicedBuf));
+        assertEquals(MAPPER.writeValueAsString(new byte[] { 3, 4, 5 }),
+                MAPPER.writeValueAsString(slicedBuf));
+
+        // but how about offset within?
+        slicedBuf.position(1);
+        assertEquals(MAPPER.writeValueAsString(new byte[] { 4, 5 }),
+                MAPPER.writeValueAsString(slicedBuf));
+    }
+
+    // [databind#2602]: Need to consider position()
+    public void testDuplicatedByteBufferWithCustomPosition() throws IOException
+    {
+        final byte[] INPUT_BYTES = new byte[] { 1, 2, 3, 4, 5 };
+
+        String exp = MAPPER.writeValueAsString(new byte[] { 3, 4, 5 });
+        ByteBuffer bbuf = ByteBuffer.wrap(INPUT_BYTES);
+        bbuf.position(2);
+        ByteBuffer duplicated = bbuf.duplicate();
+        assertEquals(exp, MAPPER.writeValueAsString(duplicated));
+
+        // also check differently constructed bytebuffer (noting that
+        // offset given is the _position_ to use, NOT array offset
+        exp = MAPPER.writeValueAsString(new byte[] { 2, 3, 4 });
+        bbuf = ByteBuffer.wrap(INPUT_BYTES, 1, 3);
+        assertEquals(exp, MAPPER.writeValueAsString(bbuf.duplicate()));
     }
 
     // Verify that efficient UUID codec won't mess things up:
@@ -199,4 +222,15 @@ public class JDKTypeSerializationTest
         assertEquals(aposToQuotes("{'value':null}"),
                 MAPPER.writeValueAsString(new VoidBean()));
     }
+
+    // [databind#2657]
+    public void testNonStandardProperties() throws Exception
+    {
+        Properties properties = new Properties();
+        // Bad usage: Properties should NOT contain non-Strings. But
+        // some do that regardless and compiler won't stop it so.
+        properties.put("key", 1);
+        String json = MAPPER.writeValueAsString(properties);
+        assertEquals("{\"key\":1}", json);
+    }
 }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/jdk/MapKeySerialization2306Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/jdk/MapKeySerialization2306Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/jdk/MapKeySerialization2306Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/jdk/MapKeySerialization2306Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,35 @@
+package com.fasterxml.jackson.databind.ser.jdk;
+
+import java.util.Collections;
+import java.util.Map;
+
+import com.fasterxml.jackson.annotation.JsonValue;
+import com.fasterxml.jackson.databind.*;
+
+public class MapKeySerialization2306Test extends BaseMapTest
+{
+    static class JsonValue2306Key {
+        @JsonValue
+        private String id;
+
+        public JsonValue2306Key(String id) {
+            this.id = id;
+        }
+    }
+
+    /*
+    /**********************************************************************
+    /* Test methods
+    /**********************************************************************
+     */
+
+    private final ObjectMapper MAPPER = newJsonMapper();
+
+    public void testMapKeyWithJsonValue() throws Exception
+    {
+        final Map<JsonValue2306Key, String> map = Collections.singletonMap(
+                new JsonValue2306Key("myId"), "value");
+        assertEquals(aposToQuotes("{'myId':'value'}"),
+                MAPPER.writeValueAsString(map));
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/SerializationFeaturesTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/SerializationFeaturesTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/SerializationFeaturesTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/SerializationFeaturesTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -81,14 +81,14 @@ public class SerializationFeaturesTest
         assertTrue(mapper.getSerializationConfig().isEnabled(SerializationFeature.FLUSH_AFTER_WRITE_VALUE));
         // default is to flush after writeValue()
         StringWriter sw = new StringWriter();
-        JsonGenerator g = mapper.getFactory().createGenerator(sw);
+        JsonGenerator g = mapper.createGenerator(sw);
         mapper.writeValue(g, Integer.valueOf(13));
         assertEquals("13", sw.toString());
         g.close();
 
         // ditto with ObjectWriter
         sw = new StringWriter();
-        g = mapper.getFactory().createGenerator(sw);
+        g = mapper.createGenerator(sw);
         ObjectWriter ow = mapper.writer();
         ow.writeValue(g, Integer.valueOf(99));
         assertEquals("99", sw.toString());
@@ -101,7 +101,7 @@ public class SerializationFeaturesTest
         ObjectMapper mapper = new ObjectMapper();
         mapper.configure(SerializationFeature.FLUSH_AFTER_WRITE_VALUE, false);
         StringWriter sw = new StringWriter();
-        JsonGenerator g = mapper.getFactory().createGenerator(sw);
+        JsonGenerator g = mapper.createGenerator(sw);
 
         mapper.writeValue(g, Integer.valueOf(13));
         // no flushing now:
@@ -112,7 +112,7 @@ public class SerializationFeaturesTest
         g.close();
         // Also, same should happen with ObjectWriter
         sw = new StringWriter();
-        g = mapper.getFactory().createGenerator(sw);
+        g = mapper.createGenerator(sw);
         ObjectWriter ow = mapper.writer();
         ow.writeValue(g, Integer.valueOf(99));
         assertEquals("", sw.toString());
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/SerializationOrderTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/SerializationOrderTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/SerializationOrderTest.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/SerializationOrderTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,163 @@
+package com.fasterxml.jackson.databind.ser;
+
+import com.fasterxml.jackson.annotation.*;
+
+import com.fasterxml.jackson.databind.*;
+
+/**
+ * Unit tests for verifying that constraints on ordering of serialized
+ * properties are held.
+ */
+public class SerializationOrderTest
+    extends BaseMapTest
+{
+    static class BeanWithCreator
+    {
+        public int a;
+        public int b;
+        public int c;
+
+        @JsonCreator public BeanWithCreator(@JsonProperty("c") int c, @JsonProperty("a") int a) {
+            this.a = a;
+            this.c = c;
+        }
+    }
+
+    @JsonPropertyOrder({"c", "a", "b"})
+    static class BeanWithOrder
+    {
+        public int d, b, a, c;
+
+        public BeanWithOrder(int a, int b, int c, int d) {
+            this.a = a;
+            this.b = b;
+            this.c = c;
+            this.d = d;
+        }
+    }
+
+    @JsonPropertyOrder(value={"d"}, alphabetic=true)
+    static class SubBeanWithOrder extends BeanWithOrder
+    {
+        public SubBeanWithOrder(int a, int b, int c, int d) {
+            super(a, b, c, d);
+        }
+    }
+
+    @JsonPropertyOrder({"b", "a",
+        // note: including non-existant properties is fine (has no effect, but not an error)
+        "foobar",
+        "c"
+    })
+    static class OrderMixIn { }
+
+    @JsonPropertyOrder(value={"a","b","x","z"})
+    static class BeanFor268 {
+        @JsonProperty("a") public String xA = "a";
+        @JsonProperty("z") public String aZ = "z";
+    	   @JsonProperty("b") public String xB() { return "b"; }
+    	   @JsonProperty("x") public String aX() { return "x"; }
+    }
+
+    static class BeanFor459 {
+        public int d = 4;
+        public int c = 3;
+        public int b = 2;
+        public int a = 1;
+    }
+
+    // For [databind#311]
+    @JsonPropertyOrder(alphabetic = true)
+    static class BeanForGH311 {
+        private final int a;
+        private final int b;
+
+        @JsonCreator
+        public BeanForGH311(@JsonProperty("b") int b, @JsonProperty("a") int a) { //b and a are out of order, although alphabetic = true
+            this.a = a;
+            this.b = b;
+        }
+
+        public int getA() { return a; }
+        public int getB() { return b; }
+    }
+
+    // We'll expect ordering of "FUBAR"
+    @JsonPropertyOrder({ "f"  })
+    static class OrderingByIndexBean {
+        public int r;
+        public int a;
+
+        @JsonProperty(index = 1)
+        public int b;
+
+        @JsonProperty(index = 0)
+        public int u;
+
+        public int f;
+    }
+
+    /*
+    /*********************************************
+    /* Unit tests
+    /*********************************************
+     */
+
+    private final ObjectMapper MAPPER = newJsonMapper();
+
+    private final ObjectMapper ALPHA_MAPPER = jsonMapperBuilder()
+            .configure(MapperFeature.SORT_PROPERTIES_ALPHABETICALLY, true)
+            .build();
+
+    public void testImplicitOrderByCreator() throws Exception {
+        assertEquals("{\"c\":1,\"a\":2,\"b\":0}",
+                MAPPER.writeValueAsString(new BeanWithCreator(1, 2)));
+    }
+
+    public void testExplicitOrder() throws Exception {
+        assertEquals("{\"c\":3,\"a\":1,\"b\":2,\"d\":4}",
+                MAPPER.writeValueAsString(new BeanWithOrder(1, 2, 3, 4)));
+    }
+
+    public void testAlphabeticOrder() throws Exception {
+        assertEquals("{\"d\":4,\"a\":1,\"b\":2,\"c\":3}",
+                MAPPER.writeValueAsString(new SubBeanWithOrder(1, 2, 3, 4)));
+    }
+
+    public void testOrderWithMixins() throws Exception
+    {
+        ObjectMapper m = jsonMapperBuilder()
+                .addMixIn(BeanWithOrder.class, OrderMixIn.class)
+                .build();
+        assertEquals("{\"b\":2,\"a\":1,\"c\":3,\"d\":4}",
+                serializeAsString(m, new BeanWithOrder(1, 2, 3, 4)));
+    }
+
+    public void testOrderWrt268() throws Exception
+    {
+        assertEquals("{\"a\":\"a\",\"b\":\"b\",\"x\":\"x\",\"z\":\"z\"}",
+                MAPPER.writeValueAsString(new BeanFor268()));
+    }
+
+    public void testOrderWithFeature() throws Exception
+    {
+        assertEquals("{\"a\":1,\"b\":2,\"c\":3,\"d\":4}",
+                ALPHA_MAPPER.writeValueAsString(new BeanFor459()));
+    }
+
+    // [databind#311]
+    public void testAlphaAndCreatorOrdering() throws Exception
+    {
+        String json = ALPHA_MAPPER.writeValueAsString(new BeanForGH311(2, 1));
+        assertEquals("{\"a\":1,\"b\":2}", json);
+    }
+
+    // [databind#2555]
+    public void testOrderByIndexEtc() throws Exception
+    {
+        // since "default" order can actually vary with later JDKs, only verify
+        // case of alphabetic-as-default
+        assertEquals(aposToQuotes("{'f':0,'u':0,'b':0,'a':0,'r':0}"),
+                ALPHA_MAPPER.writeValueAsString(new OrderingByIndexBean()));
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/TestArraySerialization.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/TestArraySerialization.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/TestArraySerialization.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/TestArraySerialization.java	2020-06-25 02:44:21.000000000 +0000
@@ -18,7 +18,7 @@ public class TestArraySerialization
         }
         String str = sb.toString();
         byte[] data = MAPPER.writeValueAsBytes(new String[] { "abc", str, null, str });
-        JsonParser jp = MAPPER.getFactory().createParser(data);
+        JsonParser jp = MAPPER.createParser(data);
         assertToken(JsonToken.START_ARRAY, jp.nextToken());
         assertToken(JsonToken.VALUE_STRING, jp.nextToken());
         assertEquals("abc", jp.getText());
@@ -51,10 +51,9 @@ public class TestArraySerialization
         // Let's try couple of times, to ensure that state is handled
         // correctly by ObjectMapper (wrt buffer recycling used
         // with 'writeAsBytes()')
-        JsonFactory f = MAPPER.getFactory();
         for (int round = 0; round < 3; ++round) {
             byte[] data = MAPPER.writeValueAsBytes(ints);
-            JsonParser jp = f.createParser(data);
+            JsonParser jp = MAPPER.createParser(data);
             assertToken(JsonToken.START_ARRAY, jp.nextToken());
             for (int i = 0; i < SIZE; ++i) {
                 assertToken(JsonToken.VALUE_NUMBER_INT, jp.nextToken());
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/TestConfig.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/TestConfig.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/TestConfig.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/TestConfig.java	2020-06-25 02:44:21.000000000 +0000
@@ -171,7 +171,7 @@ public class TestConfig
 
         // [Issue#12]
         StringWriter sw = new StringWriter();
-        JsonGenerator jgen = MAPPER.getFactory().createGenerator(sw);
+        JsonGenerator jgen = MAPPER.createGenerator(sw);
         indentWriter.writeValue(jgen, input);
         jgen.close();
         assertEquals(INDENTED, sw.toString());
@@ -180,7 +180,7 @@ public class TestConfig
         sw = new StringWriter();
         ObjectMapper m2 = new ObjectMapper();
         m2.enable(SerializationFeature.INDENT_OUTPUT);
-        jgen = m2.getFactory().createGenerator(sw);
+        jgen = m2.createGenerator(sw);
         m2.writeValue(jgen, input);
         jgen.close();
         assertEquals(INDENTED, sw.toString());
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/TestCyclicTypes.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/TestCyclicTypes.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/TestCyclicTypes.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/TestCyclicTypes.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,78 +0,0 @@
-package com.fasterxml.jackson.databind.ser;
-
-import java.util.*;
-
-
-import com.fasterxml.jackson.databind.*;
-
-/**
- * Simple unit tests to verify that it is possible to handle
- * potentially cyclic structures, as long as object graph itself
- * is not cyclic. This is the case for directed hierarchies like
- * trees and DAGs.
- */
-public class TestCyclicTypes
-    extends BaseMapTest
-{
-    /*
-    /**********************************************************
-    /* Helper bean classes
-    /**********************************************************
-     */
-
-    static class Bean
-    {
-        Bean _next;
-        final String _name;
-
-        public Bean(Bean next, String name) {
-            _next = next;
-            _name = name;
-        }
-
-        public Bean getNext() { return _next; }
-        public String getName() { return _name; }
-
-        public void assignNext(Bean n) { _next = n; }
-    }
-
-    /*
-    /**********************************************************
-    /* Types
-    /**********************************************************
-     */
-
-    public void testLinked() throws Exception
-    {
-        Bean last = new Bean(null, "last");
-        Bean first = new Bean(last, "first");
-        Map<String,Object> map = writeAndMap(new ObjectMapper(), first);
-
-        assertEquals(2, map.size());
-        assertEquals("first", map.get("name"));
-
-        @SuppressWarnings("unchecked")
-        Map<String,Object> map2 = (Map<String,Object>) map.get("next");
-        assertNotNull(map2);
-        assertEquals(2, map2.size());
-        assertEquals("last", map2.get("name"));
-        assertNull(map2.get("next"));
-    }
-
-    /**
-     * Test for verifying that [JACKSON-158] works as expected
-     */
-    public void testSelfReference() throws Exception
-    {
-        Bean selfRef = new Bean(null, "self-refs");
-        Bean first = new Bean(selfRef, "first");
-        selfRef.assignNext(selfRef);
-        ObjectMapper m = new ObjectMapper();
-        Bean[] wrapper = new Bean[] { first };
-        try {
-            writeAndMap(m, wrapper);
-        } catch (JsonMappingException e) {
-            verifyException(e, "Direct self-reference leading to cycle");
-        }
-    }
-}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/TestJsonSerialize.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/TestJsonSerialize.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/TestJsonSerialize.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/TestJsonSerialize.java	2020-06-25 02:44:21.000000000 +0000
@@ -8,6 +8,7 @@ import com.fasterxml.jackson.annotation.
 import com.fasterxml.jackson.core.JsonGenerator;
 import com.fasterxml.jackson.databind.*;
 import com.fasterxml.jackson.databind.annotation.JsonSerialize;
+import com.fasterxml.jackson.databind.json.JsonMapper;
 
 /**
  * This unit test suite tests use of @JsonClass Annotation
@@ -227,8 +228,9 @@ public class TestJsonSerialize
 
     public void testIssue294() throws Exception
     {
-        assertEquals("{\"id\":\"fooId\",\"bar\":\"barId\"}",
-                MAPPER.writeValueAsString(new Foo294("fooId", "barId")));
+        JsonMapper mapper = JsonMapper.builder().enable(MapperFeature.SORT_PROPERTIES_ALPHABETICALLY).build();
+        assertEquals("{\"bar\":\"barId\",\"id\":\"fooId\"}",
+                mapper.writeValueAsString(new Foo294("fooId", "barId")));
     }
 
     @JsonPropertyOrder({ "a", "something" })
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/TestSerializationOrder.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/TestSerializationOrder.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/TestSerializationOrder.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/TestSerializationOrder.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,141 +0,0 @@
-package com.fasterxml.jackson.databind.ser;
-
-import com.fasterxml.jackson.annotation.*;
-
-import com.fasterxml.jackson.databind.*;
-
-/**
- * Unit tests for verifying that constraints on ordering of serialized
- * properties are held.
- */
-public class TestSerializationOrder
-    extends BaseMapTest
-{
-    static class BeanWithCreator
-    {
-        public int a;
-        public int b;
-        public int c;
-
-        @JsonCreator public BeanWithCreator(@JsonProperty("c") int c, @JsonProperty("a") int a) {
-            this.a = a;
-            this.c = c;
-        }
-    }
-
-    @JsonPropertyOrder({"c", "a", "b"})
-    static class BeanWithOrder
-    {
-        public int d, b, a, c;
-
-        public BeanWithOrder(int a, int b, int c, int d) {
-            this.a = a;
-            this.b = b;
-            this.c = c;
-            this.d = d;
-        }
-    }
-
-    @JsonPropertyOrder(value={"d"}, alphabetic=true)
-    static class SubBeanWithOrder extends BeanWithOrder
-    {
-        public SubBeanWithOrder(int a, int b, int c, int d) {
-            super(a, b, c, d);
-        }
-    }
-
-    @JsonPropertyOrder({"b", "a",
-        // note: including non-existant properties is fine (has no effect, but not an error)
-        "foobar",
-        "c"
-    })
-    static class OrderMixIn { }
-
-    @JsonPropertyOrder(value={"a","b","x","z"})
-    static class BeanFor268 {
-        @JsonProperty("a") public String xA = "a";
-        @JsonProperty("z") public String aZ = "z";
-    	   @JsonProperty("b") public String xB() { return "b"; }
-    	   @JsonProperty("x") public String aX() { return "x"; }
-    }
-
-    static class BeanFor459 {
-        public int d = 4;
-        public int c = 3;
-        public int b = 2;
-        public int a = 1;
-    }
-
-    // For [databind#311]
-    @JsonPropertyOrder(alphabetic = true)
-    public class BeanForGH311 {
-        private final int a;
-        private final int b;
-
-        @JsonCreator
-        public BeanForGH311(@JsonProperty("b") int b, @JsonProperty("a") int a) { //b and a are out of order, although alphabetic = true
-            this.a = a;
-            this.b = b;
-        }
-
-        public int getA() { return a; }
-        public int getB() { return b; }
-    }
-
-    /*
-    /*********************************************
-    /* Unit tests
-    /*********************************************
-     */
-
-    private final ObjectMapper MAPPER = newJsonMapper();
-
-    public void testImplicitOrderByCreator() throws Exception
-    {
-        assertEquals("{\"c\":1,\"a\":2,\"b\":0}", MAPPER.writeValueAsString(new BeanWithCreator(1, 2)));
-    }
-
-    public void testExplicitOrder() throws Exception
-    {
-        assertEquals("{\"c\":3,\"a\":1,\"b\":2,\"d\":4}", MAPPER.writeValueAsString(new BeanWithOrder(1, 2, 3, 4)));
-    }
-
-    public void testAlphabeticOrder() throws Exception
-    {
-        assertEquals("{\"d\":4,\"a\":1,\"b\":2,\"c\":3}", MAPPER.writeValueAsString(new SubBeanWithOrder(1, 2, 3, 4)));
-    }
-
-    public void testOrderWithMixins() throws Exception
-    {
-        ObjectMapper m = jsonMapperBuilder()
-                .addMixIn(BeanWithOrder.class, OrderMixIn.class)
-                .build();
-        assertEquals("{\"b\":2,\"a\":1,\"c\":3,\"d\":4}",
-                serializeAsString(m, new BeanWithOrder(1, 2, 3, 4)));
-    }
-
-    public void testOrderWrt268() throws Exception
-    {
-        assertEquals("{\"a\":\"a\",\"b\":\"b\",\"x\":\"x\",\"z\":\"z\"}",
-                MAPPER.writeValueAsString(new BeanFor268()));
-    }
-
-    public void testOrderWithFeature() throws Exception
-    {
-        ObjectMapper m = jsonMapperBuilder()
-                .configure(MapperFeature.SORT_PROPERTIES_ALPHABETICALLY, true)
-                .build();
-        assertEquals("{\"a\":1,\"b\":2,\"c\":3,\"d\":4}",
-                m.writeValueAsString(new BeanFor459()));
-    }
-
-    // [databind#311]
-    public void testAlphaAndCreatorOrdering() throws Exception
-    {
-        ObjectMapper m = jsonMapperBuilder()
-                .configure(MapperFeature.SORT_PROPERTIES_ALPHABETICALLY, true)
-                .build();
-        String json = m.writeValueAsString(new BeanForGH311(2, 1));
-        assertEquals("{\"a\":1,\"b\":2}", json);
-    }
-}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/TestTreeSerialization.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/TestTreeSerialization.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/ser/TestTreeSerialization.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/ser/TestTreeSerialization.java	2020-06-25 02:44:21.000000000 +0000
@@ -33,7 +33,7 @@ public class TestTreeSerialization
         ObjectNode n2 = n.putObject("ob");
         n2.putArray("arr");
         StringWriter sw = new StringWriter();
-        JsonGenerator jg = mapper.getFactory().createGenerator(sw);
+        JsonGenerator jg = mapper.createGenerator(sw);
         mapper.writeTree(jg, n);
 
         Map<String,Object> result = (Map<String,Object>) mapper.readValue(sw.toString(), Map.class);
@@ -61,7 +61,7 @@ public class TestTreeSerialization
         ObjectNode n = mapper.getNodeFactory().objectNode();
         n.set("pojo", mapper.getNodeFactory().pojoNode("abc"));
         StringWriter sw = new StringWriter();
-        JsonGenerator jg = mapper.getFactory().createGenerator(sw);
+        JsonGenerator jg = mapper.createGenerator(sw);
         mapper.writeTree(jg, n);
         Map<String,Object> result = (Map<String,Object>) mapper.readValue(sw.toString(), Map.class);
         assertEquals(1, result.size());
@@ -77,7 +77,7 @@ public class TestTreeSerialization
         ObjectNode n = mapper.getNodeFactory().objectNode();
         n.set("pojo", mapper.getNodeFactory().pojoNode(new int[] { 1, 2, 3 }));
         StringWriter sw = new StringWriter();
-        JsonGenerator jg = mapper.getFactory().createGenerator(sw);
+        JsonGenerator jg = mapper.createGenerator(sw);
         mapper.writeTree(jg, n);
 
         Map<String,Object> result = (Map<String,Object>) mapper.readValue(sw.toString(), Map.class);
@@ -101,7 +101,7 @@ public class TestTreeSerialization
         ObjectNode n = mapper.getNodeFactory().objectNode();
         n.set("pojo", mapper.getNodeFactory().pojoNode(new Bean()));
         StringWriter sw = new StringWriter();
-        JsonGenerator jg = mapper.getFactory().createGenerator(sw);
+        JsonGenerator jg = mapper.createGenerator(sw);
         mapper.writeTree(jg, n);
 
         Map<String,Object> result = (Map<String,Object>) mapper.readValue(sw.toString(), Map.class);
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/struct/ScalarCoercionTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/struct/ScalarCoercionTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/struct/ScalarCoercionTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/struct/ScalarCoercionTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -1,15 +1,22 @@
 package com.fasterxml.jackson.databind.struct;
 
+import java.io.ByteArrayInputStream;
 import java.io.IOException;
+import java.io.StringReader;
 import java.math.BigDecimal;
 import java.math.BigInteger;
 
+import com.fasterxml.jackson.core.JsonParser;
+import com.fasterxml.jackson.core.JsonToken;
 import com.fasterxml.jackson.databind.*;
 import com.fasterxml.jackson.databind.exc.MismatchedInputException;
 
-// for [databind#1106]
 public class ScalarCoercionTest extends BaseMapTest
 {
+    static class BooleanPOJO {
+        public boolean value;
+    }
+
     private final ObjectMapper COERCING_MAPPER = jsonMapperBuilder()
             .enable(MapperFeature.ALLOW_COERCION_OF_SCALARS)
             .build();
@@ -138,30 +145,52 @@ public class ScalarCoercionTest extends
 
     public void testStringCoercionFail() throws Exception
     {
-        _verifyCoerceFail(quote("true"), Boolean.TYPE);
-        _verifyCoerceFail(quote("true"), Boolean.class);
-        _verifyCoerceFail(quote("123"), Byte.TYPE);
-        _verifyCoerceFail(quote("123"), Byte.class);
-        _verifyCoerceFail(quote("123"), Short.TYPE);
-        _verifyCoerceFail(quote("123"), Short.class);
-        _verifyCoerceFail(quote("123"), Integer.TYPE);
-        _verifyCoerceFail(quote("123"), Integer.class);
-        _verifyCoerceFail(quote("123"), Long.TYPE);
-        _verifyCoerceFail(quote("123"), Long.class);
-        _verifyCoerceFail(quote("123.5"), Float.TYPE);
-        _verifyCoerceFail(quote("123.5"), Float.class);
-        _verifyCoerceFail(quote("123.5"), Double.TYPE);
-        _verifyCoerceFail(quote("123.5"), Double.class);
+        _verifyRootStringCoerceFail("true", Boolean.TYPE);
+        _verifyRootStringCoerceFail("true", Boolean.class);
+        _verifyRootStringCoerceFail("123", Byte.TYPE);
+        _verifyRootStringCoerceFail("123", Byte.class);
+        _verifyRootStringCoerceFail("123", Short.TYPE);
+        _verifyRootStringCoerceFail("123", Short.class);
+        _verifyRootStringCoerceFail("123", Integer.TYPE);
+        _verifyRootStringCoerceFail("123", Integer.class);
+        _verifyRootStringCoerceFail("123", Long.TYPE);
+        _verifyRootStringCoerceFail("123", Long.class);
+        _verifyRootStringCoerceFail("123.5", Float.TYPE);
+        _verifyRootStringCoerceFail("123.5", Float.class);
+        _verifyRootStringCoerceFail("123.5", Double.TYPE);
+        _verifyRootStringCoerceFail("123.5", Double.class);
+
+        _verifyRootStringCoerceFail("123", BigInteger.class);
+        _verifyRootStringCoerceFail("123.0", BigDecimal.class);
+    }
+
+    // [databind#2635], [databind#2770]
+    public void testToBooleanCoercionFailBytes() throws Exception
+    {
+        final String beanDoc = aposToQuotes("{'value':1}");
+        _verifyBooleanCoerceFail("1", true, JsonToken.VALUE_NUMBER_INT, "1", Boolean.TYPE);
+        _verifyBooleanCoerceFail("1", true, JsonToken.VALUE_NUMBER_INT, "1", Boolean.class);
+        _verifyBooleanCoerceFail(beanDoc, true, JsonToken.VALUE_NUMBER_INT, "1", BooleanPOJO.class);
 
-        _verifyCoerceFail(quote("123"), BigInteger.class);
-        _verifyCoerceFail(quote("123.0"), BigDecimal.class);
+        _verifyBooleanCoerceFail("1.25", true, JsonToken.VALUE_NUMBER_FLOAT, "1.25", Boolean.TYPE);
+        _verifyBooleanCoerceFail("1.25", true, JsonToken.VALUE_NUMBER_FLOAT, "1.25", Boolean.class);
+    }
+
+    // [databind#2635], [databind#2770]
+    public void testToBooleanCoercionFailChars() throws Exception
+    {
+        final String beanDoc = aposToQuotes("{'value':1}");
+        _verifyBooleanCoerceFail("1", false, JsonToken.VALUE_NUMBER_INT, "1", Boolean.TYPE);
+        _verifyBooleanCoerceFail("1", false, JsonToken.VALUE_NUMBER_INT, "1", Boolean.class);
+        _verifyBooleanCoerceFail(beanDoc, false, JsonToken.VALUE_NUMBER_INT, "1", BooleanPOJO.class);
+
+        _verifyBooleanCoerceFail("1.25", false, JsonToken.VALUE_NUMBER_FLOAT, "1.25", Boolean.TYPE);
+        _verifyBooleanCoerceFail("1.25", false, JsonToken.VALUE_NUMBER_FLOAT, "1.25", Boolean.class);
     }
 
     public void testMiscCoercionFail() throws Exception
     {
         // And then we have coercions from more esoteric types too
-        _verifyCoerceFail("1", Boolean.TYPE);
-        _verifyCoerceFail("1", Boolean.class);
 
         _verifyCoerceFail("65", Character.class);
         _verifyCoerceFail("65", Character.TYPE);
@@ -192,4 +221,79 @@ public class ScalarCoercionTest extends
             verifyException(e, "enable `MapperFeature.ALLOW_COERCION_OF_SCALARS` to allow");
         }
     }
+
+    private void _verifyRootStringCoerceFail(String unquotedValue, Class<?> type) throws IOException
+    {
+        // Test failure for root value: for both byte- and char-backed sources:
+
+        final String input = quote(unquotedValue);
+        try (JsonParser p = NOT_COERCING_MAPPER.createParser(new StringReader(input))) {
+            _verifyStringCoerceFail(p, unquotedValue, type);
+        }
+        final byte[] inputBytes = utf8Bytes(input);
+        try (JsonParser p = NOT_COERCING_MAPPER.createParser(new ByteArrayInputStream(inputBytes))) {
+            _verifyStringCoerceFail(p, unquotedValue, type);
+        }
+    }
+
+    private void _verifyStringCoerceFail(JsonParser p,
+            String unquotedValue, Class<?> type) throws IOException
+    {
+        try {
+            NOT_COERCING_MAPPER.readerFor(type)
+                .readValue(p);
+            fail("Should not have allowed coercion");
+        } catch (MismatchedInputException e) {
+            verifyException(e, "Cannot coerce ");
+            verifyException(e, " for type `");
+            verifyException(e, "enable `MapperFeature.ALLOW_COERCION_OF_SCALARS` to allow");
+
+            assertNotNull(e.getProcessor());
+            assertSame(p, e.getProcessor());
+
+            assertToken(JsonToken.VALUE_STRING, p.currentToken());
+            assertEquals(unquotedValue, p.getText());
+        }
+    }
+
+    private void _verifyBooleanCoerceFail(String doc, boolean useBytes,
+            JsonToken tokenType, String tokenValue, Class<?> targetType) throws IOException
+    {
+        // Test failure for root value: for both byte- and char-backed sources.
+
+        // [databind#2635]: important, need to use `readValue()` that takes content and NOT
+        // JsonParser, as this forces closing of underlying parser and exposes more issues.
+
+        final ObjectReader r = NOT_COERCING_MAPPER.readerFor(targetType);
+        try {
+            if (useBytes) {
+                r.readValue(utf8Bytes(doc));
+            } else {
+                r.readValue(doc);
+            }
+            fail("Should not have allowed coercion");
+        } catch (MismatchedInputException e) {
+            _verifyBooleanCoerceFailReason(e, tokenType, tokenValue);
+        }
+    }
+
+    @SuppressWarnings("resource")
+    private void _verifyBooleanCoerceFailReason(MismatchedInputException e,
+            JsonToken tokenType, String tokenValue) throws IOException
+    {
+        // 2 different possibilities here
+        verifyException(e, "Cannot coerce Number", "Cannot deserialize instance of `");
+
+        JsonParser p = (JsonParser) e.getProcessor();
+
+        assertToken(tokenType, p.currentToken());
+
+        final String text = p.getText();
+
+        if (!tokenValue.equals(text)) {
+            String textDesc = (text == null) ? "NULL" : quote(text);
+            fail("Token text ("+textDesc+") via parser of type "+p.getClass().getName()
+                    +" not as expected ("+quote(tokenValue)+"); exception message: '"+e.getMessage()+"'");
+        }
+    }
 }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/struct/TestUnwrapped.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/struct/TestUnwrapped.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/struct/TestUnwrapped.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/struct/TestUnwrapped.java	2020-06-25 02:44:21.000000000 +0000
@@ -3,6 +3,7 @@ package com.fasterxml.jackson.databind.s
 import com.fasterxml.jackson.annotation.*;
 
 import com.fasterxml.jackson.databind.*;
+import com.fasterxml.jackson.databind.json.JsonMapper;
 
 /**
  * Unit tests for verifying that basic {@link JsonUnwrapped} annotation
@@ -148,13 +149,15 @@ public class TestUnwrapped extends BaseM
     private final ObjectMapper MAPPER = new ObjectMapper();
 
     public void testSimpleUnwrappingSerialize() throws Exception {
-        assertEquals("{\"name\":\"Tatu\",\"x\":1,\"y\":2}",
-                MAPPER.writeValueAsString(new Unwrapping("Tatu", 1, 2)));
+        JsonMapper mapper = JsonMapper.builder().enable(MapperFeature.SORT_PROPERTIES_ALPHABETICALLY).build();
+        assertEquals("{\"x\":1,\"y\":2,\"name\":\"Tatu\"}",
+                mapper.writeValueAsString(new Unwrapping("Tatu", 1, 2)));
     }
 
     public void testDeepUnwrappingSerialize() throws Exception {
-        assertEquals("{\"name\":\"Tatu\",\"x\":1,\"y\":2}",
-                MAPPER.writeValueAsString(new DeepUnwrapping("Tatu", 1, 2)));
+        JsonMapper mapper = JsonMapper.builder().enable(MapperFeature.SORT_PROPERTIES_ALPHABETICALLY).build();
+        assertEquals("{\"x\":1,\"y\":2,\"name\":\"Tatu\"}",
+                mapper.writeValueAsString(new DeepUnwrapping("Tatu", 1, 2)));
     }
 
     /*
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/struct/TestUnwrappedWithPrefix.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/struct/TestUnwrappedWithPrefix.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/struct/TestUnwrappedWithPrefix.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/struct/TestUnwrappedWithPrefix.java	2020-06-25 02:44:21.000000000 +0000
@@ -2,7 +2,9 @@ package com.fasterxml.jackson.databind.s
 
 import com.fasterxml.jackson.annotation.JsonUnwrapped;
 import com.fasterxml.jackson.databind.BaseMapTest;
+import com.fasterxml.jackson.databind.MapperFeature;
 import com.fasterxml.jackson.databind.ObjectMapper;
+import com.fasterxml.jackson.databind.json.JsonMapper;
 
 public class TestUnwrappedWithPrefix extends BaseMapTest
 {
@@ -148,14 +150,16 @@ public class TestUnwrappedWithPrefix ext
 
     public void testPrefixedUnwrappingSerialize() throws Exception
     {
-        assertEquals("{\"name\":\"Tatu\",\"_x\":1,\"_y\":2}",
-                MAPPER.writeValueAsString(new PrefixUnwrap("Tatu", 1, 2)));
+        JsonMapper mapper = JsonMapper.builder().enable(MapperFeature.SORT_PROPERTIES_ALPHABETICALLY).build();
+        assertEquals("{\"_x\":1,\"_y\":2,\"name\":\"Tatu\"}",
+                mapper.writeValueAsString(new PrefixUnwrap("Tatu", 1, 2)));
     }
 
     public void testDeepPrefixedUnwrappingSerialize() throws Exception
     {
-        String json = MAPPER.writeValueAsString(new DeepPrefixUnwrap("Bubba", 1, 1));
-        assertEquals("{\"u.name\":\"Bubba\",\"u._x\":1,\"u._y\":1}", json);
+        JsonMapper mapper = JsonMapper.builder().enable(MapperFeature.SORT_PROPERTIES_ALPHABETICALLY).build();
+        String json = mapper.writeValueAsString(new DeepPrefixUnwrap("Bubba", 1, 1));
+        assertEquals("{\"u._x\":1,\"u._y\":1,\"u.name\":\"Bubba\"}", json);
     }
 
     public void testHierarchicConfigSerialize() throws Exception
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/struct/TestUnwrappedWithTypeInfo.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/struct/TestUnwrappedWithTypeInfo.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/struct/TestUnwrappedWithTypeInfo.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/struct/TestUnwrappedWithTypeInfo.java	2020-06-25 02:44:21.000000000 +0000
@@ -6,6 +6,7 @@ import com.fasterxml.jackson.annotation.
 import com.fasterxml.jackson.annotation.JsonUnwrapped;
 import com.fasterxml.jackson.databind.BaseMapTest;
 import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.MapperFeature;
 import com.fasterxml.jackson.databind.ObjectMapper;
 import com.fasterxml.jackson.databind.SerializationFeature;
 
@@ -47,7 +48,7 @@ public class TestUnwrappedWithTypeInfo e
     /**********************************************************
      */
 
-	// [Issue#81]
+	// [databind#81]
 	public void testDefaultUnwrappedWithTypeInfo() throws Exception
 	{
 	    Outer outer = new Outer();
@@ -76,10 +77,13 @@ public class TestUnwrappedWithTypeInfo e
 		inner.setP2("202");
 		outer.setInner(inner);
 
-		ObjectMapper mapper = new ObjectMapper();
-		mapper = mapper.disable(SerializationFeature.FAIL_ON_UNWRAPPED_TYPE_IDENTIFIERS);
+		ObjectMapper mapper = jsonMapperBuilder()
+		        .disable(SerializationFeature.FAIL_ON_UNWRAPPED_TYPE_IDENTIFIERS)
+		        .enable(MapperFeature.SORT_PROPERTIES_ALPHABETICALLY)
+		        .build();
 
 		String json = mapper.writeValueAsString(outer);
-		assertEquals("{\"@type\":\"OuterType\",\"p1\":\"101\",\"p2\":\"202\"}", json);
+
+		assertEquals("{\"@type\":\"OuterType\",\"p2\":\"202\",\"p1\":\"101\"}", json);
 	}
 }
\ No newline at end of file
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/struct/UnwrapSingleArrayMiscTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/struct/UnwrapSingleArrayMiscTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/struct/UnwrapSingleArrayMiscTest.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/struct/UnwrapSingleArrayMiscTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,73 @@
+package com.fasterxml.jackson.databind.struct;
+
+import java.util.Collections;
+import java.util.EnumMap;
+import java.util.Map;
+
+import com.fasterxml.jackson.core.type.TypeReference;
+import com.fasterxml.jackson.databind.*;
+import com.fasterxml.jackson.databind.exc.MismatchedInputException;
+
+public class UnwrapSingleArrayMiscTest extends BaseMapTest
+{
+    private final ObjectMapper UNWRAPPING_MAPPER = jsonMapperBuilder()
+            .enable(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS)
+            .build();
+
+    /*
+    /**********************************************************
+    /* Tests methods, POJOs
+    /**********************************************************
+     */
+
+    public void testSimplePOJOUnwrapping() throws Exception
+    {
+        ObjectReader r = UNWRAPPING_MAPPER.readerFor(IntWrapper.class);
+        IntWrapper w = r.readValue(aposToQuotes("[{'i':42}]"));
+        assertEquals(42, w.i);
+
+        try {
+            r.readValue(aposToQuotes("[{'i':42},{'i':16}]"));
+            fail("Did not throw exception while reading a value from a multi value array");
+        } catch (MismatchedInputException e) {
+            verifyException(e, "more than one value");
+        }
+    }
+
+    /*
+    /**********************************************************
+    /* Tests methods, Maps
+    /**********************************************************
+     */
+
+    // [databind#2767]: should work for Maps, too
+    public void testSimpleMapUnwrapping() throws Exception
+    {
+        ObjectReader r = UNWRAPPING_MAPPER.readerFor(Map.class);
+        Map<String,Object> m = r.readValue(aposToQuotes("[{'stuff':42}]"));
+        assertEquals(Collections.<String,Object>singletonMap("stuff", Integer.valueOf(42)), m);
+
+        try {
+            r.readValue(aposToQuotes("[{'i':42},{'i':16}]"));
+            fail("Did not throw exception while reading a value from a multi value array");
+        } catch (MismatchedInputException e) {
+            verifyException(e, "more than one value");
+        }
+    }
+
+    public void testEnumMapUnwrapping() throws Exception
+    {
+        ObjectReader r = UNWRAPPING_MAPPER.readerFor(new TypeReference<EnumMap<ABC,Integer>>() { });
+        EnumMap<ABC,Integer> m = r.readValue(aposToQuotes("[{'A':42}]"));
+        EnumMap<ABC,Integer> exp = new EnumMap<>(ABC.class);
+        exp.put(ABC.A, Integer.valueOf(42));
+        assertEquals(exp, m);
+
+        try {
+            r.readValue(aposToQuotes("[{'A':42},{'B':13}]"));
+            fail("Did not throw exception while reading a value from a multi value array");
+        } catch (MismatchedInputException e) {
+            verifyException(e, "more than one value");
+        }
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/struct/UnwrapSingleArrayScalarsTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/struct/UnwrapSingleArrayScalarsTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/struct/UnwrapSingleArrayScalarsTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/struct/UnwrapSingleArrayScalarsTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -16,8 +16,19 @@ import com.fasterxml.jackson.databind.ex
 public class UnwrapSingleArrayScalarsTest extends BaseMapTest
 {
     static class BooleanBean {
-        boolean _v;
-        void setV(boolean v) { _v = v; }
+        public boolean v;
+    }
+
+    static class IntBean {
+        public int v;
+    }
+
+    static class LongBean {
+        public long v;
+    }
+
+    static class DoubleBean {
+        public double v;
     }
 
     private final ObjectMapper MAPPER = new ObjectMapper();
@@ -35,22 +46,22 @@ public class UnwrapSingleArrayScalarsTes
     public void testBooleanPrimitiveArrayUnwrap() throws Exception
     {
         // [databind#381]
-        final ObjectMapper mapper = new ObjectMapper();
-        mapper.enable(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS);
-        BooleanBean result = mapper.readValue(new StringReader("{\"v\":[true]}"), BooleanBean.class);
-        assertTrue(result._v);
+        final ObjectReader r = UNWRAPPING_READER.forType(BooleanBean.class);
+        BooleanBean result = r.readValue(new StringReader("{\"v\":[true]}"));
+        assertTrue(result.v);
 
         _verifyMultiValueArrayFail("[{\"v\":[true,true]}]", BooleanBean.class);
 
-        result = mapper.readValue("{\"v\":[null]}", BooleanBean.class);
+        result = r.readValue("{\"v\":[null]}");
         assertNotNull(result);
-        assertFalse(result._v);
+        assertFalse(result.v);
         
-        result = mapper.readValue("[{\"v\":[null]}]", BooleanBean.class);
+        result = r.readValue("[{\"v\":[null]}]");
         assertNotNull(result);
-        assertFalse(result._v);
+        assertFalse(result.v);
         
-        boolean[] array = mapper.readValue(new StringReader("[ [ null ] ]"), boolean[].class);
+        boolean[] array = UNWRAPPING_READER.forType(boolean[].class)
+                .readValue(new StringReader("[ [ null ] ]"));
         assertNotNull(array);
         assertEquals(1, array.length);
         assertFalse(array[0]);
@@ -61,8 +72,115 @@ public class UnwrapSingleArrayScalarsTes
     /* Single-element as array tests, numbers
     /**********************************************************
      */
-    
-    // [databind#381]
+
+    public void testIntPrimitiveArrayUnwrap() throws Exception
+    {
+        try {
+            NO_UNWRAPPING_READER.forType(IntBean.class)
+                .readValue("{\"v\":[3]}");
+            fail("Did not throw exception when reading a value from a single value array with the UNWRAP_SINGLE_VALUE_ARRAYS feature disabled");
+        } catch (MismatchedInputException e) {
+            verifyException(e, "Cannot deserialize instance of `int`");
+        }
+
+        ObjectReader r = UNWRAPPING_READER.forType(IntBean.class);
+        IntBean result = r.readValue("{\"v\":[3]}");
+        assertEquals(3, result.v);
+        
+        result = r.readValue("[{\"v\":[3]}]");
+        assertEquals(3, result.v);
+        
+        try {
+            r.readValue("[{\"v\":[3,3]}]");
+            fail("Did not throw exception while reading a value from a multi value array with UNWRAP_SINGLE_VALUE_ARRAY feature enabled");
+        } catch (MismatchedInputException e) {
+            verifyException(e, "more than one value");
+        }
+        
+        result = r.readValue("{\"v\":[null]}");
+        assertNotNull(result);
+        assertEquals(0, result.v);
+
+        int[] array = UNWRAPPING_READER.forType(int[].class).readValue("[ [ null ] ]");
+        assertNotNull(array);
+        assertEquals(1, array.length);
+        assertEquals(0, array[0]);
+        
+    }
+
+    public void testLongPrimitiveArrayUnwrap() throws Exception
+    {
+        final ObjectReader unwrapR = UNWRAPPING_READER.forType(LongBean.class);
+        final ObjectReader noUnwrapR = NO_UNWRAPPING_READER.forType(LongBean.class);
+        
+        try {
+            noUnwrapR.readValue("{\"v\":[3]}");
+            fail("Did not throw exception when reading a value from a single value array");
+        } catch (MismatchedInputException e) {
+            verifyException(e, "Cannot deserialize instance of `long`");
+        }
+
+        LongBean result = unwrapR.readValue("{\"v\":[3]}");
+        assertEquals(3, result.v);
+        
+        result = unwrapR.readValue("[{\"v\":[3]}]");
+        assertEquals(3, result.v);
+
+        try {
+            unwrapR.readValue("[{\"v\":[3,3]}]");
+            fail("Did not throw exception while reading a value from a multi value array");
+        } catch (MismatchedInputException e) {
+            verifyException(e, "more than one value");
+        }
+        
+        result = unwrapR.readValue("{\"v\":[null]}");
+        assertNotNull(result);
+        assertEquals(0, result.v);
+
+        long[] array = unwrapR.forType(long[].class)
+                .readValue("[ [ null ] ]");
+        assertNotNull(array);
+        assertEquals(1, array.length);
+        assertEquals(0, array[0]);
+    }
+
+    public void testDoubleAsArray() throws Exception
+    {
+        final ObjectReader unwrapR = UNWRAPPING_READER.forType(DoubleBean.class);
+        final ObjectReader noUnwrapR = NO_UNWRAPPING_READER.forType(DoubleBean.class);
+
+        final double value = 0.016;
+        try {
+            noUnwrapR.readValue("{\"v\":[" + value + "]}");
+            fail("Did not throw exception when reading a value from a single value array");
+        } catch (MismatchedInputException e) {
+            verifyException(e, "Cannot deserialize instance of `double`");
+        }
+        
+        DoubleBean result = unwrapR.readValue("{\"v\":[" + value + "]}");
+        assertEquals(value, result.v);
+        
+        result = unwrapR.readValue("[{\"v\":[" + value + "]}]");
+        assertEquals(value, result.v);
+        
+        try {
+            unwrapR.readValue("[{\"v\":[" + value + "," + value + "]}]");
+            fail("Did not throw exception while reading a value from a multi value array");
+        } catch (MismatchedInputException e) {
+            verifyException(e, "more than one value");
+        }
+        
+        result = unwrapR.readValue("{\"v\":[null]}");
+        assertNotNull(result);
+        assertEquals(0d, result.v);
+
+        double[] array = unwrapR.forType(double[].class)
+                .readValue("[ [ null ] ]");
+        assertNotNull(array);
+        assertEquals(1, array.length);
+        assertEquals(0d, array[0]);
+    }
+
     public void testSingleElementScalarArrays() throws Exception {
         final int intTest = 932832;
         final double doubleTest = 32.3234;
@@ -72,143 +190,138 @@ public class UnwrapSingleArrayScalarsTes
         final byte byteTest = (byte) 43;
         final char charTest = 'c';
 
-        final ObjectMapper mapper = new ObjectMapper();
-        mapper.enable(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS);
-
-        final int intValue = mapper.readValue(asArray(intTest), Integer.TYPE);
+        final int intValue = UNWRAPPING_READER.readValue(asArray(intTest), Integer.TYPE);
         assertEquals(intTest, intValue);
-        final Integer integerWrapperValue = mapper.readValue(asArray(Integer.valueOf(intTest)), Integer.class);
+        final Integer integerWrapperValue = UNWRAPPING_READER.readValue(asArray(Integer.valueOf(intTest)), Integer.class);
         assertEquals(Integer.valueOf(intTest), integerWrapperValue);
 
-        final double doubleValue = mapper.readValue(asArray(doubleTest), Double.class);
+        final double doubleValue = UNWRAPPING_READER.readValue(asArray(doubleTest), Double.class);
         assertEquals(doubleTest, doubleValue);
-        final Double doubleWrapperValue = mapper.readValue(asArray(Double.valueOf(doubleTest)), Double.class);
+        final Double doubleWrapperValue = UNWRAPPING_READER.readValue(asArray(Double.valueOf(doubleTest)), Double.class);
         assertEquals(Double.valueOf(doubleTest), doubleWrapperValue);
 
-        final long longValue = mapper.readValue(asArray(longTest), Long.TYPE);
+        final long longValue = UNWRAPPING_READER.readValue(asArray(longTest), Long.TYPE);
         assertEquals(longTest, longValue);
-        final Long longWrapperValue = mapper.readValue(asArray(Long.valueOf(longTest)), Long.class);
+        final Long longWrapperValue = UNWRAPPING_READER.readValue(asArray(Long.valueOf(longTest)), Long.class);
         assertEquals(Long.valueOf(longTest), longWrapperValue);
 
-        final short shortValue = mapper.readValue(asArray(shortTest), Short.TYPE);
+        final short shortValue = UNWRAPPING_READER.readValue(asArray(shortTest), Short.TYPE);
         assertEquals(shortTest, shortValue);
-        final Short shortWrapperValue = mapper.readValue(asArray(Short.valueOf(shortTest)), Short.class);
+        final Short shortWrapperValue = UNWRAPPING_READER.readValue(asArray(Short.valueOf(shortTest)), Short.class);
         assertEquals(Short.valueOf(shortTest), shortWrapperValue);
 
-        final float floatValue = mapper.readValue(asArray(floatTest), Float.TYPE);
+        final float floatValue = UNWRAPPING_READER.readValue(asArray(floatTest), Float.TYPE);
         assertEquals(floatTest, floatValue);
-        final Float floatWrapperValue = mapper.readValue(asArray(Float.valueOf(floatTest)), Float.class);
+        final Float floatWrapperValue = UNWRAPPING_READER.readValue(asArray(Float.valueOf(floatTest)), Float.class);
         assertEquals(Float.valueOf(floatTest), floatWrapperValue);
 
-        final byte byteValue = mapper.readValue(asArray(byteTest), Byte.TYPE);
+        final byte byteValue = UNWRAPPING_READER.readValue(asArray(byteTest), Byte.TYPE);
         assertEquals(byteTest, byteValue);
-        final Byte byteWrapperValue = mapper.readValue(asArray(Byte.valueOf(byteTest)), Byte.class);
+        final Byte byteWrapperValue = UNWRAPPING_READER.readValue(asArray(Byte.valueOf(byteTest)), Byte.class);
         assertEquals(Byte.valueOf(byteTest), byteWrapperValue);
 
-        final char charValue = mapper.readValue(asArray(quote(String.valueOf(charTest))), Character.TYPE);
+        final char charValue = UNWRAPPING_READER.readValue(asArray(quote(String.valueOf(charTest))), Character.TYPE);
         assertEquals(charTest, charValue);
-        final Character charWrapperValue = mapper.readValue(asArray(quote(String.valueOf(charTest))), Character.class);
+        final Character charWrapperValue = UNWRAPPING_READER.readValue(asArray(quote(String.valueOf(charTest))), Character.class);
         assertEquals(Character.valueOf(charTest), charWrapperValue);
 
-        final boolean booleanTrueValue = mapper.readValue(asArray(true), Boolean.TYPE);
+        final boolean booleanTrueValue = UNWRAPPING_READER.readValue(asArray(true), Boolean.TYPE);
         assertTrue(booleanTrueValue);
 
-        final boolean booleanFalseValue = mapper.readValue(asArray(false), Boolean.TYPE);
+        final boolean booleanFalseValue = UNWRAPPING_READER.readValue(asArray(false), Boolean.TYPE);
         assertFalse(booleanFalseValue);
 
-        final Boolean booleanWrapperTrueValue = mapper.readValue(asArray(Boolean.valueOf(true)), Boolean.class);
+        final Boolean booleanWrapperTrueValue = UNWRAPPING_READER.readValue(asArray(Boolean.valueOf(true)), Boolean.class);
         assertEquals(Boolean.TRUE, booleanWrapperTrueValue);
     }
 
     public void testSingleElementArrayDisabled() throws Exception {
-        final ObjectMapper mapper = new ObjectMapper();
-        mapper.disable(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS);
         try {
-            mapper.readValue("[42]", Integer.class);
-            fail("Single value array didn't throw an exception when DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS is disabled");
+            NO_UNWRAPPING_READER.readValue("[42]", Integer.class);
+            fail("Single value array didn't throw an exception");
         } catch (MismatchedInputException exp) {
             //Exception was thrown correctly
         }
         try {
-            mapper.readValue("[42]", Integer.TYPE);
-            fail("Single value array didn't throw an exception when DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS is disabled");
+            NO_UNWRAPPING_READER.readValue("[42]", Integer.TYPE);
+            fail("Single value array didn't throw an exception");
         } catch (MismatchedInputException exp) {
             //Exception was thrown correctly
         }
         try {
-            mapper.readValue("[42342342342342]", Long.class);
-            fail("Single value array didn't throw an exception when DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS is disabled");
+            NO_UNWRAPPING_READER.readValue("[42342342342342]", Long.class);
+            fail("Single value array didn't throw an exception");
         } catch (MismatchedInputException exp) {
             //Exception was thrown correctly
         }
         try {
-            mapper.readValue("[42342342342342342]", Long.TYPE);
-            fail("Single value array didn't throw an exception when DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS is disabled");
+            NO_UNWRAPPING_READER.readValue("[42342342342342342]", Long.TYPE);
+            fail("Single value array didn't throw an exception");
         } catch (MismatchedInputException exp) {
             //Exception was thrown correctly
         }
 
         try {
-            mapper.readValue("[42]", Short.class);
-            fail("Single value array didn't throw an exception when DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS is disabled");
+            NO_UNWRAPPING_READER.readValue("[42]", Short.class);
+            fail("Single value array didn't throw an exception");
         } catch (MismatchedInputException exp) {
             //Exception was thrown correctly
         }
         try {
-            mapper.readValue("[42]", Short.TYPE);
-            fail("Single value array didn't throw an exception when DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS is disabled");
+            NO_UNWRAPPING_READER.readValue("[42]", Short.TYPE);
+            fail("Single value array didn't throw an exception");
         } catch (MismatchedInputException exp) {
             //Exception was thrown correctly
         }
 
         try {
-            mapper.readValue("[327.2323]", Float.class);
-            fail("Single value array didn't throw an exception when DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS is disabled");
+            NO_UNWRAPPING_READER.readValue("[327.2323]", Float.class);
+            fail("Single value array didn't throw an exception");
         } catch (MismatchedInputException exp) {
             //Exception was thrown correctly
         }
         try {
-            mapper.readValue("[82.81902]", Float.TYPE);
-            fail("Single value array didn't throw an exception when DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS is disabled");
+            NO_UNWRAPPING_READER.readValue("[82.81902]", Float.TYPE);
+            fail("Single value array didn't throw an exception");
         } catch (MismatchedInputException exp) {
             //Exception was thrown correctly
         }
 
         try {
-            mapper.readValue("[22]", Byte.class);
-            fail("Single value array didn't throw an exception when DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS is disabled");
+            NO_UNWRAPPING_READER.readValue("[22]", Byte.class);
+            fail("Single value array didn't throw an exception");
         } catch (MismatchedInputException exp) {
             //Exception was thrown correctly
         }
         try {
-            mapper.readValue("[22]", Byte.TYPE);
-            fail("Single value array didn't throw an exception when DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS is disabled");
+            NO_UNWRAPPING_READER.readValue("[22]", Byte.TYPE);
+            fail("Single value array didn't throw an exception");
         } catch (MismatchedInputException exp) {
             //Exception was thrown correctly
         }
 
         try {
-            mapper.readValue("['d']", Character.class);
-            fail("Single value array didn't throw an exception when DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS is disabled");
+            NO_UNWRAPPING_READER.readValue("['d']", Character.class);
+            fail("Single value array didn't throw an exception");
         } catch (MismatchedInputException exp) {
             //Exception was thrown correctly
         }
         try {
-            mapper.readValue("['d']", Character.TYPE);
-            fail("Single value array didn't throw an exception when DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS is disabled");
+            NO_UNWRAPPING_READER.readValue("['d']", Character.TYPE);
+            fail("Single value array didn't throw an exception");
         } catch (MismatchedInputException exp) {
             //Exception was thrown correctly
         }
 
         try {
-            mapper.readValue("[true]", Boolean.class);
-            fail("Single value array didn't throw an exception when DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS is disabled");
+            NO_UNWRAPPING_READER.readValue("[true]", Boolean.class);
+            fail("Single value array didn't throw an exception");
         } catch (MismatchedInputException exp) {
             //Exception was thrown correctly
         }
         try {
-            mapper.readValue("[true]", Boolean.TYPE);
-            fail("Single value array didn't throw an exception when DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS is disabled");
+            NO_UNWRAPPING_READER.readValue("[true]", Boolean.TYPE);
+            fail("Single value array didn't throw an exception");
         } catch (MismatchedInputException exp) {
             //Exception was thrown correctly
         }
@@ -239,61 +352,49 @@ public class UnwrapSingleArrayScalarsTes
     /**********************************************************
      */
 
-    public void testSingleString() throws Exception
-    {
-        String value = "FOO!";
-        String result = MAPPER.readValue("\""+value+"\"", String.class);
-        assertEquals(value, result);
-    }
-    
     public void testSingleStringWrapped() throws Exception
     {
-        final ObjectMapper mapper = new ObjectMapper();
-        mapper.disable(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS);
-        
         String value = "FOO!";
         try {
-            mapper.readValue("[\""+value+"\"]", String.class);
+            NO_UNWRAPPING_READER.readValue("[\""+value+"\"]", String.class);
             fail("Exception not thrown when attempting to unwrap a single value 'String' array into a simple String");
         } catch (MismatchedInputException exp) {
             verifyException(exp, "Cannot deserialize");
             verifyException(exp, "out of START_ARRAY");
         }
-        
-        mapper.enable(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS);
-        
+ 
         try {
-            mapper.readValue("[\""+value+"\",\""+value+"\"]", String.class);
+            UNWRAPPING_READER.forType(String.class)
+                .readValue("[\""+value+"\",\""+value+"\"]");
             fail("Exception not thrown when attempting to unwrap a single value 'String' array that contained more than one value into a simple String");
         } catch (MismatchedInputException exp) {
             verifyException(exp, "Attempted to unwrap");
         }
-        String result = mapper.readValue("[\""+value+"\"]", String.class);
+        String result = UNWRAPPING_READER.forType(String.class)
+                .readValue("[\""+value+"\"]");
         assertEquals(value, result);
     }
 
     public void testBigDecimal() throws Exception
     {
-        final ObjectMapper mapper = objectMapper();
-        mapper.disable(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS);
-        
         BigDecimal value = new BigDecimal("0.001");
-        BigDecimal result = mapper.readValue(value.toString(), BigDecimal.class);
+        ObjectReader r = NO_UNWRAPPING_READER.forType(BigDecimal.class);
+        BigDecimal result = r.readValue(value.toString());
         assertEquals(value, result);
         try {
-            mapper.readValue("[" + value.toString() + "]", BigDecimal.class);
+            r.readValue("[" + value.toString() + "]");
             fail("Exception was not thrown when attempting to read a single value array of BigDecimal when UNWRAP_SINGLE_VALUE_ARRAYS feature is disabled");
         } catch (MismatchedInputException exp) {
             verifyException(exp, "Cannot deserialize");
             verifyException(exp, "out of START_ARRAY");
         }
-        
-        mapper.enable(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS);
-        result = mapper.readValue("[" + value.toString() + "]", BigDecimal.class);
+
+        r = UNWRAPPING_READER.forType(BigDecimal.class);
+        result = r.readValue("[" + value.toString() + "]");
         assertEquals(value, result);
         
         try {
-            mapper.readValue("[" + value.toString() + "," + value.toString() + "]", BigDecimal.class);
+            r.readValue("[" + value.toString() + "," + value.toString() + "]");
             fail("Exception was not thrown when attempting to read a muti value array of BigDecimal when UNWRAP_SINGLE_VALUE_ARRAYS feature is enabled");
         } catch (MismatchedInputException exp) {
             verifyException(exp, "Attempted to unwrap");
@@ -302,27 +403,23 @@ public class UnwrapSingleArrayScalarsTes
 
     public void testBigInteger() throws Exception
     {
-        final ObjectMapper mapper = objectMapper();
-        mapper.disable(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS);
-        
         BigInteger value = new BigInteger("-1234567890123456789012345567809");
-        BigInteger result = mapper.readValue(value.toString(), BigInteger.class);
+        BigInteger result = NO_UNWRAPPING_READER.readValue(value.toString(), BigInteger.class);
         assertEquals(value, result);
 
         try {
-            mapper.readValue("[" + value.toString() + "]", BigInteger.class);
+            NO_UNWRAPPING_READER.readValue("[" + value.toString() + "]", BigInteger.class);
             fail("Exception was not thrown when attempting to read a single value array of BigInteger when UNWRAP_SINGLE_VALUE_ARRAYS feature is disabled");
         } catch (MismatchedInputException exp) {
             verifyException(exp, "Cannot deserialize");
             verifyException(exp, "out of START_ARRAY");
         }
-        
-        mapper.enable(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS);
-        result = mapper.readValue("[" + value.toString() + "]", BigInteger.class);
+
+        result = UNWRAPPING_READER.readValue("[" + value.toString() + "]", BigInteger.class);
         assertEquals(value, result);
         
         try {
-            mapper.readValue("[" + value.toString() + "," + value.toString() + "]", BigInteger.class);
+            UNWRAPPING_READER.readValue("[" + value.toString() + "," + value.toString() + "]", BigInteger.class);
             fail("Exception was not thrown when attempting to read a multi-value array of BigInteger when UNWRAP_SINGLE_VALUE_ARRAYS feature is enabled");
         } catch (MismatchedInputException exp) {
             verifyException(exp, "Attempted to unwrap");
@@ -331,15 +428,13 @@ public class UnwrapSingleArrayScalarsTes
 
     public void testClassAsArray() throws Exception
     {
-        Class<?> result = MAPPER
-                    .readerFor(Class.class)
-                    .with(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS)
+        Class<?> result = UNWRAPPING_READER
+                    .forType(Class.class)
                     .readValue(quote(String.class.getName()));
         assertEquals(String.class, result);
 
         try {
-            MAPPER.readerFor(Class.class)
-                .without(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS)
+            NO_UNWRAPPING_READER.forType(Class.class)
                 .readValue("[" + quote(String.class.getName()) + "]");
             fail("Did not throw exception when UNWRAP_SINGLE_VALUE_ARRAYS feature was disabled and attempted to read a Class array containing one element");
         } catch (MismatchedInputException e) {
@@ -348,18 +443,16 @@ public class UnwrapSingleArrayScalarsTes
 
         _verifyMultiValueArrayFail("[" + quote(Object.class.getName()) + "," + quote(Object.class.getName()) +"]",
                 Class.class);
-        result = MAPPER.readerFor(Class.class)
-                .with(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS)
+        result = UNWRAPPING_READER.forType(Class.class)
                 .readValue("[" + quote(String.class.getName()) + "]");
         assertEquals(String.class, result);
     }
 
     public void testURIAsArray() throws Exception
     {
-        final ObjectReader reader = MAPPER.readerFor(URI.class);
         final URI value = new URI("http://foo.com");
         try {
-            reader.without(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS)
+            NO_UNWRAPPING_READER.forType(URI.class)
                 .readValue("[\""+value.toString()+"\"]");
             fail("Did not throw exception for single value array when UNWRAP_SINGLE_VALUE_ARRAYS is disabled");
         } catch (MismatchedInputException e) {
@@ -371,18 +464,17 @@ public class UnwrapSingleArrayScalarsTes
 
     public void testUUIDAsArray() throws Exception
     {
-        final ObjectReader reader = MAPPER.readerFor(UUID.class);
         final String uuidStr = "76e6d183-5f68-4afa-b94a-922c1fdb83f8";
         UUID uuid = UUID.fromString(uuidStr);
         try {
             NO_UNWRAPPING_READER.forType(UUID.class)
                 .readValue("[" + quote(uuidStr) + "]");
-            fail("Exception was not thrown when UNWRAP_SINGLE_VALUE_ARRAYS is disabled and attempted to read a single value array as a single element");
+            fail("Exception was not thrown as expected");
         } catch (MismatchedInputException e) {
             verifyException(e, "out of START_ARRAY token");
         }
         assertEquals(uuid,
-                reader.with(DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS)
+                UNWRAPPING_READER.forType(UUID.class)
                     .readValue("[" + quote(uuidStr) + "]"));
         _verifyMultiValueArrayFail("[" + quote(uuidStr) + "," + quote(uuidStr) + "]", UUID.class);
     }
@@ -396,7 +488,7 @@ public class UnwrapSingleArrayScalarsTes
     private void _verifyMultiValueArrayFail(String input, Class<?> type) throws IOException {
         try {
             UNWRAPPING_READER.forType(type).readValue(input);
-            fail("Single value array didn't throw an exception when DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS is disabled");
+            fail("Single value array didn't throw an exception");
         } catch (MismatchedInputException e) {
             verifyException(e, "Attempted to unwrap");
         }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/TestRootName.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/TestRootName.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/TestRootName.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/TestRootName.java	2020-06-25 02:44:21.000000000 +0000
@@ -3,6 +3,8 @@ package com.fasterxml.jackson.databind;
 import com.fasterxml.jackson.annotation.*;
 
 import com.fasterxml.jackson.databind.ObjectMapper;
+import com.fasterxml.jackson.databind.exc.MismatchedInputException;
+import com.fasterxml.jackson.databind.json.JsonMapper;
 
 /**
  * Unit tests dealing with handling of "root element wrapping",
@@ -42,6 +44,80 @@ public class TestRootName extends BaseMa
         assertEquals(2, bean2.a);
     }
 
+    public void testRootViaMapperFails() throws Exception
+    {
+        final ObjectMapper mapper = rootMapper();
+        // First kind of fail, wrong name
+        try {
+            mapper.readValue(aposToQuotes("{'notRudy':{'a':3}}"), Bean.class);
+            fail("Should not pass");
+        } catch (MismatchedInputException e) {
+            verifyException(e, "Root name 'notRudy' does not match expected ('rudy')");
+        }
+
+        // second: non-Object
+        try {
+            mapper.readValue(aposToQuotes("[{'rudy':{'a':3}}]"), Bean.class);
+            fail("Should not pass");
+        } catch (MismatchedInputException e) {
+            verifyException(e, "Unexpected token (START_ARRAY");
+        }
+
+        // Third: empty Object
+        try {
+            mapper.readValue(aposToQuotes("{}]"), Bean.class);
+            fail("Should not pass");
+        } catch (MismatchedInputException e) {
+            verifyException(e, "Current token not FIELD_NAME");
+        }
+
+        // Fourth, stuff after wrapped
+        try {
+            mapper.readValue(aposToQuotes("{'rudy':{'a':3}, 'extra':3}"), Bean.class);
+            fail("Should not pass");
+        } catch (MismatchedInputException e) {
+            verifyException(e, "Unexpected token");
+            verifyException(e, "Current token not END_OBJECT (to match wrapper");
+        }
+    }
+
+    public void testRootViaReaderFails() throws Exception
+    {
+        final ObjectReader reader = rootMapper().readerFor(Bean.class);
+        // First kind of fail, wrong name
+        try {
+            reader.readValue(aposToQuotes("{'notRudy':{'a':3}}"));
+            fail("Should not pass");
+        } catch (MismatchedInputException e) {
+            verifyException(e, "Root name 'notRudy' does not match expected ('rudy')");
+        }
+
+        // second: non-Object
+        try {
+            reader.readValue(aposToQuotes("[{'rudy':{'a':3}}]"));
+            fail("Should not pass");
+        } catch (MismatchedInputException e) {
+            verifyException(e, "Unexpected token (START_ARRAY");
+        }
+
+        // Third: empty Object
+        try {
+            reader.readValue(aposToQuotes("{}]"));
+            fail("Should not pass");
+        } catch (MismatchedInputException e) {
+            verifyException(e, "Current token not FIELD_NAME");
+        }
+
+        // Fourth, stuff after wrapped
+        try {
+            reader.readValue(aposToQuotes("{'rudy':{'a':3}, 'extra':3}"));
+            fail("Should not pass");
+        } catch (MismatchedInputException e) {
+            verifyException(e, "Unexpected token");
+            verifyException(e, "Current token not END_OBJECT (to match wrapper");
+        }
+    }
+
     public void testRootViaWriterAndReader() throws Exception
     {
         ObjectMapper mapper = rootMapper();
@@ -121,12 +197,13 @@ public class TestRootName extends BaseMa
     /* Helper methods
     /**********************************************************
      */
-    
-    private ObjectMapper rootMapper()
-    {
-        ObjectMapper mapper = new ObjectMapper();
-        mapper.configure(SerializationFeature.WRAP_ROOT_VALUE, true);
-        mapper.configure(DeserializationFeature.UNWRAP_ROOT_VALUE, true);
-        return mapper;
+
+    private final ObjectMapper ROOT_MAPPER = JsonMapper.builder()
+            .enable(SerializationFeature.WRAP_ROOT_VALUE)
+            .enable(DeserializationFeature.UNWRAP_ROOT_VALUE)
+            .build();
+
+    private ObjectMapper rootMapper() {
+        return ROOT_MAPPER;
     }
 }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/type/RecursiveType1658Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/type/RecursiveType1658Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/type/RecursiveType1658Test.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/type/RecursiveType1658Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -30,12 +30,13 @@ public class RecursiveType1658Test exten
     public void testRecursive1658() throws Exception
     {
         Tree<String> t = new Tree<String>(Arrays.asList("hello", "world"));
-        ObjectMapper mapper = new ObjectMapper();
 
         final TypeResolverBuilder<?> typer = new StdTypeResolverBuilder()
                 .init(JsonTypeInfo.Id.CLASS, null)
                 .inclusion(JsonTypeInfo.As.PROPERTY);
-        mapper.setDefaultTyping(typer);
+        ObjectMapper mapper = jsonMapperBuilder()
+                .setDefaultTyping(typer)
+                .build();
 
         String res = mapper.writeValueAsString(t);
 
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/type/TestJavaType.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/type/TestJavaType.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/type/TestJavaType.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/type/TestJavaType.java	2020-06-25 02:44:21.000000000 +0000
@@ -25,6 +25,22 @@ public class TestJavaType
         private MyEnum2(int value) { }
     }
 
+    static enum MyEnumSub {
+        A(1) {
+            @Override public String toString() { 
+                return "a";
+            }
+        },
+        B(2) {
+            @Override public String toString() { 
+                return "b";
+            }
+        }
+        ;
+
+        private MyEnumSub(int value) { }
+    }
+    
     // [databind#728]
     static class Issue728 {
         public <C extends CharSequence> C method(C input) { return null; }
@@ -122,7 +138,8 @@ public class TestJavaType
 
         assertTrue(arrayT.equals(arrayT));
         assertFalse(arrayT.equals(null));
-        assertFalse(arrayT.equals("xyz"));
+        final Object bogus = "xyz";
+        assertFalse(arrayT.equals(bogus));
 
         assertTrue(arrayT.equals(ArrayType.construct(tf.constructType(String.class), null)));
         assertFalse(arrayT.equals(ArrayType.construct(tf.constructType(Integer.class), null)));
@@ -145,14 +162,19 @@ public class TestJavaType
         
         assertTrue(mapT.equals(mapT));
         assertFalse(mapT.equals(null));
-        assertFalse(mapT.equals("xyz"));
+        Object bogus = "xyz";
+        assertFalse(mapT.equals(bogus));
     }
-    
+
     public void testEnumType()
     {
         TypeFactory tf = TypeFactory.defaultInstance();
         JavaType enumT = tf.constructType(MyEnum.class);
+        // JDK actually works fine with "basic" Enum types...
+        assertTrue(enumT.getRawClass().isEnum());
         assertTrue(enumT.isEnumType());
+        assertTrue(enumT.isEnumImplType());
+
         assertFalse(enumT.hasHandlers());
         assertTrue(enumT.isTypeOrSubTypeOf(MyEnum.class));
         assertTrue(enumT.isTypeOrSubTypeOf(Object.class));
@@ -165,6 +187,17 @@ public class TestJavaType
         assertTrue(tf.constructType(MyEnum2.class).isEnumType());
         assertTrue(tf.constructType(MyEnum.A.getClass()).isEnumType());
         assertTrue(tf.constructType(MyEnum2.A.getClass()).isEnumType());
+
+        // [databind#2480]
+        assertFalse(tf.constructType(Enum.class).isEnumImplType());
+        JavaType enumSubT = tf.constructType(MyEnumSub.B.getClass());
+        assertTrue(enumSubT.isEnumType());
+        assertTrue(enumSubT.isEnumImplType());
+
+        // and this is kind of odd twist by JDK: one might except this to return true,
+        // but no, sub-classes (when Enum values have overrides, and require sub-class)
+        // are NOT considered enums for whatever reason
+        assertFalse(enumSubT.getRawClass().isEnum());
     }
 
     public void testClassKey()
@@ -216,6 +249,9 @@ public class TestJavaType
         JavaType t  = tf.constructType(AtomicStringReference.class);
         assertTrue(t.isReferenceType());
         assertTrue(t.hasContentType());
+        JavaType ct = t.getContentType();
+        assertEquals(String.class, ct.getRawClass());
+        assertSame(ct, t.containedType(0));
         ReferenceType rt = (ReferenceType) t;
         assertFalse(rt.isAnchorType());
         assertEquals(AtomicReference.class, rt.getAnchorType().getRawClass());
@@ -232,4 +268,19 @@ public class TestJavaType
         assertEquals(AtomicReference.class, sub.getRawClass());
         assertTrue(sub.isReferenceType());
     }
+
+    // for [databind#2091]
+    public void testConstructReferenceType() throws Exception
+    {
+        TypeFactory tf = TypeFactory.defaultInstance();
+        // do AtomicReference<Long>
+        final JavaType refdType = tf.constructType(Long.class);
+        JavaType t  = tf.constructReferenceType(AtomicReference.class, refdType);
+        assertTrue(t.isReferenceType());
+        assertTrue(t.hasContentType());
+        assertEquals(Long.class, t.getContentType().getRawClass());
+
+        // 26-Mar-2020, tatu: [databind#2019] suggest this should be 1...
+//        assertEquals(1, t.containedTypeCount());
+    }
 }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/util/ClassUtilTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/util/ClassUtilTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/util/ClassUtilTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/util/ClassUtilTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -1,8 +1,12 @@
 package com.fasterxml.jackson.databind.util;
 
+import java.io.*;
 import java.util.*;
 
+import com.fasterxml.jackson.core.JsonFactory;
+import com.fasterxml.jackson.core.JsonGenerator;
 import com.fasterxml.jackson.core.type.TypeReference;
+
 import com.fasterxml.jackson.databind.BaseMapTest;
 import com.fasterxml.jackson.databind.JavaType;
 import com.fasterxml.jackson.databind.type.TypeFactory;
@@ -51,6 +55,15 @@ public class ClassUtilTest extends BaseM
         public void c() { }
     }
 
+    static class MaybeGetters {
+        public static void staticMethod() { }
+
+        public void voidMethod() { }
+
+        public int getMethod() { return 1; }
+        public void setMethod(int x) { }
+    }
+
     /*
     /**********************************************************
     /* Test methods
@@ -209,4 +222,92 @@ public class ClassUtilTest extends BaseM
         assertEquals("`java.util.Map<java.lang.String,java.lang.Integer>`",
                 ClassUtil.getTypeDescription(mapType));
     }
+
+    public void testSubtypes()
+    {
+        final JavaType stringType = TypeFactory.defaultInstance().constructType(String.class);
+        List<JavaType> supers = ClassUtil.findSuperTypes(stringType, Object.class, false);
+        assertEquals(Collections.emptyList(), supers);
+
+        supers = ClassUtil.findSuperTypes(stringType, Object.class, true);
+        assertEquals(Collections.singletonList(stringType), supers);
+    }
+
+    public void testGetDeclaringClass()
+    {
+        assertEquals(null, ClassUtil.getDeclaringClass(String.class));
+        assertEquals(getClass(), ClassUtil.getDeclaringClass(BaseClass.class));
+    }
+
+    public void testIsXxxType()
+    {
+        assertTrue(ClassUtil.isCollectionMapOrArray(String[].class));
+        assertTrue(ClassUtil.isCollectionMapOrArray(ArrayList.class));
+        assertTrue(ClassUtil.isCollectionMapOrArray(LinkedHashMap.class));
+        assertFalse(ClassUtil.isCollectionMapOrArray(java.net.URL.class));
+
+        assertTrue(ClassUtil.isBogusClass(Void.class));
+        assertTrue(ClassUtil.isBogusClass(Void.TYPE));
+        assertFalse(ClassUtil.isBogusClass(String.class));
+    }
+
+    public void testEnforceSubtype()
+    {
+        try {
+            ClassUtil.verifyMustOverride(Number.class, Boolean.TRUE, "Test");
+        } catch (IllegalStateException e) {
+            verifyException(e, "must override method 'Test'");
+        }
+    }
+
+    public void testCloseEtc() throws Exception
+    {
+        final Exception testExc1 = new IllegalArgumentException("test");
+        // First: without any actual stuff, with an RTE
+        try {
+            ClassUtil.closeOnFailAndThrowAsIOE(null, null, testExc1);
+            fail("Should not pass");
+        } catch (Exception e) {
+            assertSame(testExc1, e);
+        }
+
+        // then with bogus Closeable and with non-RTE:
+        JsonFactory f = new JsonFactory();
+        ByteArrayOutputStream bytes = new ByteArrayOutputStream();
+        JsonGenerator gen = f.createGenerator(bytes);
+        final Exception testExc2 = new Exception("test");
+        try {
+            ClassUtil.closeOnFailAndThrowAsIOE(gen, bytes, testExc2);
+            fail("Should not pass");
+        } catch (Exception e) {
+            assertEquals(RuntimeException.class, e.getClass());
+            assertSame(testExc2, e.getCause());
+            assertEquals("test", e.getCause().getMessage());
+            assertTrue(gen.isClosed());
+        }
+        gen.close();
+    }
+
+    /*
+    /**********************************************************
+    /* Test methods, deprecated
+    /**********************************************************
+     */
+
+    @SuppressWarnings("deprecation")
+    public void testSubtypesDeprecated()
+    {
+        // just for code coverage
+        List<Class<?>> supers = ClassUtil.findSuperTypes(String.class, Object.class);
+        assertFalse(supers.isEmpty()); // serializable/comparable/char-seq
+    }
+
+    @SuppressWarnings("deprecation")
+    public void testHasGetterSignature() throws Exception
+    {
+        assertFalse(ClassUtil.hasGetterSignature(MaybeGetters.class.getDeclaredMethod("staticMethod")));
+        assertFalse(ClassUtil.hasGetterSignature(MaybeGetters.class.getDeclaredMethod("voidMethod")));
+        assertFalse(ClassUtil.hasGetterSignature(MaybeGetters.class.getDeclaredMethod("setMethod", Integer.TYPE)));
+        assertTrue(ClassUtil.hasGetterSignature(MaybeGetters.class.getDeclaredMethod("getMethod")));
+    }
 }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/util/EnumValuesTest.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/util/EnumValuesTest.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/util/EnumValuesTest.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/util/EnumValuesTest.java	2020-06-25 02:44:21.000000000 +0000
@@ -52,7 +52,8 @@ public class EnumValuesTest extends Base
 
     public void testEnumResolver()
     {
-        EnumResolver enumRes = EnumResolver.constructUnsafeUsingToString(ABC.class, null);
+        EnumResolver enumRes = EnumResolver.constructUnsafeUsingToString(ABC.class,
+                MAPPER.getSerializationConfig().getAnnotationIntrospector());
         assertEquals(ABC.B, enumRes.getEnum(1));
         assertNull(enumRes.getEnum(-1));
         assertNull(enumRes.getEnum(3));
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/util/TestTokenBuffer.java 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/util/TestTokenBuffer.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/databind/util/TestTokenBuffer.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/databind/util/TestTokenBuffer.java	2020-06-25 02:44:21.000000000 +0000
@@ -59,7 +59,7 @@ public class TestTokenBuffer extends Bas
         
         // First, with empty buffer
         JsonParser p = buf.asParser();
-        assertNull(p.getCurrentToken());
+        assertNull(p.currentToken());
         assertNull(p.nextToken());
         p.close();
 
@@ -67,7 +67,7 @@ public class TestTokenBuffer extends Bas
         buf.writeString("abc");
 
         p = buf.asParser();
-        assertNull(p.getCurrentToken());
+        assertNull(p.currentToken());
         assertToken(JsonToken.VALUE_STRING, p.nextToken());
         assertEquals("abc", p.getText());
         assertNull(p.nextToken());
@@ -76,7 +76,7 @@ public class TestTokenBuffer extends Bas
         // Then, let's append at root level
         buf.writeNumber(13);
         p = buf.asParser();
-        assertNull(p.getCurrentToken());
+        assertNull(p.currentToken());
         assertToken(JsonToken.VALUE_STRING, p.nextToken());
         assertToken(JsonToken.VALUE_NUMBER_INT, p.nextToken());
         assertEquals(13, p.getIntValue());
@@ -107,7 +107,7 @@ public class TestTokenBuffer extends Bas
         }
 
         JsonParser p = buf.asParser();
-        assertNull(p.getCurrentToken());
+        assertNull(p.currentToken());
 
         for (double v : values1) {
             assertToken(JsonToken.VALUE_NUMBER_FLOAT, p.nextToken());
@@ -206,7 +206,7 @@ public class TestTokenBuffer extends Bas
         assertTrue(buf.getOutputContext().inRoot());
 
         JsonParser p = buf.asParser();
-        assertNull(p.getCurrentToken());
+        assertNull(p.currentToken());
         assertTrue(p.getParsingContext().inRoot());
         assertToken(JsonToken.START_ARRAY, p.nextToken());
         assertTrue(p.getParsingContext().inArray());
@@ -267,7 +267,7 @@ public class TestTokenBuffer extends Bas
         assertTrue(buf.getOutputContext().inRoot());
 
         JsonParser p = buf.asParser();
-        assertNull(p.getCurrentToken());
+        assertNull(p.currentToken());
         assertTrue(p.getParsingContext().inRoot());
         assertToken(JsonToken.START_OBJECT, p.nextToken());
         assertTrue(p.getParsingContext().inObject());
@@ -284,22 +284,22 @@ public class TestTokenBuffer extends Bas
         buf.writeEndObject();
 
         p = buf.asParser();
-        assertNull(p.getCurrentToken());
+        assertNull(p.currentToken());
         assertToken(JsonToken.START_OBJECT, p.nextToken());
-        assertNull(p.getCurrentName());
+        assertNull(p.currentName());
         assertToken(JsonToken.FIELD_NAME, p.nextToken());
-        assertEquals("num", p.getCurrentName());
+        assertEquals("num", p.currentName());
         // and override should also work:
         p.overrideCurrentName("bah");
-        assertEquals("bah", p.getCurrentName());
+        assertEquals("bah", p.currentName());
         
         assertToken(JsonToken.VALUE_NUMBER_FLOAT, p.nextToken());
         assertEquals(1.25, p.getDoubleValue());
         // should still have access to (overridden) name
-        assertEquals("bah", p.getCurrentName());
+        assertEquals("bah", p.currentName());
         assertToken(JsonToken.END_OBJECT, p.nextToken());
         // but not any more
-        assertNull(p.getCurrentName());
+        assertNull(p.currentName());
         assertNull(p.nextToken());
         p.close();
         buf.close();
@@ -350,10 +350,10 @@ public class TestTokenBuffer extends Bas
         JsonParser p = buf1.asParser();
         assertToken(JsonToken.START_OBJECT, p.nextToken());
         assertToken(JsonToken.FIELD_NAME, p.nextToken());
-        assertEquals("a", p.getCurrentName());
+        assertEquals("a", p.currentName());
         assertToken(JsonToken.VALUE_TRUE, p.nextToken());
         assertToken(JsonToken.FIELD_NAME, p.nextToken());
-        assertEquals("b", p.getCurrentName());
+        assertEquals("b", p.currentName());
         assertToken(JsonToken.VALUE_NUMBER_INT, p.nextToken());
         assertEquals(13, p.getIntValue());
         assertToken(JsonToken.END_OBJECT, p.nextToken());
@@ -403,7 +403,7 @@ public class TestTokenBuffer extends Bas
     {
         TokenBuffer buf = new TokenBuffer(null, false); // no ObjectCodec
         StringWriter w = new StringWriter();
-        JsonGenerator gen = MAPPER.getFactory().createGenerator(w);
+        JsonGenerator gen = MAPPER.createGenerator(w);
  
         // test content: [{"a":1,"b":{"c":2}},{"a":2,"b":{"c":3}}]
 
@@ -565,8 +565,8 @@ public class TestTokenBuffer extends Bas
         assertFalse(p.isClosed());
         
         assertFalse(seq.hasCurrentToken());
-        assertNull(seq.getCurrentToken());
-        assertNull(seq.getCurrentName());
+        assertNull(seq.currentToken());
+        assertNull(seq.currentName());
 
         assertToken(JsonToken.START_ARRAY, seq.nextToken());
         assertToken(JsonToken.VALUE_STRING, seq.nextToken());
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/AsEmptyPOJONoDefaultCtor2572Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/AsEmptyPOJONoDefaultCtor2572Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/AsEmptyPOJONoDefaultCtor2572Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/AsEmptyPOJONoDefaultCtor2572Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,38 @@
+package com.fasterxml.jackson.failing;
+
+import java.util.Objects;
+
+import com.fasterxml.jackson.annotation.*;
+
+import com.fasterxml.jackson.databind.*;
+
+// [databind#2572]: "empty" setter, POJO with no 0-arg constructor
+public class AsEmptyPOJONoDefaultCtor2572Test extends BaseMapTest
+{
+    static class Outer {
+        @JsonProperty("inner")
+        private final Inner inner;
+
+        @JsonCreator
+        public Outer(@JsonProperty("inner") Inner inner) {
+            this.inner = Objects.requireNonNull(inner, "inner");
+        }
+    }
+
+    static class Inner {
+        @JsonProperty("field")
+        private final String field;
+
+        @JsonCreator
+        public Inner(@JsonProperty("field") String field) {
+            this.field = field;
+        }
+    }
+
+    public void testJackson() throws Exception {
+        ObjectMapper mapper = new ObjectMapper()
+                .setDefaultSetterInfo(JsonSetter.Value.construct(Nulls.AS_EMPTY, Nulls.AS_EMPTY));
+        final String json = mapper.writeValueAsString(new Outer(new Inner("inner")));
+        mapper.readValue(json, Outer.class);
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/BuilderWithBackRef2686Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/BuilderWithBackRef2686Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/BuilderWithBackRef2686Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/BuilderWithBackRef2686Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,101 @@
+package com.fasterxml.jackson.failing;
+
+import java.beans.ConstructorProperties;
+
+import com.fasterxml.jackson.annotation.*;
+
+import com.fasterxml.jackson.databind.*;
+import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
+import com.fasterxml.jackson.databind.annotation.JsonPOJOBuilder;
+
+// [databind#2686]: Not sure if this can ever be solved as
+//  setter/builder is on Builder class, but it is called after
+//  building completes, i.e. on wrong class.
+
+public class BuilderWithBackRef2686Test extends BaseMapTest
+{
+    // [databind#2686]
+    public static class Container {
+        private Content forward;
+
+        private String containerValue;
+
+        @JsonManagedReference
+        public Content getForward() {
+             return forward;
+        }
+
+        @JsonManagedReference
+        public void setForward(Content forward) {
+             this.forward = forward;
+        }
+
+        public String getContainerValue() {
+             return containerValue;
+        }
+
+        public void setContainerValue(String containerValue) {
+             this.containerValue = containerValue;
+        }
+   }
+
+    @JsonDeserialize(builder = Content.Builder.class) // Works when removing this, i.e. using the constructor
+    public static class Content {
+//         @JsonBackReference
+         private Container back;
+
+         private String contentValue;
+         
+         @ConstructorProperties({ "back", "contentValue" })
+         public Content(Container back, String contentValue) {
+              this.back = back;
+              this.contentValue = contentValue;
+         }
+
+         public String getContentValue() {
+              return contentValue;
+         }
+
+         @JsonBackReference
+         public Container getBack() {
+              return back;
+         }
+
+         @JsonPOJOBuilder(withPrefix = "")
+         public static class Builder {
+             private Container back;
+             private String contentValue;
+
+              @JsonBackReference
+              Builder back(Container b) {
+                   this.back = b;
+                   return this;
+              }
+
+              Builder contentValue(String cv) {
+                   this.contentValue = cv;
+                   return this;
+              }
+              
+              Content build() {
+                   return new Content(back, contentValue);
+              }
+         }
+    }
+
+    private final ObjectMapper MAPPER = sharedMapper();
+
+
+    public void testBuildWithBackRefs2686() throws Exception
+    {
+        Container container = new Container();
+        container.containerValue = "containerValue";
+        Content content = new Content(container, "contentValue");
+        container.forward = content;
+     
+        String json = MAPPER.writeValueAsString(container);
+        Container result = MAPPER.readValue(json, Container.class); // Exception here
+
+        assertNotNull(result);
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/EnumDeserializationFromInt1850Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/EnumDeserializationFromInt1850Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/EnumDeserializationFromInt1850Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/EnumDeserializationFromInt1850Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,36 @@
+package com.fasterxml.jackson.failing;
+
+import com.fasterxml.jackson.annotation.JsonValue;
+
+import com.fasterxml.jackson.databind.*;
+
+public class EnumDeserializationFromInt1850Test extends BaseMapTest
+{
+    enum Example1 {
+        A(101);
+        final int x;
+        Example1(int x) { this.x = x; }
+        @JsonValue
+        public int code() { return x; }
+    }
+
+    enum Example2 {
+        A(202);
+        @JsonValue
+        public final int x;
+        Example2(int x) { this.x = x; }
+    }
+
+    public void testEnumFromInt1850() throws Exception
+    {
+        final ObjectMapper mapper = newJsonMapper();
+
+        String json = mapper.writeValueAsString(Example1.A);
+        Example1 e1 = mapper.readValue(json, Example1.class);
+        assertEquals(Example1.A, e1);
+
+        json = mapper.writeValueAsString(Example2.A);
+        Example2 e2 = mapper.readValue(json, Example2.class);
+        assertEquals(Example2.A, e2);
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/JacksonInject2465Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/JacksonInject2465Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/JacksonInject2465Test.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/JacksonInject2465Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -1,23 +1,23 @@
 package com.fasterxml.jackson.failing;
 
-import com.fasterxml.jackson.annotation.JacksonInject;
-import com.fasterxml.jackson.annotation.JsonAutoDetect;
-import com.fasterxml.jackson.annotation.JsonCreator;
-import com.fasterxml.jackson.annotation.JsonProperty;
-import com.fasterxml.jackson.annotation.JsonSetter;
-import com.fasterxml.jackson.annotation.Nulls;
-import com.fasterxml.jackson.annotation.PropertyAccessor;
+import com.fasterxml.jackson.annotation.*;
 
 import com.fasterxml.jackson.databind.*;
 
+// [databind#2465]
 public class JacksonInject2465Test extends BaseMapTest
 {
+    // [databind#2465]
     public static final class TestCase2465 {
+        // 17-Apr-2020, tatu: Forcing this to be ignored will work around the
+        //   problem, but this really should not be necessary.
+//        @JsonIgnore
         private final Internal2465 str;
         private final int id;
 
         @JsonCreator
-        public TestCase2465(@JacksonInject Internal2465 str, @JsonProperty("id") int id) {
+        public TestCase2465(@JacksonInject(useInput = OptBoolean.FALSE) Internal2465 str,
+                @JsonProperty("id") int id) {
             this.str = str;
             this.id = id;
         }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/JacksonInject2678Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/JacksonInject2678Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/JacksonInject2678Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/JacksonInject2678Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,59 @@
+package com.fasterxml.jackson.failing;
+
+import java.util.Objects;
+
+import com.fasterxml.jackson.annotation.JacksonInject;
+import com.fasterxml.jackson.annotation.JsonProperty;
+import com.fasterxml.jackson.annotation.OptBoolean;
+
+import com.fasterxml.jackson.databind.*;
+import com.fasterxml.jackson.databind.json.JsonMapper;
+
+// [databind#2678]: constructor-passed data overridden via field/setter injection
+public class JacksonInject2678Test extends BaseMapTest
+{
+    // [databind#2678]
+    protected static class Some {
+        private String field1;
+
+        @JacksonInject(value = "defaultValueForField2", useInput = OptBoolean.TRUE)
+        private String field2;
+
+        public Some(@JsonProperty("field1") final String field1,
+                @JsonProperty("field2")
+                @JacksonInject(value = "defaultValueForField2", useInput = OptBoolean.TRUE)
+                final String field2) {
+//System.err.println("CTOR: setField2 as ["+field2+"]");            
+            this.field1 = Objects.requireNonNull(field1);
+             this.field2 = Objects.requireNonNull(field2);
+        }
+
+        public String getField1() {
+             return field1;
+        }
+
+        public String getField2() {
+             return field2;
+        }
+    }
+
+    // [databind#2678]
+    public void testReadValueInjectables() throws Exception {
+        final InjectableValues injectableValues =
+                  new InjectableValues.Std().addValue("defaultValueForField2", "somedefaultValue");
+        final ObjectMapper mapper = JsonMapper.builder()
+                .injectableValues(injectableValues)
+                .build();
+
+        final Some actualValueMissing = mapper.readValue("{\"field1\": \"field1value\"}", Some.class);
+        assertEquals("field1value", actualValueMissing.getField1());
+        assertEquals("somedefaultValue", actualValueMissing.getField2());
+
+        final Some actualValuePresent = mapper.readValue(
+                "{\"field1\": \"field1value\", \"field2\": \"field2value\"}", Some.class);
+        assertEquals("field1value", actualValuePresent.getField1());
+
+        // if I comment @JacksonInject that is next to the property the valid assert is the correct one:
+        assertEquals("field2value", actualValuePresent.getField2());
+   }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/JDKNumberDeser2644Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/JDKNumberDeser2644Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/JDKNumberDeser2644Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/JDKNumberDeser2644Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,56 @@
+package com.fasterxml.jackson.failing;
+
+import java.math.BigDecimal;
+
+import com.fasterxml.jackson.annotation.JsonProperty;
+import com.fasterxml.jackson.annotation.JsonSubTypes;
+import com.fasterxml.jackson.annotation.JsonTypeInfo;
+import com.fasterxml.jackson.databind.*;
+
+public class JDKNumberDeser2644Test extends BaseMapTest
+{
+    // [databind#2644]
+    static class NodeRoot2644 {
+        public String type;
+
+        @JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.EXTERNAL_PROPERTY, property = "type")
+        @JsonSubTypes(value = {
+                @JsonSubTypes.Type(value = NodeParent2644.class, name = "NodeParent")
+        })
+        public Node2644 node;
+    }
+
+    public static class NodeParent2644 extends Node2644 { }
+
+    public static abstract class Node2644 {
+        @JsonProperty("amount")
+        BigDecimal val;
+
+        public BigDecimal getVal() {
+            return val;
+        }
+
+        public void setVal(BigDecimal val) {
+            this.val = val;
+        }
+    }
+
+    // [databind#2644]
+    public void testBigDecimalSubtypes() throws Exception
+    {
+        ObjectMapper mapper = newJsonMapper();
+
+        // NOTE: uncommenting this does work around the issue:
+//        mapper.enable(DeserializationFeature.USE_BIG_DECIMAL_FOR_FLOATS);
+        mapper.registerSubtypes(NodeParent2644.class);
+
+        NodeRoot2644 root = mapper.readValue(
+                "{\"type\": \"NodeParent\",\"node\": {\"amount\": 9999999999999999.99} }",
+                NodeRoot2644.class
+        );
+
+        assertEquals(new BigDecimal("9999999999999999.99"), root.node.getVal());
+
+    }
+
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/MergeWithCreator1921Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/MergeWithCreator1921Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/MergeWithCreator1921Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/MergeWithCreator1921Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,89 @@
+package com.fasterxml.jackson.failing;
+
+import java.util.Objects;
+
+import com.fasterxml.jackson.annotation.*;
+
+import com.fasterxml.jackson.databind.*;
+import com.fasterxml.jackson.databind.exc.ValueInstantiationException;
+
+// For [databind#1921]: Creator method not used when merging even if there is
+// no feasible alternative. Unclear whether this can even theoretically be
+// improved since combination of Creator + Setter(s)/field is legit; but use
+// of Creator always means that operation is not true merge.
+// But added test just in case future brings us a good idea of way forward.
+public class MergeWithCreator1921Test extends BaseMapTest
+{
+    static class Account {
+        @JsonMerge(value = OptBoolean.TRUE)
+        private final Validity validity;
+
+        @JsonCreator
+        public Account(@JsonProperty(value = "validity", required = true) Validity validity) {
+            this.validity = validity;
+        }
+
+        public Validity getValidity() {
+            return validity;
+        }
+    }
+
+    static class Validity {
+        public static final String VALID_FROM_CANT_BE_NULL = "Valid from can't be null";
+        public static final String VALID_TO_CANT_BE_BEFORE_VALID_FROM = "Valid to can't be before valid from";
+
+        private final String _validFrom;
+        private final String _validTo;
+
+        @JsonCreator
+        public Validity(@JsonProperty(value = "validFrom", required = true) String validFrom,
+                        @JsonProperty("validTo") String validTo) {
+            checkValidity(validFrom, validTo);
+
+            this._validFrom = validFrom;
+            this._validTo = validTo;
+        }
+
+        private void checkValidity(String from, String to) {
+            Objects.requireNonNull(from, VALID_FROM_CANT_BE_NULL);
+            if (to != null) {
+                if (from.compareTo(to) > 0) {
+                    throw new IllegalStateException(VALID_TO_CANT_BE_BEFORE_VALID_FROM);
+                }
+            }
+        }
+
+        public String getValidFrom() {
+            return _validFrom;
+        }
+
+        public String getValidTo() {
+            return _validTo;
+        }
+    }
+
+    public void testMergeWithCreator() throws Exception
+    {
+        final String JSON = "{ \"validity\": { \"validFrom\": \"2018-02-01\", \"validTo\": \"2018-01-31\" } }";
+
+        final ObjectMapper mapper = newJsonMapper();
+
+        try {
+            mapper.readValue(JSON, Account.class);
+            fail("Should not pass");
+        } catch (ValueInstantiationException e) {
+            verifyException(e, "Cannot construct");
+            verifyException(e, Validity.VALID_TO_CANT_BE_BEFORE_VALID_FROM);
+        }
+
+        try {
+            Account acc = new Account(new Validity("abc", "def"));
+            mapper.readerForUpdating(acc)
+                .readValue(JSON);
+            fail("Should not pass");
+        } catch (ValueInstantiationException e) {
+            verifyException(e, "Cannot construct");
+            verifyException(e, Validity.VALID_TO_CANT_BE_BEFORE_VALID_FROM);
+        }
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/NodeContext2049Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/NodeContext2049Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/NodeContext2049Test.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/NodeContext2049Test.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,183 +0,0 @@
-package com.fasterxml.jackson.failing;
-
-import java.io.IOException;
-import java.util.ArrayList;
-import java.util.Iterator;
-import java.util.List;
-
-import com.fasterxml.jackson.core.*;
-
-import com.fasterxml.jackson.databind.*;
-import com.fasterxml.jackson.databind.deser.*;
-import com.fasterxml.jackson.databind.deser.std.CollectionDeserializer;
-import com.fasterxml.jackson.databind.deser.std.DelegatingDeserializer;
-import com.fasterxml.jackson.databind.type.CollectionLikeType;
-
-public class NodeContext2049Test extends BaseMapTest
-{
-    public interface HasParent {
-        void setParent(Parent parent);
-        Parent getParent();
-    }
-
-    static class Child implements HasParent {
-        public Parent parent;
-        public String property;
-
-        @Override
-        public void setParent(Parent p) { parent = p; }
-        @Override
-        public Parent getParent() { return parent; }
-    }
-
-    static class Parent {
-        public List<Child> children;
-        public Child singleChild;
-    }
-
-    static class ListValueInstantiator extends ValueInstantiator {
-        @Override
-        public String getValueTypeDesc() {
-             return List.class.getName();
-        }
-
-        @Override
-        public Object createUsingDefault(DeserializationContext ctxt) throws IOException {
-             return new ArrayList<>();
-        }
-    }
-
-    static class ParentSettingDeserializerModifier extends BeanDeserializerModifier {
-        @Override
-        public BeanDeserializerBuilder updateBuilder(DeserializationConfig config, BeanDescription beanDesc,
-                  BeanDeserializerBuilder builder) {
-             for (Iterator<SettableBeanProperty> propertyIt = builder.getProperties(); propertyIt.hasNext(); ) {
-                  SettableBeanProperty property = propertyIt.next();
-                  builder.addOrReplaceProperty(property.withValueDeserializer(new ParentSettingDeserializerContextual()), false);
-             }
-             return builder;
-        }
-    }
-
-    @SuppressWarnings("serial")
-    static class ParentSettingDeserializer extends DelegatingDeserializer {
-        public ParentSettingDeserializer(JsonDeserializer<?> delegatee) {
-             super(delegatee);
-        }
-
-        @Override
-        public Object deserialize(JsonParser jp, DeserializationContext ctxt) throws IOException, JsonProcessingException {
-             Object retValue = super.deserialize(jp, ctxt);
-             if (retValue instanceof HasParent) {
-                  HasParent obj = (HasParent) retValue;
-                  Parent parent = null;
-                  JsonStreamContext parsingContext = jp.getParsingContext();
-                  while (parent == null && parsingContext != null) {
-                       Object currentValue = parsingContext.getCurrentValue();
-                       if (currentValue != null && currentValue instanceof Parent) {
-                            parent = (Parent) currentValue;
-                       }
-                       parsingContext = parsingContext.getParent();
-                  }
-                  if (parent != null) {
-                       obj.setParent(parent);
-                  }
-             }
-             return retValue;
-        }
-
-        @Override
-        protected JsonDeserializer<?> newDelegatingInstance(JsonDeserializer<?> newDelegatee) {
-             return new ParentSettingDeserializer(newDelegatee);
-        }
-
-   }
-    
-    static class ParentSettingDeserializerContextual extends JsonDeserializer<Object> implements ContextualDeserializer {
-
-        @Override
-        public JsonDeserializer<?> createContextual(DeserializationContext ctxt, BeanProperty property)
-                  throws JsonMappingException {
-             JavaType propertyType = property.getType();
-             JavaType contentType = propertyType;
-             if (propertyType.isCollectionLikeType()) {
-                  contentType = propertyType.getContentType();
-             }
-             JsonDeserializer<Object> delegatee = ctxt.findNonContextualValueDeserializer(contentType);
-             JsonDeserializer<Object> objectDeserializer = new ParentSettingDeserializer(delegatee);
-             JsonDeserializer<?> retValue;
-             if (propertyType.isCollectionLikeType()) {
-                  CollectionLikeType collectionType = ctxt.getTypeFactory().constructCollectionLikeType(propertyType.getRawClass(),
-                            contentType);
-                  ValueInstantiator instantiator = new ListValueInstantiator();
-                  retValue = new CollectionDeserializer(collectionType, objectDeserializer, null, instantiator);
-             } else {
-                  retValue = objectDeserializer;
-             }
-             return retValue;
-        }
-
-        @Override
-        public Object deserialize(JsonParser p, DeserializationContext ctxt) throws IOException, JsonProcessingException {
-             // TODO Auto-generated method stub
-             return null;
-        }
-
-   }
-    
-    /*
-    /**********************************************************************
-    /* Test methods
-    /**********************************************************************
-     */
-    
-    private ObjectMapper objectMapper;
-    {
-        objectMapper = new ObjectMapper();
-        objectMapper.registerModule(new com.fasterxml.jackson.databind.Module() {
-              @Override
-              public String getModuleName() {
-                   return "parentSetting";
-              }
-              @Override
-              public Version version() {
-                   return Version.unknownVersion();
-              }
-              @Override
-              public void setupModule(SetupContext context) {
-                   context.addBeanDeserializerModifier(new ParentSettingDeserializerModifier());
-              }
-         });
-    }
-
-    final static String JSON = "{\n" + 
-            "     \"children\": [\n" + 
-            "          {\n" + 
-            "               \"property\": \"value1\"\n" + 
-            "          },\n" + 
-            "          {\n" + 
-            "               \"property\": \"value2\"\n" + 
-            "          }\n" + 
-            "     ],\n" + 
-            "     \"singleChild\": {\n" + 
-            "          \"property\": \"value3\"\n" + 
-            "     }\n" + 
-            "}";
-
-    public void testReadNoBuffering() throws IOException {
-        Parent obj = objectMapper.readerFor(Parent.class).readValue(JSON);
-        assertSame(obj, obj.singleChild.getParent());
-        for (Child child : obj.children) {
-            assertSame(obj, child.getParent());
-        }
-    }
-
-    public void testReadFromTree() throws IOException {
-        JsonNode tree = objectMapper.readTree(JSON);
-        Parent obj = objectMapper.reader().forType(Parent.class).readValue(tree);
-        assertSame(obj, obj.singleChild.getParent());
-        for (Child child : obj.children) {
-            assertSame(obj, child.getParent());
-        }
-    }
-}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/NumberNodes1770Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/NumberNodes1770Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/NumberNodes1770Test.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/NumberNodes1770Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -10,7 +10,10 @@ public class NumberNodes1770Test extends
 {
     private final ObjectMapper MAPPER = newJsonMapper();
 
-    // Related to [databind#1770]
+    // For to [databind#1770] (broken due to fix for #1028): `JsonNodeDeserializer`
+    // would coerce ok but does `parser.isNaN()` check which ends up parsing
+    // as Double, gets `POSITIVE_INFINITY` and returns `true`: this results in
+    // `DoubleNode` being used even tho `BigDecimal` could fit the number.
     public void testBigDecimalCoercion() throws Exception
     {
         final JsonNode jsonNode = MAPPER.reader()
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/ParsingContext2525Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/ParsingContext2525Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/ParsingContext2525Test.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/ParsingContext2525Test.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,237 +0,0 @@
-package com.fasterxml.jackson.failing;
-
-import java.io.IOException;
-
-import com.fasterxml.jackson.core.JsonParser;
-import com.fasterxml.jackson.core.JsonPointer;
-import com.fasterxml.jackson.core.JsonToken;
-
-import com.fasterxml.jackson.databind.*;
-import com.fasterxml.jackson.databind.util.TokenBuffer;
-
-public class ParsingContext2525Test extends BaseMapTest
-{
-    private final ObjectMapper MAPPER = sharedMapper();
-
-    private final String MINIMAL_ARRAY_DOC = "[ 42 ]";
-    
-    private final String MINIMAL_OBJECT_DOC = "{\"answer\" : 42 }";
-
-    private final String FULL_DOC = aposToQuotes("{'a':123,'array':[1,2,[3],5,{'obInArray':4}],"
-            +"'ob':{'first':[false,true],'second':{'sub':37}},'b':true}");
-
-    /*
-    /**********************************************************************
-    /* Baseline sanity check first
-    /**********************************************************************
-     */
-
-    public void testAllWithRegularParser() throws Exception
-    {
-        try (JsonParser p = MAPPER.getFactory().createParser(MINIMAL_ARRAY_DOC)) {
-            _testSimpleArrayUsingPathAsPointer(p);
-        }
-        try (JsonParser p = MAPPER.getFactory().createParser(MINIMAL_OBJECT_DOC)) {
-            _testSimpleObjectUsingPathAsPointer(p);
-        }
-        try (JsonParser p = MAPPER.getFactory().createParser(FULL_DOC)) {
-            _testFullDocUsingPathAsPointer(p);
-        }
-    }
-
-    /*
-    /**********************************************************************
-    /* Then TokenBuffer-backed tests
-    /**********************************************************************
-     */
-
-    public void testSimpleArrayWithBuffer() throws Exception
-    {
-        try (TokenBuffer buf = _readAsTokenBuffer(MINIMAL_ARRAY_DOC)) {
-            _testSimpleArrayUsingPathAsPointer(buf.asParser());
-        }
-    }
-
-    public void testSimpleObjectWithBuffer() throws Exception
-    {
-        try (TokenBuffer buf = _readAsTokenBuffer(MINIMAL_OBJECT_DOC)) {
-            _testSimpleObjectUsingPathAsPointer(buf.asParser());
-        }
-    }
-
-    public void testFullDocWithBuffer() throws Exception
-    {
-        try (TokenBuffer buf = _readAsTokenBuffer(FULL_DOC)) {
-            _testFullDocUsingPathAsPointer(buf.asParser());
-        }
-    }
-
-    private TokenBuffer _readAsTokenBuffer(String doc) throws IOException
-    {
-        try (JsonParser p = MAPPER.getFactory().createParser(doc)) {
-            p.nextToken();
-            return TokenBuffer.asCopyOfValue(p)
-                    .overrideParentContext(null);
-        }
-    }
-
-    /*
-    /**********************************************************************
-    /* And Tree-backed tests
-    /**********************************************************************
-     */
-
-    public void testSimpleArrayWithTree() throws Exception
-    {
-        JsonNode root = MAPPER.readTree(MINIMAL_ARRAY_DOC);
-        try (JsonParser p = root.traverse(null)) {
-            _testSimpleArrayUsingPathAsPointer(p);
-        }
-    }
-
-    public void testSimpleObjectWithTree() throws Exception
-    {
-        JsonNode root = MAPPER.readTree(MINIMAL_OBJECT_DOC);
-        try (JsonParser p = root.traverse(null)) {
-            _testSimpleObjectUsingPathAsPointer(p);
-        }
-    }
-
-    public void testFullDocWithTree() throws Exception
-    {
-        JsonNode root = MAPPER.readTree(FULL_DOC);
-        try (JsonParser p = root.traverse(null)) {
-            _testFullDocUsingPathAsPointer(p);
-        }
-    }
-
-    /*
-    /**********************************************************************
-    /* Shared helper methods
-    /**********************************************************************
-     */
-    
-    private void _testSimpleArrayUsingPathAsPointer(JsonParser p) throws Exception
-    {
-        assertSame(JsonPointer.empty(), p.getParsingContext().pathAsPointer());
-        assertTrue(p.getParsingContext().inRoot());
-
-        assertToken(JsonToken.START_ARRAY, p.nextToken());
-        assertSame(JsonPointer.empty(), p.getParsingContext().pathAsPointer());
-        assertTrue(p.getParsingContext().inArray());
-
-        assertToken(JsonToken.VALUE_NUMBER_INT, p.nextToken());
-        assertEquals("/0", p.getParsingContext().pathAsPointer().toString());
-        
-        assertToken(JsonToken.END_ARRAY, p.nextToken());
-        assertSame(JsonPointer.empty(), p.getParsingContext().pathAsPointer());
-        assertTrue(p.getParsingContext().inRoot());
-
-        assertNull(p.nextToken());
-    }
-
-    private void _testSimpleObjectUsingPathAsPointer(JsonParser p) throws Exception
-    {
-        assertSame(JsonPointer.empty(), p.getParsingContext().pathAsPointer());
-        assertTrue(p.getParsingContext().inRoot());
-
-        assertToken(JsonToken.START_OBJECT, p.nextToken());
-        assertSame(JsonPointer.empty(), p.getParsingContext().pathAsPointer());
-        assertTrue(p.getParsingContext().inObject());
-
-        assertToken(JsonToken.FIELD_NAME, p.nextToken());
-        assertEquals("/answer", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.VALUE_NUMBER_INT, p.nextToken());
-        assertEquals(42, p.getIntValue());
-        assertEquals("/answer", p.getParsingContext().pathAsPointer().toString());
-        
-        assertToken(JsonToken.END_OBJECT, p.nextToken());
-        assertSame(JsonPointer.empty(), p.getParsingContext().pathAsPointer());
-        assertTrue(p.getParsingContext().inRoot());
-
-        assertNull(p.nextToken());
-    }
-    
-    private void _testFullDocUsingPathAsPointer(JsonParser p) throws Exception
-    {
-        // by default should just get "empty"
-        assertSame(JsonPointer.empty(), p.getParsingContext().pathAsPointer());
-        assertTrue(p.getParsingContext().inRoot());
-
-        // let's just traverse, then:
-        assertToken(JsonToken.START_OBJECT, p.nextToken());
-        assertSame(JsonPointer.empty(), p.getParsingContext().pathAsPointer());
-        assertTrue(p.getParsingContext().inObject());
-
-        assertToken(JsonToken.FIELD_NAME, p.nextToken()); // a
-        assertEquals("/a", p.getParsingContext().pathAsPointer().toString());
-
-        assertToken(JsonToken.VALUE_NUMBER_INT, p.nextToken());
-        assertEquals("/a", p.getParsingContext().pathAsPointer().toString());
-
-        assertToken(JsonToken.FIELD_NAME, p.nextToken()); // array
-        assertEquals("/array", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.START_ARRAY, p.nextToken());
-        assertEquals("/array", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.VALUE_NUMBER_INT, p.nextToken()); // 1
-        assertEquals("/array/0", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.VALUE_NUMBER_INT, p.nextToken()); // 2
-        assertEquals("/array/1", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.START_ARRAY, p.nextToken());
-        assertEquals("/array/2", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.VALUE_NUMBER_INT, p.nextToken()); // 3
-        assertEquals("/array/2/0", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.END_ARRAY, p.nextToken());
-        assertEquals("/array/2", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.VALUE_NUMBER_INT, p.nextToken()); // 5
-        assertEquals("/array/3", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.START_OBJECT, p.nextToken());
-        assertEquals("/array/4", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.FIELD_NAME, p.nextToken()); // obInArray
-        assertEquals("/array/4/obInArray", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.VALUE_NUMBER_INT, p.nextToken()); // 4
-        assertEquals("/array/4/obInArray", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.END_OBJECT, p.nextToken());
-        assertEquals("/array/4", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.END_ARRAY, p.nextToken()); // /array
-        assertEquals("/array", p.getParsingContext().pathAsPointer().toString());
-
-        assertToken(JsonToken.FIELD_NAME, p.nextToken()); // ob
-        assertEquals("/ob", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.START_OBJECT, p.nextToken());
-        assertEquals("/ob", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.FIELD_NAME, p.nextToken()); // first
-        assertEquals("/ob/first", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.START_ARRAY, p.nextToken());
-        assertEquals("/ob/first", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.VALUE_FALSE, p.nextToken());
-        assertEquals("/ob/first/0", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.VALUE_TRUE, p.nextToken());
-        assertEquals("/ob/first/1", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.END_ARRAY, p.nextToken());
-        assertEquals("/ob/first", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.FIELD_NAME, p.nextToken()); // second
-        assertEquals("/ob/second", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.START_OBJECT, p.nextToken());
-        assertEquals("/ob/second", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.FIELD_NAME, p.nextToken()); // sub
-        assertEquals("/ob/second/sub", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.VALUE_NUMBER_INT, p.nextToken()); // 37
-        assertEquals("/ob/second/sub", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.END_OBJECT, p.nextToken());
-        assertEquals("/ob/second", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.END_OBJECT, p.nextToken()); // /ob
-        assertEquals("/ob", p.getParsingContext().pathAsPointer().toString());
-
-        assertToken(JsonToken.FIELD_NAME, p.nextToken()); // b
-        assertEquals("/b", p.getParsingContext().pathAsPointer().toString());
-        assertToken(JsonToken.VALUE_TRUE, p.nextToken());
-        assertEquals("/b", p.getParsingContext().pathAsPointer().toString());
-
-        assertToken(JsonToken.END_OBJECT, p.nextToken());
-        assertSame(JsonPointer.empty(), p.getParsingContext().pathAsPointer());
-        assertTrue(p.getParsingContext().inRoot());
-
-        assertNull(p.nextToken());
-    }
-}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/PropertyAccessReadOnly2118Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/PropertyAccessReadOnly2118Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/PropertyAccessReadOnly2118Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/PropertyAccessReadOnly2118Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,54 @@
+package com.fasterxml.jackson.failing;
+
+import java.util.*;
+
+import com.fasterxml.jackson.annotation.*;
+
+import com.fasterxml.jackson.databind.*;
+
+public class PropertyAccessReadOnly2118Test extends BaseMapTest
+{
+    // [databind#2118]
+    static class SecurityGroup {
+
+        private List<SecurityGroupRule> securityGroupRules;
+
+        public SecurityGroup() {
+            this.securityGroupRules = new ArrayList<>();
+        }
+
+        @JsonProperty(value="security_group_rules", access=JsonProperty.Access.READ_ONLY)
+        public List<SecurityGroupRule> getSecurityGroupRules() {
+            return securityGroupRules;
+        }
+
+        public SecurityGroup setSecurityGroupRules(List<SecurityGroupRule> securityGroupRules) {
+            throw new Error("Should not be called");
+        }
+    }
+
+    static class SecurityGroupRule {
+        private String id;
+
+        public SecurityGroupRule() { }
+
+        @JsonProperty
+        public String getId() {
+            return id;
+        }
+
+        public void setId(String id) {
+            this.id = id;
+        }
+    }
+
+    // [databind#2118]
+    public void testAccessReadOnly() throws Exception {
+        String data ="{\"security_group_rules\": [{\"id\": \"id1\"}, {\"id\": \"id2\"}, {\"id\": \"id3\"}, {\"id\": \"id4\"}]}";
+        ObjectMapper mapper = new ObjectMapper();
+// This would work around the issue:        
+//        mapper.disable(MapperFeature.USE_GETTERS_AS_SETTERS);
+        SecurityGroup sg = mapper.readValue(data, SecurityGroup.class);
+        System.out.println(mapper.writeValueAsString(sg));
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/ReadOnlyList2283Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/ReadOnlyList2283Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/ReadOnlyList2283Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/ReadOnlyList2283Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,70 @@
+package com.fasterxml.jackson.failing;
+
+import java.util.*;
+
+import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
+import com.fasterxml.jackson.annotation.JsonProperty;
+import com.fasterxml.jackson.databind.*;
+
+// [databind#2283]: ignore read-only Lists even if "getter-as-setter" enabled
+public class ReadOnlyList2283Test
+    extends BaseMapTest
+{
+    static class RenamedToSameOnGetter {
+        @JsonProperty(value = "list", access = JsonProperty.Access.READ_ONLY)
+        List<Long> getList() {
+            return Collections.emptyList();
+        }
+    }
+
+    static class RenamedToDifferentOnGetter {
+        @JsonProperty(value = "renamedList", access = JsonProperty.Access.READ_ONLY)
+        List<Long> getList() {
+            return Collections.emptyList();
+        }
+    }
+
+    @JsonIgnoreProperties(value={ "renamedList" }, allowGetters=true)
+    static class RenamedOnClass {
+        @JsonProperty("renamedList")
+        List<Long> getList() {
+            return Collections.emptyList();
+        }
+    }
+
+    /*
+    /**********************************************************
+    /* Test methods
+    /**********************************************************
+     */
+
+    private final ObjectMapper MAPPER = jsonMapperBuilder()
+            .configure(MapperFeature.USE_GETTERS_AS_SETTERS, true).build();
+
+    public void testRenamedToSameOnGetter() throws Exception
+    {
+        assertEquals("{\"list\":[]}",
+                MAPPER.writeValueAsString(new RenamedToSameOnGetter()));
+        String payload = "{\"list\":[1,2,3,4]}";
+        RenamedToSameOnGetter foo = MAPPER.readValue(payload, RenamedToSameOnGetter.class);
+        assertTrue("List should be empty", foo.getList().isEmpty());
+    }
+
+    public void testRenamedToDifferentOnGetter() throws Exception
+    {
+        assertEquals("{\"renamedList\":[]}",
+                MAPPER.writeValueAsString(new RenamedToDifferentOnGetter()));
+        String payload = "{\"renamedList\":[1,2,3,4]}";
+        RenamedToDifferentOnGetter foo = MAPPER.readValue(payload, RenamedToDifferentOnGetter.class);
+        assertTrue("List should be empty", foo.getList().isEmpty());
+    }
+
+    public void testRenamedOnClass() throws Exception
+    {
+        assertEquals("{\"renamedList\":[]}",
+                MAPPER.writeValueAsString(new RenamedOnClass()));
+        String payload = "{\"renamedList\":[1,2,3,4]}";
+        RenamedOnClass foo = MAPPER.readValue(payload, RenamedOnClass.class);
+        assertTrue("List should be empty", foo.getList().isEmpty());
+    }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/RequireSetterForGetter736Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/RequireSetterForGetter736Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/RequireSetterForGetter736Test.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/RequireSetterForGetter736Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -31,6 +31,7 @@ public class RequireSetterForGetter736Te
     {
         ObjectMapper mapper = jsonMapperBuilder()
                 .visibility(PropertyAccessor.ALL, Visibility.NONE)
+                .visibility(PropertyAccessor.FIELD, Visibility.NONE)
                 .visibility(PropertyAccessor.GETTER, Visibility.PUBLIC_ONLY)
                 .visibility(PropertyAccessor.SETTER, Visibility.PUBLIC_ONLY)
                 .enable(MapperFeature.REQUIRE_SETTERS_FOR_GETTERS)
@@ -39,6 +40,5 @@ public class RequireSetterForGetter736Te
 
         String json = mapper.writeValueAsString(dataB);
         assertEquals(aposToQuotes("{'readwrite':2}"), json);
-        
     }
 }
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/SetterlessList2692Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/SetterlessList2692Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/SetterlessList2692Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/SetterlessList2692Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,44 @@
+package com.fasterxml.jackson.failing;
+
+import java.util.*;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+import com.fasterxml.jackson.databind.BaseMapTest;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+public class SetterlessList2692Test extends BaseMapTest
+{
+    static class DataBean {
+
+        final String val;
+
+        @JsonCreator
+        public DataBean(@JsonProperty(value = "val") String val) {
+          super();
+          this.val = val;
+        }
+
+        public String getVal() {
+          return val;
+        }
+        
+        public List<String> getList(){
+          return new ArrayList<>();
+        }
+
+        @Override
+        public String toString() {
+          return "DataBean [val=" + val + "]";
+        }
+    }
+
+    public void testIssue2692() throws Exception {
+          ObjectMapper om = newJsonMapper();
+          String json;
+          DataBean out;
+          json = "{\"list\":[\"11\"],\"val\":\"VAL2\"}";
+          out = om.readerFor(DataBean.class).readValue(json);
+          System.out.println("this is ko" + out);
+     }
+}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/SkipInjectableIntrospection962Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/SkipInjectableIntrospection962Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/SkipInjectableIntrospection962Test.java	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/SkipInjectableIntrospection962Test.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,58 +0,0 @@
-package com.fasterxml.jackson.failing;
-
-import com.fasterxml.jackson.annotation.JacksonInject;
-import com.fasterxml.jackson.annotation.JsonCreator;
-import com.fasterxml.jackson.annotation.JsonProperty;
-import com.fasterxml.jackson.annotation.OptBoolean;
-import com.fasterxml.jackson.databind.*;
-
-public class SkipInjectableIntrospection962Test extends BaseMapTest
-{
-    static class InjectMe
-    {
-        private String a;
-
-        public InjectMe(boolean dummy) { }
-
-        public void setA(Integer a) {
-            this.a = a.toString();
-        }
-
-        public void setA(InjectMe a) {
-            this.a = String.valueOf(a);
-        }
-        
-        public String getA() {
-            return a;
-        }
-    }
-
-    static class Injectee
-    {
-        private String b;
-
-        // Important! Prevent binding from data
-        @JsonCreator
-        public Injectee(@JacksonInject(useInput=OptBoolean.FALSE) InjectMe injectMe,
-                @JsonProperty("b") String b) {
-            this.b = b;
-        }
-
-        public String getB() {
-            return b;
-        }
-    }
-
-    // 14-Jun-2016, tatu: For some odd reason, this test sometimes fails, other times not...
-    //    possibly related to unstable ordering of properties?
-    public void testInjected() throws Exception
-    {
-        InjectMe im = new InjectMe(true);
-        ObjectMapper mapper = new ObjectMapper()
-            .setInjectableValues(new InjectableValues.Std().addValue(InjectMe.class, im));
-        String test = "{\"b\":\"bbb\"}";
-
-        Injectee actual = mapper.readValue(test, Injectee.class);
-        assertEquals("bbb", actual.getB());
-    }
-}
diff -pruN 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/VoidProperties2675Test.java 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/VoidProperties2675Test.java
--- 2.10.2-1/src/test/java/com/fasterxml/jackson/failing/VoidProperties2675Test.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.1-1/src/test/java/com/fasterxml/jackson/failing/VoidProperties2675Test.java	2020-06-25 02:44:21.000000000 +0000
@@ -0,0 +1,25 @@
+package com.fasterxml.jackson.failing;
+
+import com.fasterxml.jackson.databind.*;
+
+public class VoidProperties2675Test extends BaseMapTest
+{
+    static class VoidBean {
+        public Void getValue() { return null; }
+    }
+
+    /*
+    /**********************************************************************
+    /* Test methods
+    /**********************************************************************
+     */
+
+    private final ObjectMapper MAPPER = new ObjectMapper();
+
+    public void testVoidBean() throws Exception {
+        final String EXP = "{\"value\":null}";
+        assertEquals(EXP, MAPPER.writeValueAsString(new VoidBean()));
+        VoidBean result = MAPPER.readValue(EXP, VoidBean.class);
+        assertNotNull(result);
+    }
+}
diff -pruN 2.10.2-1/.travis.yml 2.11.1-1/.travis.yml
--- 2.10.2-1/.travis.yml	2020-01-05 02:13:21.000000000 +0000
+++ 2.11.1-1/.travis.yml	2020-06-25 02:44:21.000000000 +0000
@@ -4,8 +4,7 @@ git:
   quiet: true
   submodules: false
 
-# Since Jackson 2.7, build requires jdk7, although module itself works on jdk6 still (for now)
-# and since 2.10, will require jdk8 for build
+# Since Jackson 2.10 build requires JDK 8 even if only JDK 7 runtime
 jdk:
   - openjdk8
   - oraclejdk11
@@ -25,7 +24,7 @@ after_success:
 branches:
   only:
     - master
-    - "2.10"
+    - "2.11"
 
 env:
   global:
